#!/usr/bin/suidperl -U
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: change_passwd_cyrus.pl,v 1.4 2003/10/24 14:25:08 varkoly Exp $
#

BEGIN{
    use POSIX;
    push @INC,"/srv/www/lib";
    $ENV{"PATH"}="/bin:/sbin:/usr/bin:/usr/sbin:/srv/www/imap-bin";
    $ENV{"HOME"}="/root";
    my $x = (getpwnam("root"))[2];
    my $y = getgrnam("root");
    setuid($x);
    setgid($y);
    undef $x;
    undef $y;
}

use strict;
use LDAPUtils;
use Display;
use Session;
use Net::LDAP qw(:all);
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Utils qw(%CONF_GLOBAL $lmsg);

&Utils::read_LangINI || die;
&Utils::read_Config || die;

my $q = new CGI;
$q->autoEscape(undef);

my $sessionID = $q->param('sessionID');    

my $session = Session->new();
my $confParam = ($session->load($sessionID))->data();
my $message;

my $menu = new Display($q, $session);

if(! defined $confParam) {
    print $q->header(-refresh=>"0; URL=/suse/login.pl");
    print $q->start_html(-title=>"");
    print $q->end_html;
    exit;
} else {
    $message = ($session->getLanguage($confParam->{LANG},"CHANGE_PASSWD"))->data();
}


my $doit          = $q->param('doit');

my $LOGINuid      = $confParam->{uid};
my $LOGINpasswd   = $confParam->{passwd};

my $ldapbase      = $confParam->{baseDN};
my $ldaphost      = $confParam->{LDAPserver};
if ($ldaphost =~ /^([-\@\w.]+)$/) {
    $ldaphost = $1;                     # $data now untainted
} else {
    print STDERR "bad data: $ldaphost\n";
    exit;
}
my $ldapport      = $confParam->{LDAPport};
my $imaphost      = $confParam->{IMAPserver}; 
my $imapport      = $confParam->{IMAPport};


my $uid         = $q->param('USER');
my $old_passwd  = $q->param('old_passwd');
my $new_passwd  = $q->param('new_passwd');
my $new2_passwd = $q->param('new2_passwd');
my $tab         = $q->param('tab');
my $stab        = $q->param('stab');

my $command = "";
my $errs = "";
my $filter = $q->param('filter');

if ($confParam->{uid} ne "cyrus") {
    $menu->display_error($message->{access_denied},
			 "/suse/menu.pl?sessionID=$sessionID");
    exit;
} else {
    $uid = $LOGINuid;
}


if(defined $doit && $doit eq "change") {
    change_pass();
} else {
    startup();
}

exit;

sub startup {
    my $html = "";

    $html = $q->table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"},
		      $q->Tr({},
			     $q->td({},
				    $q->table({-border=>0, -cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					      $q->Tr(
						     [
						      $menu->help_th(2, $message->{change_passwd},
								     "CHANGE_PASSWD_ADMIN" ),
						      $q->td({-colspan=>2, -class=>'AdminSubHeader'},
							     "$message->{for_user}: $uid"),
						      $q->start_form(-action=>"$confParam->{cgi_path}/change_passwd_cyrus.pl",
								     -method=>"post").
						      $q->td(
							     [ "$message->{old_pass}",
							     $q->password_field(-name=>'old_passwd',-size=>20)]),
						      $q->td(
							     [ "$message->{new_pass}",
							      $q->password_field(-name=>'new_passwd',-size=>20)]),
						      $q->td(
							     [ "$message->{new2_pass}",
							     $q->password_field(-name=>'new2_passwd',-size=>20)]),
						      $q->td({-colspan=>2,
							      -align=>"center"},
							     $q->submit(-class=>"button",-name=>"$message->{update}").
							     $q->hidden(-name=>"USER", -value=>$uid).
							     $q->hidden(-name=>"doit", -value=>"change").
							     $q->hidden(-name=>"sessionID", -value=>$sessionID).
							     $q->hidden(-name=>"tab", -value=>$tab).
							     $q->hidden(-name=>"stab", -value=>$stab).
							     $q->hidden(-name=>"filter", -value=>$filter).
							     $q->end_form()
							     )
						      ]
						     )
					      )
				    )
			     )
		      );

    $menu->display($html);
}

sub change_pass {

    if($uid eq "" || $new_passwd eq "" || $new2_passwd eq "" || $old_passwd eq "" ) {
	$menu->display_error($message->{miss_some_values},
			     $confParam->{"cgi_path"}."/change_passwd_cyrus.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    } elsif($new_passwd ne $new2_passwd) {
	$menu->display_error($message->{new_passwds_not_equal},
			     $confParam->{"cgi_path"}."/change_passwd_cyrus.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    } elsif(length($new_passwd) < 5 || length($new_passwd) > 8) {
	$menu->display_error($message->{incorrect_passwd_length},
			     $confParam->{"cgi_path"}."/change_passwd_cyrus.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    } elsif($new_passwd !~ /^[:\/\w\d\$\%&!]+$/) {
	$menu->display_error($message->{bad_data}.":".$new_passwd,
			     $confParam->{"cgi_path"}."/change_passwd_cyrus.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }else {

	my $bind_dn = "";
	my $bind_pass = "";
	
	$bind_dn = "uid=".$uid.",".$ldapbase;
	$bind_pass = $old_passwd;

	my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);
	if(!defined $ldap) {
	    $menu->display_error("can't contact LDAP Server",
				 "/suse/menu.pl?sessionID=$sessionID\&tab=$tab");
	    exit;
	}
	
	my $mesg = $ldap->bind (   # bind to a directory with dn and password
				dn       => "$bind_dn",
				password => "$bind_pass"
			       );
	
	if($mesg->code != 0) {
	    # -- begin html-site
	    $errs = "bind $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $menu->display_error($errs,
				 "/suse/menu.pl?sessionID=$sessionID\&tab=$tab");
	    exit;
	}

	my $smbcommand1 = "/usr/bin/smbpasswd -w \'$new_passwd\' 2>&1 > /dev/null";
	my $smbcommand2 ="/usr/bin/smbpasswd root \'$new_passwd\' 2>&1 > /dev/null";

# C SCHULSERVER
#	$ldap->unbind;   # take down session - old passwd is ok
# E SCHULSERVER

	my $salt = join '', ('.', '/', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64];
	my $crypt_passwd = crypt $new_passwd,$salt;
	my $old_crypt_passwd = crypt $old_passwd,$salt;
	
	my $exit_value  = "";

        system("touch /etc/1");
# C SCHULSERVER
#	my $command = "echo \"cyrus:$crypt_passwd\" | /usr/sbin/chpasswd -e" ;
#
#	if ($command =~ /^([:\/\s\w\d.|\"-]+)$/) {
#	    $command = $1;                     # $data now untainted
#	} else {
#	    print STDERR "bad data: $command";
#	    $errs .= "$message->{bad_data}: $command";
#	    disp_msg('0');
#	    exit;
#	}
#
#	system($command);
#	my $exit_value  = $? >> 8;
#
#	if($exit_value != 0) {
#	    # error
#	    $errs = "$message->{change_pw_failed}: File /etc/shadow: $exit_value\n";
#	    disp_msg('0');
#	    exit;
#	}	
# E SCHULSERVER
	
	$crypt_passwd = "{crypt}".$crypt_passwd;

	# -- oeffnen zum lesen UND schreiben
	if(open (SLDC,"+</etc/openldap/slapd.conf")) {
	    my @file = ();
	    
	    while(<SLDC>) {
		chomp;
		if($_ =~ /^rootpw\s*\{crypt\}/) {
		    push @file, "rootpw\t\t$crypt_passwd\n";
		} else {
		    push @file, $_;
	    }	
	    }
	    
	    # -- Dateilnge auf 0 setzen
	    truncate(SLDC,0);
	    
	    # -- An Dateianfang positionieren
	    seek(SLDC,0,0);
	    
	    # -- Neue Werte schreiben
	    foreach (@file) {
		print SLDC "$_\n";
	    }
	    
	    # -- neue Dateilnge richtig setzen
	    truncate(SLDC,tell(SLDC));
	    
	    if(!close(SLDC)) {
		# error
		$errs  .=  "$message->{close_failed}:/etc/openldap/slapd.conf: $!\n";
		disp_msg('0');
	    }
	    
	} else {
	    # error do revoke
	    my $open_err = $!;

#	    my $revokec = "echo \"cyrus:$old_crypt_passwd\" | /usr/sbin/chpasswd -e" ;
	    
#	    if ($revokec =~ /^([:\/\s\w\d.|\"-]+)$/) {
#		$revokec = $1;                     # $data now untainted
#	    } else {
#		print STDERR "bad data: $revokec";
#		$errs .= "$message->{bad_data}: $revokec";
#		disp_msg('0');
#		exit;
#	    }
#	    
#	    system($revokec);
		$errs .= "$message->{open_failed}:/etc/openldap/slapd.conf: $open_err\n $message->{revoke_failed}: $!\n";
	    disp_msg('0');
	    exit;
	} 

# I SCHULSERVER 
# Setzten des Admin Passwortes fr mysql:
	$command = "echo grant all on phpgroupware.* to cyrus identified by \\\'\'$new_passwd\'\\\' | /usr/bin/mysql -u root -p\'$old_passwd\'";
	system($command);
	$exit_value  = $? >> 8;
        $command = "mysqladmin password \'$new_passwd\' -p\'$old_passwd\'";
	system($command);
	$exit_value  = $? >> 8;
	$command = "echo update phpgw_config set config_value=\\\'\'$new_passwd\'\\\' where config_name=\\\'ldap_contact_pw\\\' | /usr/bin/mysql -p\'$new_passwd\' phpgroupware";
	system($command);
	$exit_value  = $? >> 8;
	$command = "echo update phpgw_config set config_value=\\\'\'$new_passwd\'\\\' where config_name=\\\'ldap_root_pw\\\' | /usr/bin/mysql -p\'$new_passwd\' phpgroupware";
	system($command);
	$exit_value  = $? >> 8;
	$new_passwd =~ s/\$/\\\$/g; $old_passwd =~ s/\$/\\\$/g; 
	$new_passwd =~ s/\%/\\\%/g; $old_passwd =~ s/\%/\\\%/g; 
	$new_passwd =~ s/\&/\\\&/g; $old_passwd =~ s/\&/\\\&/g; 
	$new_passwd =~ s/\^/\\\^/g; $old_passwd =~ s/\^/\\\^/g; 
	$new_passwd =~ s/\//\\\//g; $old_passwd =~ s/\//\\\//g; 
	$command = "/usr/bin/perl -pi -e \'s/$old_passwd/$new_passwd/g\' /srv/inc/header.inc.php";
	system($command);
# E SCHULSERVER 


# I SCHULSERVER 
# Setzten des Passwortes fr mailadmin und cyrus in der LDAP-Datenbank
	$mesg = $ldap->modify( "uid=cyrus,$ldapbase",     replace => { userpassword => $crypt_passwd });
	$mesg = $ldap->modify( "uid=mailadmin,$ldapbase", replace => { userpassword => $crypt_passwd });
# E SCHULSERVER 
	$ldap->unbind;   # take down session

	# starte LDAP-Server neu
	$command = 'rcldap restart 2>&1 > /dev/null' ;
	#$command = 'rcldap stop 2>&1 > /dev/null; sleep 3; rcldap start 2>&1 > /dev/null' ;

	if ($command =~ /^([\s\w21\&\>\/;]+)$/) {
	    $command = $1;                     # $data now untainted
	} else {
	    print STDERR "bad data: $command";
	    $errs .= "$message->{bad_data}: $command";
	    disp_msg('0');
	    exit;
	}

	system($command);
	$exit_value  = $? >> 8;

	if($exit_value != 0) {
	    # error
	    $errs = "$message->{restart_ldap_failed}: $exit_value\n";
	    disp_msg('0');
	    exit;
	}	

	$mesg = ($session->modify( { passwd => "$new_passwd" } ))->code();
	disp_msg($mesg);

#	}
# E SCHULSERVER
	system($smbcommand1);
	my $exit_value  = $? >> 8;
	
	if($exit_value != 0) {
	    # error
	    $errs = "$message->{change_pw_failed}: smbpasswd -w : $exit_value\n";
	    disp_msg('0');
	    exit;
	}	

	system($smbcommand2);
	my $exit_value  = $? >> 8;
	
	if($exit_value != 0) {
	    # error
	    $errs = "$message->{change_pw_failed}: smbpasswd root : $exit_value\n";
	    disp_msg('0');
	    exit;
	}	

	exit;
    }
}

sub disp_msg($) {
    my $mesg = shift;
    if($mesg ne "0") {
	if($mesg eq "OK") {
	    $menu->display_msg("$message->{change_passwd_txt} $message->{success}",
				 "/suse/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab".
				 "&filter=$filter&filtered=1",
				 2);
	} else {
	    $menu->display_error($message->{write2session_failed},
				 "/suse/menu.pl?sessionID=$sessionID\&tab=$tab");
	}
    } else {
	$menu->display_error($errs,
			     "/suse/menu.pl?sessionID=$sessionID\&tab=$tab");
    }
}

