#!/usr/bin/suidperl
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: creadel_ServCert.pl,v 1.1.1.1 2003/03/25 10:31:47 ray Exp $
# 

BEGIN {
    use POSIX;
    push @INC,"/srv/www/lib";
    $ENV{"PATH"}="/bin:/sbin:/usr/bin:/usr/sbin";
    $ENV{"HOME"}="/root";
    my $x = (getpwnam("root"))[2];
    my $y = getgrnam("root");
    setuid($x);
    setgid($y);
    undef $x;
    undef $y;
}

use strict;
use openssl;
use Display;
use Session;
use CGI qw(-no_xhtml);
#use CGI::Carp qw(fatalsToBrowser);
use File::Copy "cp";
use IPC::Open2;
use Net::LDAP qw(:all);
use Net::Domain;
use Digest::MD5  qw(md5_hex);
use Utils qw(%CONF_GLOBAL $lmsg);

&Utils::read_LangINI || die;
&Utils::read_Config || die;

my $q = new CGI;
$q->autoEscape(undef);

my $sessionID = $q->param('sessionID');    

my $session = Session->new();
my $confParam = ($session->load($sessionID))->data();
my $message;

my $menu = new Display($q, $session);

if(! defined $confParam) {
    print $q->header(-refresh=>"0; URL=".$session->cgi_path."/login.pl");
    print $q->start_html(-title=>"");
    print $q->end_html;
    exit;
} else {
    $message = ($session->getLanguage($confParam->{LANG},"CREADEL_CA"))->data();
}

if ($confParam->{uid} ne "cyrus") {
    $menu->display_error($message->{access_denied},
			 "/suse/menu.pl?sessionID=$sessionID");
    exit;
} 

# ==================

my $doit = $q->param('doit') || '';;
my $tab  = $q->param('tab') || 'sec';
my $stab = $q->param('stab') || 'ca';

my $dir           = "/etc/ssl";
my $cert_dir      = $dir."/certs";
my $CA_collection = $dir."/CA";
my $newcerts      = $dir."/newcerts";
my $CA_derForm    = "/srv/www/cacert.der";
my $crl_dir       = $dir."/crl";

my $HTML = "";

if($doit eq "delCert") {
    delcert();
} else {
    startup();
}

exit;

sub startup {
    $q->delete('doit');
    if (!(-s "$cert_dir/cert.pem")) {
	# Frage: Zertifikat erstellen?

	$HTML .= $q->table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"},
			   $q->Tr({},
				  $q->td({}, 
					 $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
						   $q->Tr({},
							  $menu->help_th(2, "$message->{new_servercert}",
									 "CREADEL_CA")
							 ),
						   $q->Tr({},
							  $q->td({-colspan=>"2",
								  -align=>"center"},
								 $message->{ask_import})
							 ),
						   $q->Tr({},
							  $q->td({
								  -valign=>"center",
								  -align=>"center"},
								 $q->start_form(-action=>"$confParam->{cgi_path}/import_ServCert.pl",
										-method=>"post").
								 $q->hidden(-name=>"sessionID",
									    -value=>"$sessionID").
								 $q->hidden(-name=>"tab",
									    -value=>"$tab").
								 $q->hidden(-name=>"stab",
									    -value=>"$stab").
								 $q->submit(-class=>"button",-value=>"$message->{import}").
								 $q->end_form()
								),
							  $q->td({
								  -valign=>"center",
								  -align=>"center"},
								 $q->start_form(-action=>"$confParam->{cgi_path}/create_own_ServCert.pl",
										-method=>"post").
								 $q->hidden(-name=>"sessionID",
									    -value=>"$sessionID").
								 $q->hidden(-name=>"tab",
									    -value=>"$tab").
								 $q->hidden(-name=>"stab",
									    -value=>"$stab").
								 $q->submit(-class=>"button",-value=>"$message->{create_own}").
								 $q->end_form()
								)
							 )
						  )
					)
				 )
			  );
	
	$menu->display($HTML);

    } else {
	# Frage: Zertifikat lschen?

	my $is_self_signed = 1; #yes

	my $sslon = 0;
	open(IN, "/usr/bin/grep \"^HTTPD_SEC_MOD_SSL.*yes\" /etc/sysconfig/apache |");
	my @hp = <IN>;
	close(IN);
	
	if( $#hp >= 0 ) {
	    $sslon++;
	}
	
	open(IN, "/usr/bin/grep \"^SSLEngine[[:space:]]\\+on\" /etc/httpd/httpd.conf |");
	my @hp = <IN>;
	close(IN);
	
	if( $#hp >= 0 ) {
	    $sslon++;
	}
	
	if( $sslon == 2 ) {
	    $menu->display_error($message->{warn_exist_CA} ,
				 "/suse/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=ssl");
	    exit;
	}

	#-- have we a selfsigned CA?
	if (-s "$CA_collection/ownCA.pem") {

	    if( ! open(IN1, "<$CA_collection/usedCA.pem") ) {
		$menu->display_error("can't open file $CA_collection/usedCA.pem: $!",
				     "/suse/menu.pl?sessionID=$sessionID");
		exit;
	    }

	    my @used = <IN1>;
	    if( ! open(IN2, "<$CA_collection/ownCA.pem") ) {
		$menu->display_error("can't open file $CA_collection/ownCA.pem: $!",
				     "/suse/menu.pl?sessionID=$sessionID");
		exit;
	    }

	    my @own = <IN2>;
	    close IN1;
	    close IN2;
	
	    if( md5_hex(@own) ne md5_hex(@used) ) {
		$is_self_signed = 0; #no
	    }
	    #for(my $j = 0; $j <= @used; $j++) {
		#if($used[$j] ne $own[$j]) {
		 #   $is_self_signed = 0; #no
		#}
	    #}
	} else {
	    $is_self_signed = 0; #no
	}
	

	$HTML .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
	$HTML .= $q->start_Tr({});
	$HTML .= $q->start_td({});
	$HTML .= $q->start_table({ -cellspacing=>0, -cellpadding=>3, -width=>"100%"});
	$HTML .= $q->start_form(-action=>"$confParam->{cgi_path}/creadel_ServCert.pl",
				-method=>"post");
	$HTML .= $q->Tr({},
			$menu->help_th(2,
				       $message->{delete_head}, 
				       "DELCA"),
		       );
	$HTML .= $q->Tr({},
			$q->td({-class=>'AdminSubHeaderRed', -colspan=>2},
			       "$message->{warn_delete_ServCert}")
		       );
	if($is_self_signed) {
	    $HTML .= $q->Tr(
			    $q->td({
				    -align=>"center"},
				   "$message->{pem}"),
			    $q->td({
				    -align=>"center"},
				   $q->password_field(-name=>"CApasswd",
						      -value=>""))
			   );
	}

	$HTML .= $q->hidden(-name=>"is_self_signed",	
			    -value=>"$is_self_signed",
			    -override=>1);

	$HTML .= $q->Tr({},
			$q->td({
				-align=>"center",
				-colspan=>2},
			       $q->hidden(-name=>"sessionID",
					  -value=>"$sessionID"
					 ),
			       $q->hidden(-name=>"doit",
					  -value=>"delCert"
					 ),
			       $q->submit(-class=>"button",-value=>"$message->{delete_button}"),
			       $q->end_form()
			      )
		       );
	$HTML .= $q->end_table();
	$HTML .= $q->end_td();
	$HTML .= $q->end_Tr();
	$HTML .= $q->end_table();
	$menu->display($HTML);
    }
}

sub delcert {
    my $text = "";
    my $passwd = $q->param('CApasswd');
    my $is_self_signed = $q->param('is_self_signed');

    if($is_self_signed) {
	my $msg = revoke_ServCert($passwd);
	
	if($msg ne "") {
	    $menu->display_error(
				 "Server Certificate: ".$message->{warn_ldap_remove}." ".$msg,
				 "/suse/menu.pl?sessionID=$sessionID&tab=$tab");
	    exit;
	} else {	
	    $text .= "$message->{del_cert}: Server Certificate ok\n";
	    $menu->display_msg($text,
			       "/suse/menu.pl?sessionID=$sessionID&tab=$tab");
	    exit;
	    
	}
    } else {
	my $ret = "";
	unlink("$cert_dir/cert.pem") or $ret .= "can't remove cert.pem: $!\n";
	unlink("$cert_dir/skey.pem") or $ret .= "can't remove skey.pem: $!\n";
	unlink("$CA_collection/usedCA.pem") or $ret .= "can't remove usedCA.pem: $!\n";
	unlink("$CA_derForm") or $ret .= "can't remove cacert.der: $!\n";

	if($ret ne "") {
	    $menu->display_error("$ret",
				 "/suse/menu.pl?sessionID=$sessionID&tab=$tab");
	    exit
	} else {	
	    $ret .= "$message->{del_cert}: Server Certificate ok\n";
	    $menu->display_msg($ret, "/suse/menu.pl?sessionID=$sessionID&tab=$tab");
	}
    }
    exit;
}
