#!/usr/bin/suidperl
#
# Copyright (c) 2000-2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: creadel_usercert.pl,v 1.3 2003/10/29 10:35:38 varkoly Exp $
#

BEGIN {
    use POSIX;
    push @INC,"/srv/www/lib";
    $ENV{"PATH"}="/bin:/sbin:/usr/bin:/usr/sbin";
    $ENV{"HOME"}="/root";
    my $x = (getpwnam("root"))[2];
    my $y = getgrnam("root");
    setuid($x);
    setgid($y);
    undef $x;
    undef $y;
}	

use openssl;
use Display;
use Session;

use CGI qw/:standard *table/;
use Encode;
#use CGI::Carp qw(fatalsToBrowser);
use strict;
use File::Copy 'cp';
use IPC::Open2;
use Net::LDAP qw(:all);
use vars qw($message $confParam);
use Utils qw(%CONF_GLOBAL $lmsg);

&Utils::read_LangINI || die;
&Utils::read_Config || die;

my $cgi = new CGI;


my $sessionID = $cgi->param('sessionID');

my $session = Session->new();
$confParam = ($session->load($sessionID))->data();
my $message;

my $menu = new Display($cgi, $session);

if(! defined $confParam) {
    print $cgi->header(-refresh=>"0; URL=".$session->cgi_path."/login.pl");
    print $cgi->start_html(-title=>"");
    print $cgi->end_html;
    exit;
} else {
    $message = ($session->getLanguage($confParam->{LANG},"CREADEL_USERCERT"))->data();
}

if ($confParam->{uid} ne "cyrus") {
    $menu->display_error($message->{access_denied},
			 "/suse/menu.pl?sessionID=$sessionID");
    exit;
} 

my $startpage=$confParam->{cgi_path}."browse_user.pl";

my $dir           = "/etc/ssl";
my $cert_dir      = $dir."/certs";
my $CA_collection = $dir."/CA";
my $newcerts      = $dir."/newcerts";
my $crl_dir       = $dir."/crl";
my $HTML = "";
my $tab  = $cgi->param('tab')  || 'user';
my $stab = $cgi->param('stab') || 'edit';

my $filter    = $cgi->param('filter');
my $usr       = $cgi->param('USER');

my $ldaphost=$confParam->{LDAPserver};
if ($ldaphost =~ /^([-\@\w.]+)$/) {
    $ldaphost = $1;                     # $data now untainted
} else {
    $menu->display_error("Bad data in $ldaphost",
			 "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab",
			 3);
    exit;
}

my $ldap = Net::LDAP->new($ldaphost, port => $confParam->{LDAPport}, version => 3);
if( ! defined $ldap ) {
    $menu->display_error("couldn't connect to LDAP server",
			 "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab",
			 3);
    exit;
}

my $ret = $ldap->bind (dn=>"uid=".$confParam->{uid}.", ".$confParam->{baseDN}, 
		       password=>$confParam->{passwd});
if( $ret->code != 0 ) {
    $menu->display_error("unable to bind to LDAP server",
			 "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab",
			 3);
    exit;
}


if(!defined $usr || $usr eq "" || $usr eq "0") {
    $menu->display_error($message->{select_user},
			 "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab",
			 3);
    exit;
}

if (!(-s "$CA_collection/ownCA.pem")) {
    display_no_ca();
    exit;
} else {
    if (!defined($cgi->param("action")) or $cgi->param("action") eq "start") {
	&creadel_usercert();
	exit 0;
  } elsif ($cgi->param("action") eq "create") {
      &create_usercert();
      exit 0;
  } elsif ($cgi->param("action") eq "delete") {
      &delete_usercert();
      exit 0;
  }
}

exit;

#
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# create/delete userCA
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#

sub creadel_usercert {

    my $user=$cgi->param("USER");       #parameter from Form
    my $exist;				#temporary variable (existence of an entry in LDAP)
    my $entry;				#hash of the entry
    my $default;			#hash of the default entry
    my $attr;				#single attributes of the entry

    my ($def_l,$def_st,$def_c,$def_o,$def_ou);

my $JavaScript=<<EOF;
    function open_help_win( win_location ) {
        parem='width=540,height=500,directories=no,menubar=no,toolbar=no,resizable=yes';   contacts_window=window.open(win_location, 'ImapHelpWin', parem);
        if (!contacts_window.opener) contacts_window.opener=self;
    }
    function close_help_win() {
        document.all['ImapHelpWin'].close();
    }
EOF

    if (!defined $user) {
      $user=shift;
    }

    #-- check if the CA is selfsigned

    if( ! open(IN1, "<$CA_collection/usedCA.pem") ) {
	$menu->display_error("can't open file $CA_collection/usedCA.pem: $!",
			     "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab&filtered=1",
			     3);
	exit;
    }
    my @used = <IN1>;

    if( ! open(IN2, "<$CA_collection/ownCA.pem") ) {
	$menu->display_error("can't open file $CA_collection/ownCA.pem: $!",
			     "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab&filtered=1",
			     3);
	exit;
    }
    my @own = <IN2>;
    close IN1;
    close IN2;

    for(my $j = 0; $j <= @used; $j++) {
	if($used[$j] ne $own[$j]) {
	    display_no_ca();
	    exit;
	}
    }

    $exist = $ldap->search(base=>"uid=$user,".$confParam->{baseDN},
			   scope  => "base",
			   filter=>"userpkcs12=*");

    if ($exist->count == 0) {
	#create form
	$exist = $ldap->search(base=>$confParam->{baseDN},
			       scope  => "one",
			       attrs => ['cn', 'l', 'st', 'mail',
					 'o', 'ou', 'c'],
			       filter=>"uid=cyrus");
	
	if($exist->code != 0) {
	    display_error($cgi,
			  &LDAPerror($exist),
			  "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab&filtered=1");
	    exit;
	}
	
	$default = $exist->entry(0); #cyrus entry
	
	$exist = $ldap->search(base=>"uid=$user,".$confParam->{baseDN},
			       scope  => "base",
			       attrs => ['cn', 'l', 'st', 'mail',
					 'o', 'ou', 'c'],
			       filter=>"uid=$user");
	if($exist->code != 0) {
	    display_error($cgi,&LDAPerror($exist),
			  "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab&filtered=1");
	    exit;
	}
	
	$entry = $exist->entry(0); #user entry
	
	if ($entry->get_value("l")) {
	    $def_l=$entry->get_value('l');
	} elsif ($default->get_value("l")) {
	    $def_l=$default->get_value('l');
	} else {
	    $def_l='';
	}
	Encode::from_to($def_l  , "utf8", "iso-8859-15");
	
	if ($entry->get_value("st")) {
	    $def_st=$entry->get_value('st');
	} elsif ($default->get_value("st")) {
	    $def_st=$default->get_value('st');
	} else {
	    $def_st='';
	}
	Encode::from_to($def_st  , "utf8", "iso-8859-15");
	
	if ($entry->get_value('c')) {
	    $def_c=$entry->get_value('c');
	} elsif ($default->get_value('c')) {
	    $def_c=$default->get_value('c');
	} else {
	    $def_c='';
	}
	
	if ($entry->get_value("o")) {
	    $def_o=$entry->get_value('o');
	} elsif ($default->get_value("o")) {
	    $def_o=$default->get_value('o');
	} else {
	    $def_o='';
	}
	Encode::from_to($def_o  , "utf8", "iso-8859-15");
	
	if ($entry->get_value("ou")) {
	    $def_ou=$entry->get_value('ou');
	} elsif ($default->get_value("ou")) {
	    $def_ou=$default->get_value('ou');
	} else {
	    $def_ou='';
	}
	Encode::from_to($def_ou  , "utf8", "iso-8859-15");

	my $cn = join(" ",$entry->get_value("cn"));
	Encode::from_to($cn  , "utf8", "iso-8859-15");

	$HTML .= $cgi->start_multipart_form(-name=>"form");
        $HTML .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
	$HTML .= $cgi->start_Tr();
	$HTML .= $cgi->start_td();
	$HTML .= $cgi->table({-cellspacing=>0, -cellpadding=>3, width=>"100%"},
			     $cgi->Tr({},
				      $menu->help_th(2, $message->{create}, "CREACERT")
				     ),
			     Tr({},	
				td({-class=>'AdminSubHeader', -colspan=>2},
				   $message->{creawarn})
			       ),
			     Tr({},
				td({-width=>"50%"},
				   $message->{user}.": "),
				td({-width=>"50%"},
				   "$user"),
			       ),
			     Tr({},
				td($message->{cn}.": "),
				td(
				   $cgi->textfield(-name=>"CN",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 30,
						   -value     => $cn ))
			       ),	
			     Tr({},
				td($message->{pem}.": "),
				td(
				   $cgi->password_field(-name=>"PEM",
							-size      => 30,
							-maxlength => 30))
			       ),
			     Tr({},
				td($message->{challenge}.": "),
				td(
				   $cgi->password_field(-name=>"PASSWD",
							-size      => 30,
							-maxlength => 30))
			       ),
			     Tr({},
				td($message->{verify}.": "),
				td(
				   $cgi->password_field(-name=>"PASSWD2",
							-size      => 30,
							-maxlength => 30))
			       ),
			     Tr({},
				td(
				   $message->{locality}.": ".$message->{optional}),
				td(
				   $cgi->textfield(-name=>"LOCAL",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 30,
						   -value     => $def_l))
			       ),	
			     Tr({},
				td(
				   $message->{state}.": ".$message->{optional}),
				td(
				   $cgi->textfield(-name=>"STATE",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 30,
						   -value     => $def_st))
			       ),
			     Tr({},
				td(
				   $message->{country}.": ".$message->{optional}),
				td(
				   $cgi->textfield(-name=>"c",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 2,
						   -value     => $def_c),
				   $cgi->a({-href=>"javascript:void(0);",
					  -onclick=>"$JavaScript; open_help_win('/suse/country_codes.pl?sessionID=$sessionID')"},
					 $cgi->img({-border=>0,
						  -src=>"$confParam->{image_path}/help1.gif",
						  -width=>18,
						  -height=>18,
						  -alt=>"Help"
						 })
					)
				  )
			       ),
			     Tr({},
				td(
				   $message->{email}.": ".$message->{optional}),
				td(
				   $cgi->textfield(-name=>"EMAIL",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 30,
						   -value     => join("",$entry->get_value("mail"))
						  ))
			       ),
			     Tr({},
				td(
				   $message->{org}.": ".$message->{optional}),
				td(
				   $cgi->textfield(-name=>"ORG",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 30,
						   -value     => $def_o))
			       ),
			     Tr({},
				td(
				   $message->{orgu}.": ".$message->{optional}),
				td(
				   $cgi->textfield(-name=>"ORGU",
						   -override  => 0,
						   -size      => 30,
						   -maxlength => 30,
						   -value     => $def_ou))
			       ),
			     Tr({},
				td({-colspan=>2,  -align=>"center"},
				   $cgi->submit(-class=>"button",-name=>"usercrea", -value=>$message->{sign}).
				   $cgi->hidden(-name=>"filter", -value=>$filter).
				   $cgi->hidden(-name=>"action", -value=>"create").
				   $cgi->hidden(-name=>"uid", -value=>"$user").
				   $cgi->hidden(-name=>"USER", -value=>"$usr").
				   $cgi->hidden(-name=>"sessionID", -value=>"$sessionID").
				   $cgi->end_form()
				   )
			       )
			    );
	$HTML .= $cgi->end_td();
	$HTML .= $cgi->end_Tr();
	$HTML .= $cgi->end_table();
    } else {

#delete form
        $HTML .= $cgi->start_table({-border=>0, -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
	$HTML .= $cgi->start_Tr();
	$HTML .= $cgi->start_td();
	$HTML .= $cgi->start_form(-method=>"get",
				  -action=>$confParam->{cgi_path}."/creadel_usercert.pl");

	$HTML .= $cgi->start_table({-border=>0, -cellspacing=>0, -cellpadding=>5, -width=>"100%"});
	$HTML .= $cgi->Tr({},
		       $menu->help_th(4, $message->{delete}, "DELCERT")
		       );
	$HTML .= $cgi->Tr({},
			  td({-class=>'AdminSubHeader', -colspan=>4},
			     $message->{delwarn})
		       );
	
	$entry = $exist->entry(0); #user entry
	foreach my $attr ($entry->attributes) {
	    if ($attr=~/^(uid|cn)\Z/i) {
		my $utf8attr = join(", ",$entry->get_value($attr));
		Encode::from_to($utf8attr , "utf8", "iso-8859-15");
		$HTML .= $cgi->Tr({},
				  td({ -align=>"left", -colspan=>2},
				     $message->{$attr}),
				  td({ -align=>"left", -colspan=>2},
				     $utf8attr)
				  );
		if ($attr eq "uid") {
		    $HTML .= $cgi->hidden(-name=>$attr, -value=>join(", ",$entry->get_value($attr)));
		}
	    }
	}
	$HTML .= Tr(
		 td({ -align=>"left", -colspan=>2},
		    "$message->{pem}"),
		 td({ -align=>"left", -colspan=>2},
		    $cgi->password_field(-name=>"CApassword",
					 -value=>""))
		 );
	$HTML .= Tr(
		    td({ -align=>"center", -colspan=>4},
		       $cgi->submit(-class=>"button",-name=>"userdel", -value=>$message->{del_button}).
		       $cgi->hidden(-name=>"filter", -value=>"$filter").
		       $cgi->hidden(-name=>"action", -value=>"delete").
		       $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
		       $cgi->hidden(-name=>"USER", -value=>$user).
		       $cgi->end_form()
		      )
		   );
	$HTML .= $cgi->end_table();
	$HTML .= $cgi->end_td();
	$HTML .= $cgi->end_Tr();
	$HTML .= $cgi->end_table();
    }

    $menu->back_url("/suse/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter\&filtered=1");
    $menu->display($HTML);
    return 0;
}

#
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# create
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
sub create_usercert {

    my $pempass	= $cgi->param('PEM');
    my $passwd  = $cgi->param('PASSWD');
    my $passwd2 = $cgi->param('PASSWD2');
    my $country = $cgi->param('c');
    my $state   = $cgi->param('STATE');
    my $local   = $cgi->param('LOCAL');
    my $org     = $cgi->param('ORG');
    my $orgu    = $cgi->param('ORGU');
    my $cn      = $cgi->param('CN');
    my $email   = $cgi->param('EMAIL');

    my $user	= $cgi->param('uid');

    my $exist;
    my $fingerprint = "";
    my $msg = "";

    if ((! defined($cn)) or ($cn eq '')) {
	quit($message->{warn_no_cn});
    }

    if ((! defined($pempass)) or ($pempass eq '')) {
	quit($message->{warn_no_pem});
    }

    if  (($passwd eq '') or ($passwd ne $passwd2)) {
	quit($message->{warn_no_pass});
    }

#  #create reqest
    
    my $ret = create_ureq($cn, $passwd, $country, $state, $local, $org, $orgu, $email);
    if($ret ne "0") {
	quit($ret);
    }

  #sign request
    while (-z "$cert_dir/newreq.pem" || -z "$cert_dir/newreq.der" ) {
    }

    $ret = sign_ureq("client_cert", $pempass);
    if($ret ne "0") {
	quit($ret);
    }

    $ret = cert2pkcs12($passwd);
    if($ret ne "0") {
	quit($ret);
    }

#  #create PKCS12
    while (-z "$cert_dir/newcert.p12")
      { }

  #create fingerprint

    ($ret, $fingerprint) = create_fingerprint();
    if($ret ne "0") {
	quit($ret);
    }

    $msg = $ldap->modify("uid=$user, ".$confParam->{baseDN},
			 add=>{ relayClientcert => $fingerprint } );
    if ($msg->code != 0) {
	quit($message->{warn_ldap_add}." (relayClientcert): ".$msg->error);
    }

  #create LDAP entries
    $exist = $ldap->search(base=>"uid=$user,".$confParam->{baseDN},
			   scope  => "base",
			   attrs => ['uid'],
			   filter=>"objectclass=organizationalPerson");
    if ($exist->count == 0) {
	$msg = $ldap->modify("uid=$user,".$confParam->{baseDN},
			     add=>{objectclass=>"organizationalPerson"});
	if ($msg->code != 0 ) {
	    quit($message->{warn_ldap_add}." (organizationalPerson): ".$msg->error);
	}
    }
    
    $exist = $ldap->search(base=>"uid=$user,".$confParam->{baseDN},
			   scope  => "base",
			   attrs => ['uid'],
			   filter=>"objectclass=inetOrgPerson");
    if ($exist->count == 0) {
	$msg = $ldap->modify("uid=$user,".$confParam->{baseDN}, 
			     add=>{objectclass=>"inetOrgPerson"});
	if ($msg->code != 0) {
	    quit($message->{warn_ldap_add}." (inetOrgPerson)".$msg->error);
	}
    }
    
    open (OUT,"<$cert_dir/newcert.p12") or quit($message->{warn_file}." (PKCS12)");
    my $i='';
    while (<OUT>) {
	$i.=$_ or &quit($message->{warn_file}." (PKCS12)");
    }
    close (OUT);
    if (! defined ($i)) {
	&quit($message->{warn_pkcs_file});
    }
    
    $msg = $ldap->modify("uid=$user, ".$confParam->{baseDN},
			     add=>{"userPKCS12"=>$i} );
    if ($msg->code != 0) {
	quit($message->{warn_ldap_add}." (userPKCS12): ".$msg->error);
    }

    # convert to DER format, because userCertificate;binary should not use
    # an ascii representation of the certificate
    open (IN,"/usr/bin/openssl x509 -in $cert_dir/newcert.pem -inform PEM -outform DER|") or quit($message->{warn_file}." (newcert)");
    my $client_cert = "";
    while( <IN> ) {
	$client_cert .= $_;
    }
    close IN;

    $msg = $ldap->modify("uid=$user, ".$confParam->{baseDN},
			 add=>{ 'userCertificate;binary' => $client_cert } );
    if ($msg->code != 0) {
	$ldap->modify("uid=$user, ".$confParam->{baseDN},
		      changes => [
				  delete => [ userPKCS12 => [] ],
				  delete => [ relayClientcert => [] ]
				  ]);
	quit($message->{warn_ldap_add}." (userCertificate): ".$msg->error);
    }

    unlink("$cert_dir/newreq.pem");
    unlink("$cert_dir/newcert.pem");
    unlink("$cert_dir/newcert.p12");

    $menu->display_msg("$message->{succ_completed}", 
		       "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab&stab=$stab&filtered=1");
}


#
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# delete
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
sub delete_usercert {
    my $user = $cgi->param('uid');
    my $passwd  = $cgi->param('CApassword');

    my $msg = revoke_usercert($user, $passwd, $ldap);

    if($msg eq "") {
	$menu->display_msg($message->{succ_completed},
			   "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab\&stab=$stab&filtered=1");
	exit;
    } else {
	$menu->display_error($msg,
			     "/suse/browse_user.pl?sessionID=$sessionID\&filter=$filter\&tab=$tab\&stab=$stab&filtered=1");
	exit;
    }	
}


#
#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# Subroutines
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#

sub quit {
    my $msg=shift;

    unlink("$cert_dir/newreq.pem");
    unlink("$cert_dir/newcert.pem");
    unlink("$cert_dir/newcert.p12");
    
    $menu->display_error($msg,
			 "/suse/browse_user.pl?tab=$tab\&stab=$stab\&sessionID=$sessionID\&filter=$filter&filtered=1");
    exit;
} 

sub display_no_ca {
    $menu->back_url("/suse/browse_user.pl?tab=$tab\&stab=$stab\&sessionID=$sessionID\&filter=$filter&filtered=1");
    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$cgi->start_Tr();
    $html .=	    $cgi->start_td();
    $html .=		$cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=		    $menu->help_th(1, $message->{create}, "CREACERT");
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->start_td();
    $html .=			    $message->{"no_selfsigned_CA"};
    $html .=			$cgi->end_td();
    $html .=		    $cgi->end_Tr();
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->start_td({-align=>"center"});
    $html .=			    $cgi->a({ -href=> "/imap-bin/creadel_ServCert.pl?sessionID=$sessionID&tab=sec&stab=ca"},
					    $message->{'create_ca_now'});
    $html .=			$cgi->end_td();
    $html .=		    $cgi->end_Tr();
    $html .=		$cgi->end_table();
    $html .=	    $cgi->end_td();
    $html .=	$cgi->end_Tr();
    $html .= $cgi->end_table;
    $menu->display($html);
}
