#!/usr/bin/suidperl
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: create_own_ServCert.pl,v 1.1.1.1 2003/03/25 10:31:47 ray Exp $
# 
BEGIN {
    use POSIX;
    push @INC,"/srv/www/lib";
    $ENV{"PATH"}="/bin:/sbin:/usr/bin:/usr/sbin";
    $ENV{"HOME"}="/root";
    my $x = (getpwnam("root"))[2];
    my $y = getgrnam("root");
    setuid($x);
    setgid($y);
    undef $x;
    undef $y;
}

use strict;
use openssl;
use Display;
use Session;
use CGI qw(-no_xhtml);
#use CGI::Carp qw(fatalsToBrowser);
use File::Copy "cp";
#use IPC::Open2;
use Net::LDAP qw(:all);
use Net::Domain;
use Encode;
# C SCHULSERVER
use Utils qw(%CONF_GLOBAL $lmsg &read_rcconfig);
# E SCHULSERVER

&Utils::read_LangINI || die;
&Utils::read_Config || die;

my $q = new CGI;
$q->autoEscape(undef);

my $sessionID = $q->param('sessionID');    

my $session = Session->new();
my $confParam = ($session->load($sessionID))->data();
my $message;

my $menu = new Display($q, $session);

if(! defined $confParam) {
    print $q->header(-refresh=>"0; URL=".$session->cgi_path."/login.pl");
    print $q->start_html(-title=>"");
    print $q->end_html;
    exit;
} else {
    $message = ($session->getLanguage($confParam->{LANG},"CREADEL_CA"))->data();
}

if ($confParam->{uid} ne "cyrus") {
    $menu->display_error($message->{access_denied},
			 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
    exit;
} 

# ==================
umask(0133);

my $doit = $q->param('doit') || '';
my $tab  = $q->param('tab') || 'system';
my $stab = $q->param('stab') || 'ca';

my $dir           = "/etc/ssl";
my $cert_dir      = $dir."/certs";
my $CA_collection = $dir."/CA";
my $newcerts      = $dir."/newcerts";
my $CA_derForm    = "/srv/www/htdocs/cacert.der";
my $crl_dir       = $dir."/crl";

my $HTML = "";

if($doit eq "create_CA") {
    create_CA();
} elsif($doit eq "new_ServCert") {
    new_ServCert();
} elsif($doit eq "create_ServCert") {
    create_ServCert();
} else {
    startup();
}

1;


sub startup {
    $q->delete('doit');

    my $JavaScript=<<EOF;
    function open_help_win( win_location ) {
        parem='width=540,height=500,directories=no,menubar=no,toolbar=no,resizable=yes';   contacts_window=window.open(win_location, 'ImapHelpWin', parem);
        if (!contacts_window.opener) contacts_window.opener=self;
    }
    function close_help_win() {
        document.all['ImapHelpWin'].close();
    }
EOF

    # search for existing ownCA.pem
    if (-s "$CA_collection/ownCA.pem" && $doit ne "create_new") {

	$HTML .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
	$HTML .= $q->start_Tr({});
	$HTML .= $q->start_td({});
	
	$HTML .= $q->table({ -cellspacing=>0, -cellpadding=>3, -width=>"100%"},
			   $q->Tr({},
				  $menu->help_th(2, "$message->{create_CA}",
						 "CA_EXISTS")
				 ),
			   $q->Tr({},
				  $q->td({-colspan=>"2",
					  -class=>'AdminSubHeader'},
					 $message->{use_oldCA})
				 ),
			   $q->Tr({},
				  $q->td({
					  -align=>"center"},
					 $q->start_form(-action=>"$confParam->{cgi_path}/create_own_ServCert.pl",
							-method=>"post"),
					 $q->hidden(-name=>"tab",
						    -value=>"$tab").
					 $q->hidden(-name=>"stab",
						    -value=>"$stab").
					 $q->hidden(-name=>"sessionID",
						    -value=>"$sessionID"
						   ),
					 $q->hidden(-name=>"doit",
						    -value=>"new_ServCert"
						   ),
					 $q->submit(-class=>"button",-value=>"$message->{use_old}"),
					 $q->end_form()
					),
				  $q->td({
					  -align=>"center"},
					 $q->start_form(-action=>"$confParam->{cgi_path}/create_own_ServCert.pl",
							-method=>"post"),
					 $q->hidden(-name=>"sessionID",
						    -value=>"$sessionID"
						   ),
					 $q->hidden(-name=>"tab",
						    -value=>"$tab").
					 $q->hidden(-name=>"stab",
						    -value=>"$stab").
					 $q->hidden(-name=>"doit",
						    -value=>"create_new"
						   ),
					 $q->submit(-class=>"button",-value=>"$message->{create_new}"),
					 $q->end_form()
					)
				 )
			   );

	$HTML .= $q->end_td();
	$HTML .= $q->end_Tr();
	$HTML .= $q->end_table();
	
	$menu->display($HTML);
	exit;
    } else {

	my $warn_text = "";

	if(-s "$CA_collection/ownCA.pem") {
	    $warn_text = "<font color=#ff0000><b>$message->{warn_new_CA}</b></font>";
	} else {
	    $warn_text = $message->{creawarn};
	}

	my $ldaphost=$confParam->{LDAPserver};
	if ($ldaphost =~ /^([-\@\w.]+)$/) {
	    $ldaphost = $1;                     # $data now untainted
	} else {
	    $menu->display_error("Bad data in $ldaphost",
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
	my $ldap = Net::LDAP->new($ldaphost, port => $confParam->{LDAPport}, version => 3);
	if( ! defined $ldap ) {
	    $menu->display_error("couldn't connect to LDAP server",
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $ret = $ldap->bind (dn=>"uid=$confParam->{uid},$confParam->{baseDN}",
			       password=>$confParam->{passwd});
	if( $ret->code != 0 ) {
	    $menu->display_error("couldn't bind to LDAP server",
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}   
	
	my $exist = $ldap->search(base=>$confParam->{baseDN},
				  scope  => "one",
				  attrs => ['cn', 'l', 'st', 'o', 'ou', 'c'],
				  filter=>"uid=cyrus");
	
	if($exist->code != 0) {
	    $menu->display_error(&LDAPerror($exist),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $entry = $exist->entry(0);

# C SCHULSERVER	
	my $cn   = $entry->get_value("cn")   || '';
        Encode::from_to($cn  , "utf8", "iso-8859-2");
	my $l    = $entry->get_value("l")    || '';
        Encode::from_to($l  , "utf8", "iso-8859-2");
	my $st   = $entry->get_value("st")   || '';
        Encode::from_to($st  , "utf8", "iso-8859-2");
	my $o    = $entry->get_value("o")    || '';
        Encode::from_to($o  , "utf8", "iso-8859-2");
	my $ou   = $entry->get_value("ou")   || '';
        Encode::from_to($ou  , "utf8", "iso-8859-2");
	my $c    = $entry->get_value("c")    || '';
	my $mail = '';
# C SCHULSERVER	

	$HTML .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
	$HTML .= $q->start_Tr({});
	$HTML .= $q->start_td({});
	$HTML .= $q->start_form(-action=>"$confParam->{cgi_path}/create_own_ServCert.pl",
				-name=>"form",
				-method=>"post");
	$HTML .= $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
			   $q->Tr({},
				  $menu->help_th(2, $message->{create}, "CREACA")
				   ),
			  $q->Tr({},
				 $q->td({-class=>'AdminSubHeaderRed', -colspan=>2},$warn_text),
				 ),
			   $q->Tr({},
				  $q->td(
					"$message->{ca_name}"),
				  $q->td(
					$q->textfield(-name=>"CN",
						      -override  =>0,
						      -size      =>30,
						      -value=>"$o CA"))
				  ),
			   $q->Tr({},
				  $q->td($message->{pem}),
				  $q->td(
					 $q->password_field(-name=>"PASSWD",
							    -size=> 30))
				 ),
			   $q->Tr({},
				  $q->td($message->{verify}),
				  $q->td(
					 $q->password_field(-name=>"PASSWD2",
							    -size=> 30))
				   ),
			  $q->Tr({},
				 $q->td(
					$message->{locality}." ".$message->{optional}),
				 $q->td($q->textfield(-name=>"LOCAL",
										    -override  => 0,
										    -size      => 30,
										    -value=>$l))
				 ),
			   $q->Tr({},
				  $q->td(
					 $message->{state}." ".$message->{optional}),
				  $q->td($q->textfield(-name=>"STATE",
										     -override  => 0,
										     -size      => 30,
										     -value     =>$st))
				  ),
			   $q->Tr({},
				  $q->td(
					 $message->{country}." ".$message->{optional}),
				  $q->td(
					 $q->textfield(-name=>"c",
						       -override=>0,
						       -size=>30,
						       -maxlength=>2,
						       -value=>$c),
					 $q->a({-href=>"javascript:void(0);",
						-onclick=>"$JavaScript; open_help_win('/suse/country_codes.pl?sessionID=$sessionID')"},
					       $q->img({-border=>0,
							-src=>"$confParam->{image_path}/help1.gif",
							-width=>18,
							-height=>18,
							-alt=>"Help"
							})
					       ))
				  ),
			   $q->Tr({},
				  $q->td(
					 $message->{email}." ".$message->{optional}),
				  $q->td($q->textfield(-name=>"EMAIL",
										     -override  => 0,
										     -size      => 30,
										     -value=>$mail))
				  ),
			   $q->Tr({},
				  $q->td(
					 $message->{org}." ".$message->{optional}),
				  $q->td($q->textfield(-name=>"ORG",
									     -override=> 0,
									      -size   => 30,
									      -value=>$o))
				 ),
			   $q->Tr({},
				  $q->td(
					 $message->{orgu}." ".$message->{optional}),
				  $q->td($q->textfield(-name=>"ORGU",
									      -override=> 0,
									      -size=> 30,
									      -value=>$ou))
				 ),
			   $q->Tr({},
				  $q->td({ -colspan=>"2", -align=>"center"},
					 $q->reset(-class=>"button", -name=>" ".$message->{reset}." ").
					 "&nbsp".
					 $q->submit(-class=>"button",-value=>"$message->{next}").
					 $q->hidden(-name=>"doit", -value=>"create_CA").
					 $q->hidden(-name=>"tab",
						    -value=>"$tab").
					 $q->hidden(-name=>"stab",
						    -value=>"$stab").
					 $q->hidden(-name=>"sessionID", -value=>"$sessionID").
					 $q->end_form()
					)
				 )
			  );
	$HTML .= $q->end_td();
	$HTML .= $q->end_Tr();
	$HTML .= $q->end_table();

	$menu->display($HTML);
	exit;

    }
}

sub create_CA {
    $q->delete('doit');
    my $passwd   = $q->param("PASSWD");
    my $passwd2  = $q->param("PASSWD2");
    my $country  = $q->param("c");
    my $state    = $q->param("STATE");
    my $local    = $q->param("LOCAL");
    my $org      = $q->param("ORG");
    my $orgu     = $q->param("ORGU");
    my $cn       = $q->param("CN"); # Name of the CA
    my $email    = $q->param("EMAIL");


    if (!defined($cn) or $cn eq "") {
	$menu->display_error($message->{no_host},
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID&tab=$tab");
	exit;
    }

    if  (($passwd eq "") or ($passwd ne $passwd2)) {
	$menu->display_error($message->{no_pass},
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID&tab=$tab");
	exit;
    }

#when VPASS is not used there must be secured that the password is at least 4 characters long
    if (length($passwd) <= 4) {
	$menu->display_error($message->{short_pass},
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID&tab=$tab");
	exit;
    }

    if (! -d "$dir"."/CA") {
	if( ! mkdir ("$dir"."/CA",0777) ) {
	    $menu->display_error($message->{warn_mkdir}.": $!",
				 "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID&tab=$tab");
	    exit;
	}
    }
    if (! -d "$dir"."/private") {
	if( ! mkdir ("$dir"."/private",0777) ) {
	    $menu->display_error($message->{warn_mkdir}.": $!",
				 "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID&tab=$tab");
	    exit;
	}
    }

    my $ldaphost=$confParam->{LDAPserver};
    if ($ldaphost =~ /^([-\@\w.]+)$/) {
	$ldaphost = $1;                     # $data now untainted
    } else {
	$menu->display_error("Bad data in $ldaphost",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    my $ldap = Net::LDAP->new($ldaphost, port => $confParam->{LDAPport}, version => 3);
    if( ! defined $ldap ) {
	$menu->display_error("couldn't connect to LDAP server",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $msg = $ldap->bind (dn=>"uid=$confParam->{uid},$confParam->{baseDN}",
			   password=>$confParam->{passwd});
    if( $msg->code != 0 ) {
	$menu->display_error("couldn't bind to LDAP server",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $ret = del_all_Certs($ldap, $confParam, $message);

    $ldap->unbind();

    if($ret ne "") {
        $menu->display_error($ret,
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID&tab=$tab");
	exit;
    }

    #-----------------------------------------------------------------------------
    # create root CA

    $ret = create_selfsign_CA($cn, $passwd, $country, $state, $local, $org, $orgu, $email);
    if($ret ne "0") {
        $menu->display_error($ret,
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    my $mode = 0600;
    if( ! chmod($mode, "$dir/private/cakey.pem") ) {
	$menu->display_error("$message->{warn_chmod}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    if( ! cp ("$CA_collection/ownCA.pem", "$CA_collection/usedCA.pem") ) {
	$menu->display_error("$message->{warn_copy}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    
    new_ServCert();
    
}

sub new_ServCert {
    $q->delete('doit');
    $q->delete('PASSWD2');
    $q->delete('CN');
    my $JavaScript=<<EOF;
    function open_help_win( win_location ) {
        parem='width=540,height=500,directories=no,menubar=no,toolbar=no,resizable=yes';   contacts_window=window.open(win_location, 'ImapHelpWin', parem);
        if (!contacts_window.opener) contacts_window.opener=self;
    }
    function close_help_win() {
        document.all['ImapHelpWin'].close();
    }
EOF

    my $ldaphost=$confParam->{LDAPserver};
    if ($ldaphost =~ /^([-\@\w.]+)$/) {
	$ldaphost = $1;		# $data now untainted
    } else {
	$menu->display_error("Bad data in $ldaphost",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $ldap = Net::LDAP->new($ldaphost, port => $confParam->{LDAPport}, version => 3 );
    if( ! defined $ldap ) {
	$menu->display_error("couldn't connect to LDAP server",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $ret = $ldap->bind (dn=>"uid=$confParam->{uid},$confParam->{baseDN}",
			   password=>$confParam->{passwd});
    if( $ret->code != 0 ) {
	$menu->display_error("couldn't bind to LDAP server",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }   

    my $exist = $ldap->search(base=>$confParam->{baseDN},
			      scope  => "one",
			      attrs => ['cn', 'l', 'st', 'o', 'ou', 'c'],
			      filter=>"uid=cyrus");

    if($exist->code != 0) {
	$menu->display_error(&LDAPerror($exist),
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    my $entry = $exist->entry(0);

# C SCHULSERVER	
    my $cn   = $entry->get_value("cn")   || '';
    Encode::from_to($cn  , "utf8", "iso-8859-2");
    my $l    = $entry->get_value("l")    || '';
    Encode::from_to($l  , "utf8", "iso-8859-2");
    my $st   = $entry->get_value("st")   || '';
    Encode::from_to($st  , "utf8", "iso-8859-2");
    my $o    = $entry->get_value("o")    || '';
    Encode::from_to($o  , "utf8", "iso-8859-2");
    my $ou   = $entry->get_value("ou")   || '';
    Encode::from_to($ou  , "utf8", "iso-8859-2");
    my $c    = $entry->get_value("c")    || '';
    my $mail = '';
    my $admin = "";
    my $cf = "/etc/httpd/admin_include.conf";
    if( ! open(IN, "< $cf")) {
        $menu->display_error("$message->{apache_cfg_not_readable} $cf: $?",
                             "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    my @raw = <IN>;
    chomp(@raw);
    close(IN);
    foreach my $l ( @raw ) {
        if ( $l =~ /ServerName\s+(.*)/ ) {
            $admin = $1; 
        }
    }

# E SCHULSERVER	

    $HTML .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2,
			      -cellpadding=>0, -width=>"100%"});
    $HTML .= $q->start_Tr({});
    $HTML .= $q->start_td({});
    $HTML .= $q->start_form(-action=>"$confParam->{cgi_path}/create_own_ServCert.pl",
			    -name=>"form",
			    -method=>"post");
    $HTML .= $q->start_table({-cellspacing=>0, -cellpadding=>3, -width => "100%"});
    $HTML .= $q->Tr({},
		    $menu->help_th(3, $message->{create_ServCert}, "CREA_SERVCERT")
		   );
    $HTML .= $q->Tr({},
		    $q->td({-colspan=>3, -class=>'AdminSubHeader'},$message->{creawarn}),
		   );
#    $HTML .= $q->Tr({},
#		    $q->td({-width=>"30%"},"$message->{host}"),
#		    $q->td({-width=>"39%"},
#			   $q->textfield(-name=>"CN",
#					 -override  =>0,
#					 -size      =>30,
#					 -value=>Net::Domain::hostfqdn())),
#		    $q->td({-width=>"31%"},"<br>")
#		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{s_pem}),
		    $q->td($q->password_field(-name=>"S_PASSWD",
								     -size=> 30)),
		    $q->td("<br>")
		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{s_verify}),
		    $q->td($q->password_field(-name=>"S_PASSWD2",
								     -size=> 30)),
		    $q->td("<br>")
		   );
    if(!defined $q->param('PASSWD')) {
	$HTML .= $q->Tr({},
			$q->td($message->{pem}),
			$q->td($q->password_field(-name=>"PASSWD",
									 -size=> 30)),
			$q->td("<br>")
		       );
    } else {
	$HTML .= $q->hidden(-name=>'PASSWD', -value=>$q->param('PASSWD'));
    }	
    $HTML .= $q->Tr({},
		    $q->td($message->{locality}." ".$message->{optional}),
		    $q->td($q->textfield(-name=>"LOCAL",
								-override  => 0,
								-size      => 30,
								-value=>$l)),
		    $q->td($q->checkbox_group(-name=>"LOCAL_CH",
								     -values=>["set as default"],
								     -default=>["set as default"]))
		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{state}." ".$message->{optional}),
		    $q->td($q->textfield(-name=>"STATE",
								-override  => 0,
								-size      => 30,
								-value     =>$st)),
		    $q->td($q->checkbox_group(-name=>"STATE_CH",
								     -values=>["set as default"],
								     -default=>["set as default"]))
		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{country}." ".$message->{optional}),
		    $q->td(
			   $q->textfield(-name=>"c",
					 -override=>0,
					 -size=>30,
					 -maxlength=>2,
					 -value=>$c),
			   $q->a({-href=>"javascript:void(0);",
				  -onclick=>"$JavaScript; open_help_win('/suse/country_codes.pl?sessionID=$sessionID')"},
				 $q->img({-border=>0,
					  -src=>"$confParam->{image_path}/help1.gif",
					  -width=>18,
					  -height=>18,
					  -alt=>"Help"
					 })
				)),
		    $q->td($q->checkbox_group(-name=>"COUNTRY_CH",
								     -values=>["set as default"],
								     -default=>["set as default"]))
		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{email}." ".$message->{optional}),
		    $q->td($q->textfield(-name=>"EMAIL",
								-override  => 0,
								-size      => 30,
								-value=>$mail)),
		    $q->td("<br>")
		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{org}." ".$message->{optional}),
		    $q->td($q->textfield(-name=>"ORG",
								-override=> 0,
								-size   => 30,
								-value=>$o)),
		    $q->td($q->checkbox_group(-name=>"ORG_CH",
								     -values=>["set as default"],
								     -default=>["set as default"]))
		   );
    $HTML .= $q->Tr({},
		    $q->td($message->{orgu}." ".$message->{optional}),
		    $q->td($q->textfield(-name=>"ORGU",
								-override=> 0,
								-size=> 30,
								-value=>$ou)),
		    $q->td($q->checkbox_group(-name=>"ORGU_CH",
								     -values=>["set as default"],
								     -default=>["set as default"]))
		   );
    $HTML .= $q->Tr({},
		    $q->td({ -colspan=>"3", -align=>"center"},
			   $q->reset(-class=>"button", -name=>" ".$message->{reset}." ").
			   "&nbsp".
			   $q->submit(-class=>"button",-value=>"$message->{next}").
			   $q->hidden(-name=>"doit", -value=>"create_ServCert").
			   $q->hidden(-name=>"tab",
				      -value=>"$tab").
			   $q->hidden(-name=>"stab",
				      -value=>"$stab").
			   $q->hidden(-name=>"CN",
				      -value=>"$admin").
			   $q->hidden(-name=>"sessionID", -value=>"$sessionID")
			  )
		   );
    $HTML .= $q->end_table();
    $HTML .= $q->end_td();
    $HTML .= $q->end_Tr();
    $HTML .= $q->end_form();
    $HTML .= $q->end_table();

    $menu->display($HTML);
    exit;
}

sub create_ServCert {
    my $passwd   = $q->param("PASSWD");
    my $s_passwd  = $q->param("S_PASSWD");
    my $s_passwd2  = $q->param("S_PASSWD2");
    my $country  = $q->param("c");
    my $state    = $q->param("STATE");
    my $local    = $q->param("LOCAL");
    my $org      = $q->param("ORG");
    my $orgu     = $q->param("ORGU");
    my $cn       = $q->param("CN"); # Name of the CA
    my $email    = $q->param("EMAIL");

    my $countryCH = $q->param("COUNTRY_CH");
    my $stateCH   = $q->param("STATE_CH");
    my $localCH   = $q->param("LOCAL_CH");
    my $orgCH     = $q->param("ORG_CH");
    my $orguCH    = $q->param("ORGU_CH");

    # -- make some needed Files and Directorys

    if ( ! -d "$newcerts") {
	if( ! mkdir ("$newcerts",0777) ) {
	    $menu->display_error($message->{warn_mkdir}.": $!",
				 "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
    }
    if (! -d "$dir"."/crl") {
	if( ! mkdir ("$dir"."/crl",0777) ) {
	    $menu->display_error($message->{warn_mkdir}.": $!",
				 "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	# We need to just create it, because apache won't start, else
	open(OUT,">$crl_dir/crl.pem");
	close(OUT);
    }
    if (! -d "$dir"."/certs"){
	if( ! mkdir ("$dir"."/certs",0777) ) {
	    $menu->display_error($message->{warn_mkdir}.": $!",
				 "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
    }

    if ( ! -f "$dir/index.txt" ) {
	open(FOO, ">$dir/index.txt");
	close(FOO);
    }
    if ( -f "$cert_dir"."/skey.pem") {
	unlink("$cert_dir"."/skey.pem");
    }
    if ( -f "$cert_dir"."/cert.pem") {
	unlink("$cert_dir"."/cert.pem");
    }

    if( ! cp ("$CA_collection/ownCA.pem", "$CA_collection/usedCA.pem") ) {
	$menu->display_error("$message->{warn_copy}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    if (!defined($cn) or $cn eq "") {
	$menu->display_error($message->{no_host},
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    
    if  (($passwd eq "") or ($s_passwd eq "") or ($s_passwd ne $s_passwd2)) {
	$menu->display_error($message->{no_pass}, 
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

#when VPASS is not used there must be secured that the password is at least 4 characters long
    if (length($passwd) <= 4) {
	$menu->display_error($message->{short_pass},
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    # -- save defaults
    my $ldaphost=$confParam->{LDAPserver};
    if ($ldaphost =~ /^([-\@\w.]+)$/) {
	$ldaphost = $1;                     # $data now untainted
    } else {
	$menu->display_error("Bad data in $ldaphost",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    my $ldap = Net::LDAP->new($ldaphost, port => $confParam->{LDAPport}, version => 3);
    if( ! defined $ldap ) {
	$menu->display_error("couldn't connect to LDAP server",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $ret = $ldap->bind (dn=>"uid=$confParam->{uid},$confParam->{baseDN}",
			   password=>$confParam->{passwd});
    if( $ret->code != 0 ) {
	$menu->display_error("couldn't bind to LDAP server",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }   

# C SCHULSERVER
    Encode::from_to($country , "iso-8859-2", "utf8");
    Encode::from_to($state , "iso-8859-2", "utf8");
    Encode::from_to($org , "iso-8859-2", "utf8");
    Encode::from_to($orgu , "iso-8859-2", "utf8");
    Encode::from_to($local , "iso-8859-2", "utf8");
# E SCHULSERVER

    $ret = $ldap->modify("uid=cyrus,$confParam->{baseDN}",
			 changes => [
				     replace => [ c  => ( $country eq "" ? [] : [$country] ) ],
				     replace => [ st => ( $state   eq "" ? [] : [$state]   ) ],
				     replace => [ o  => ( $org     eq "" ? [] : [$org]     ) ],
				     replace => [ ou => ( $orgu    eq "" ? [] : [$orgu]    ) ],
				     replace => [ l  => ( $local   eq "" ? [] : [$local]   ) ]
				     ]
			 );
    
    if( $ret->code != 0 ) {
	my $errs = "modify $message->{failed}\n\n";
	$errs .= &LDAPerror($ret);
	$ldap->unbind();
	$menu->display_error($errs,
			     "/suse/menu.pl?sessionID=$sessionID");
	exit;
    }   

    $ldap->unbind();

    #-----------------------------------------------------------------------------
    # create reqest for oneself

    $ret = create_sreq($cn, $s_passwd, $country, $state, $local, $org, $orgu, $email);
    if($ret ne "0") {
        $menu->display_error($ret, 
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    #-----------------------------------------------------------------------------
    # sign own request

    $ret = sign_sreq("server_cert", $passwd);
    if($ret ne "0") {
        $menu->display_error($ret, 
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    my $mode = 0640;

# I SCHULSERVER
    #-----------------------------------------------------------------------------
    # create reqest for oneself
    my $cf = "/etc/httpd/schoolserver_include.conf";
    if( ! open(IN, "< $cf")) {
        $menu->display_error("$message->{apache_cfg_not_readable} $cf: $?",
                             "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    my @raw = <IN>;
    chomp(@raw);
    close(IN);
    foreach my $l ( @raw ) {
        if ( $l =~ /ServerName\s+(.*)/ ) {
            $cn = $1; 
        }
    }
 
    $ret = create_schoolserver_sreq($cn, $s_passwd, $country, $state, $local, $org, $orgu, $email);
    if($ret ne "0") {
        $menu->display_error($ret, 
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    #-----------------------------------------------------------------------------
    # sign own request

    $ret = sign_schoolserver_sreq("server_cert", $passwd);
    if($ret ne "0") {
        $menu->display_error($ret, 
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    if( ! chmod($mode, "$cert_dir/schoolserver_skey.pem") ) {
	$menu->display_error("$message->{warn_chmod}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    if( ! chown((getpwnam("root"))[2], (getgrnam("mail"))[2], "$cert_dir/schoolserver_skey.pem") ) {
	$menu->display_error("$message->{warn_chown}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

# I SCHULSERVER

    if( ! chmod($mode, "$cert_dir/skey.pem") ) {
	$menu->display_error("$message->{warn_chmod}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    if( ! chown((getpwnam("root"))[2], (getgrnam("mail"))[2], "$cert_dir/skey.pem") ) {
	$menu->display_error("$message->{warn_chown}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    # --PEM to DER Format
    $ret = change_cert_format("$CA_collection/usedCA.pem", "PEM",
			      "$CA_derForm", "DER");

    if($ret != 0) {
	$menu->display_error("$message->{warn_proc_out}",
			     "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    $menu->display_msg("$message->{warn_success}",
		       "/suse/menu.pl?sessionID=$sessionID&tab=$tab");

}

