#!/usr/bin/perl
#
# Copyright (c) 2000-2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: help.pl,v 1.4 2003/10/29 10:35:38 varkoly Exp $
#

BEGIN{
    push @INC,"/srv/www/lib";
}

$| = 1; # do not buffer stdout
 
use strict;
use Session;
use Display;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use subs qw(exit);
use Config::IniFiles;
use vars qw($cgi $lmsg);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };

$cgi=new CGI;
 
if( $ENV{MOD_PERL} ) {
    $lmsg = $::lmsg;
}else{
    my $libdir = "/srv/www/lib";
    if( ! opendir(LIB, $libdir) ) {
	print "ERROR: unable to opendir $libdir";
	exit;
    }
    
    foreach my $langfile ( grep(/^imap_lang_[A-Z][A-Z]\.ini$/, readdir(LIB)) ) {
	$langfile =~ /imap_lang_(\w+)\.ini/;
	$lmsg->{$1} = new Config::IniFiles( -file => $libdir."/".$langfile );
    }
    
    closedir(LIB);
    
    if( ! defined $lmsg ) {
	print "Unable to load a language file";
	exit;
    }
}


my $sessionID = $cgi->param('sessionID');    

my $session = Session->new();
my $confParam = ($session->load($sessionID))->data();
my $message;

if(! defined $confParam) {
    print $cgi->header(-refresh=>"0; URL=".$session->cgi_path."/login.pl");
    print $cgi->start_html(-title=>"");
    print $cgi->end_html;
    exit;
} else {
    $message = ($session->getLanguage($confParam->{LANG},"MAIN"))->data();
}

my @content=get_content($cgi->param("topic"));

my $JavaScript=<<EOF;
function setFocus() {
    document.FORM.AREA.blur();
}
EOF
   
my $charset =  'utf-8'; 
my $html = "";
$html .=  $cgi->header( -charset => $charset );
$html .=  $cgi->start_html (-title  => 'SuSE Linux School Server',
                            -style  => {'src'=>'/stylesheetAdmin.css'},
                            -script => $JavaScript,
                            -onLoad => "this.focus()");
    $html .=  $cgi->start_center;
        $html .=  $cgi->start_form();
        $html .=  "<br>".$cgi->start_table({-class=>'AdminBorder', -cellspacing=>0, -cellpadding=>5, -width=>"95%"} );
            $html .=  $cgi->Tr({},
                        $cgi->td({-class=>'AdminHeader'},
                            $cgi->b($content[0])));
            $html .=  $cgi->Tr({-class=>'AdminHelp'}, $cgi->td({-class=>'AdminHelp'}, $content[1]));
            $html .=  $cgi->Tr({}, $cgi->td({-align=>"center"}, 
                            $cgi->submit(-class=>"button",   -name=>$message->{close},
                                            -value=>$message->{close}, 
                                            -onclick=>"javascript:window.close();")));
            $html .=  $cgi->end_table();
        $html .=  $cgi->end_form();
    $html .=  $cgi->end_center;
$html .=  $cgi->end_html;

print $html;

1;
###############################################################################
##  subroutines
###############################################################################

sub get_content {
    my $topic   = shift;
        $topic = lc($topic);
    my $body    = "";
    my $line    = "";

    my $sessionID = $cgi->param('sessionID');    

    my $session = Session->new();
    my $confParam = ($session->load($sessionID))->data();
    my $message = ($session->getLanguage($confParam->{LANG},"HELP"))->data();
    my $helppath = $confParam->{'help_path'}."/".$confParam->{LANG}."/".$topic.".html";
    if(! (open (FILE,"< $helppath")) ){
        return($message->{'no_help_avail'},$message->{'no_help_avail'},$message->{'no_help_avail_long'});
    }else{
        while ($line=<FILE>) {
            $body.=$line;
        }
    }
    close FILE;
    return ($message->{help}, $body);
}

