#!/usr/bin/suidperl
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: import_ServCert.pl,v 1.1.1.1 2003/03/25 10:31:47 ray Exp $
#

BEGIN {
    use POSIX;
    push @INC,"/srv/www/lib";
    $ENV{"PATH"}="/bin:/sbin:/usr/bin:/usr/sbin";
    $ENV{"HOME"}="/root";
    my $x = (getpwnam("root"))[2];
    my $y = getgrnam("root");
    setuid($x);
    setgid($y);
    undef $x;
    undef $y;
}

use openssl;
use Display;
use Session;

use CGI qw(-no_xhtml);
#use CGI::Carp qw(fatalsToBrowser);
use strict;

use File::Copy "cp";
use IPC::Open2;
use Net::LDAP qw(:all);
use Net::Domain;
use Config::IniFiles;
use vars qw($lmsg);

my $q = new CGI;
$q->autoEscape(undef);

my $sessionID = $q->param("sessionID");

my $session = Session->new();
my $confParam = ($session->load($sessionID))->data();
my $message;

my $libdir = "/srv/www/lib";

my $menu = new Display($q, $session);

if( ! opendir(LIB, $libdir) ) {
    $menu->display_error("ERROR: unable to opendir $libdir",
			 "/suse/menu.pl?sessionID=$sessionID");
    exit;
}

foreach my $langfile ( grep(/^imap_lang_[A-Z][A-Z]\.ini$/, readdir(LIB)) ) {
    $langfile =~ /imap_lang_(\w+)\.ini/;
    $lmsg->{$1} = new Config::IniFiles( -file => $libdir."/".$langfile );
}

closedir(LIB);

if( ! defined $lmsg ) {
    $menu->display_error("Unable to load a language file",
			 "/suse/menu.pl?sessionID=$sessionID");
   exit;
}

if(! defined $confParam) {
    print $q->header(-refresh=>"0; URL=".$session->cgi_path."/login.pl");
    print $q->start_html(-title=>"");
    print $q->end_html;
    exit;
} else {
    $message = ($session->getLanguage($confParam->{LANG},"CREADEL_CA"))->data();
}

if ($confParam->{uid} ne "cyrus") {
    $menu->display_error($message->{access_denied},
			 "/suse/menu.pl?sessionID=$sessionID");
    exit;
} 

# ==================

my $doit = $q->param('doit') || '';
my $tab  = $q->param('tab')  || 'system';
my $stab = $q->param('stab') || 'ca';

my $dir           = "/etc/ssl";
my $cert_dir      = $dir."/certs";
my $CA_collection = $dir."/CA";
my $newcerts      = $dir."/newcerts";
my $CA_derForm    = "/srv/www/htdocs/cacert.der";
my $HTML = "";

if($doit eq "check_cert") {
    check_cert();
} elsif($doit eq "load_CA") {
    load_CA();
} elsif($doit eq "ask4CA") {
    ask4CA();
} elsif($doit eq "decrypt_key") {
    decrypt_key();
} else {
    startup();
}

1;

sub startup {
#    print STDERR "startup:\n";
    $HTML .= $q->table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"},
		       $q->start_multipart_form(-action=>"$confParam->{cgi_path}/import_ServCert.pl"),
		       $q->Tr({},
			      $q->td({}, 
				     $q->table({ -cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					       $q->Tr({},
						      $menu->help_th(1,
								     "$message->{load_ServCert}",
								     "IMPORT_SERVCERT")
						      ),
					       $q->Tr({},
						      $q->td({-class=>'AdminSubHeaderRed'},
							     "<B>$message->{warn_import_ServCert}</B>"),
						      ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $message->{key_and_cert}
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->filefield(-name=>'cert_key',
									   -size=>40,
									   -maxlength=>100)
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->font({-size=>"+1"}, $q->b($message->{or}))
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $message->{cert_only}
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->filefield(-name=>'cert',
									   -size=>40,
									   -maxlength=>100)
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $message->{key_only}
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->filefield(-name=>'key',
									   -size=>40,
									   -maxlength=>100)
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->submit(-class=>"button",-value=>$message->{next})
							    )
						     )
					      )
				    )
			     ),
		       $q->hidden(-name=>"sessionID", -value=>"$sessionID"),
		       $q->hidden(-name=>"doit", -value=>"check_cert"),
		       $q->end_multipart_form()
		      );
	
    $menu->display($HTML);
}

sub check_cert {

    my $cert_key = $q->param('cert_key') || '';
    my $cert     = $q->param('cert')     || '';
    my $key      = $q->param('key')      || '';

    my $is_key_encrypted = 1;

    my $ldaphost=$confParam->{LDAPserver};
    if ($ldaphost =~ /^([-\@\w.]+)$/) {
	$ldaphost = $1;                     # $data now untainted
    } else {
	die "Bad data in $ldaphost";        # log this somewhere
    }
    my $ldap = Net::LDAP->new($ldaphost, port => $confParam->{LDAPport}, version => 3);
    if( ! defined $ldap ) {
	$menu->display_error("couldn't connect to LDAP server",
			     "/suse/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $ret = $ldap->bind (dn=>"uid=$confParam->{uid},$confParam->{baseDN}",
			    password=>$confParam->{passwd});
    if( $ret->code != 0 ) {
	$menu->display_error("couldn't bind to LDAP server",
			     "/suse/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $ret = del_all_Certs($ldap, $confParam, $message);

    $ldap->unbind();

    if($ret ne "") {
        $menu->display_error($ret,
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    if($cert_key ne "") {
	my @cert = ();
	my @key = ();
	my $found = "";
	print STDERR "$cert_key\n";

	while(<$cert_key>) {
#	    print STDERR "CERT:$_";
	    chomp();
	    if($_ =~ /^-+BEGIN[\s\w]*KEY-+/) {
		$found = "key";
		push @key, "$_\n";
	    } elsif($_ =~ /^-+END[\s\w]*KEY-+/) {
		$found = "";
		push @key, "$_\n";
	    } elsif($_ =~ /^-+BEGIN[\s]*CERTIFICATE-+/) {
		$found = "cert";
		push @cert, "$_\n";
	    } elsif($_ =~ /^-+END[\s]*CERTIFICATE-+/) {
		$found = "";
		push @cert, "$_\n";
	    } elsif($found eq "key") {
		if($_ =~ /ENCRYPTED/) {
		    $is_key_encrypted = 1;
		}
		push @key, "$_\n";
	    } elsif($found eq "cert") {
		push @cert, "$_\n";
	    }
	}

	if( ! open(OUT,">$cert_dir/skey.pem") ) {
	    $menu->display_error("cannot open file $cert_dir/skey.pem: $!",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	
	print OUT @key;
	close OUT;

	if( ! open (OUT,">$cert_dir/cert.pem") ) {
	    $menu->display_error("cannot open file $cert_dir/cert.pem: $!",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	print OUT @cert;
	close OUT;
    } elsif($cert ne "" and $key ne "") {

	if( ! open (OUT,">$cert_dir/skey.pem") ) {
	    $menu->display_error("cannot open file $cert_dir/skey.pem: $!",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	while(<$key>) {
	    if($_ =~ /ENCRYPTED/) {
		$is_key_encrypted = 1;
	    }
	    chomp();
	    print OUT "$_\n";
	}
	close OUT;
	
	if( ! open (OUT,">$cert_dir/cert.pem") ) {
	    $menu->display_error("cannot open file $cert_dir/cert.pem: $!",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	while(<$cert>) {
	    chomp();
	    print OUT "$_\n";
	}
	close OUT;
    } else {
	$menu->display_error($message->{no_files},
			     "/suse/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $mode = 0640;
    if( ! chmod($mode, "$cert_dir/skey.pem") ) {
	$menu->display_error($message->{warn_chmod},
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    if( ! chown((getpwnam("root"))[2], (getgrnam("mail"))[2], "$cert_dir/skey.pem") ) {
        $menu->display_error("$message->{warn_chmod}",
                             "$confParam->{cgi_path}/create_own_ServCert.pl?sessionID=$sessionID");
        exit;
    }
    # -- decrypt RSA Key
    
    if($is_key_encrypted) {
	
	ask_key_pass();
	exit;
    }

    # -- check CA

    check_CA();
    exit;
}


sub ask4CA {
    $q->delete('doit');
    $HTML .= $q->table({-border=>0, -cellspacing=>2, -cellpadding=>0, -width=>"100%"},
		       $q->start_multipart_form(-action=>"$confParam->{cgi_path}/import_ServCert.pl",
						-method=>"post"),
		       $q->Tr({},
			      $q->td({}, 
				     $q->table({-border=>0,
						-cellspacing=>0,
						-cellpadding=>5,
						-width=>"100%"},
					       $q->Tr({},
						      $menu->help_th(1, "$message->{load_CA}",
								     "IMPORT_SERVCERT")
						     ),
					       $q->Tr({},
						      $q->td({-colspan=>"2",
							      -align=>"center"},
							     $message->{warn_no_CA_found})
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $message->{CA_file}
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->filefield(-name=>'CA_file',
#									   -default=>'starting value',
									   -size=>40,
									   -maxlength=>100)
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->submit(-class=>"button",-value=>$message->{next})
							    )
						     )
					      )
				    )
			     ),
		       $q->hidden(-name=>"sessionID", -value=>"$sessionID"),
		       $q->hidden(-name=>"doit", -value=>"load_CA"),
		       $q->end_multipart_form()
		      );
	
    $menu->display($HTML);
}

sub load_CA {
    $q->delete('doit');
    my $CA_file = $q->param('CA_file') || '';

#    print STDERR "$CA_file\n";

    if( ! open (OUT,">$CA_collection/loadCA.pem") ) { 
	$menu->display_error("cannot open file $CA_collection/loadCA.pem: $!",
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    while(<$CA_file>) {
	chomp();
	print OUT "$_\n";
    }
    close OUT;
    
    # -- verify the cert
    
    my $i = verify_certificate("loadCA.pem", "cert.pem");

    if($i ne "OK") {
	unlink("$CA_collection/loadCA.pem");
	$menu->display_error("$message->{warn_verify}",
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID&tab=$tab&stab=$stab&doit=ask4CA");
	exit;
    } else {
	if( ! cp ("$CA_collection/loadCA.pem", "$CA_collection/usedCA.pem") ) {
	    $menu->display_error("$message->{warn_copy}",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $ret = change_cert_format("$CA_collection/usedCA.pem", "PEM",
				     "$CA_derForm", "DER");

	if($ret != 0) {
	    $menu->display_error("$message->{warn_proc_out}",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
	
	$menu->display_msg("$message->{warn_success}",
			   "/suse/menu.pl?sessionID=$sessionID&tab=$tab");
	exit;
    }
}

sub check_CA {
    my $ca = "";

    # -- check certifikate

    my @CAs = ();
    if( ! opendir(CA, $CA_collection) ) {
	$menu->display_error("can`t open directory",
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    @CAs = grep { !/^\.+$/ && -f "$CA_collection/$_" } readdir(CA);
    closedir(CA);
    
    foreach (@CAs) {

	my $i = verify_certificate("$_", "cert.pem");
	
	if($i eq "OK") {
	    $ca = $_;
	    last;
	}
    }

    if($ca eq "") {
	
	ask4CA();
	
	exit;
    } else {
	if ($ca =~ /^([\w\d\-_\.,]+)$/) {
	    $ca = $1;
	} else {
	    die "bad data in $ca";
	}
	
	if( ! cp("$CA_collection/$ca", "$CA_collection/usedCA.pem") ) {
	    $menu->display_error("$message->{warn_copy}",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID"); 
	    exit;
	}
	

	my $ret = change_cert_format("$CA_collection/usedCA.pem", "PEM",
				     "$CA_derForm", "DER");

	if($ret != 0) {
	    $menu->display_error("$message->{warn_proc_out}",
				 "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	    exit;
	}
    }

    $menu->display_msg("$message->{warn_success}",
		       "/suse/menu.pl?sessionID=$sessionID&tab=$tab");
    exit;
}

sub ask_key_pass {
    $q->delete('doit');
    $HTML .= $q->table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"},
		       $q->start_multipart_form(-action=>"$confParam->{cgi_path}/import_ServCert.pl",
						-method=>"post"),
		       $q->Tr({},
			      $q->td({}, 
				     $q->table({ -cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					       $q->Tr({},
						      $menu->help_th(1, "$message->{keypass}",
								     "IMPORT_SERVCERT")
						     ),
					       $q->Tr({},
						      $q->td({-colspan=>"2",
							      -align=>"center"},
							     $message->{warn_keypass})
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $message->{s_pem}
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->password_field(-name=>'keypass',
										-value=>'',
										-size=>40,
										-maxlength=>100)
							    )
						     ),
					       $q->Tr({},
						      $q->td({
							      -align=>"center"},
							     $q->submit(-class=>"button",-value=>$message->{next})
							    )
						     )
					      )
				    )
			     ),
		       $q->hidden(-name=>"sessionID", -value=>"$sessionID"),
		       $q->hidden(-name=>"doit", -value=>"decrypt_key"),
		       $q->end_multipart_form()
		      );

    $menu->display($HTML);
}

sub decrypt_key {
    my $pass = $q->param('keypass');

    my $ret = decrypt_Key($pass);
    if($ret ne "0") {
	$menu->display_error("$ret",
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	exit;
    }

    my $mode = 0640;
    if( ! chmod($mode, "$cert_dir/skey.pem") ) {
	$menu->display_error("$message->{warn_chmod}",
			     "$confParam->{cgi_path}/import_ServCert.pl?sessionID=$sessionID");
	exit;
    }
    
    check_CA();
    exit;
}

