#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: Display.pm,v 1.19 2003/11/27 15:04:15 varkoly Exp $
#
package Display;

use Exporter;
use strict;
use CGI qw(-no_xhtml);
use Net::IMAP;
use Tie::IxHash;
use LDAPUtils;
use Utils;

my $_content = '<img src="/images/welcome.png" alt="Welcome">';


sub new {
	my ($this, $cgi, $session) = @_;
    my $class = ref($this) || $this;
    my $self  = {};
    	$self->{"cgi"}     			= $cgi;
      	$self->{"session"} 			= $session;
      	$self->{"topic"}   			= 'def';
		$self->{"__tab_real_path"}	= '/srv/www';
		$self->{"__tab_path"}      	= '/images/top_nav';

    $self->{'USE_SAMBA'} = 1;

    $self->{"charset"} = "utf-8";

    $self->{'ISGATE'}  = read_rcconfig("SCHOOL_ISGATE");

    bless $self, $class;
    return $self;
}

sub back_url {
    my $this = shift;
    $this->{"back_url"} = shift;
}

sub display {
    my $this    	= shift;
    my $content 	= shift || $_content;
    $this->{"ref"}      = shift;
    $this->{"ref_time"}	= shift;
    my $cgi       	= $this->{"cgi"};
    my $confParam 	= $this->{"session"}->{"confParam"};
    my $session   	= $this->{"session"};
    my $ref       	= $this->{"ref"};
    my $ref_time  	= $this->{"ref_time"};
    my $lang      	= $confParam->{"LANG"};

    my $active    	= $cgi->param("tab")  || '';
    my $sactive   	= $cgi->param("stab") || '';

    my $sessionID 	= $confParam->{sessionID};
    my $wosid     	= $confParam->{wosid};
    my $message		= ($session->getLanguage($confParam->{LANG},"GLOBAL"))->data();

    $this->{"content"}  = $content;

	#-- check sessionID#{{{
    if( ! defined $sessionID || $sessionID eq "" ) {
      $this->display_error('No session ID defined');
      exit;
    }#}}}

	if ( $active eq '' ) {
		if ( $this->{"session"}->{"confParam"}->{"uid"} eq "cyrus" ) {
			$active = 'user';
		} else {
			$active = 'settings';
		}
	}
    
    #foreach my $k ( keys %ENV ) {
    #	print STDERR "$k: $ENV{$k}\n";
    #}

    if( ( defined $confParam->{mustchangepasswd} && $sactive ne "password" ) ||
	( defined $confParam->{mustchangepasswd} && $ENV{'SCRIPT_NAME'} !~ /\/change_passwd\.pl/ )
	) {
	print $cgi->header( -Refresh=>"0; URL=/suse/change_passwd.pl?sessionID=$sessionID\&tab=settings\&stab=password", -charset => "$this->{'charset'}" );
    }

	my ($topmenu, $where, $submenu, $topics) = $this->__makeMenuS();

    if ( ! defined $ref_time ) {#-- select html-header#{{{
        print $cgi->header(-expires => "-10y", -pragma => "no-cache" , -charset => "$this->{'charset'}" );
    } else {
    	print $cgi->header(-Refresh=>"$ref_time; URL=$ref", -pragma => "no-cache", -expires => "-10y" , -charset => "$this->{'charset'}");
    }#}}}

	my $JSCRIPT=<<END;
		function change_img(img1,img2) {
		  if (document.images) {
			active = new Image ();
			normal = new Image ();
			active.src = '/images/' + 'top_nav/' + img2 + '.png';
			normal.src = '/images/' + 'top_nav/' + img1 + '.png';
			if (img1 != img2) {
			  document.images[img1].src = active.src;
			} else {
			  document.images[img1].src = normal.src;
			}
		  }
		}
END


    print $cgi->start_html( -title      => "SuSE Linux School Server Administration Administration",
                            -style      =>{'src'=>'/stylesheetAdmin.css'},
							-script		=> $JSCRIPT);
		print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>0, -cellpadding=>0, -width=>1000});
			#-- head logo#{{{
			print $cgi->Tr(
				$cgi->td({-valign=>"top", -colspan=>2},
					$cgi->img({-src=>$this->{"__tab_path"} . "/header.png", -alt=>"Logo"})
				)
			);#}}}
			#-- top menu#{{{
			print $cgi->Tr( $cgi->td({-colspan=>2}, $topmenu ) );#}}}
			#-- work area
			print $cgi->start_Tr();
				#-- content#{{{
				print $cgi->start_td({-valign=>'top'});
					print $cgi->start_table({-cellspacing=>0, -cellpadding=>2, -width=>"100%"});
						print $cgi->start_Tr();
							print $cgi->td({-class=>'AdminHead1', -width=>'751'}, $where);
							print $cgi->td({-class=>'AdminHead2'}, $message->{'user'}.": ".$confParam->{fullname});
						print $cgi->end_Tr();
						print $cgi->start_Tr();
							print $cgi->start_td();# TD #{{{
								print $cgi->start_table({-cellspacing=>0, -cellpadding=>0, -width=>"100%"});
									#--- das submenu
									print $cgi->Tr($cgi->td($submenu));
									#--- der inhalt
									#--- wenn kein submenue aktive ist, wird ein text angezeigt
									if ( $sactive ) {
										print $cgi->Tr($cgi->td($content));
									} else {
										$this->{'topic'} = $active;
										print $cgi->start_Tr();
										print   $cgi->start_td();
										print       $cgi->start_table({-class=>'AdminBorder', -cellspacing=>0, -cellpadding=>2, -width=>"100%"});
										print           $cgi->Tr( $cgi->td($content));
										print       $cgi->end_table();
										print   $cgi->end_td();
										print $cgi->end_Tr();
									}
								print $cgi->end_table();
							print $cgi->end_td();#}}}
							#-- help on right side#{{{
							print $cgi->td({-class=>'AdminHelp', -valign=>'top', -width=>'249'}, $this->__help_GetContent( $topics ));#}}}
						print $cgi->end_Tr();
						#-- footer#{{{
						if ( $this->{"session"}->{"confParam"}->{"uid"} eq "cyrus" ) {
							if( $sactive ne "" ) {
								print $cgi->Tr($cgi->td({-colspan=>2, -class=>'AdminFooter', -align=>"center"},
									$cgi->a({-class=>'AdminFooter', -href=>$this->{"back_url"}}, "<b>$message->{back}</b>")));
							} else {
								print $cgi->Tr($cgi->td({-colspan=>2, -class=>'AdminFooter', -align=>"center"}, '<br>'));
							}
						} else {
							# -- fetch quota information#{{{
						    if( ! defined $confParam->{mustchangepasswd} ) {
						        my $ih = new Net::IMAP($confParam->{IMAPserver});
							if( ! defined $ih ) {
							  $this->display_error('unable connect to imap-sever');
							  exit;
							}#}}}
							# We need to catch alerts, so we have to provide our own callback function to "NO" responses of cyrus-imapd#{{{
							my $alert = undef;

							my $nocb = sub {
							  my $self = shift;
							  my $resp = shift;
							  if( defined $resp->{RespCode}->[0] ) {
								$alert = $resp->{Text};
							  }
							};

							$ih->set_untagged_callback('no', $nocb);

							my $ret = $ih->login($confParam->{uid}, $confParam->{passwd});
							if( $ret->{Status} ne "ok" ) {
							  $this->display_error('unable to login');
							  exit;
							}

							$ret = $ih->select("INBOX");
							if( $ret->{Status} ne "ok" ) {
							  $this->display_error('unable to select');
							  exit;
							}

							my $qinuse = "NA";
							my $qtotal = "NA";

							my $cbf = sub {
							  my $self  = shift;
							  my $resp  = shift;
							  $qinuse   = $resp->{Quota}->{storage}->[0];
							  $qtotal   = $resp->{Quota}->{storage}->[1];
							};

							$ih->set_untagged_callback('quota', $cbf);

							$ret = $ih->getquotaroot("INBOX");
							if( ! defined $ret ) {
							  $this->display_error('unable to get quota');
							  exit;
							}

							$ih->logout();
							#}}}
							print $cgi->Tr(
									$cgi->td({-colspan=>2, -class=>'AdminFooter'},
											"&nbsp;<b> $message->{status}: ".
											( defined $alert ? "<font color=red>$alert</font>" : "$qinuse kB $message->{quota_inuse} $qtotal kB </b>")
									)
							);
						    }
						}#}}}
					print $cgi->end_table();
				print $cgi->end_td();#}}}
			print $cgi->end_Tr();
		print $cgi->end_table;
	print $cgi->end_html();
}

sub __makeMenuS {#-- create menu and submenu#{{{
	my $self 		= shift;
    my $cgi       	= $self->{"cgi"};
    my $active    	= $cgi->param("tab")  || '';
    my $sactive   	= $cgi->param("stab") || '';
    my $session   	= $self->{"session"};
	my $confParam 	= $self->{"session"}->{"confParam"};
    my $lang      	= $confParam->{"LANG"};
    my $sessionID	= $confParam->{"sessionID"};
    my $wosid     	= $confParam->{"wosid"};
    my $message 	= ($session->getLanguage($confParam->{"LANG"},"GLOBAL"))->data();
    my $msg_head_short  = ($session->getLanguage($confParam->{"LANG"},"TOP_MENU_SHORT"))->data();
    my $msg_head_long   = ($session->getLanguage($confParam->{"LANG"},"TOP_MENU_LONG"))->data();
    my $msg_submenu     = ($session->getLanguage($confParam->{"LANG"},"SUB_MENU"))->data();

    my %menu = ();
    tie %menu, "Tie::IxHash";
    my $ret_menu;
    my $wo_ich_sein;
    my $sub_menu;

	
	# ADMIN MENU
	my %m_user = ();
	tie %m_user, "Tie::IxHash";
	my %m_group = ();
	tie %m_group, "Tie::IxHash";
	my %m_mail = ();
	tie %m_mail, "Tie::IxHash";
	my %m_sec = ();
	tie %m_sec, "Tie::IxHash";
	my %m_ho_dom = ();
	tie %m_ho_dom, "Tie::IxHash";
	my %m_tools = ();
	tie %m_tools, "Tie::IxHash";
	my %m_mon = ();
	tie %m_mon, "Tie::IxHash";
	my %m_resource = ();
	tie %m_resource, "Tie::IxHash";
	my %m_files = ();
	tie %m_files, "Tie::IxHash";
	# ADMIN MENU

	# USER MENU
	my %m_settings = ();
	tie %m_settings, "Tie::IxHash";
	my %m_folder = ();
	tie %m_folder, "Tie::IxHash";
	my %m_sieve = ();
	tie %m_sieve, "Tie::IxHash";
	my %m_teacher = ();
        tie %m_teacher, "Tie::IxHash";
	# USER MENU

	# SHARED MENU
	my %m_lang = ();
	my %m_logout = ();
	# SHARED MENU
	
	my $remotehost = $::CONF_GLOBAL{'GENERAL'}{'GroupwareHostname'};
	if( defined $remotehost && $remotehost ne "" ) {
	    $remotehost = &getPROTO().$remotehost;
	} else {
	    $remotehost = "";
	}
	
	if ( $active eq '' ) {
		if ( $self->{"session"}->{"confParam"}->{"uid"} eq "cyrus" ) {
			$active = 'user';
		} else {
			$active = 'settings';
		}
	}

	if ( $self->{"session"}->{"confParam"}->{"uid"} eq "cyrus" ) {
		#-- menu hash
		#--- top menu
		$menu{'user'} = "/suse/menu.pl?sessionID=$sessionID\&tab=user\&lang=$lang";
			$m_user{'new'}          = "/suse/create_user.pl?sessionID=$sessionID\&tab=user\&lang=$lang\&stab=new";
			$m_user{'import'}  	= "/suse/import_user.pl?sessionID=$sessionID\&tab=user\&lang=$lang\&stab=import";
			$m_user{'edit'}         = "/suse/browse_user.pl?sessionID=$sessionID\&tab=user\&lang=$lang\&stab=edit";
			$m_user{'v_new'}        = "/suse/create_vuser.pl?sessionID=$sessionID\&tab=user\&lang=$lang\&stab=v_new";
			$m_user{'v_edit'}       = "/suse/edit_vuser.pl?sessionID=$sessionID\&tab=user\&lang=$lang\&stab=v_edit";
		$menu{'group'} = "/suse/menu.pl?sessionID=$sessionID\&tab=group\&lang=$lang";
			$m_group{'new_grp'}     = "/suse/create_group.pl?sessionID=$sessionID\&tab=group\&lang=$lang\&stab=new_grp";
			$m_group{'edit_grp'}    = "/suse/browse_groups.pl?sessionID=$sessionID\&tab=group\&lang=$lang\&stab=edit_grp";
			$m_group{'sf_new'}      = "/suse/create_sfolder.pl?sessionID=$sessionID\&tab=group\&lang=$lang\&stab=sf_new";
			$m_group{'sf_edit'}     = "/suse/edit_sfolder.pl?sessionID=$sessionID\&tab=group\&lang=$lang\&stab=sf_edit";
			$m_group{'acl_edit'}    = "/suse/edit_acl.pl?sessionID=$sessionID\&tab=group\&lang=$lang\&stab=acl_edit";
		$menu{'mail'} = "/suse/menu.pl?sessionID=$sessionID\&tab=mail\&lang=$lang";
			$m_mail{'postfix'}      = "/suse/postfix.pl?sessionID=$sessionID\&tab=mail\&lang=$lang\&stab=postfix";
			$m_mail{'postfix_ex'}   = "/suse/expert_postfix.pl?sessionID=$sessionID\&tab=mail\&lang=$lang\&stab=postfix_ex";
			$m_mail{'imap'}         = "/suse/imap_conf.pl?sessionID=$sessionID\&tab=mail\&lang=$lang\&stab=imap";
			$m_mail{'fetch'}        = "/suse/fetch_mail.pl?sessionID=$sessionID\&tab=mail\&lang=$lang\&stab=fetch";
		        $m_mail{'alias'}        = "/suse/manage_aliases.pl?sessionID=$sessionID\&tab=mail\&lang=$lang\&stab=alias";
			#$m_mail{'avgate'}      = "/suse/avmailgate_conf.pl?sessionID=$sessionID\&tab=mail\&lang=$lang\&stab=avgate";
		$menu{'sec'} = "/suse/menu.pl?sessionID=$sessionID\&tab=sec\&lang=$lang";
			$m_sec{'ssl'} 		= "/suse/ssl_conf.pl?sessionID=$sessionID\&tab=sec\&lang=$lang\&stab=ssl";
			if(defined($::CONF_GLOBAL{'GENERAL'}{'EnableVPNSrv'}) and $::CONF_GLOBAL{'GENERAL'}{'EnableVPNSrv'} eq 'true') {
			    $m_sec{'vpn'}	= "/suse/vpn_conf.pl?sessionID=$sessionID\&tab=sec\&lang=$lang\&stab=vpn";
			}
			$m_sec{'ca'}		= "/imap-bin/creadel_ServCert.pl?sessionID=$sessionID\&tab=sec\&lang=$lang\&stab=ca";
			if($self->{'ISGATE'} eq 'yes') {
				$m_sec{'firewall'}	= "/suse/firewall.pl?sessionID=$sessionID\&tab=sec\&lang=$lang\&stab=firewall";
			}
		$menu{'ho_dom'} = "/suse/menu.pl?sessionID=$sessionID\&tab=ho_dom\&lang=$lang";
                        $m_ho_dom{'new'}	= "/suse/register_pc.pl?sessionID=$sessionID\&tab=ho_dom\&stab=new\&lang=$lang";
                        $m_ho_dom{'control'}	= "/suse/control.pl?sessionID=$sessionID\&tab=ho_dom\&stab=control\&lang=$lang";
			$m_ho_dom{'dns'}	= "/suse/manage_vdom.pl?sessionID=$sessionID\&tab=ho_dom\&lang=$lang\&stab=dns";
			$m_ho_dom{'dhcp'}	= "/suse/dhcp.pl?sessionID=$sessionID\&tab=ho_dom\&lang=$lang\&stab=dhcp";
			if(defined($::CONF_GLOBAL{'GENERAL'}{'EnableDynDns'}) and 'true' eq $::CONF_GLOBAL{'GENERAL'}{'EnableDynDns'}) {
			  $m_ho_dom{'dyndns'}	= "/suse/dyndns.pl?sessionID=$sessionID\&tab=ho_dom\&lang=$lang\&stab=dyndns";
			}
			$m_ho_dom{'squid_conf'}	= "/suse/squid_conf.pl?sessionID=$sessionID\&tab=ho_dom\&lang=$lang\&stab=squid_conf";
            		$m_ho_dom{'admin_cups'}	= "/suse/admin_cups.pl?sessionID=$sessionID\&tab=ho_dom\&lang=$lang\&stab=admin_cups";
		$menu{'tools'} = "/suse/menu.pl?sessionID=$sessionID\&tab=tools\&lang=$lang";
			$m_tools{'ldpbrowse'}   = "/suse/ldap_browser.pl?sessionID=$sessionID\&tab=tools\&lang=$lang\&stab=ldpbrowse";
			$m_tools{'wall'}        = "/suse/wall.pl?sessionID=$sessionID\&tab=tools\&lang=$lang\&stab=wall";
			#$m_tools{'cfg_files'}   = "/suse/file_edit.pl?sessionID=$sessionID\&tab=tools\&lang=$lang\&stab=cfg_files";
                        $m_tools{'global_conf'}	= "/suse/global_conf.pl?sessionID=$sessionID\&tab=tools\&lang=$lang\&stab=global_conf";
			$m_tools{'cyrus_data'}	= "/suse/edit_cyrus_data.pl?sessionID=$sessionID\&tab=tools\&lang=$lang\&stab=cyrus_data";
		$menu{'mon'} = "/suse/menu.pl?sessionID=$sessionID\&tab=mon\&lang=$lang";
			$m_mon{'monitor'}	= "/suse/monitor.pl?sessionID=$sessionID\&tab=mon\&lang=$lang\&stab=monitor";
			$m_mon{'queue'}		= "/suse/mailq.pl?sessionID=$sessionID\&tab=mon\&lang=$lang\&stab=queue";
			$m_mon{'traf'}		= "/suse/mail_graph.pl?sessionID=$sessionID\&tab=mon\&lang=$lang\&stab=traf";
			$m_mon{'sysMon'}	= "/suse/sysMonitor.pl?sessionID=$sessionID\&tab=mon\&lang=$lang\&stab=sysMon";
		        $m_mon{'services'}	= "/suse/manage_services.pl?sessionID=$sessionID\&tab=mon\&lang=$lang\&stab=services";
		$menu{'lang'} = "/suse/change_lang.pl?sessionID=$sessionID\&tab=lang";
				$m_lang{'lang_select_dummy'} = "/suse/change_lang.pl?sessionID=$sessionID\&tab=lang";
		$menu{'logout'} = "/suse/menu.pl?sessionID=$sessionID\&tab=logout\&lang=$lang";
		#-- make menus
		$ret_menu = $cgi->start_table();
			$ret_menu .= $cgi->start_Tr();
		$sub_menu = $cgi->start_table({-cellspacing=>0, -cellpadding=>0, -width=>'100%'});
			$sub_menu .= $cgi->start_Tr();

		my $icon_file = $self->{"__tab_path"} . "/dummy.png";
		my $in_icon_name = 'dummy';
		my $ac_icon_name = 'dummy';
		foreach my $x (keys %menu) {
			if ( $x eq $active ) {
				if (-f $self->{"__tab_real_path"} . $self->{"__tab_path"} . "/ac_$x.png") {
					$icon_file = $self->{"__tab_path"} . "/ac_$x.png";
					$in_icon_name = "in_$x";
					$ac_icon_name = "ac_$x";
				}


				$ret_menu .=	$cgi->start_td({-align=>'center'});
				$ret_menu .=		$cgi->a({ -href => "$menu{$x}" }, $cgi->img({-class=>'top_menu', -name=>$ac_icon_name, -src=>$icon_file, -alt=>"$x", -border=>0}));
				$ret_menu .= 		$cgi->font({-class=>'ac_menu'}, "<br>&nbsp;$msg_head_short->{$x}&nbsp;");
				$ret_menu .= 	$cgi->end_td();

				my $foo    = "\%m_$x"; #-- select sub menu hash
				if ($foo =~ /^([\%\w_]+)$/) {
					$foo = $1;  # $foo now untainted
				} else {
					$self->display_error('Bad data in select submenu hash...');
				}

				if( ! defined $self->{"back_url"} ) {
                	# assemble url to active submenu
                	my $act_sub = "\$m\_$active\{$sactive\}";
                	if ($act_sub =~ /^([\$\%\w_\{\}]+)$/) {
                		$act_sub = $1; # $foo now untainted
                	} else {
                		$self->display_error('Bad data ...');
                	exit;
                	}
                	$self->{"back_url"} = eval("$act_sub");
                }

				my %s_hash = ();
				tie %s_hash, "Tie::IxHash";
					%s_hash = eval("$foo");
				if( keys %s_hash ){
					my $__c = 0;
					foreach my $y ( keys %s_hash ) {
					    my $menutext = $msg_submenu->{$y};
					    if( $y eq "ca" ) {
						if( -f "/etc/ssl/certs/cert.pem" ) {
						    $menutext = $msg_submenu->{$y."_del"};
						} else {
						    $menutext = $msg_submenu->{$y."_crea"};
						}
					    }
						if ( $y eq $sactive ) {
							if ( $__c > 0) {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'active'}, $cgi->a({-class=>'active', -href=>$s_hash{$y}}, $menutext));
							} else {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'f_active'}, $cgi->a({-class=>'active', -href=>$s_hash{$y}}, $menutext));
							}
						} else {
							if ( $__c > 0) {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'inactive'}, $cgi->a({-class=>'inactive', -href=>$s_hash{$y}}, $menutext));
							} else {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'f_inactive'}, $cgi->a({-class=>'inactive', -href=>$s_hash{$y}}, $menutext));
							}
						}
						$__c++;
					}
					undef $__c;
					$sub_menu .= $cgi->td({-with=>'100%', -class=>'menu_space'}, '&nbsp;');
					$sub_menu .= $cgi->end_Tr();
				} else {
					$sub_menu="";
				}
				$sub_menu .= $cgi->end_table();
			} else {
	 			if (-f $self->{"__tab_real_path"} . $self->{"__tab_path"} . "/in_$x.png") {
					$icon_file = $self->{"__tab_path"} . "/in_$x.png";
					$in_icon_name = "in_$x";
					$ac_icon_name = "ac_$x";
				}
				$ret_menu .=	$cgi->start_td({-align=>'center'});
				$ret_menu .=		$cgi->a({	-href			=> "$menu{$x}",
												-onMouseOver	=> "change_img('$in_icon_name','$ac_icon_name')",
												-onMouseOut		=> "change_img('$in_icon_name','$in_icon_name')"
											}, $cgi->img({-class=>'top_menu', -name=>$in_icon_name, -src=>$icon_file, -alt=>"$x", -border=>0}));
				$ret_menu .= 				$cgi->font({-class=>'ac_menu'}, "<br>&nbsp;$msg_head_short->{$x}&nbsp;");
				$ret_menu .=	$cgi->end_td();
			}
		}
		$ret_menu .= $cgi->end_Tr();
		$ret_menu .= $cgi->end_table();
	} else  {
		#-- menu hash
		#--- top menu
		$menu{'settings'} = "/suse/menu.pl?sessionID=$sessionID\&lang=$lang\&tab=settings";

		if( ! defined $confParam->{mustchangepasswd} ) {
		    $menu{'folder'}   = "/suse/menu.pl?sessionID=$sessionID\&lang=$lang\&tab=folder";
		    $menu{'sieve'}    = "/suse/menu.pl?sessionID=$sessionID\&lang=$lang\&tab=sieve";
		    if( $self->{'session'}->{'confParam'}->{'gidnumber'} == 102 ) {
                    	$menu{'teacher'}    = "/suse/menu.pl?sessionID=$sessionID\&lang=$lang\&tab=teacher";
		    }
		    $menu{'lang'}     = "/suse/change_lang.pl?sessionID=$sessionID\&tab=lang";
		}
		$menu{'logout'}   = "/suse/menu.pl?sessionID=$sessionID\&tab=logout\&lang=$lang";

		#--- submenu data
		if( ! defined $confParam->{mustchangepasswd} ) {
		    $m_settings{'data'}     = "/suse/edit_user4user.pl?sessionID=$sessionID\&lang=$lang\&tab=settings\&stab=data";
		    $m_settings{'cert'}     = "/suse/readcert.pl?sessionID=$sessionID\&lang=$lang\&tab=settings\&stab=cert";
		    if(defined($::CONF_GLOBAL{'GENERAL'}{'EnableVPNSrv'}) and $::CONF_GLOBAL{'GENERAL'}{'EnableVPNSrv'} eq 'true') {
		        $m_settings{'cvpn'} = "/suse/readvpnconf.pl?sessionID=$sessionID\&lang=$lang\&tab=settings\&stab=cvpn";
		    }
		    $m_settings{'user_cups'} = "/suse/user_cups.pl?sessionID=$sessionID\&tab=settings\&lang=$lang\&stab=user_cups";
		}
		$m_settings{'password'} = "/suse/change_passwd.pl?sessionID=$sessionID\&lang=$lang\&tab=settings\&stab=password";

		#--- submenu folder
		if( ! defined $confParam->{mustchangepasswd} ) {
		    $m_folder{'new'}	    = "/suse/manage_folder.pl?sessionID=$sessionID\&tab=folder\&lang=$lang\&stab=new\&View=new";
		    $m_folder{'edit'}	    = "/suse/manage_folder.pl?sessionID=$sessionID\&tab=folder\&lang=$lang\&stab=edit";
		    $m_folder{'subscribe'}  = "/suse/subscribe_folder.pl?sessionID=$sessionID\&tab=folder\&lang=$lang\&stab=subscribe";
		    $m_folder{'acl_edit'}   = "/suse/edit_acl.pl?sessionID=$sessionID\&tab=folder\&lang=$lang\&stab=acl_edit";
		}
		#--- submenu sieve
		#print STDERR $::CONF_GLOBALS{'GENERAL'}{'EnableSieveEditor'}."\n";
		if( ! defined $confParam->{mustchangepasswd} ) {
                  $m_sieve{'procmail'}  = "/suse/mail_filter.pl?sessionID=$sessionID\&tab=sieve\&lang=$lang\&stab=procmail";
                  if( $::CONF_GLOBAL{'GENERAL'}{'EnableUserSpamFrontend'} eq 'true' ){
                    $m_sieve{'spamfilter'}  = "/suse/spam_filter.pl?sessionID=$sessionID\&tab=sieve\&lang=$lang\&stab=spamfilter";
                  }
                  $m_sieve{'vacation'} = "/suse/vacation.pl?sessionID=$sessionID\&tab=sieve\&lang=$lang\&stab=vacation";
                  if($::CONF_GLOBAL{'GENERAL'}{'EnableSieveEditor'} eq 'true'){
                    $m_sieve{'sieve_edit'} = "/suse/edit_sieve.pl?sessionID=$sessionID\&tab=sieve\&lang=$lang\&stab=sieve_edit";
                  }
		}

		#--- submenu network services
		if( ! defined $confParam->{mustchangepasswd} ) {
			$m_teacher{'control'}   = "/suse/control.pl?sessionID=$sessionID\&tab=teacher\&lang=$lang\&stab=control";
			$m_teacher{'post_file'} = "/suse/post_file.pl?sessionID=$sessionID\&tab=teacher\&lang=$lang\&stab=post_file";
			$m_teacher{'get_file'}  = "/suse/get_file.pl?sessionID=$sessionID\&tab=teacher\&lang=$lang\&stab=get_file";
			if( $self->{"session"}->{"confParam"}->{"admin"} ) {
				$m_teacher{'user'}     = "/suse/browse_user.pl?sessionID=$sessionID\&tab=teacher\&lang=$lang\&stab=user";
				$m_teacher{'new_grp'}  = "/suse/create_group.pl?sessionID=$sessionID\&tab=teacher\&lang=$lang\&stab=new_grp";
				$m_teacher{'edit_grp'} = "/suse/browse_groups.pl?sessionID=$sessionID\&tab=teacher\&lang=$lang\&stab=edit_grp";
			}
		}

		#--- submenu flag
			$m_lang{'lang_select_dummy'} = "/suse/change_lang.pl?sessionID=$sessionID\&tab=lang";

		#--- submenu logout

		#}}}
		#-- make menus#{{{
		$ret_menu = $cgi->start_table();
			$ret_menu .= $cgi->start_Tr();
		$sub_menu = $cgi->start_table({-cellspacing=>0, -cellpadding=>0, -width=>'100%'});
			$sub_menu .= $cgi->start_Tr();

		my $icon_file = $self->{"__tab_path"} . "/dummy.png";
		my $in_icon_name = 'dummy';
		my $ac_icon_name = 'dummy';
		foreach my $x (keys %menu) {
			if ( $x eq $active ) {
				if (-f $self->{"__tab_real_path"} . $self->{"__tab_path"} . "/ac_$x.png") {
					$icon_file = $self->{"__tab_path"} . "/ac_$x.png";
					$in_icon_name = "in_$x";
					$ac_icon_name = "ac_$x";
				}
				$wo_ich_sein = $msg_head_long->{$x};

				$ret_menu .=	$cgi->start_td({-align=>'center'});
				$ret_menu .=		$cgi->a({ -href => "$menu{$x}" }, $cgi->img({-class=>'top_menu', -name=>$ac_icon_name, -src=>$icon_file, -alt=>"$x", -border=>0}));
				$ret_menu .= 		$cgi->font({-class=>'ac_menu'}, "<br>&nbsp;$msg_head_short->{$x}&nbsp;");
				$ret_menu .= 	$cgi->end_td();

				my $foo    = "\%m_$x"; #-- select sub menu hash
				if ($foo =~ /^([\%\w_]+)$/) {
					$foo = $1;  # $foo now untainted
				} else {
					$self->display_error('Bad data in select submenu hash...');
				}
				
				my %s_hash = ();
				tie %s_hash, "Tie::IxHash";
					%s_hash = eval("$foo");
				if( keys %s_hash ){
					my $__c = 0;
					foreach my $y ( keys %s_hash ) {
						if ( $y eq $sactive ) {
							if ( $__c > 0) {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'active'}, $cgi->a({-class=>'active', -href=>$s_hash{$y}}, $msg_submenu->{$y}));
							} else {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'f_active'}, $cgi->a({-class=>'active', -href=>$s_hash{$y}}, $msg_submenu->{$y}));
							}
						} else {
							if ( $__c > 0) {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'inactive'}, $cgi->a({-class=>'inactive', -href=>$s_hash{$y}}, $msg_submenu->{$y}));
							} else {
								$sub_menu .= $cgi->td({-width=>'1', -class=>'f_inactive'}, $cgi->a({-class=>'inactive', -href=>$s_hash{$y}}, $msg_submenu->{$y}));
							}
						}
						$__c++;
					}
					undef $__c;
					$sub_menu .= $cgi->td({-with=>'100%', -class=>'menu_space'}, '&nbsp;');
					$sub_menu .= $cgi->end_Tr();
				} else {
					$sub_menu="";
				}
				$sub_menu .= $cgi->end_table();
			} else {
	 			if (-f $self->{"__tab_real_path"} . $self->{"__tab_path"} . "/in_$x.png") {
					$icon_file = $self->{"__tab_path"} . "/in_$x.png";
					$in_icon_name = "in_$x";
					$ac_icon_name = "ac_$x";
				}
				$ret_menu .=	$cgi->start_td({-align=>'center'});
				if ($x eq 'webmail') {
					$ret_menu .=		$cgi->a({	-href			=> "$menu{$x}",
													-target			=> 'WebMail',
													-onMouseOver	=> "change_img('$in_icon_name','$ac_icon_name')",
													-onMouseOut		=> "change_img('$in_icon_name','$in_icon_name')"
												}, $cgi->img({-class=>'top_menu', -name=>$in_icon_name, -src=>$icon_file, -alt=>"$x", -border=>0}));
				} else {
					$ret_menu .=		$cgi->a({	-href			=> "$menu{$x}",
													-onMouseOver	=> "change_img('$in_icon_name','$ac_icon_name')",
													-onMouseOut		=> "change_img('$in_icon_name','$in_icon_name')"
												}, $cgi->img({-class=>'top_menu', -name=>$in_icon_name, -src=>$icon_file, -alt=>"$x", -border=>0}));
				}
				$ret_menu .= 		$cgi->font({-class=>'ac_menu'}, "<br>&nbsp;$msg_head_short->{$x}&nbsp;");
				$ret_menu .=	$cgi->end_td();
			}
		}
		$ret_menu .= $cgi->end_Tr();
		$ret_menu .= $cgi->end_table();
		#}}}

	}

	# build list of submenu items to return to main DISPLAY
	my $foo    = "\%m_$active";
	if ($foo =~ /^([\%\w_]+)$/) {
	    $foo = $1;  # $foo now untainted
	} else {
	    $self->display_error('Bad data in select submenu hash...');
	}
	my %s_hash = ();
	tie %s_hash, "Tie::IxHash";
	%s_hash = eval("$foo");
	my $topics;
	foreach my $k ( keys %s_hash ) {
	    my $post_fix = $k;
	    if( $post_fix eq "ca" ) {
		if( -f "/etc/ssl/certs/cert.pem" ) {
		    $post_fix .= "_del";
		} else {
		    $post_fix .= "_crea";
		}
	    }
            push @$topics, $active."_".$post_fix;
	    #print STDERR "<$k>\n";
	}
	
	return ($ret_menu, $wo_ich_sein, $sub_menu, $topics);
}#}}}

sub display_error {#{{{
    my $this = shift;
    my $content  = shift;

    my $lang     = $this->{"session"}->{"confParam"}->{"LANG"};
    my $cgi      = $this->{"cgi"};

    my $uri      = shift || '/';
    my $ref_time = shift || undef;
    my $ref_txt  = shift || undef;

    #--- subdir zu den icons
    my $__tab_path  = '/images/top_nav';

    my $head = "";
    if ($lang eq 'DE') {
      $head = 'Fehler';
    } elsif ($lang eq 'HU') {
       $head = 'HIBA';
    } else {
      $head = 'ERROR';
    }

    if ( ! defined $ref_time  ) {
        print $cgi->header(-expires => "-10y", -pragma => "no-cache", -charset => "$this->{'charset'}");
    } else {
        print $cgi->header(-Refresh=>"$ref_time; URL=$uri", -pragma => "no-cache", -expires => "-10y" , -charset => "$this->{'charset'}" );
    }
    print $cgi->start_html( -title  => "SuSE Linux School Server Administration",
                            -style  =>{'src'=>'/stylesheetAdmin.css'});
    print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>751});
    print $cgi->Tr($cgi->td({-valign=>"top"}, $cgi->img({-src=>"$__tab_path/header.png", -alt=>"Logo"})));
    print $cgi->start_Tr();
    print $cgi->start_td({});
    #--- roter rahmen start
    print $cgi->start_table({-class=>'AdminError', -cellspacing=>0, -cellpadding=>2, -width=>"100%"});
    print $cgi->start_Tr();
    print $cgi->start_td();
    print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>0, -cellpadding=>0, -width=>"100%"});
    print $cgi->Tr($cgi->td({-class=>'AdminTdRed'}, $head));
    #--- der inhalt
    print $cgi->Tr($cgi->td("<br><pre>$content</pre><br>"));
    #--- footer
    if (defined $ref_time ) {
      print $cgi->start_Tr();
      if ($lang eq 'DE') {
        print $cgi->td({-align=>"center"},
            ( defined $ref_txt ? $ref_txt :
                        'Werden sie nicht weitergeleitet,<br>klicken Sie bitte ').
                        $cgi->a({-href=>"$uri"}, '<b>hier</b><br><br>'));
    } elsif ($lang eq 'HU') {
    	print $cgi->td({-align=>"center"},
        	( defined $ref_txt ? $ref_txt :
                    'Amennyiben nem történik az átirányítás,<br>kattintson ').
                    $cgi->a({-href=>"$uri"}, '<b>ide</b><br><br>'));
    } else {
        print $cgi->td({-align=>"center"},
            ( defined $ref_txt ? $ref_txt :
                        'If you would not get redirected,<br>please click ').
                        $cgi->a({-href=>"$uri"}, '<b>here</b><br><br>'));
      }
      print $cgi->end_Tr();
    } else {
      print $cgi->start_Tr();
      print $cgi->td({-align=>"center"}, $cgi->a({-href=>"$uri"}, '<b>OK</b><br><br>'));
      print $cgi->end_Tr();
    }
    print $cgi->end_table();
    print $cgi->end_td();
    print $cgi->end_Tr();
    print $cgi->end_table();
    #--- roter rahmen ende
    print $cgi->end_td();
    print $cgi->end_Tr();
    print $cgi->end_table();
    print $cgi->end_html();
}#}}}

sub display_msg {#{{{
    my $this     = shift;
    my $content  = shift;

    my $lang     = $this->{"session"}->{"confParam"}->{"LANG"};
    my $cgi      = $this->{"cgi"};

    my $uri      = shift || '/';
    my $ref_time = shift || undef;
    my $ref_txt  = shift || undef;

    #--- subdir zu den icons
    my $__tab_path  = '/images/top_nav';

    my $head = "";
    if ($lang eq 'DE') {
      $head = 'Nachricht';
    } elsif ($lang eq 'HU') {
      $head = 'Üzenet';
    } else {
      $head = 'Message';
    }

    if ( ! defined $ref_time ) {
        print $cgi->header(-expires => "-10y", -pragma => "no-cache", -charset => "$this->{'charset'}" );
    } else {
        print $cgi->header(-Refresh=>"$ref_time; URL=$uri", -pragma => "no-cache", -expires => "-10y", -charset => "$this->{'charset'}" );
    }
    print $cgi->start_html( -title  => "SuSE Linux School Server Administration",
                            -style  =>{'src'=>'/stylesheetAdmin.css'});
    print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>751});
    print $cgi->Tr($cgi->td({-valign=>"top"}, $cgi->img({-src=>"$__tab_path/header.png", -alt=>"Logo"})));
    print $cgi->start_Tr();
    print $cgi->start_td({});
    #--- grüner rahmen start
    print $cgi->start_table({-class=>'AdminInfo', -cellspacing=>0, -cellpadding=>2, -width=>"100%"});
    print $cgi->start_Tr();
    print $cgi->start_td();
    print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>0, -cellpadding=>0, -width=>"100%"});
    print $cgi->Tr($cgi->td({-class=>'AdminTdGray'}, $head));
    #--- der inhalt
    print $cgi->Tr($cgi->td("<br><pre>$content</pre><br>"));
    #--- footer
    if ( defined $ref_time ) {
      print $cgi->start_Tr();
      if ($lang eq 'DE') {
        print $cgi->td({-align=>"center"},
            ( defined $ref_txt ? $ref_txt :
                        'Werden sie nicht weitergeleitet,<br>klicken Sie bitte ').
                        $cgi->a({-href=>"$uri"}, '<b>hier</b><br><br>'));
    } elsif ($lang eq 'HU') {
    	print $cgi->td({-align=>"center"},
        	( defined $ref_txt ? $ref_txt :
                    'Amennyiben nem történik az átirányítás,<br>kattintson ').
                    $cgi->a({-href=>"$uri"}, '<b>ide</b><br><br>'));
      } else {
        print $cgi->td({-align=>"center"},
            ( defined $ref_txt ? $ref_txt : 
                        'If you would not get redirected,<br>please click ').
                        $cgi->a({-href=>"$uri"}, '<b>here</b><br><br>'));
      }
      print $cgi->end_Tr();
    } else {
      print $cgi->start_Tr();
      print $cgi->td({-align=>"center"},
                      $cgi->a({-href=>"$uri"}, '<b>OK</b><br><br>'));
      print $cgi->end_Tr();
    }
    print $cgi->end_table();
    print $cgi->end_td();
    print $cgi->end_Tr();
    print $cgi->end_table();
    #--- grüner rahmen ende
    print $cgi->end_td();
    print $cgi->end_Tr();
    print $cgi->end_table();
    print $cgi->end_html();
}#}}}

sub help_th() {#{{{
    my $this            = shift;
    my $colspan         = shift;
    my $title           = shift;
    $this->{'topic'}    = shift;
    my $to = $this->{'topic'};

    my $confParam = $this->{"session"}->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $content  = $this->{"content"};
    my $lang     = $confParam->{"LANG"};
    my $cgi      = $this->{"cgi"};

    my $uri      = shift || '/';
    my $ref_time = shift || undef;

    # --- ist krank, aber geht
    my $JavaScript=<<EOF;
    parem='width=570,height=510,directories=no,menubar=no,toolbar=no,scrollbars=yes,resizable=yes'; contacts_window=window.open('$confParam->{cgi_path}/help.pl?sessionID=$sessionID\&topic=$to', 'ImapHelpWin', parem); if (!contacts_window.opener) contacts_window.opener=self;
EOF

    return  $cgi->td({-class=>"AdminHeader", -colspan=>$colspan, -valign=>"TOP"},
                $cgi->table({-border=>0, -cellspacing=>0, -cellpadding=>5, -width=>"100%"},
                    $cgi->Tr({},
                        $cgi->td({-class=>"AdminHeader", -align=>"LEFT", -width=>"1%"},
				 ( $lang eq "DE" ? 
				   $cgi->a({-href=>"/manual/manual".$lang.".pdf", -target=>"Manual"},
					   $cgi->img({-border=>0, -src=>"/images/manual.gif", -alt=>"Manual"})
					   )
				   :
				   $cgi->img({-border=>0, -src=>"/images/manual.gif", -alt=>"Manual"})
				   )
                                ).

                        $cgi->td({-class=>"AdminHeader", -align=>"CENTER", -width=>"98%"}, $title).
                        $cgi->td({-class=>"AdminHeader", -align=>"LEFT", -width=>"1%"},
                            $cgi->a({-href=>"javascript:void(0);", -onclick=>$JavaScript},
                                $cgi->img({-border=>0, -src=>"$confParam->{image_path}/help1.gif", -width=>18, -height=>18, -alt=>"Help" })
                            )
                        )
                    )
                )
                );
}#}}}

sub display_head {#{{{
    my $this     = shift;

    my $lang     = $this->{"session"}->{"confParam"}->{"LANG"};
    my $cgi      = $this->{"cgi"};

    #my $ref_time = shift || undef;

    #--- subdir zu den icons
    my $__tab_path  = '/images/top_nav';

    my $head = "";
    if ($lang eq 'DE') {
      $head = 'Nachricht';
    } elsif ($lang eq 'HU') {
      $head = 'Üzenet';
    } else {
      $head = 'Message';
    }
    print $cgi->header(-expires => "-10y", -pragma => "no-cache", -charset => "$this->{'charset'}");
    print $cgi->start_html( -title  => "SuSE Linux School Server Administration",
                            -style  =>{'src'=>'/stylesheetAdmin.css'});
    print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>751});
    print $cgi->Tr($cgi->td({-valign=>"top"}, $cgi->img({-src=>"$__tab_path/header.png", -alt=>"Logo"})));
    print $cgi->start_Tr();
    print $cgi->start_td({});
    #--- grner rahmen start
    print $cgi->start_table({-class=>'AdminInfo', -cellspacing=>0, -cellpadding=>2, -width=>"100%"});
    print $cgi->start_Tr();
    print $cgi->start_td();
    print $cgi->start_table({-class=>'AdminBorder', -cellspacing=>0, -cellpadding=>0, -width=>"100%"});
    print $cgi->Tr($cgi->td({-class=>'AdminTdGray'}, $head));
}#}}}

sub display_footer {#{{{
    my $this     = shift;

    my $lang     = $this->{"session"}->{"confParam"}->{"LANG"};
    my $cgi      = $this->{"cgi"};

    my $uri      = shift || '/';
    print $cgi->end_td().$cgi->end_Tr();
    print $cgi->start_Tr();
    print $cgi->td({-align=>"center"},
         $cgi->a({-href=>"$uri"}, '<b>OK</b><br><br>')
         );
    print $cgi->end_Tr();
    print $cgi->end_table();
    print $cgi->end_td();
    print $cgi->end_Tr();
    print $cgi->end_table();
    #--- grüner rahmen ende
    print $cgi->end_td();
    print $cgi->end_Tr();
    print $cgi->end_table();
    print $cgi->end_html();
}#}}}

sub __help_GetContent {#{{{
    my $self        = shift;
    my $topics      = shift;
    my $session     = $self->{'session'};
    my $confParam   = $session->{"confParam"};
    my $line        = '';
    my $body        = '<dl>';

    my $message     = ($session->getLanguage($confParam->{LANG},"HELP"))->data();

    foreach my $topic ( @$topics ) {
	my $helppath = $confParam->{'shorthelp_path'}."/".$confParam->{'LANG'}."/".$topic.".html";
	if(! (open (FILE,"< $helppath")) ){
	    $body .= "<dt><b>$topic</b></dt><dd>".$message->{'no_help_avail_long'}."</dd>";
	}else{
	    while ($line=<FILE>) {
		$body .= $line;
	    }
	}
	close FILE;
    }	

    return $body."</dl>";
}#}}}

1;

