#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: GroupFilterlist.pm,v 1.4 2004/05/03 20:04:36 varkoly Exp $
#
# Dieses Paket wurde vom Filterlist erweitert. Es gibt ein Zweites Feld zum Suchen:
# Klassen

package GroupFilterlist;
use LDAPUtils;
use Exporter;
use Utils;
use Display;
use strict;

sub new {
    my ($this, $cgi, $session, $ldap) = @_;
    my $class= ref($this) || $this;
    my $self = {};
    $self->{'cgi'} = $cgi;
    $self->{'session'} = $session;
    $self->{'ldap'} = $ldap;

    return bless($self,$class);

}

sub make_filter_view {
    my $this = shift;

    my $cgi  = $this->{"cgi"};
    my $ldap = $this->{"ldap"};

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};

    my $param    = shift;
    my $textlabel   = $param->{'textlabel'};
    my $listlabel_left  = $param->{'listlabel_left'};
    my $name1    = $param->{'textfield'};     #name of the textfield
    my $name2    = $param->{'listname'};      #name of the list
    my $name3    = $param->{'classname'};      #name of the list
    my $buttonlabel     = $param->{'buttonlabel'};
    my $listlabel_right = $param->{'listlabel_right'};
    my $nofilter = $param->{"nofilter-msg"}||"set filter";  #message if no filter has been set
    my $listfilter  = $param->{"listfilter"};   #ldap filter-rule for list (array: attr,value)
    my $listattrs   = $param->{"listattrs"};   #ldap filter-rule for list (array: attr,value)
    my $labelexp = $$param{"labelexp"};      #expression for labels
    my $width    = $$param{"width"};         #width of text-field
    my $height   = $$param{"height"};        #number of lines in select-box
    my $multi    = $$param{"multiple"}||"";  #select-box with multiple selection
    my $selectedfilter  = $$param{"selectedfilter"}; #ldap filter-rule for selected values (array: attr,value)
#    my $selectedattrs   = $$param{"selectedattrs"}; #ldap filter-rule for selected values (array: attr,value)
    my $selectedregex    = $$param{"selectedregex"}; #optional parameter  this array holds the 
						     #ldap attribute and the regular expression for defaults
    my $url      = $$param{"error-url"};     #url to return after errors
# I SCHULSERVER
    my @entries = ();
# E SCHULSERVER
    
    my $output  = "";
    my $values=[];
    my $defaults=[];
    my $result;
    my $result2;
    my $textfield  = $cgi->param($name1) || '*';
    my $classfield = $cgi->param($name3) || '*';

    if ( ( (!(defined $cgi->param($buttonlabel))) || ( $cgi->param($buttonlabel) eq "" ) ) && 
	 ( (!(defined $cgi->param("filtered"))) || ( $cgi->param("filtered") != 1) ) ){
        $values=[$nofilter];
        $defaults=[$nofilter];
    } else {
# SCHULSERVER I
# Jetzt werden die Mitglieder der gewhlten Klasse gesucht.
	if ($classfield ne "*" ) {
	   my $classfilter = "";
	   if($textfield eq '*') {
		$listfilter = '';
	   }
	   if ($confParam->{uid}  == "cyrus" ) {
		$classfilter = "(&(objectclass=posixgroup)(|(description=$classfield)(cn=$classfield)))";
	   } else {
		$classfilter = "(&(objectclass=posixgroup)(cn=$classfield)(memberUid=$confParam->{uid})";
	   }
	   $result=$ldap->search(base   => $confParam->{"baseDN"},
                              scope  => "one",
                              filter => $classfilter,
			      attrs  => ['memberUid','gidnumber']
			     );
	   my @entr = $result->entries;
	   # Jetzerla suchen wir die Benutzer mssen jedoch dafr sorgen, dass jeder uid nur ein mal vorkommt:
	   my $ind = {}; 
           foreach my $act_entry ( @entr ){
		my @uids = $act_entry->get_value('memberUid');
		foreach my $uid ( @uids ) {
		   if( not exists($ind->{$uid}) ) {
			$result=$ldap->search(base   => $confParam->{"baseDN"},
				scope  => "one",
				filter => "(&(&(objectclass=posixAccount)(objectclass=SuSEeMailObject)(uid=$uid))".
					   $listfilter.")",
				attrs  => $listattrs
			);
			if ($result->count() > 0) {
 			  push @entries , $result->entries;
			}
		        $ind->{$uid} = 1;
		   } 
		}
	   	# And now we are searching the users with primary group
		my $gidnumber = $act_entry->get_value('gidnumber');
		$result=$ldap->search(base   => $confParam->{"baseDN"},
                                scope  => "one",
                                filter => "(&(&(objectclass=posixAccount)(objectclass=SuSEeMailObject)(gidnumber=$gidnumber))".$listfilter.")",
                                attrs  => $listattrs
                );
		foreach my $ent ($result->entries()){
		    if ($result->count() > 0) {
			    my $uid = $ent->get_value('uid');
			    if( not exists($ind->{$uid}) ) {
				push @entries , $ent;
				$ind->{$uid} = 1;
			    }
		    }
		}
	   }
	   
	   if( $#entries == -1 ){
		$values=[$nofilter];
	   }
	} else {
# SCHULSERVER E
# SCHULSERVER C
		my $ldapfilter=$listfilter;
		
		$result=$ldap->search(base   => $confParam->{"baseDN"},
				      scope  => "one",
				      filter => $ldapfilter,
				      attrs  => $listattrs  
				     );
		if ($result->code != 0) {
		    my $errs = "search: failed\n\n";
		    $errs .= &LDAPerror($result);
#		    $this->display_error($errs,$url);
		    $ldap->unbind;   # take down session
		    exit;
		}
		if ($result->count==0) {
		    #no results => set new filter
		    $values=[$nofilter];
		    #$defaults=[$nofilter];
		} else {
		    #otherwise show results
		    push @entries , $result->entries;
		}
	 }
            foreach my $act_entry (@entries){
# SCHULSERVER E
                push @$values, $act_entry->get_value($listattrs->[0]);
                if( (! (defined $selectedfilter)) && (defined $selectedregex) && (@$selectedregex == 2)){
                    my @values = $act_entry->get_value($selectedregex->[0]);
                    if( @values > 0 ){
                       foreach my $value (@values){
                            if( $value =~ /$selectedregex->[1]/ ){
			        if(defined $1){
				    push @$defaults, $1;
                                }else{
	                            push @$defaults, $act_entry->get_value($selectedregex->[0]);
	                        }
			    }
			}
                    }
                }
            }
            if (defined $selectedfilter) {
                $result2=$ldap->search(base => $confParam->{"baseDN"},
				       scope => "one",
				       filter => $selectedfilter,
				       attrs => $selectedregex->[0]);
                if ($result2->code != 0) {
                    my $errs = "search: failed\n\n";
                    $errs .= &LDAPerror($result2);
#                    $this->display_error($errs,$url);
                    $ldap->unbind;   # take down session
                    exit;
                }
		my @entr = $result2->entries();
		foreach my $act_entry (@entr){
		    if((defined $selectedregex) && (@$selectedregex == 2)){
			my @values = $act_entry->get_value($selectedregex->[0]);
			if( @values > 0 ){
			   foreach my $value (@values){
				if( $value =~ /$selectedregex->[1]/ ){
				    if(defined $1){ 
					push @$defaults, $1;
				    }else{
					push @$defaults, $act_entry->get_value($$selectedregex[0]);
				    }
				}
			    }
			}
		    }
		}
           }
    }
    
    $output .= $cgi->start_Tr();
    if( (defined $textlabel) || (defined $listlabel_right) ){
        $output .= $cgi->start_td();
        if(defined $textlabel){
            $output .= $textlabel;
        }else{
            $output .= "&nbsp;"
        }
        $output .= $cgi->end_td();
    }
    $output .= $cgi->start_td({-align => 'center'}).
                $cgi->textfield(-name=>"$name1",-default=>$textfield || "*",-size=>"$width").
            $cgi->end_td().
            $cgi->start_td({-align => 'center'}).
                $cgi->submit(-class=>"button",-name => $buttonlabel).
            $cgi->end_td().
        $cgi->end_Tr();
    $output .= $cgi->start_Tr().
	    $cgi->start_td().$name3.$cgi->end_td().
            $cgi->start_td({-align => 'center'}).
            $cgi->textfield(-name=>"$name3",-default=>$classfield || "*",-size=>"$width").
            $cgi->end_td().
	    $cgi->end_Tr();
    
    #create the labels hash for the scrolling list
    my %labels;
    if( $values->[0] ne $nofilter ){
        foreach my $act_entry ( @entries ){
            for (my $j=0; $j <= $#$labelexp; $j = $j + 2) {
              my $attrname = $act_entry->get_value($$labelexp[$j+1]);
              my $string = $$labelexp[$j];
              if ($string=~/\$\$/)  {
                $string=~s/\$\$/$attrname/;
              }
              elsif ($string=~/%.%/)  {
              #typ is FLAG
                if (defined $attrname) {
                    $string=~s/%(.)%/$1/;
                }
                else {
                  $string=~s/%(.)%//;
                }
              }
              $string=~s/\\\$/\$/;
              $string=~s/\\%/%/;
              $labels{$act_entry->get_value($listattrs->[0])} .= $string;
            }
        }
    } 
    @$values=sort(@$values);
    if(defined $defaults){
        @$defaults=sort(@$defaults);
    }
    if( (defined $defaults) && @$defaults && ($defaults->[0] eq $nofilter)){
        $defaults = [];
    }

    $output .= $cgi->start_Tr();
    if( (defined $textlabel) || (defined $listlabel_right) ){
        $output .= $cgi->start_td({-valign => "top"});
        if(defined $listlabel_left){
            $output .= $listlabel_left;
        }else{
            $output .= "&nbsp;"
        }
        $output .= $cgi->end_td();
    }
    $output .= $cgi->start_td({-align => 'center'}).
                $cgi->scrolling_list(-name => $name2,
                                    -values => $values, 
                                    -default => $defaults, 
                                    -labels => \%labels,
                                    -override => 1, 
                                    -size => $height,
				    -width => ($width*8),
				    -multiple   => ( $multi ne "" ? 'true' : "" )
                                    );
    if( (defined $values) && (defined $values->[0]) && ($values->[0] ne $nofilter) ){
        $output .= $cgi->hidden( -name => "filtered",
                                 -value => 1,
                                 -override => 1);
    }
    $output .= $cgi->end_td().
            $cgi->start_td({-align => 'center'});
    if(defined $listlabel_right){
        $output .= $listlabel_right;
    }else{
        $output .= "&nbsp;";
    }
    $output .= $cgi->end_td().
        $cgi->end_Tr();

   return $output;
}

1;

