# 
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: admin_cups.pm,v 1.2 2003/07/29 13:27:05 varkoly Exp $
#

package admin_cups;

use strict;
use Storable qw(thaw freeze);
use CGI qw/:standard *table start_ul -no_xhtml/;
use CGI::Carp qw(fatalsToBrowser);
use Display;
use vars qw(@ISA $confParam);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };

@ISA = qw(Display);

sub new{
    my $this = shift;
    my $self = new Display(@_);

    return bless $self, $this;
}

####################################
# display
sub display{
    my $this = shift;

    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $q = $this->{'cgi'};
    my $sessionID = $confParam->{'sessionID'};
    my $username= $confParam->{"uid"};

    $this->{'HTMLOUT'} = "" ;
    my $mode = $q->param('mode');
    if (! defined $mode ){
        $mode = 'display';
    }

    if( $mode eq 'display' ){
        $this->display_script();
    }

}
# end display
###################################

###################################
#
sub display_script(){
    my $this = shift;
    my $q = $this->{'cgi'};
    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $sessionID = $confParam->{'sessionID'};
    my $message = ($session->getLanguage($confParam->{LANG},"ADM_CUPS"))->data();
    my $tab = $q->param('tab');
    my $stab = $q->param('stab');
    my @browse_addresses = ();
    my $browse_intervall = 30;
    #my @location = ();
    my @location_ip = ();
    #my @location_admin = ();
    my @location_admin_ip = ();

    my $server = 'http://printserver';
#    my $server = $q->url(-base => 1);
#    if( exists $ENV{'CUPS_SERVER'} ) {
#        $server = $ENV{'CUPS_SERVER'};
#    } elsif ( -r "/etc/cups/client.conf" ) {
#        if( open( CUPSCONF, "< /etc/cups/client.conf" ) ) {
#            my $l;
#            while( $l = <CUPSCONF> ) {
#                next unless( $l =~ /^ServerName\s+(.*)/ );
#                $server = $1;
#                last;
#            }
#            close(CUPSCONF);
#        }
#    }
#    $server =~ s/https/http/i;

    #
    # reading data from cupsd.conf
    #
    if( -e '/etc/cups/cupsd.conf' ) {
        my $cdata = $session->suad_read('/etc/cups/cupsd.conf');
        if($cdata->code() =~ /^ERROR:\s*(.*)/) {
            $this->display_error("unable to open /etc/cups/cupsd.conf: $1",
                                 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit(1);
        }
        # parse config data
        my @cupsd_conf = split("\n", $cdata->data());
        @cupsd_conf = map( "$_\n", @cupsd_conf );  # I want my "\n" back
        for( my $i=0; $i <  @cupsd_conf; $i++ ) {
            next if( $cupsd_conf[$i] =~ /^#/ ); # 90% are comments
            if( $cupsd_conf[$i] =~ /^BrowseAddress\s+(.*)/ ) {
                push( @browse_addresses, $1 );
            } elsif( $cupsd_conf[$i] =~ /^BrowseInterval\s+(\d+)/ ) {
                $browse_intervall = $1;
            } elsif( $cupsd_conf[$i] =~ /^<Location\s*\/>/ ) {
                while( $cupsd_conf[++$i] !~ /^<\/Location>/ and $i < @cupsd_conf ) {
                    #push( @location, $cupsd_conf[$i] );
                    if( $cupsd_conf[$i] =~ /^Allow From (.*)/ ) {
                        push ( @location_ip, $1 );
                    }
                }
            } elsif( $cupsd_conf[$i] =~ /^<Location\s+\/admin>/ ) {
                while( $cupsd_conf[++$i] !~ /^<\/Location>/ and $i < @cupsd_conf ) {
                    #push( @location_admin, $cupsd_conf[$i] );
                    if( $cupsd_conf[$i] =~ /^Allow From (.*)/ ) {
                        push ( @location_admin_ip, $1 );
                    }
                }
            }
        }
        if( $q->param('apply') ) {
            if( defined($q->param('add.x')) ) {
                $browse_intervall = $q->param('browse_intervall');
                if( $q->param('add_this_to_browseaddress') ) {
                    push( @browse_addresses, $q->param('add_this_to_browseaddress') );
                }
                if( $q->param('add_this_to_root') ) {
                    push( @location_ip, $q->param('add_this_to_root') );
                }
                if( $q->param('add_this_to_admin') ) {
                    push( @location_admin_ip, $q->param('add_this_to_admin') );
                }
            } elsif( defined($q->param('drop.x')) ) {
                if( $q->param('del_from_browseaddress' ) ) {
                    my @to_kick = $q->param('del_from_browseaddress' );
                    @browse_addresses = kick_from_array( \@browse_addresses, \@to_kick );
                }
                if( $q->param('del_from_root' ) ) {
                    my @to_kick = $q->param('del_from_root' );
                    @location_ip = kick_from_array( \@location_ip, \@to_kick );
                }
                if( $q->param('del_from_admin' ) ) {
                    my @to_kick = $q->param('del_from_admin' );
                    @location_admin_ip = kick_from_array( \@location_admin_ip, \@to_kick );
                }
            }
            #
            # write /etc/cups/cupsd.conf
            #
            @cupsd_conf = grep(!/^BrowseAddress/, @cupsd_conf);
            @cupsd_conf = grep(!/^BrowseInterval/, @cupsd_conf);
            for( my $i=0; $i <  @cupsd_conf; $i++ ) {
                if( $cupsd_conf[$i] =~ /^<Location\s*\/>/ ) {
                    while( $cupsd_conf[++$i] !~ /^<\/Location>/ and $i < @cupsd_conf ) {
                        if( $cupsd_conf[$i] =~ /^Allow From/ ) {
                            $cupsd_conf[$i] = "";
                        }
                    }
                    foreach my $dummy ( reverse(@location_ip) ) {
                        $cupsd_conf[$i] = "Allow From $dummy\n".$cupsd_conf[$i];
                    }
                } elsif( $cupsd_conf[$i] =~ /^<Location\s+\/admin>/ ) {
                    while( $cupsd_conf[++$i] !~ /^<\/Location>/ and $i < @cupsd_conf ) {
                        if( $cupsd_conf[$i] =~ /^Allow From/ ) {
                            $cupsd_conf[$i] = "";
                        }
                    }
                    foreach my $dummy ( reverse(@location_admin_ip) ) {
                        $cupsd_conf[$i] = "Allow From $dummy\n".$cupsd_conf[$i];
                    }
                }
            }
            foreach my $dummy ( @browse_addresses ) {
                push( @cupsd_conf, "BrowseAddress $dummy\n" );
            }
            push( @cupsd_conf, "BrowseInterval $browse_intervall\n" );
            my @dummy = ();
            foreach my $l (@cupsd_conf) { 
                chomp($l); 
                push( @dummy, $l ) if( $l ne '' ) 
            }
            my $ret  = $session->suad_save( \@dummy, '/etc/cups/cupsd.conf' );
            unless($ret and $ret->code() eq "OK" ) {
                $this->display_error("$message->{'SAVE_FAILED'} : /etc/cups/cupsd.conf ".$ret->code(),
                                     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
                exit(1);
            }
            $ret = $session->suad_chown("/etc/cups/cupsd.conf", 'lp', 'sys');
            unless($ret and $ret->code() eq "OK" ) {
                $this->display_error("$message->{'CHOWN_FAILED'} /etc/cups/cupsd.conf : ".$ret->code(),
                                     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
                exit(1);
            }
            $session->suad_service_exec("cups", "reload");
        }
    }


    my $HTMLOUT ="";
    #foreach my $p ( $q->param() ) { $HTMLOUT .= "$p = ".$q->param($p)."<br>" }
    $HTMLOUT .= "\n".$q->start_table({-class       => 'AdminBorder', 
                                      -cellpadding => 2, 
				      -border=>0,
                                      -width       => "100%", 
                                      } ).
        $q->th($message->{'ADM_LINKS'}).
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->a({href=>$server.":631/printers", -target=>"Print Server" },$message->{'ADM_TOPRINTERS'}).
            $q->end_td.
        $q->end_Tr().
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->a({href=>$server.":631/jobs", -target=>"Print Server" },$message->{'ADM_TOJOBS'}).
            $q->end_td.
        $q->end_Tr.
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->a({href=>$server.":631/admin", -target=>"Print Server" },$message->{'ADM_TOADMIN'}).
            $q->end_td.
        $q->end_Tr.
    $q->end_table;
    if( -e '/etc/cups/cupsd.conf' ) {
    $HTMLOUT .= "\n".$q->start_table({-class       => 'AdminBorder',
				      -cellspacing=>0, -cellpadding=>3,
				      -border	   => 0,
                                      -width       => "100%",
                                      } ).
        $q->Tr([$this->help_th(4, $message->{'ADM_ADMIN_LOCAL_PS'}, 'CUPS_ADMIN' )]).
        $q->start_Tr().
            $q->start_form().
                    $q->hidden(-name=>'sessionID',
                               -value=>$sessionID,
                               -override=>1).
                    $q->hidden( -name => "tab",
                                -value => $tab,
                                -override => 1).
                    $q->hidden( -name => "stab",
                                -value => $stab,
                                -override => 1).
                    $q->hidden( -name  => "apply",
                                -value => "apply",
                                -override => 1).
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable1"}).
                "&nbsp;".
            $q->end_td().
            $q->start_td( { -colspan => 2 , -class=>"dhcpSubTable1"} ).
                $message->{'ADM_TO_ADD'}.
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable1"}).
                $message->{'ADM_CURRENT'}.
            $q->end_td().
        $q->end_Tr().
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $message->{'ADM_BC_TO'}.
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->textfield(-name     => 'add_this_to_browseaddress',
                              -override => 1,
                              -default  => "",
                             ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->image_button( -name => 'add',
                                  -src  => '/images/arrow_next.gif'
                                ).
                "<br>".
                $q->image_button( -name => 'drop',
                                  -src  => '/images/trashcan_small.gif'
                                ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->scrolling_list( -name     => 'del_from_browseaddress',
                                    -values   => \@browse_addresses,
                                    -override => 1,
                                    -multiple => 'true',
                                    -size     => 4
                                  ).
            $q->end_td().
        $q->end_Tr().
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $message->{'ADM_BC_INTERVALL'}.
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->textfield(-name      => 'browse_intervall',
                              -default   => $browse_intervall,
                              -size      => 4,
                              -maxlength => 4
                              ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->image_button( -name => 'add',
                                  -src  => '/images/arrow_next.gif'
                                ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $browse_intervall.
            $q->end_td().
        $q->end_Tr().
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $message->{'ADM_ACCESS'}.
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->textfield(-name     => 'add_this_to_root',
                              -default  => "",
                              -override => 1,
                             ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->image_button( -name => 'add',
                                  -src  => '/images/arrow_next.gif'
                                ).
                "<br>".
                $q->image_button( -name => 'drop',
                                  -src  => '/images/trashcan_small.gif'
                                ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable2"}).
                $q->scrolling_list( -name     => 'del_from_root',
                                    -override => 1,
                                    -size     => 4,
                                    -values   => \@location_ip,
                                    -multiple => 'true'
                                  ).
            $q->end_td().
        $q->end_Tr().
        $q->start_Tr().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $message->{'ADM_ADMIN_ACCESS'}.
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->textfield(-name     => 'add_this_to_admin',
                              -override => 1,
                              -default  => "",
                              ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->image_button( -name => 'add',
                                  -src  => '/images/arrow_next.gif'
                                ).
                "<br>".
                $q->image_button( -name => 'drop',
                                  -src  => '/images/trashcan_small.gif'
                                ).
            $q->end_td().
            $q->start_td({-class=>"dhcpSubTable4"}).
                $q->scrolling_list( -name     => 'del_from_admin',
                                    -values   => \@location_admin_ip,
                                    -size     => 4,
                                    -override => 1,
                                    -multiple => 'true'
                                  ).
            $q->end_td().
        $q->end_Tr().
        $q->end_form().
    $q->end_table;
    }
    $this->SUPER::display($HTMLOUT);
    exit;
}

sub kick_from_array {
    my $data = shift;
    my $kick = shift;

    my @temp = ();
    foreach my $e ( @{$data} ) {
        push( @temp, $e ) if( ! grep(/^$e$/, @{$kick}) );
    }
    return @temp;
}
