#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
#
#
# $Id: apache_conf.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#
package apache_conf;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


my @sslvclnt = ( "none",
		 "optional",
		 "require",
		 "optional_no_ca" );

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit    = $cgi->param('doit');

    if(defined $doit && $doit eq "add") {
	$this->modify();
    } else {
	$this->startup();
    }

}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"APACHE"))->data();

    my $html = "";
    my $tfsize = 10;

    my $noCA = ( -s "/usr/ssl/certs/cert.pem" ? 0 : 1 );

    $this->readConfig();
    
    
    
    my $sslcb;
    if ( $noCA ) {
	$sslcb = "<font color=$Display::__red>$message->{apache_creaca}</font>";
    } else {
	$sslcb = $q->checkbox(-name=>'sslon', -checked=>$this->{"conf"}->{sslon}, -label=>"" );
    }
    
    $q->param(-name=>'sslverifyclient', -value=>$this->{"conf"}->{sslverifyclient});
    $q->param(-name=>'sslverifydepth', -value=>$this->{"conf"}->{sslverifydepth});
    $q->param(-name=>'sslon', -checked=>$this->{"conf"}->{sslon});
    
    $html .= $q->start_table({-border=>0, -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->start_multipart_form(-method=>"get",
				      -action=>$confParam->{cgi_path}."/apache_conf.pl");
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-border=>0, -cellspacing=>0, 
				      -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $this->help_th(2, $message->{apache_cfg_head}, "APACHE_CONF"),
					     $q->td({-colspan=>2, -bgcolor=>$Display::__yellow,
						     -align=>"center", -height => "25"},
						    ["$message->{apache_cfg_warn}"]),
					     $q->td({-bgcolor=>$Display::__gray1},[$message->{apache_cfg_sslon},
								      $sslcb ] ),
					     $q->td({-bgcolor=>$Display::__gray1},
						    [$message->{apache_cfg_sslverifyclient},
						     $q->popup_menu(-name=>'sslverifyclient',
								    -values=>\@sslvclnt, )]),
					     $q->td({-bgcolor=>$Display::__gray1},
						    [$message->{apache_cfg_sslverifydepth},
						     $q->textfield(-name=>'sslverifydepth',
								   -value=>$this->{"conf"}->{sslverifydepth},
								   -size=>$tfsize)]  ),
					     $q->td({-colspan=>2 ,-bgcolor=>$Display::__gray1, -align => "center"},
						    [ 
						      ( $noCA ? "&nbsp" :
							$q->submit(-name=>$message->{apache_doit}) ) 
						      ] )
					     ]
					    )
				     )
			   )
		    );
        
    $html .= $q->hidden(-name=>"sessionID", -value=>$sessionID);
    if( ! $noCA ) {
	$html .= $q->hidden(-name=>"doit", -value=>"add");
    }
    $html .= $q->end_form();	    
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub readConfig {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"APACHE"))->data();

    my $cf = "/etc/httpd/httpd.conf";
    
    if( ! open(IN, "< $cf") ) {
	$this->display_error("$message->{apache_cfg_not_readable} $cf: $?",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = <IN>;
    chomp(@raw);
    close(IN);
    
    # store data into session
    my $msg = $session->save_store2session("apachecf", $cf, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{apache_file_modified},
				 "$confParam->{cgi_path}/apache_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    $this->{"conf"}->{sslon} = "";
    $this->{"conf"}->{sslverifyclient} = "";
    $this->{"conf"}->{sslverifydepth} = "";
    
    foreach my $l ( @raw ) {
	next if $l =~ /^\s*\#.*/;
	$this->{"conf"}->{sslon} = "checked" if $l =~ /^\s*SSLEngine\s+on\s*/;
	
	if( $l =~ /^\s*SSLVerifyClient\s*.*/ ) {
	    $l =~ /^\s*SSLVerifyClient\s+([a-z_]+)\s*.*/;
	    $this->{"conf"}->{sslverifyclient} = $1;
	}
	if( $l =~ /^\s*SSLVerifyDepth\s*.*/ ) {
	    $l =~ /^\s*SSLVerifyDepth\s+([0-9]+)\s*.*/;
	    $this->{"conf"}->{sslverifydepth} = $1;
	}	
    }
    
    #print STDERR $this->{"conf"}->{sslverifydepth}." | ".$this->{"conf"}->{sslverifyclient}."\n";
}

sub modify {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"APACHE"))->data();

    my $cf = "/etc/httpd/httpd.conf";

    my $msg = $session->save_read2session("apachecf", $cf);

    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{apache_file_modified},
				 "$confParam->{cgi_path}/apache_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $raw = $msg->data();

    foreach my $l ( @$raw ) {
	if( $l =~ /^\s*SSLEngine\s+.*/ ) {
	    $l = "SSLEngine ".( defined $q->param('sslon') ? "on" : "off" );
	}
	if( $l =~ /^\s*SSLVerifyClient\s*.*/ ) {
	    $l = "SSLVerifyClient ".$q->param('sslverifyclient');
	}
	if( $l =~ /^\s*SSLVerifyDepth\s*.*/ ) {
	    $l = "SSLVerifyDepth ".$q->param('sslverifydepth');
	}
	
	# activate commented path's to cert, key and cacert
	if( $l =~ /^[\#\s]*SSLCertificateFile\s+.*/ ) {
	    $l = ( defined $q->param('sslon') ? "" : "#" )."SSLCertificateFile /usr/ssl/certs/cert.pem";
	}
	if( $l =~ /^[\#\s]*SSLCertificateKeyFile\s+.*/ ) {
	    $l = ( defined $q->param('sslon') ? "" : "#" )."SSLCertificateKeyFile /usr/ssl/certs/skey.pem";
	}
	if( $l =~ /^[\#\s]*SSLCACertificateFile\s+.*/ ) {
	    $l = ( defined $q->param('sslon') ? "" : "#" )."SSLCACertificateFile /usr/ssl/CA/usedCA.pem";
	}
	if( $l =~ /^[\#\s]*SSLCARevocationFile\s+.*/ ) {
	    $l = ( defined $q->param('sslon') ? "" : "#" )."SSLCARevocationFile /usr/ssl/crl/crl.pem";
	}
    }
    
    my $ret = $session->suad_save($raw, $cf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("apachecf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    $ret = $session->suad_exec("apacherestart");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $this->display_msg($message->{apache_restart},
		       "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");

    exit;
}

1;
