#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: browse_user.pm,v 1.9 2003/10/29 10:35:39 varkoly Exp $
#
package browse_user;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(thaw freeze);
use Net::LDAP;
use URI::Escape;
use LDAPUtils;
use Display;
use Session;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
use GroupFilterlist;
@ISA = (qw(Display));


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $ADMINuid  = $confParam->{uid};

    my $message = ($session->getLanguage($confParam->{LANG},"BROWSE_USER"))->data();

    my $DEBUG=0; # 0=off 1=on

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');

    my $ldap= Net::LDAP->new($confParam->{LDAPserver},port=>$confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    my $mesg=$ldap->bind ("uid=".$confParam->{uid}.", ".$confParam->{baseDN}, password=>$confParam->{passwd});
    if($mesg->code != 0) {
        my $text = "bind failed\n".&LDAPerror($mesg);
        $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my $filterlist = GroupFilterlist->new($cgi, $session, $ldap);

    my $filter = "*";
    if ( defined $cgi->param("filter") ) {
	$filter=$cgi->param("filter");
#	$filter = LDAP_filter_escape($filter);
#	$filter =~ s/,.*$//;
    }

    if (defined $cgi->param("user") && $cgi->param("user") eq $message->{"set_filter_first"}) {
        $this->display_msg($message->{"set_filter_first"},
                           "$confParam->{'cgi_path'}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
		$ldap->unbind();
		exit;
    } elsif( ! defined $cgi->param("select") && 
       (defined $cgi->param("delete") || defined $cgi->param("susp") ||
        defined $cgi->param("cert") || defined $cgi->param("group") ||
        defined $cgi->param("userdata") || defined $cgi->param("password") ||
		defined $cgi->param("ldapaci") || defined $cgi->param("togglesamba") ||
		defined $cgi->param("comfirerights") || defined $cgi->param("vacation") ||
		defined $cgi->param('internet') ) ){
	
			my @users = $cgi->param("user");
			if(@users){
				my $frozen = freeze(\@users);      #freeze data
				$frozen = unpack('H*',$frozen);   #convert to ASCII
				my %tmp = ( "usersToMod" => $frozen );
				my $s_reply=$session->modify(\%tmp);
				if( $s_reply->code() ne "OK" ) {
					$this->display_error($message->{'write2session_failed'},
							 "$confParam->{'cgi_path'}/menu.pl?sessionID=$sessionID");
					$ldap->unbind();
					exit;
				}
			} else {
        			$this->display_msg($message->{"select_user"},
		                           "$confParam->{'cgi_path'}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
					$ldap->unbind();
					exit;
			}
			$cgi->delete('user');
			if( grep /^cyrus$/, @users ){
				if (defined ($cgi->param("userdata"))) {
					print $cgi->header;
					print "<script language=javascript>\n";
					print "window.location.href=\"";
					print "edit_cyrus_data.pl?sessionID=$sessionID&tab=$tab&stab=$stab&filter=$filter";
					print "\";</script>\n";
				} elsif (defined ($cgi->param("password"))) {
					print $cgi->header;
					print "<script language=javascript>\n";
					print "window.location.href=\"";
					print "/imap-bin/change_passwd_cyrus.pl?sessionID=$sessionID&tab=$tab&stab=$stab&filter=$filter";
					print "\";</script>\n";
				}else{
					$this->display_error($message->{'not_possible_for_cyrus'},
								 "$confParam->{'cgi_path'}/browse_user.pl?sessionID=$sessionID".
								 "&tab=$tab&stab=$stab&filter=$filter&filtered=1");
					$ldap->unbind();
					exit;
				}
			}else{
				print $cgi->header;
				print "<script language=javascript>\n";
				print "window.location.href=\"";
				if (defined ($cgi->param("delete"))) {
					print "delete_user.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
				elsif (defined ($cgi->param("susp"))) {
					print "de_aktivate_user.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
				elsif (defined ($cgi->param("internet"))) {
					print "internet.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
				elsif (defined ($cgi->param("cert"))) {
					print "/imap-bin/creadel_usercert.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
				elsif (defined ($cgi->param("group"))) {
					print "browse_usr_grp.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
				elsif (defined ($cgi->param("userdata"))) {
					print "edit_user4admin.pl?sessionID=$sessionID\&uid=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
		#	    elsif (defined ($cgi->param("comfirerights"))) {
		#		my $backurl = $confParam->{'cgi_path'}."/browse_user.pl?sessionID=$sessionID&tab=$tab&stab=$stab".
		#			"&filter=$filter&filtered=1";
		#		$backurl = uri_escape($backurl);
		#	        print "/servlet/intranet?SITE=suse/user_rights_upd&login=".$users[0]."&sessionID=$sessionID&backurl=$backurl";
		#	    }
				elsif (defined ($cgi->param("ldapaci"))) {
					print "edit_useraci.pl?sessionID=$sessionID\&uid=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				}
		#	    elsif (defined ($cgi->param("togglesamba"))) {
		#	        print "toggle_samba.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
		#	    }
				elsif (defined ($cgi->param("password"))) {
					print "change_passwd.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				} 
				elsif (defined ($cgi->param("vacation"))) {
					print "vacation.pl?sessionID=$sessionID\&USER=".$users[0]."\&filter=$filter\&tab=$tab\&stab=$stab";
				} 

				print "\";</script>\n";
			}
			##############################################################################
    } else {
	my $html = "";

	if ( ( ! defined($cgi->param("user")) || $cgi->param("user") eq "" ||
	       $cgi->param("user") eq "0" ) && 
	     ( defined($cgi->param("delete")) || defined($cgi->param("susp")) ||
	       defined($cgi->param("cert")) || defined($cgi->param("group")) ||
	       defined($cgi->param("userdata")) || defined($cgi->param('internet'))) 
	     ) { 
	    
	    $this->display_error($message->{no_selected},
			  "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	}
	if ( defined $cgi->param("procedurecall") ) {
	    my @x=();
	    @x=split (/,,/, $cgi->param("procedurecall"));
	    print status($message->{$x[0]},$message->{$x[1]},$x[2]);
	}

	my $width = 250;
        $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
        $html .=   $cgi->start_Tr();
        $html .=     $cgi->start_td();
	$html .=     $cgi->start_form(-method=>"post", -action=>$confParam->{cgi_path}."/browse_user.pl");
        $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
        $html .=         $cgi->Tr( $this->help_th(3, $message->{show_user_title},"EDIT_USER") );
        $html .=         $cgi->Tr( $cgi->td({-colspan=>3, -class=>'AdminSubHeaderRed'},
                                            $message->{acc_chosen_user}
					   ) );
        
        my $actions = $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
	    if( $ADMINuid eq 'cyrus' ) {
            $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"delete", -value=>$message->{delete_button},
                                                -width=>$width)));
        }
        $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"susp", -value=>$message->{suspend_button},
                                                -width=>$width)));
        $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"internet", -value=>$message->{internet_button},
                                                -width=>$width)));
        $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"group", -value=>$message->{add2group_button},
                                                -width=>$width)));
# --- C SCHULSERVER
        if( $ADMINuid eq 'cyrus' ) {
            $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"cert", -value=>$message->{certificate_button},
                                                -width=>$width)));
            $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"userdata",
                                                -value=>$message->{edit_userdata_button},
                                                -width=>$width)));
#                $cgi->Tr( $cgi->td({-align=>"center"},
#                                   $cgi->submit(-class=>"BlockButton",-name=>"comfirerights",
#                                                -value=>$message->{'comfire_rights'},
#                                                -width=>$width))).
            $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"ldapaci",
                                                -value=>$message->{'change_aci'},
                                                -width=>$width)));
            $actions .=   $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"vacation",
                                                -value=>$message->{'vacation_button'},
                                                -width=>$width)));
        }
# --- E SCHULSERVER
	$actions .=     $cgi->Tr( $cgi->td({-align=>"center"},
                                   $cgi->submit(-class=>"BlockButton",-name=>"password", -value=>$message->{change_pass},
                                                -width=>$width).
                                   $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
                                   $cgi->hidden(-name=>"tab", -value=>$tab).
                                   $cgi->hidden(-name=>"stab", -value=>$stab))
                                 ).
                $cgi->end_table;
    
#        $html .=           $cgi->start_Tr();
#        $html .=             $cgi->td({-align=>"center", -valign=>"top"},
	my $listfilter = "(&".
				"(objectclass=posixAccount)(objectclass=SuSEeMailObject)".
                                "(gidNumber=100)(!(uid=mailadmin))(!(uid=cyrus))".
                                "(|(sn=$filter)(givenname=$filter)(uid=$filter))".
                         ")";

	if( $ADMINuid eq 'cyrus' ) {
	   $listfilter = "(&".
                                "(objectclass=posixAccount)(objectclass=SuSEeMailObject)".
                                "(!(uid=mailadmin))(!(uid=cyrus))(!(gidNumber=103))".
                                "(|(sn=$filter)(givenname=$filter)(uid=$filter))".
                         ")";
		
	}
        $html .=    $filterlist->make_filter_view({"textfield"    => "filter",
                          "textlabel"    => $message->{'filter'},
                          "buttonlabel"  => $message->{'apply_filter'},
                          "listname"     => "user",
			  "classname"    => $message->{'classe'},
                          "listlabel_left" => $message->{'user'},
                          "listlabel_right" => $actions,
                          "nofilter-msg" => $message->{set_filter_first},
                          "listfilter"   => $listfilter,
			  "listattrs"	 => ['uid', 'cn', 'description','ou'],
                          "labelexp"     => ["\$\$ ","uid","(\$\$) ","cn","(\$\$)","description","(\$\$)","ou"],
                          "width"        => "30",
                          "height"       => "20",
                          "multiple"     => "MULTIPLE",
                          "error-url"    => "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID",
			  "charset"      => $this->{'charset'}
			});
        $html .=       $cgi->end_table();
        $html .=     $cgi->end_form();
        $html .=     $cgi->end_td();
        $html .=   $cgi->end_Tr();
        $html .= $cgi->end_table();
        
        $this->SUPER::display($html);
    }
}

1;
