#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: browse_usr_grp.pm,v 1.6 2003/11/07 11:39:31 varkoly Exp $
#
package browse_usr_grp;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use LDAPUtils;
use Utils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $add = $cgi->param('doit');

    if(defined $add && $add eq "add") {
	$this->replace_groups();
    } else {
	$this->get_groups();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"BROWSE_USR_GRP"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $filter    = $q->param('filter');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $USER      = $q->param('USER');

    my $sel_group = $this->{"sel_group"};
    my $group = $this->{"group"};
    my $size = $this->{"size"};

    my $hfields = "";

    foreach my $sel (@$sel_group) {
	$hfields .= $q->hidden(-name=>"sel_group", -value=>$sel);
    }
    
    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->start_form(-action=>$confParam->{cgi_path}."/browse_usr_grp.pl",),
				     $q->Tr({},
					    $this->help_th(2, $message->{add2grp}, "ADD2GRP")
					    ),
				     $q->Tr({},
					    $q->td({-class=>'AdminSubHeader', -colspan=>"2"},
						   $message->{user}.": ".$USER)
					    ),
				     $q->Tr({},
					    $q->td({-colspan=>"2",
						    -align=>"center"},
						   $q->scrolling_list(-name=>"new_groups",
								      -value=>[@$group],
								      -size=>"$size",
								      -multiple=>'true',
								      -default=>[@$sel_group]
								      )
						   )
					    ),
				     $q->Tr({},
					    $q->td({-colspan => "2",
						    -align=>"center"},
						   $q->submit(-class=>"button",-name=>"add",
							      -value=>$message->{commit}).
						   $hfields.
						   $q->hidden(-name=>"USER", -value=>"$USER").
						   $q->hidden(-name=>"filter", -value=>"$filter").
						   $q->hidden(-name=>"filtered", -value=>1).
						   $q->hidden(-name=>"sessionID", -value=>"$sessionID").
						   $q->hidden(-name=>"doit", -value=>"add").
						   $q->hidden(-name=>"tab", -value=>"$tab").
						   $q->hidden(-name=>"stab", -value=>"$stab").
						   $q->end_form()
						   )
					    )
				     )
			   )
		    );

    $html .= $q->end_table;

    $this->back_url("$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter\&filtered=1");
    $this->SUPER::display($html);
}

sub get_groups {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"BROWSE_USR_GRP"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $filter    = $q->param('filter');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $USER      = $q->param('USER');

    $q->delete('group');
    $q->delete('sel_group');
    my @sel_group = ();
    my @group=();
    my $text = "";
    my $size = 20;

    my $ldap= Net::LDAP->new($ldaphost, port=>$ldapport, version => 3);
    
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
    
    my $mesg = $ldap->bind (	# bind to a directory with dn and password
				dn       => "$bind_dn",
				password => "$ADMINpasswd"
				);
    
    if($mesg->code != 0) {
	$text = "bind $message->{failed}\n\n";
	$text .= &LDAPerror($mesg);
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $primaryGid = 100;
    # get GID of Users primary Group (it shouldn't be displayed
    my $result = $ldap->search (base   => "uid=$USER,$ldapbase",
				scope  => "base",
			        attrs => ['gidNumber'],
			        filter => 'objectclass=posixAccount'
			      );
    if($result->code == 0) {
	$primaryGid = $result->entry(0)->get_value("gidNumber");
    } else {
	$text = "search $message->{failed}\n\n";
	$text .= &LDAPerror($result);
	$ldap->unbind;   # take down session
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

# C SCHULSERVER
    my $adminfilter = "(&(cn=*)(objectclass=posixGroup)(!(gidNumber=$primaryGid)))";
    if( $ADMINuid ne 'cyrus' ) {
       $adminfilter = "(&(cn=*)(objectclass=SuSESchoolGroup)(!(gidNumber=$primaryGid)))";
    }
    $result = $ldap->search ( # perform a search
				 base   => "$ldapbase",
				 scope  => "one",
				 attrs => ['cn'],
				 filter => $adminfilter
				 );
# E SCHULSERVER
    
    if($result->code == 0) {
	foreach my $entry ($result->all_entries) {
	    push @group, $entry->get_value("cn");
	}
	@group = sort @group;
    } else {
	$text = "search $message->{failed}\n\n";
	$text .= &LDAPerror($result);
	$ldap->unbind;   # take down session
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

# C SCHULSERVER
    $adminfilter = "(&(cn=*)(objectclass=posixGroup)(memberuid=$USER)(!(gidNumber=$primaryGid)))";
    if( $ADMINuid ne 'cyrus' ) {
       $adminfilter = "(&(cn=*)(objectclass=SuSESchoolGroup)(memberuid=$USER)(!(gidNumber=$primaryGid)))";
    }
    $result = $ldap->search ( # perform a search
			      base   => "$ldapbase",
			      scope  => "one",
			      attrs => ['cn'],
			      filter => $adminfilter
			      );
# E SCHULSERVER
    
    if($result->code == 0) {
	foreach my $entry ($result->all_entries) {
	    push @sel_group, $entry->get_value("cn");
	}
    } else {
	$text = "search $message->{failed}\n\n";
	$text .= &LDAPerror($result);
	$ldap->unbind;   # take down session
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    if($#group < 17) {
	$size = $#group + 3; 
    }

    $ldap->unbind;   # take down session
    
    $this->{"sel_group"} = \@sel_group;
    $this->{"group"}     = \@group;
    $this->{"size"}      = $size;
    $this->startup();
}

sub replace_groups {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"BROWSE_USR_GRP"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my @new_groups = $q->param('new_groups');
    my @sel_group  = $q->param('sel_group');
    my $USER       = $q->param('USER');
    my $filter     = $q->param('filter');
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $groupware   = read_rcconfig("SCHOOL_GROUPWARE") || 'all';

    my $text = "";

    my $ldap= Net::LDAP->new($ldaphost, port => $ldapport, version => 3);
    
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
    
    my $mesg = $ldap->bind (	# bind to a directory with dn and password
				dn       => "$bind_dn",
				password => "$ADMINpasswd"
				);
    
    if($mesg->code != 0) {
	$text = "bind $message->{failed}\n\n";
	$text .= &LDAPerror($mesg);
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    for( my $i=$#sel_group; $i>=0 ; $i--) {
	my $old = $sel_group[$i];	
	for( my $j=$#new_groups; $j>=0; $j--) {
	    my $new = $new_groups[$j];
	    if($old eq $new) {
		# -- wenn gleich - hat sich nichts gendert => 
		# -- keine LDAP nderungen ntig 
		splice(@sel_group, $i, 1);
		splice(@new_groups, $j, 1);
		last;
	    }
	}
    }
    
    $text = "";

    foreach my $delete (@sel_group) {
	# get gidNumber for the group
	my $result = $ldap->search( base => "cn=$delete,$ldapbase",
				   scope => "base",
				   filter => "objectClass=*",
				   attrs => ['gidNumber']
				);
	if($result->code != 0) {
	    $text .= "search $message->{failed}\n\n";
	    $text .= &LDAPerror($result);
	    #	    exit;
	}elsif($groupware eq 'all' || $groupware eq 'comfire' ){
	    my $gidNumber = $result->entry(0)->get_value('gidNumber');
	    $result = $ldap->modify("uid=$USER,$ldapbase",
	    			   delete => {'comFireGroupId' => $gidNumber });
	    #if($result->code != 0) {
	    #    $text .= "delete $message->{failed}\n\n";
	    #    $text .= &LDAPerror($result);
	    #    #	    exit;
	    #}
	}
				   
	$result = $ldap->modify("cn=$delete,$ldapbase",
				   delete => {memberUID => $USER });
	if($result->code != 0) {
	    $text .= "delete $message->{failed}\n\n";
	    $text .= &LDAPerror($result);
	    #	    exit;
	}
    }

    foreach my $add (@new_groups) {
	my $result = $ldap->search( base => "cn=$add,$ldapbase",
				   scope => "base",
				   filter => "objectClass=*",
				   attrs => ['gidNumber']
				);
	if($result->code != 0) {
	    $text .= "search $message->{failed}\n\n";
	    $text .= &LDAPerror($result);
	    #	    exit;
	}elsif($groupware eq 'all' || $groupware eq 'comfire' ){
	    my $gidNumber = $result->entry(0)->get_value('gidNumber');
	    $result = $ldap->modify("uid=$USER,$ldapbase",
	    			   add => {'comFireGroupId' => $gidNumber });
	    if($result->code != 0) {
	        $text .= "add $message->{failed}\n\n";
	        $text .= &LDAPerror($result);
	        #	    exit;
	    }
	}
	$result = $ldap->modify("cn=$add,$ldapbase",
				   add => {memberUID => $USER });
	if($result->code != 0) {
	    $text .= "add $message->{failed}\n\n";
	    $text .= &LDAPerror($result);
	    #    exit;
	}
    }

    # We have to create the new description
    my $result = $ldap->search( base => $ldapbase,
                                   filter => "(&(cn=*)(objectclass=SuSESchoolClass)(memberuid=$USER))",
                                   attrs => ['cn']
                                );

    my @akt_groups = ();
    if($result->code == 0) {
	foreach my $entry ($result->all_entries) {
	    push @akt_groups, $entry->get_value("cn");
	}
    } 
    $ldap->modify("uid=$USER,$ldapbase",
		  replace => {'ou' => join(' ',@akt_groups) }
		 );

    if($text eq "") {
	$text = $message->{change_membership_ok};
	$this->display_msg($text,
		    "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID".
		    "\&tab=$tab\&stab=$stab\&USER=$USER\&filter=$filter&filtered=1",
		    2);
    } else {
	$this->display_error($text,
		      "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&USER=$USER\&filter=$filter&filtered=1");
	exit;
    }
}

1;
