#
# Copyright (c) 2002 SuSE GmbH Nuernberg, Germany.  All rights reserved.
#
#
# $Id: control.pm,v 1.21 2004/11/02 18:11:02 varkoly Exp $
# 
package control;
use strict;

use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use Net::Netmask;
use LDAPUtils;
use Utils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    my $setcontrol = $cgi->param("setcontrol");
    my $squidguard = $cgi->param("squidguard");

    if( defined $setcontrol && $setcontrol ne "" ) {
	    $this->setcontrol();
    } elsif( defined $squidguard && $squidguard ne "" ) {
	    $this->squidguard();
    } else {
	    $this->startup();
    }
}

sub setcontrol {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $LOGINuid      = $confParam->{uid};

    my $message = ($session->getLanguage($confParam->{LANG},"CONTROL"))->data();

    my $SCHOOL_SERVER_NET = read_rcconfig("SCHOOL_SERVER_NET");
    my $ISGATE            = read_rcconfig("SCHOOL_ISGATE");

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');

    my $internet = $q->param("internet");
    my $printing = $q->param("printing");
    my $mailing  = $q->param("mailing");
    my $samba    = $q->param("samba");
    my $all      = $q->param("all");
    my $let_me   = $q->param("let_me");
    my $network  = $q->param("rooms");
    my $ip	 = "";
    if ( $let_me ) {
		$ip = $network;
    }	
    my $befehl = "";
    if( $LOGINuid ne 'cyrus' ) {
	my $block = new Net::Netmask($SCHOOL_SERVER_NET);
        if( $block->match($network)  ) {
            $this->display_error("$message->{dont_suspend_server_net}",
                                 $confParam->{cgi_path}."/control.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
            exit;
        }
	$network = $network.'/26';
    	$block = new Net::Netmask($network);
        $network = $block->base().'/26';
    }


    if($internet eq "enable" ) {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network internet $ip");
    } else {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network internet $ip");
       system("sudo $confParam->{bin_path}/control_access DENY $network internet $ip");
    }
    if($printing eq "enable" ) {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network printing $ip");
    } else {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network printing $ip");
       system("sudo $confParam->{bin_path}/control_access DENY $network printing $ip");
    }
    if($mailing eq "enable" ) {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network mailing $ip");
    } else {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network mailing $ip");
       system("sudo $confParam->{bin_path}/control_access DENY $network mailing $ip");
    }
    if($samba eq "enable" ) {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network samba $ip");
    } else {
       system("sudo $confParam->{bin_path}/control_access ALLOW $network samba $ip");
       system("sudo $confParam->{bin_path}/control_access DENY $network samba $ip");
    }
    if($ISGATE eq 'yes') {
	if($all eq "enable" ) {
		system("sudo $confParam->{bin_path}/control_access DENY $network  all");
		system("sudo $confParam->{bin_path}/control_access ALLOW $network all");
	} else {
		system("sudo $confParam->{bin_path}/control_access DENY $network  all");
	}
    } 
    my $url = "$confParam->{cgi_path}/control.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";


    $this->display_msg("$message->{control_changed}",
		       $confParam->{cgi_path}."/control.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       1);
    exit;
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"CONTROL"))->data();

    my @rooms = ();
    my %room_net = ();
    my %room_label = ();

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $internet_default   = 'enable';
    my $printing_default   = 'enable';
    my $squidguard_default = 'negativ';
    my $mail_default       = 'enable';
    my $all_default        = 'deny';
    my $samba_default      = 'enable';
    my $class_room         = '';
    my $allowed_urls       = '';
    my $room		   = $q->param('rooms')      || '';
    my $get_status         = $q->param('get_status') || '';
    my $reset_fw           = $q->param('reset_fw')   || '';
    my $ISGATE             = read_rcconfig("SCHOOL_ISGATE");

    my $values = [ 'enable', 'deny' ];
    my $labels = { 'enable' => $message->{enable}, 
		   'deny'   => $message->{deny} 
	}; 

    my $squidguard_labels = {
    		'positiv' => $message->{positiv_list},
		'negativ' => $message->{negativ_list}
        };
    my $LOGINuid      = $confParam->{uid};
    my $ldapbase      = $confParam->{baseDN};
    my $user_dn       = "uid=".$LOGINuid.",".$ldapbase;
    my $url = "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab";
    my $ldap= Net::LDAP->new($confParam->{LDAPserver},port=>$confParam->{LDAPport},version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server", $url);
        exit;
    }
    my $result = $ldap->bind(dn=>$user_dn,
                             password=>$confParam->{"passwd"});
    if($result->code != 0) {
        my $errs = "bind $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
        exit;
    }
    if( $LOGINuid eq 'cyrus' ) {
        # Jetzt Suchen wir die Raeume
        $result = $ldap->search( base   => 'o=DHCP,'.$ldapbase,
                                 filter => '(&(Objectclass=SuSESchoolRoom)(description=*))',
                                 attrs  => ['description','dhcpRange','dhcpNetMask']
                                );
        if($result->code != 0) {
            my $errs = "search $message->{failed}\n\n";
            $errs .= &LDAPerror($result);
            $this->display_error($errs, $url);
            $ldap->unbind;
            exit;
        }
        foreach my $entry ($result->all_entries) {
           my $key = $entry->get_value("dhcpRange").'/'.$entry->get_value('dhcpNetMask');
           my $val = $entry->get_value("description");
           if ( defined $key && $key ne "" ) {
             push @rooms, $key;
             $room_label{"$key"} = $val;
           }
        }
	if($get_status ne '' && $room ne '') {
	    #looking for the status
	    $internet_default = `sudo $confParam->{bin_path}/access_status $room internet`;
	    $mail_default     = `sudo $confParam->{bin_path}/access_status $room mailing`;
	    $printing_default = `sudo $confParam->{bin_path}/access_status $room printing`;
	    $all_default      = `sudo $confParam->{bin_path}/access_status $room all`;
	    $samba_default    = `sudo $confParam->{bin_path}/access_status $room samba`;
	    chomp $internet_default; chomp $mail_default; chomp $printing_default; chomp $all_default; chomp $samba_default;
	} else {
           $room = $rooms[0];
	}
	if($reset_fw ne '') {
           $session->suad_stdout_exec("SuSEfirewall2 start");
	}
    } else {
	my $network = $q->remote_addr.'/26';
	my $block = new Net::Netmask($network);
	$network = $block->base();
	$result = $ldap->search (  # perform a search
                       base   => "o=DHCP,$ldapbase",
                       attrs => ['description'],
                       filter => "dhcpRange=$network"
                      );
	if( $result->count > 0 ) {
            $class_room = $result->entry(0)->get_value('description');
	    my $ret = $session->suad_read("/var/squidGuard/db/ROOM$class_room");
	    if($ret->code() =~ /^OK/) {
	       $allowed_urls = $ret->data();
	    }
	    #looking for the status
	    $internet_default = `sudo $confParam->{bin_path}/access_status $network/26 internet`;
	    $mail_default     = `sudo $confParam->{bin_path}/access_status $network/26 mailing`;
	    $printing_default = `sudo $confParam->{bin_path}/access_status $network/26 printing`;
	    $all_default      = `sudo $confParam->{bin_path}/access_status $network/26 all`;
	    $samba_default    = `sudo $confParam->{bin_path}/access_status $network/26 samba`;
	    chomp $internet_default; chomp $mail_default; chomp $printing_default; chomp $all_default; chomp $samba_default;
	    # looking for squidguard setting
	    my $squidguard_conf = "#BEGIN-$class_room"; 
	    my $ret = $session->suad_read('/etc/squid/squidguard.conf');
	    my $data = '';
	    if($ret->code() =~ /^OK/) {
	         $data= $ret->data();
	    }
	    if($data =~ /$squidguard_conf/) {
	    	$squidguard_default = 'positiv';
	    }
	    $class_room = $class_room.'::'.$network;
	} else {
	   $this->display_error($message->{control_only_in_classroom}, $url);
            $ldap->unbind;
            exit;
	}
    }   # Jetzt bauen wir die Startseite auf 
    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $q->start_Tr();
    $html .=      $q->start_td();
    $html .=         $q->start_table({-class=>'dhcpSubTable',-border=>0, -cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    if( $LOGINuid eq 'cyrus' ) {
	$html .=            $q->Tr( $this->help_th(4,  "$message->{title_cyrus}", "CONTROL") );
    } else {
	$html .=            $q->Tr( $this->help_th(4,  "$message->{title}<br>$class_room", "CONTROL") );
    }
    $html .=            $q->end_Tr();
    $html .=            $q->start_form(-action=>$confParam->{cgi_path}."/control.pl");
    if( $LOGINuid eq 'cyrus' ) {
    	$html .=            $q->start_Tr();
    	$html .=                $q->td({ -align=>"left", -width=>"10%"}, "&nbsp;");
    	$html .=                $q->td({ -align=>"right"}, "$message->{rooms_list}");
        $html .= $q->td({}, $q->popup_menu( -name=>'rooms', 
						                    -values  => \@rooms, 
						                    -labels  => \%room_label,
								    -default => $room,  
						                    -width   => 160
			  ));
	$html .= $q->td({}, $q->submit(-name=>'get_status', -value=>"$message->{get_status}"));
    	$html .=            $q->end_Tr()."\n";
    } else {
	$html .=        $q->hidden(-name=>'rooms', -value=>$q->remote_addr());
    } 
  
    $html .=       $q->Tr($q->td({ -align=>"center", -colspan=>4}, "&nbsp;<br>" ));
    $html .=       $q->start_Tr();
    $html .=            $q->td({ -class=>"dhcpSubTable1", -align=>"right" },$message->{internet});
    $html .=	        $q->td({ -class=>"dhcpSubTable1", -align=>"left" },
#			       $q->radio_group(-name=>'internet', -values=>$values, -labels=>$labels, -default=>$internet_default)
			       RADIOS($internet_default,'internet',$message->{enable},$message->{deny})
			       );
    $html .=            $q->td({ -class=>"dhcpSubTable2", -align=>"right" },$message->{printing});
    $html .=            $q->td({ -class=>"dhcpSubTable2", -align=>"left"},
#                               $q->radio_group(-name=>'printing', -values=>$values, -labels=>$labels, -default=>$printing_default)
			       RADIOS($printing_default,'printing',$message->{enable},$message->{deny})
			       );
    $html .=       $q->end_Tr()."\n\n";
    $html .=       $q->start_Tr();
    $html .=            $q->td({ -class=>"dhcpSubTable2", -align=>"right" },$message->{mailing});
    $html .=            $q->td({ -class=>"dhcpSubTable2", -align=>"left"},
#			       $q->radio_group(-name=>'mailing', -values=>$values, -labels=>$labels, -default=>$mail_default)
			       RADIOS($mail_default,'mailing',$message->{enable},$message->{deny})
			      );
    $html .=            $q->td({ -class=>"dhcpSubTable1", -align=>"right" },$message->{samba});
    $html .=	        $q->td({ -class=>"dhcpSubTable1", -align=>"left" },
#			       $q->radio_group(-name=>'samba', -values=>$values, -labels=>$labels, -default=>$samba_default)
			       RADIOS($samba_default,'samba',$message->{enable},$message->{deny})
			      );
    $html .=       $q->end_Tr()."\n\n";
    $html .=   $q->start_Tr();
    $html .=            $q->td({ -class=>"dhcpSubTable1", -align=>"right" },  '&nbsp;' );
    $html .=            $q->td({ -class=>"dhcpSubTable1", -align=>"left" },   '&nbsp;' );
    if( $ISGATE eq 'yes' ) {
        $html .=        $q->td({ -class=>"dhcpSubTable2", -align=>"right" },$message->{all});
        $html .=        $q->td({ -class=>"dhcpSubTable2", -align=>"left"},
#			        $q->radio_group(-name=>'all', -values=>$values, -labels=>$labels, -default=>$all_default)
			       RADIOS($all_default,'all',$message->{enable},$message->{deny})
			      );
    }
    $html .=   $q->end_Tr()."\n\n";
    if( $LOGINuid ne 'cyrus' ) {
	$html .=            $q->start_Tr();
	$html .=               $q->td({-align=>"center", -colspan=>4},
                                  $q->checkbox(-name=>'let_me',
                                               -checked=>'checked',
                                               -label=>$message->{'let_me'}
					)
				     );
	$html .=            $q->end_Tr()."\n\n";
    }
    $html .=            $q->start_Tr();
    $html .=               $q->td({ -align=>"center", -colspan=>4},
				  $q->submit(-name=>"setcontrol", -value=>"$message->{set_control}").
				  $q->submit(-name=>"reset_fw", -value=>"$message->{reset_fw}").
				  $q->hidden(-name=>"sessionID", -value=>$sessionID).
				  $q->hidden(-name=>"tab", -value=>$tab).
				  $q->hidden(-name=>"stab", -value=>$stab).
				  $q->end_form());
    $html .=            $q->end_Tr();
    $html .=          $q->end_table();
    $html .=     $q->end_Tr();
    $html .= $q->end_table();
    if( $LOGINuid ne 'cyrus' ) {
    	$html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
	$html .=   $q->start_Tr();
	$html .=      $q->start_td();
	$html .=        $q->start_table({-border=>0, -cellspacing=>0, -cellpadding=>3, -width=>"100%"});
	$html .=        $q->Tr( $this->help_th(2,  "$message->{proxy_conf}", "CONTROL") );
    	$html .=        $q->start_form(-action=>$confParam->{cgi_path}."/control.pl");
	$html .=        $q->hidden(-name=>'class_room', -value=>$class_room);
	$html .=        $q->Tr( $q->td({ -align=>"center" , -colspan=>2},
					'<br>'.
					$q->radio_group(-name=>'control_mod',
							-values=> ['negativ','positiv'],
							-default=> $squidguard_default,
							-labels=> $squidguard_labels,
							-linebreak=>0
							).'<br>'
					)
				);
	$html .=        $q->Tr(
				$q->td({ -align=>"right"}, $message->{allowed_url}),
				$q->td({ -align=>"left"}, $q->textarea(-name=>'allowed_url',
							      -default=>$allowed_urls,
							      -rows=>15,
							      -cols=>40,
							      )
					)
				);
	$html .=        $q->start_Tr();
	$html .=               $q->td({ -align=>"center", -colspan=>2},
	    			  $q->submit(-name=>"squidguard", -value=>"$message->{set_control}").
	    			  $q->hidden(-name=>"sessionID", -value=>$sessionID).
	    			  $q->hidden(-name=>"tab", -value=>$tab).
	    			  $q->hidden(-name=>"stab", -value=>$stab).
	    			  $q->end_form());
	$html .=        $q->end_Tr();
				
	$html .=        $q->end_table();
	$html .=     $q->end_Tr();
	$html .= $q->end_table();
    }

    $this->back_url("$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab"); 
    $this->SUPER::display($html);
}

sub RADIOS {
    my $status  = shift;
    my $service = shift;
    my $le      = shift;
    my $ld      = shift;
   
    if ( $status eq 'enable' ) 
    {
      return "<input type=\"radio\" name=\"$service\" value=\"enable\" checked=\"checked\">$le<input type=\"radio\" name=\"$service\" value=\"deny\">$ld";
    }
    else
    {
      return "<input type=\"radio\" name=\"$service\" value=\"enable\">$le<input type=\"radio\" name=\"$service\" value=\"deny\" checked=\"checked\">$ld";
    }
}

sub squidguard {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $LOGINuid      = $confParam->{uid};

    my $message = ($session->getLanguage($confParam->{LANG},"CONTROL"))->data();

    my $SCHOOL_SERVER_NET = read_rcconfig("SCHOOL_SERVER_NET");

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');

    my $control_mod = $q->param("control_mod");
    my $allowed_url = $q->param("allowed_url");
    my $network  = $q->param("class_room"); 
    my $room     = '';
    ($room, $network) = split /::/ ,$network;
    $network = $network.'/26';

    my $squidguard_conf = "#BEGIN-$room
src ROOM$room"."_src {
   ip $network
}

dest ROOM$room"."_dst {
      domainlist ROOM$room
}

acl {
   ROOM$room"."_src {
   	pass ROOM$room"."_dst none
	redirect 302:http://admin/verboten.html
   }
} 
#END-$room
";

    my $ret = $session->suad_read('/etc/squid/squidguard.conf');
    my $data = '';
    if($ret->code() =~ /^OK/) {
         $data= $ret->data();
    }
    $data =~ s/$squidguard_conf//m;
    my @DATA = ();
    foreach (split /\n/, $data) {
    	push @DATA, $_;
    }

    if( $control_mod eq 'positiv' ) {
        # wirting the files
    	open (OUTFILE,">/tmp/$room");
	print OUTFILE $allowed_url;
	close OUTFILE;
	$session->suad_copy("/tmp/$room","/var/squidGuard/db/$room");
	my @SQUIDGUARD_CONF= ();
	foreach ( split /\n/, $squidguard_conf) {
	  push @SQUIDGUARD_CONF ,$_;
	}
	my $i = 1;
	foreach (@DATA) {
	  if(/dbhome/){
	     splice @DATA, $i, 0, @SQUIDGUARD_CONF;
	  }
	  $i++;
	}
    }
    
    $ret = $session->suad_save(\@DATA,'/etc/squid/squidguard.conf');
    system("sudo /usr/sbin/create_sgdb $room");
    $ret = $session->suad_service_exec('squid', 'reload');
    my $url = "$confParam->{cgi_path}/control.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    $this->display_msg("$message->{control_changed}",
		       $confParam->{cgi_path}."/control.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       1);
    exit;
}
1;
