#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: create_group.pm,v 1.22 2004/09/16 21:48:55 varkoly Exp $
# 

$| = 1; # do not buffer stdout

package create_group;
use strict;

use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use LDAPUtils;
use Utils;
use Display;
# C SCHULSERVER
use GroupFilterlist;
use Net::IMAP;
# C SCHULSERVER
use vars qw(@ISA);
use subs qw(exit);
use Net::LDAP;
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_GROUP"))->data();
    
    my $cgi = $this->{"cgi"};
    
    my $doit = $cgi->param('doit');
    
    if(defined $cgi->param($message->{'apply_filter'}) ){
        $this->startup();
    }elsif (defined $doit && $doit eq "add") {
    	$this->add_group();
    } else {
	    $this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_GROUP"))->data();

    my $cn        = $q->param('cn');
    my $desc      = $q->param('desc');
    my $mUID      = $q->param('mUID');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $filter    = $q->param('filter') || "";
    $filter = LDAP_filter_escape($filter);
    
    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server",
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			   dn       => "uid=$ADMINuid,$ldapbase",
			   password => "$ADMINpasswd"
			   );
	
    if($mesg->code != 0) {
	    my $text .= "bind failed\n";
	    $text .=  &LDAPerror($mesg);
	    $this->display_error($text,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }
# SCHULSERVER C
    my $filterlist = GroupFilterlist->new($q, $session, $ldap);
# SCHULSERVER E

# SCHULSERVER I
    my @values = ('classe','posixGroup','schoolGroup');
    my $labels = {'classe'      => $message->{classe},
                  'posixGroup'  => $message->{posixGroup},
                  'schoolGroup' => $message->{schoolGroup}
                };
    my $JavaGroup =<<EOF;
<script type="text/javascript">
    function setDefDescr() {
        if ( document.form.group_type[0].value  == "classe" ) {
            document.form.desc.value = "$message->{classe}";
        }
        if ( document.form.group_type[1].value  == "posixGroup" ) {
            document.form.desc.value = "$message->{posixGroup}";
        }
        if ( document.form.group_type[2].value  == "schoolGroup" ) {
            document.form.desc.value = "$message->{schoolGroup}";
        }
	 
    }
</script>
EOF

# SCHULSERVER E


    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->start_Tr().
		    $q->start_td().
			   $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"}).
				     $q->start_form(-action=>$confParam->{cgi_path}."/create_group.pl",-name => "form").
				     $q->start_Tr().
					     $this->help_th(3, $message->{add_new_group}, "ADD_GROUP").
		                     $q->end_Tr().
		                     $q->start_Tr().
					 $q->td({-colspan=>3, -class=>'AdminSubHeader'},
								    "$message->{star_fields}").
		                     $q->end_Tr().
		                     $q->start_Tr().
					 $q->td({-width=>"40%"},"$message->{cn} *").
		                         $q->td( [ $q->textfield(-name=>'cn',-size=>20), "&nbsp;"]  ).
		                     $q->end_Tr().
		                     $q->start_Tr().
						$q->td({-width=>"40%"},"$message->{desc}").
						$q->td([$q->textfield(-name=>'desc',-size=>20, -default=>"$message->{schoolGroup}"),"&nbsp;" ]  ).
		                     $q->end_Tr();
# SCHULSERVER I
				     if( $ADMINuid eq 'cyrus' ) {
                                     	 $html .= $q->start_Tr().$JavaGroup.
                                           	  $q->td({-colspan=>3, -align=>"center"},
                                                	$q->radio_group(-name=>'group_type',
                                                   	-values=>\@values,
	                                                -labels=>$labels,
        	                                        -default=>'schoolGroup',
							-onClick=>"setDefDescr()"
                	                              )
                                                   );
				     } else {
					$html .= $q->start_Tr().
						$q->hidden(-name=>'group_type', -value=>'schoolGroup').
						$q->td("$message->{acl}").
						$q->td($q->checkbox(-name=>'acl',-label=>"")).
					$q->end_Tr();
				     }
# SCHULSERVER E

		                     $html .=  $q->start_Tr().
		                        $q->td({-colspan=>3, -align=>"center"},  
		                            $q->hr({-noshade => '1', -size => '1', -width=>'95%'})
		                        ).
		                    $q->end_Tr().
		                    $q->start_Tr().
		                        $q->td({-colspan=>3},
		                            "<b>".$message->{'creagrp_select_members'}.":</b>").
		                    $q->end_Tr()."\n".
		                    $filterlist->make_filter_view({"textfield"    => "filter",
		                                             "textlabel"    => $message->{'filter'},
		                                             "classname"    => $message->{'classe'},
		                                             "listname"     => "mUID",
		                                             "listlabel_left" => $message->{'user'},
		                                             "buttonlabel"  => $message->{"apply_filter"},
		                                             "nofilter-msg" => $message->{"set_filter_first"},
		                                             "listfilter"   => "(&".
										  "(objectclass=posixAccount)(objectclass=SuSEeMailObject)".
									          "(!(uid=mailadmin))(!(uid=cyrus))(!(gidnumber=103))".
									          "(|(sn=$filter)(givenname=$filter)(uid=$filter))".
										")",
							     "listattrs"    => ['uid','cn','description','ou'],
		                                             "labelexp"     => ["\$\$ ","uid","(\$\$)","cn","(\$\$)","description","(\$\$)","ou"],
		                                             "multiple"     => "MULTIPLE",
		                                             "error-url"    => "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID",
		                                             "width"        => "30",
		                                             "height"       => "10",
							     "charset"      => $this->{'charset'}
		                                            }
		                    )."\n".
		                     $q->start_Tr().
		                        $q->td({ -colspan=>3,-align => "center"},
		                             $q->hr({-noshade => '1', -size => '1', -width=>'95%'})
		                        ).
		                     $q->end_Tr().
		                     $q->start_Tr().
							     $q->td({-colspan=>3, -align=>"center"},
								    $q->submit(-class=>"button",-name=>"add",
									       -value=>"$message->{add}").
								    $q->hidden(-name=>"doit", -value=>"add").
								    $q->hidden(-name=>"sessionID", -value=>$sessionID).
								    $q->hidden(-name=>"tab", -value=>"tab").
								    $q->hidden(-name=>"stab", -value=>"stab").
								    $q->end_form()
								    ).
		                     $q->end_Tr().
			    $q->end_table().
		    $q->end_td().
		$q->end_Tr();
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub add_group {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    
    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_GROUP"))->data();

    my $cn        = $q->param('cn');
    my $desc      = $q->param('desc');
    my @mUID      = $q->param('mUID');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');

    if($cn eq "" ) { 
	$this->display_error($message->{miss_some_values},
		      "$confParam->{cgi_path}/create_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    } elsif($cn =~ /[^\w-]/ ) {  #   Match a non-word character
	$this->display_error($message->{false_value},
		      "$confParam->{cgi_path}/create_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    } else {

	my $exit_value  = 0;
	my $text = "";
	my $errs = "";
	($exit_value, $errs) = $this->to_ldap();
	if($exit_value != 0) {
	    $text .= "add_group_ldap $message->{failed}\n\n";
	    $this->display_error($text.$errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}	
	$text .= "add_group_ldap $message->{success}\n";

	$q->param(-name=>'cn', -value=>"");
	$q->param(-name=>'desc', -value=>"");
	$q->param(-name=>'mUID', -value=>"");

	$this->display_msg($text,
		    "$confParam->{cgi_path}/create_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		    1);
    }
}

sub to_ldap  () {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};

    my $imaphost      = $confParam->{IMAPserver};
    my $imapport      = $confParam->{IMAPport};

    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $cn        = $q->param('cn');
    my $desc      = $q->param('desc');
    my @mUID      = $q->param('mUID');
    my $message   = ($session->getLanguage($confParam->{LANG},"CREATE_GROUP"))->data();
# SCHULSERVER I
    my $SORTED_HOME = read_rcconfig("SCHOOL_SORTED_HOME") || 'no';
    my $OBSERV_HOME = read_rcconfig("SCHOOL_TEACHER_OBSERV_HOME") || 'yes';
    my $groupware   = read_rcconfig("SCHOOL_GROUPWARE") || 'all';
    my $acl       = $q->param('acl');
    my $ERRS = "";
    my $group_type = $q->param('group_type');
    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			      dn       => "uid=$ADMINuid,$ldapbase",
			      password => "$ADMINpasswd"
			   );
	
    if($mesg->code != 0) {
	    my $text .= "bind failed\n";
	    $text .=  &LDAPerror($mesg);
	    $this->display_error($text,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }
    # The creator of the group must be member every time
    if($ADMINuid ne 'cyrus') {
	my $is_member = 0;
	foreach(@mUID){
		if($_ eq $ADMINuid) {
			$is_member = 1;
		}	
	}
	if(! $is_member ) {
		push @mUID, $ADMINuid;
	}
    }
# SCHULSERVER E


# SCHULSERVER C
# wir konvertieren alles in Grobuchstaben
    $cn = uc($cn);
# SCHULSERVER E

    my $errs = "";
    my $command  = $confParam->{bin_path}."/add_group_ldap -";
    my $cmd_args = "H=$ldaphost\nP=$ldapport\nal=$ADMINuid\n";
    $cmd_args.= "bDN=$ldapbase\nap=$ADMINpasswd\ncn=$cn\n"; 
    $cmd_args.= "groupware=$groupware\n";

    if ( $group_type eq "classe" ) {
        $cmd_args .= "class=true\n";
    }

    if($desc ne "") {
	$cmd_args .= "desc=$desc\n";
    }
    if(scalar(@mUID) > 0) {
        foreach (@mUID) {
# SCHULSERVER I
	    $mesg = $ldap->search ( # Schler drfen nicht in Klassen rein 
				    scope => "one",
				    base  => $ldapbase,
				    filter => "uid=$_",
				    attrs => ["gidNumber"]
				  );
	    my $GID = $mesg->entry(0)->get_value("gidNumber");
	    if( $GID == 100 && $group_type eq "classe") {
		$ERRS .= "$message->{kidd}: $_<br>";
	    } else {
# SCHULSERVER E
               $cmd_args.= "mUID=$_\n";
	    }
        }
    }

    $errs = cmd_pipe($command, $cmd_args);

    if ( $group_type eq "schoolGroup" ) {
	$ldap->modify( 
			dn	=> "cn=$cn,$ldapbase",
			add	=> { objectClass => 'SuSESchoolGroup' } 
		);
    }

    if($errs ne "") {
        return (-1, $errs);
    }

# SCHULSERVER I
    sleep 2; 
    $mesg = $ldap->search( base   => "cn=$cn,$ldapbase",
			   scope =>  "base",
			   filter => "cn=$cn",
			   attrs => ["gidNumber"]
		  );
    my $gidnumber = $mesg->entry(0)->get_value("gidNumber");
    $mesg = $session->suad_mkdir("/home/groups/$cn", '2770');
    if($mesg->code != 0) {
            my $text .= "could not create /home/groups/$cn\n";
            $this->display_error($text, "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
    }
    $mesg = $session->suad_chown("/home/groups/$cn",'root',$gidnumber);
    $mesg = $session->suad_chmod("/home/groups/$cn", '2770');
    if( ($group_type ne 'schoolGroup' && $group_type ne 'classe') || ($group_type eq 'classe' && $SORTED_HOME ne "no" )) {
	$mesg = $session->suad_mkdir("/home/$cn", '751');
	if($mesg->code != 0) {
	    my $text .= "could not create /home/$cn\n";
	    $this->display_error($text, "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	$mesg = $session->suad_chown("/home/$cn",'root',$gidnumber);
    }
    if($group_type eq 'classe' &&  $OBSERV_HOME eq 'yes') {
	$mesg = $session->suad_mkdir("/home/classes/$cn","770");
    }

    # Creating mailbox
    #
    my $mailbox = $cn;
    if($group_type eq 'schoolGroup') {
	$mailbox = "workgroups/".$cn;	
    }
    my $imap = new Net::IMAP($imaphost, Debug => 0) or die ("can't connect to $imaphost: $!\n");
    my $resp = $imap->login($ADMINuid, $ADMINpasswd);
       $resp = $imap->create($mailbox);
       $resp = $imap->setacl($mailbox,$ADMINuid,"lrswipcda");
       if($ADMINuid ne 'cyrus') {
       		$resp = $imap->setacl($mailbox,'cyrus',"lrswipcda");
       }
       $resp = $imap->setacl($mailbox,'anyone',"");
       if($group_type eq 'schoolGroup') {
          $resp = $imap->setacl($mailbox,'group:teachers',"");
          $resp = $imap->setacl($mailbox,'group:administration',"");
          $resp = $imap->setacl($mailbox,'group:users',"");
          $resp = $imap->setacl($mailbox,"group:$cn","lrswi");
       } else {
          $resp = $imap->setacl($mailbox,"group:$cn","lrs");
       }
       $resp = $imap->logout();

    my %attributes = ();
    $attributes{fn}                 = $cn;
    $attributes{description}        = $desc if $desc ne ""; 
    $attributes{mailenabled}        = "OK";
    $attributes{mailDeliveryProgram}= "\"|/usr/bin/formail -I \\\"From \\\" |/usr/lib/cyrus/bin/deliver -e -r $cn -a cyrus -m $mailbox\"";
    $attributes{objectclass}        = [ 'top', 'SuSEIMAPFolderObject' ];  
    $mesg = $ldap->add (
                              dn   => "fn=$cn,$ldapbase",
                              attr =>  [ %attributes ]
                              );
 
    # Allow using calendar
    $mesg = $ldap->search ( # Neue gidNumber
                                    scope => "one",
                                    base  => $ldapbase,
                                    filter => "(&(cn=$cn)(objectClass=posixGroup))",
                                    attrs => ["gidNumber"]
                                  );

    my $gidnumber = $mesg->entry(0)->get_value("gidNumber");

    if(defined $acl && $acl eq "on") {
	$mesg = $ldap->modify( # ACLs
				dn	=> "cn=$cn,$ldapbase",
				add     => { 'writerdn' => "uid=$ADMINuid,$ldapbase" }
			);
    }

    $ldap->unbind;
# SCHULSERVER E
    return (0, $ERRS);
}

1;
