#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: create_sfolder.pm,v 1.4 2003/10/29 10:35:39 varkoly Exp $
#

package create_sfolder;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use LDAPUtils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    my $message = ($this->{"session"}->getLanguage($this->{"session"}->{"confParam"}->{LANG},
						   "CREATE_SFOLDER"))->data();
    
    my $next = $cgi->param("next");
    
    if(defined $next && $next eq "$message->{add}") {
	$this->create_it();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_SFOLDER"))->data();

    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');

    my $html = "";

    my $yn = [ $message->{yes}, $message->{no} ];
    
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>5, -width=>"100%"},
				     $q->start_form(-action=>$confParam->{cgi_path}."/create_sfolder.pl"),
				     $q->Tr(
					    [
					     $this->help_th(2, $message->{add_new_sfolder}, "CREATE_SFOLDER"),
					     $q->td({-colspan=>2, -class=>'AdminSubHeader'}, "$message->{star_fields}")
					     ]
					    ),
				     $q->Tr(
					    $q->td(
						   ["$message->{fn} *",
						    $q->textfield(-name=>'fn',-size=>20)]  )
					    ),
				     $q->Tr(
					    $q->td(
						   ["$message->{desc}",
						    $q->textfield(-name=>'desc',-size=>20)] )
					    ),
				     $q->Tr(
					    $q->td(
						   ["$message->{with_email}",
						    $q->popup_menu(-name=>'emailenable',
								   -values=>$yn,
								   -default=>$message->{yes})])
					    ),
				     $q->Tr(
					    $q->td({-colspan=>2,
						    -align=>"center"},
						   $q->submit(-class=>"button",-name=>"next",
							      -value=>"$message->{add}").
						   $q->hidden(-name=>"sessionID",
							      -value=>$sessionID).
						   $q->hidden(-name=>"tab", -value=>$tab).
						   $q->hidden(-name=>"stab", -value=>$stab).
						   $q->end_form()
						   )
					    )
				     )
			   )
	       );
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub create_it {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_SFOLDER"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $imaphost      = $confParam->{IMAPserver}; 
    my $imapport      = $confParam->{IMAPport};

    my $tab                 = $q->param('tab');
    my $stab                = $q->param('stab');
    my $fn                  = $q->param('fn');
    my $mailDeliveryProgram = "";
    my $description         = $q->param('desc');
    my $mailenabled         = $q->param('emailenable');

    my $text = "";
    
    if( $fn =~ /[^a-zA-Z0-9-_.\/]/ ) {
	$this->display_error($message->{invalid},
			     "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }

    my $ldap= Net::LDAP->new($ldaphost, port => $ldapport, version => 3);
    
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
    
    my $mesg = $ldap->bind (	# bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );
    
    if($mesg->code != 0) {
	$text = "bind $message->{failed}\n\n";
	$text .= &LDAPerror($mesg);
	$this->display_error($text,
		      "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }
    
    my $imap = new Net::IMAP($imaphost, Debug => 0);
    if( ! defined $imap ) {
	$this->display_error("can't connect to $imaphost: $!\n",
			     "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }
    
    # --- login as user
    my $resp = $imap->login($ADMINuid, $ADMINpasswd);
    if($$resp{Status} ne "ok") {
	$this->display_error("login failed: Serverresponse:$$resp{Status} => $$resp{Text}",
			     "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }    
    
    # fetch all the permissions already given
    my $anof = sub {
	my $self = shift;
	my $resp = shift;
	
	foreach ($resp->identifiers) {
	    $this->{"acl"}->{$_} = $resp->identifier($_);
	    #print STDERR "KEY:$_\tVALUE:$acl{$_}\n";
	}
    };
	
    $imap->set_untagged_callback('acl', $anof);
    $resp = $imap->getacl($fn);
    
    my $no_imap = 0;
    my $no_ldap = 0;
    if( $resp->status ne 'ok' && $$resp{Text} =~ /Mailbox does not exist/ ) {
	$no_imap = 1;
    }
    
    my $result = $ldap->search( base => $ldapbase,
				scope => "one",
				attrs => ['objectclass'],
				filter => "(fn=$fn)" );
    if($result->code == 0) {
	if( $result->count == 0 ) {
	    $no_ldap = 1;
	}
	if( (! $no_ldap) && (! $no_imap) ){
	    my $text = $fn.": ".$message->{'folder_already_exists'}."\n\n";
	    $ldap->unbind;   # take down session
	    $this->display_error($text,
			  "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	}
    }

#    print STDERR "mailenabled:$mailenabled\n";
    if(defined $mailenabled && $mailenabled eq $message->{yes}) {
	my $domain = "";
	my $result = $ldap->search ( # perform a search
				    base   => "$ldapbase",
				    scope  => "one",
				    attrs => ['mailDomain'],
				    filter => "(& (uid=cyrus) (objectclass=SuSEeMailObject))"
				   );
	
	if($result->code == 0) {
	    my $entry = $result->entry(0);
	    $domain = $entry->get_value("mailDomain");
	} else {
	    $text = "search $message->{failed}\n\n";
	    $text .= &LDAPerror($result);
	    $ldap->unbind;   # take down session
	    $this->display_error($text,
			  "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	}
	$result = $ldap->search( base => $ldapbase,
				    scope => "one",
				    attrs => ['objectclass'],
				    filter => "(| (alias=$fn) (uid=$fn))" );
	if($result->code == 0) {
	    if($result->count != 0){
		my $text = $fn."@".$domain.": ".$message->{'email_not_unique'}."\n\n";
		$ldap->unbind;   # take down session
		$this->display_error($text,
			      "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
		exit;
	    }
	} else {
	    $text = "search $message->{failed}\n\n";
	    $text .= &LDAPerror($result);
	    $ldap->unbind;   # take down session
	    $this->display_error($text,
			  "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	}
	
	$mailDeliveryProgram = "\"|/usr/bin/formail -I \\\"From \\\" |/usr/lib/cyrus/bin/deliver -e -r $fn -a cyrus -m $fn\"";
	
	$mailenabled = "OK"; 
    } else {
	$mailenabled = "REJECT";
    }

    my %attributes = ();

    $attributes{fn}                 = $fn if $fn ne ""; 
    $attributes{description}        = $description if $description ne ""; 
    $attributes{mailenabled}        = $mailenabled if $mailenabled ne ""; 
    $attributes{mailDeliveryProgram}= $mailDeliveryProgram
	if $mailDeliveryProgram ne "";  
    $attributes{objectclass}        = [ 'top', 'SuSEIMAPFolderObject' ];  

    if( $no_ldap ) {
	$result = $ldap->add (
			      dn   => "fn=$fn,$ldapbase",
			      attr =>  [ %attributes ]
			      );
	
	if ($result->code != 0) {
	    $text = "failed to add entry:";
	    $text .= &LDAPerror($result);
	    $ldap->unbind;   # take down session
	    $this->display_error($text,
				 "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit ;
	}
    }
    
    
    if(defined $mailenabled && $mailenabled eq "OK" && $no_ldap ) {
	
	$result = $ldap->modify( "uid=mailadmin,$ldapbase",
				 changes => [ add =>  [ alias => "owner-$fn" ]]
				 );
	if ($result->code != 0) {
	    $text = "failed to add owner-$fn alias to mailadmin:";
	    $text .= &LDAPerror($result);
	    $ldap->unbind;   # take down session
	    $this->display_error($text,
				 "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit ;
	}
    }

    $ldap->unbind;   # take down session

    # --- create new Mailbox
    $resp = $imap->create($fn);
    
    if($$resp{Status} ne "ok") {
	$text =  "create failed: Serverresponse:$$resp{Status} => $$resp{Text}\n";
	$this->display_error($text,
		      "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	$imap->logout;
	exit;
    }

    $text = "";

    # --- set all righs to admin
    $resp = $imap->setacl($fn, $ADMINuid, "lrswipcda");
    if($$resp{Status} ne "ok") {
	$text =  "setacl failed: Serverresponse:$$resp{Status} => $$resp{Text}\n";
	$text .= "I continue ...\n";
    } 

    $resp = $imap->deleteacl($fn, "anyone");
    if($$resp{Status} ne "ok") {
	$text .= "deleteacl failed: Serverresponse:$$resp{Status} => $$resp{Text}\n";
	$text .= "I continue ...\n";
    } 

    if($text ne "") {
	$this->display_error($text,
		      "$confParam->{cgi_path}/create_sfolder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	$imap->logout;
	exit;
    }
    $imap->logout;

    $text = "$message->{folder} $fn $message->{mess}";
    
#      $q->delete('fn');
#      $q->delete('desc');
#      $q->delete('mailenabled');
#      $fn = "";
#      $description = "";
#      $mailenabled = "";

    $this->display_msg($text,
		"$confParam->{cgi_path}/manage_folder_permissions.pl?sessionID=$sessionID\&Folder=$fn\&tab=$tab\&stab=$stab",
		2);
    exit;
}

1;
