#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: delete_user.pm,v 1.7 2004/05/03 20:04:36 varkoly Exp $
# 

$| = 1; # do not buffer stdout

package delete_user;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(thaw freeze);
use Utils;
use LDAPUtils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
use Net::LDAP qw(:all);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit = $cgi->param('doit');

    if(defined $doit && $doit eq "del") {
	$this->del_him();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"DELETE_USER"))->data();
    
    my $doit      = $q->param('doit');
    my $filter    = $q->param('filter');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    
    my $button_width=100;

    #load list of users from session
    my $frozen = $confParam->{"usersToMod"};
    $frozen = pack('H*',$frozen); # convert back to binary
    my $user_ref = thaw($frozen);     # melt down... :-)
    my @users    = @{$user_ref};
    

    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->start_Tr().
		    $q->start_td().
			$q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"}).
			    $q->start_form(-action=>$confParam->{cgi_path}."/delete_user.pl").
			    $q->start_Tr().
				$q->td({-class=>'AdminHeader', -colspan=>2 },
					     "<b>$message->{delete_user_really}</b>"
				    ).
			    $q->end_Tr().
			    $q->start_Tr().
				$q->start_td({-colspan=>2, -class=>'AdminSubHeaderRed', -align=>"center"});
				    foreach(@users){
					$html .= "$_<BR>";
				    }   
				    $html .= $message->{'warn_del_user'};
				    $html .= $q->end_td().
			    $q->end_Tr.   
			    $q->Tr(
				$q->td({-align=>"center"},
				    $q->submit(-class=>"button", -name=>"buttons",
						-value=>"$message->{no}",
						-width=>$button_width).
				    $q->hidden(-name=>"sessionID", -value=>"$sessionID").
				    $q->hidden(-name=>"doit", -value=>"del").
				    $q->hidden(-name=>"filter", -value=>"$filter").
				    $q->hidden(-name=>"filtered", -value=>1).
				    $q->hidden(-name=>"USER", -value=>"$users[0]").
				    $q->hidden(-name=>"tab", -value=>"$tab").
				    $q->hidden(-name=>"stab", -value=>"$stab")
				),
				$q->td({-align=>"center"},
				    $q->submit(-class=>"button",-name=>"buttons",
					       -value=>"$message->{yes}",
					       -width=>$button_width).
				    $q->end_form()
				)
	    		    ).
			$q->end_table().
		    $q->end_td().
		$q->end_Tr().    
	    $q->end_table();
    
    $this->back_url("$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter\&filtered=1");
    $this->SUPER::display($html);
}


sub del_him {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"DELETE_USER"))->data();

    my $b      = $q->param('buttons');
    my $filter = $q->param('filter');
    my $tab    = $q->param('tab');
    my $stab   = $q->param('stab');
    my $errs = "";

    #load list of users from session
    my $frozen = $confParam->{"usersToMod"};
    $frozen = pack('H*',$frozen); # convert back to binary
    my $user_ref = thaw($frozen);     # melt down... :-)
    my @users    = @{$user_ref};
    my $ldap = Net::LDAP->new($confParam->{'LDAPserver'}, port => $confParam->{'LDAPport'}, version => 3 );
    my $ldap_res = $ldap->bind("uid=".$confParam->{uid}.",".$confParam->{baseDN},
			       password=>$confParam->{passwd});
    if( $ldap_res->code() != LDAP_SUCCESS ){
        my $text = "bind failed\n".&LDAPerror($ldap_res);
        $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    if(defined $b && $b eq $message->{yes}) {
	$this->display_head();
	print $q->start_table();
	print	$q->start_Tr().$q->start_td().$message->{'deleting_user'}.$q->end_td().$q->end_Tr();
	my $text = "";
	my $error = 0;    
	my $uid = "";
	foreach $uid (@users){
	    $text = $q->start_Tr.$q->start_td();
	    $ldap_res = $ldap->search( base => "uid=$uid,".$confParam->{'baseDN'},
				      scope => "base",
				      attrs => ["userCertificate"],
				      filter => "(userCertificate=*)" );
	    if( $ldap_res->code() != LDAP_SUCCESS ){
		$text .= "search failed\n".&LDAPerror($ldap_res)."<BR>";
	    }
	    if( $ldap_res->count() > 0){
		$text .= "<b>".$uid."</b> ".
			 $message->{'delete_user_not_deleted'}." ".
			 $message->{'delete_user_has_certificate'}."<BR>\n";
	    }else{
		my $exit_imap;
		($exit_imap, $errs) = $this->from_imap($uid);
		if($exit_imap != 0) {
		    $text .= "del_user $uid IMAP $message->{failed}<BR>\n\n";
		    $text .= $errs."<BR>";
		    $error = 1;
		} else {	
		    $text .= "del_user $uid IMAP $message->{success}<BR>\n";
		}

		my $exit_sieve;
		($exit_sieve, $errs) = $this->del_sieve($uid);
		if($exit_imap != 0) {
		    $text .= "del_user $uid SIEVE $message->{failed}<BR>\n\n";
		    $text .= $errs."<BR>";
		    $error = 1;
		} else {	
		    $text .= "del_user $uid SIEVE $message->{success}<BR>\n";
		}

# I SCHULSERVER
		#Homverzeichniss wird zum archivieren bewegt "mv $home /home/archiv/$uid"
                $ldap_res = $ldap->search( base => "uid=$uid,".$confParam->{'baseDN'},
                                      scope => "base",
                                      attrs => ['homeDirectory','uidNumber'],
                                      filter => "uid=$uid" );
                my $homedir   = $ldap_res->entry(0)->get_value('homeDirectory');
                my $uidNumber = $ldap_res->entry(0)->get_value('uidNumber');
                my $ret = $session->suad_move("/home/profile/$uid","$homedir/profile");
                   $ret = $session->suad_move($homedir,"/home/archiv/$uid");
                   $ret = $session->suad_stdout_exec("echo -n $uidNumber > /home/archiv/$uid/UIDNUMBER");

		# Jetzt fhren wir die archivierung per Hand durch
#		system("sudo /usr/sbin/archiv_user");

		# Delete symlinks if exixsts;
		$session->suad_stdout_exec("RM=`find /home/classes -name $uid`; test \$RM && rm \$RM;");

		#Aus dem mysql muss auch alles ausgetragen werden
                my $mysqlc = "mysql -u $confParam->{uid} -p\'$confParam->{passwd}\' -h mailserver phpgroupware";
                my $mysqla = "";
                $mysqla = " DELETE FROM phpgw_acl WHERE acl_account=$uidNumber";
                system("echo \'$mysqla\' | $mysqlc");
                $mysqla = " DELETE FROM phpgw_preferences WHERE preference_owner=\'$uidNumber\'";
                system("echo \'$mysqla\' | $mysqlc");
		$mysqla = " DELETE FROM phpgw_categories WHERE cat_owner=$uidNumber";
                system("echo \'$mysqla\' | $mysqlc");
		$mysqla = "SELECT cal_id FROM phpgw_cal_user WHERE cal_login=$uidNumber";
		my @calenders = `echo $mysqla | $mysqlc`;
		shift @calenders;
		foreach my $i (@calenders) {
			$mysqla = " DELETE FROM phpgw_cal_user WHERE cal_id=$i";
                	system("echo \'$mysqla\' | $mysqlc");
			$mysqla = " DELETE FROM phpgw_cal WHERE cal_id=$i";
                	system("echo \'$mysqla\' | $mysqlc");
			$mysqla = " DELETE FROM phpgw_cal_alarm WHERE cal_id=$i";
                	system("echo \'$mysqla\' | $mysqlc");
			$mysqla = " DELETE FROM phpgw_cal_repeats WHERE cal_id=$i";
                	system("echo \'$mysqla\' | $mysqlc");
		}
		

		#Adressbucheintrag wird auch gelscht
		$ldap_res = $ldap->delete("uid=$uid:system,o=AddressBook,".$confParam->{'baseDN'});

		#Eigene Eintrge aus dem Adressbuch werden gelscht.
		$ldap_res = $ldap->search (  # perform a search
                               base   => "o=AddressBook,".$confParam->{'baseDN'},
                               scope => "base",
                               attrs => ['dn'],
                               filter => "phpgwContactOwner=$uidNumber"
                              );
		if( $ldap_res->count > 0 ){
			foreach my $entry ($ldap_res->all_entries) {
				my $dn = $entry->dn();
				$ldap->delete($dn);
			}
		}
		#Admineintrag wird ggf. gelscht
		$ldap_res = $ldap->search (  # perform a search
                               base   => "cn=Admins,".$confParam->{'baseDN'},
                               scope => "base",
                               attrs => ['member'],
                               filter => "member=uid=$uid,".$confParam->{'baseDN'}
                              );
		if( $ldap_res->count > 0 ){
			$ldap->modify( "cn=Admins,".$confParam->{'baseDN'},
                                delete => {"member" => "uid=$uid,".$confParam->{'baseDN'} }
                             );
		}
# E SCHULSERVER

		my $exit_ldap;
		($exit_ldap, $errs) = $this->from_ldap($uid);
		if($exit_ldap == -2) {
		    $text .= "del_user $uid LDAP $message->{not_completely_executed}<BR>\n\n";
		    $text .= $errs."<BR>";
		    $error = 1;
		} elsif($exit_ldap != 0) {
		    $text .= "del_user $uid LDAP $message->{failed}<BR>\n\n";
		    $text .= $errs."<BR>";
		    $error = 1;
		} else {
		    $text .= "del_user $uid LDAP $message->{success}<BR>\n";
		}
		
# C SCHULSERVER
#		my $exit_comfire;
#		($exit_comfire, $errs) = $this->del_comfire($uid);
#		if($exit_comfire != 0) {
#		    $text .= "deluserGroupware $uid $message->{failed}<BR>\n\n";
#		    $error = 1;
#		} else {	
#		    $text .= "deluserGroupware $uid $message->{success}<BR>\n";
#		}
# E SCHULSERVER
	    }
	    $text .= $q->end_td.$q->end_Tr();
	    print $text;
	}
	print $q->end_table();
	$session->suad_service_exec("nscd", "restart");
	$this->display_footer("$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID".
			      "\&tab=$tab\&stab=$stab\&filter=$filter&filtered=1");
    } else {
	$this->display_msg($message->{delete_user_abort}, 
			   "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID".
			   "&filter=$filter&filtered=1\&tab=$tab\&stab=$stab" ,
			   1);
    }
}

sub from_ldap  () {
    my $this = shift;

    my $user = shift;
    my $confParam = $this->{"session"}->{"confParam"};
    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $errs = "";
    my $command = $confParam->{bin_path}."/del_user -";
    my $cmd_args  = "LH=$ldaphost\nLP=$ldapport\nal=$ADMINuid\n";
    $cmd_args .= "ap=$ADMINpasswd\nuid=$user\nldap\nbDN=$ldapbase\n"; 

    $errs = cmd_pipe($command, $cmd_args);
    if($errs =~ /failed\sto\sdelete\suser\s.*/ ) {
        return (-1, $errs);
    } elsif($errs ne "") {
	return (-2, $errs);
    }
    return (0, $errs);
}

sub from_imap  () {
    my $this = shift;

    my $user = shift;
    my $confParam = $this->{"session"}->{"confParam"};
    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $imaphost      = $confParam->{IMAPserver}; 
    my $imapport      = $confParam->{IMAPport};

    my $errs = "";
    my $command = $confParam->{bin_path}."/del_user -";
    my $cmd_args  = "CH=$imaphost\nCP=$imapport\nal=$ADMINuid\n";
    $cmd_args .= "ap=$ADMINpasswd\nuid=$user\nimap\n";
    if( $::CONF_GLOBAL{'GENERAL'}{'DelUserNoAcl'} eq 'true' ){
	$cmd_args .= "noacl\n";
    }
    #print STDERR "ARGS:$cmd_args\n";
    $errs = cmd_pipe($command, $cmd_args);
    if($errs ne "") {
        return (-1,$errs);
    }
    return (0, $errs);
}

sub del_sieve  () {
    my $this = shift;

    my $user = shift;
    my $confParam = $this->{"session"}->{"confParam"};
    my $ADMINuid      = $confParam->{"uid"};
    my $ADMINpasswd   = $confParam->{"passwd"};
    my $imaphost      = $confParam->{"IMAPserver"}; 
    my $sieveport      = $confParam->{"SIEVEport"};

    my $errs = "";
    my $command = $confParam->{bin_path}."/del_user -";
    my $cmd_args  = "CH=$imaphost\nSP=$sieveport\nal=$ADMINuid\n";
    $cmd_args .= "ap=$ADMINpasswd\nuid=$user\nsieve\n";

    $errs = cmd_pipe($command, $cmd_args);
    if($errs ne "") {
        return (-1,$errs);
    }
    return (0, $errs);
}

sub del_comfire () {
    my $this = shift;

    my $user = shift;
    my $confParam   = $this->{"session"}->{"confParam"};
    my $ADMINuid    = $confParam->{"uid"};
    my $ADMINpasswd = $confParam->{"passwd"};

    my $command = "/opt/comfire/application/scripts/deleteUser $user";

    system($command);
    my $exit_value  = $? >> 8;

    if($exit_value != 0) {
	# error
        return (-1,"ems3deluser");
    }
    return (0, "");
}

1;
