#
# Copyright (c) 2003 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: dyndns.pm,v 1.1 2003/09/23 10:48:11 varkoly Exp $
#

package dyndns;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my %ddns_services = (
  'dyndns2'       => 'www.dyndns.org',
  'easydns'       => 'www.easydns.com',
  'dnspark'       => 'www.dnspark.com',
  'zoneedit1'     => 'www.zoneedit.com',
  'dslreports1'   => 'www.dslreports.com',
  'hammernode1'   => 'www.hn.org',
);
my $ddns_dservice = 'dyndns2'; # default protocol in ddclient

my %ddns_settings = (
  'dyndns2'     => {
    'login'       => '',
    'password'    => '',
    'server'      => 'members.dyndns.org:8245',
    'wildcard'    => 'yes',
    'backupmx'    => 'yes',
    'mx'          => '',
    'system'      => ['dyndns', 'custom', 'static'],
  },
  'easydns'     => {
    'login'       => '',
    'password'    => '',
    'server'      => 'members.easydns.com',
    'wildcard'    => 'yes',
    'backupmx'    => 'yes',
    'mx'          => '',
  },
  'dnspark'     => {
    'login'       => '',
    'password'    => '',
    'server'      => 'www.dnspark.com',
    'mx'          => ''
  },
  'zoneedit1'   => {
    'login'       => '',
    'password'    => '',
    'server'      => 'www.zoneedit.com',
  },
  'dslreports1' => {
    'login'       => '',
    'password'    => '',
    'server'      => 'www.dslreports.com',
  },
  'hammernode1' => {
    'login'       => '',
    'password'    => '',
    'server'      => 'dup.hn.org',
  }
);

sub new {
    my $this = shift;
    my $self = new Display(@_);

    return bless $self, $this;
}

sub display {
    my $this      = shift;
    my $cgi       = $this->{"cgi"};

    if(defined($::CONF_GLOBAL{'GENERAL'}{'EnableDynDns'}) and
       $::CONF_GLOBAL{'GENERAL'}{'DynDnsCheckGW'} eq 'true') {
      $this->check_if_gateway();
    }

    if(   $cgi->param('new_host')) {
        $this->edit_host();
    }
    elsif($cgi->param('edit_host')) {
        $this->edit_host();
    }
    elsif($cgi->param('del_host')) {
        $this->save_host();
    }
    elsif($cgi->param('save_host')) {
        $this->save_host();
    }
    else {
        $this->startup();
    }
}

sub check_if_gateway {
    my $this      = shift;
    my $found     = 0;
    my $ifcfg     = '/etc/sysconfig/network';

    if(opendir(IFCFG, $ifcfg)) {
        foreach my $e (readdir(IFCFG)) {
          $found=1 if($e =~ /^ifcfg-(?:ppp|ippp|dsl)\d+$/);
        }
        closedir(IFCFG);
    }
    return if($found);

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"DYNDNS"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $html      = '';

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>2, -width=>"100%"});
    $html .=         $this->help_th(2, $message->{'dyndns_title'}, "DYNDNS");

    $html .=       $cgi->Tr($cgi->td({-colspan=>2, -align=>'CENTER'},["&nbsp"]));
    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td({-colspan => 2, -align=>'CENTER'},
                                 '<font color="red">'.
                                 $message->{'dyndns_not_gateway'}.
                                 '</font>');
    $html .=         $cgi->end_Tr();

    $html .=       $cgi->Tr($cgi->td({-colspan=>2, -align=>'CENTER'},["&nbsp"]));

    $html .=       $cgi->end_table();
    $html .=     $cgi->end_td();
    $html .=   $cgi->end_Tr();
    $html .= $cgi->end_table();

    $this->SUPER::display($html);
    exit(0);
}

sub startup {
    my $this      = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"DYNDNS"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $html      = '';
    my $ret;

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>2, -width=>"100%"});
    $html .=         $this->help_th(2, $message->{'dyndns_title'}, "DYNDNS");

    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td({-class=>'AdminSubHeader', -colspan => 2},
                                 $message->{'dyndns_head_main'});
    $html .=         $cgi->end_Tr();

    my $conf_host = {};
    my $conf_file = '/etc/ddclient.conf';

    if(-f $conf_file) {
      # read file
      $ret =  $session->suad_read($conf_file);
      if($ret->code() =~ /^ERROR:\s*(.*)/) {
        $this->display_error($message->{'ddns_cfg_not_readable'}." ".
                             $conf_file.": $1",
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      }

      # remember data
      my @data = split("\n", $ret->data());
      $ret = $session->save_store2session($conf_file, $conf_file, \@data);
      if($ret->code() ne "OK" ) {
        if( $ret->code() eq "MD5SUM" ) {
          $this->display_error($conf_file.": ".$message->{'modified'},
                               "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
          exit(1);
        } else {
          $this->display_error($ret->code(),
                               "$confParam->{cgi_path}/dyndns.pl?".
                               "sessionID=$sessionID\&tab=$tab\&stab=$stab");
          exit(1);
        }
      }

      # parse data
      $conf_host = $this->ddclient_parse_conf(\@data);

      # store parsed config
      $ret = $session->modify({'conf_host' => $conf_host});
      if($ret->code() ne "OK" ) {
        $this->display_error($message->{'write2session_failed'},
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      }
    }

    my @host_list = sort keys %{$conf_host};
    if(scalar(@host_list)) {
      $html .=       $cgi->Tr($cgi->td({-colspan=>2, -align=>'CENTER'},["&nbsp"]));

      # *** View Host Form ***
      $html .=       $cgi->start_form(-action=>$confParam->{cgi_path}."/dyndns.pl")."\n";

      $html .=       $cgi->start_Tr();
      $html .=         $cgi->start_td({-colspan=>2, -align => 'CENTER'});

      # --- host view sub-table ---
      $html .=           $cgi->start_table({-cellspacing=>0, -cellpadding=>2, -width=>"100%"});

      $html .=             $cgi->start_Tr();
      $html .=               $cgi->th({-align =>'LEFT', -colspan=>2},
                                      [$message->{'ddns_th_hostname'}]);
      $html .=               $cgi->th({-align =>'LEFT'},
                                      [$message->{'ddns_th_wildcard'},
                                       $message->{'ddns_th_mx_host'},
                                       $message->{'ddns_th_mx_backup'}]);
      $html .=             $cgi->end_Tr()."\n";

      $html .=             $cgi->start_Tr();
      $html .=               $cgi->td({-colspan=>5, -align => 'CENTER'},
                                      [$cgi->hr({-width=>"100%"})]);
      $html .=             $cgi->end_Tr()."\n";

      my $td_style = 0;
      my @td_attrs = ({-align => 'LEFT', -class => 'list-dark'},
                      {-align => 'LEFT'});

      foreach my $host (@host_list) {
        my @line = ();
        if($conf_host->{'protocol'}) {
          next unless(exists($ddns_services{$conf_host->{'protocol'}}));
        }
        push(@line, join("<br>\n", split(/\s*,\s*/, $host)));
        push(@line, ($conf_host->{$host}->{'wildcard'} =~ /yes/i) ?
                     $message->{'yes'} : $message->{'no'});
        push(@line, ($conf_host->{$host}->{'mx'} =~ /\S+/) ?
                     $conf_host->{$host}->{'mx'} : ' - ');
        push(@line, ($conf_host->{$host}->{'backupmx'} =~ /yes/i) ?
                     $message->{'yes'} : $message->{'no'});

        $html .=           $cgi->start_Tr();
                            # minimal width!
        $html .=             $cgi->td({-width => '1', %{$td_attrs[$td_style]}}, [
                               $cgi->radio_group(-name=>'ddns_hosts',
                                                 -values => [$host],
                                                 -default=> $host_list[0],
                                                 -labels => {$host => ''})
                             ]);
        $html .=             $cgi->td($td_attrs[$td_style], \@line);
        $html .=           $cgi->end_Tr()."\n";
        $td_style = (0 == $td_style) ? 1 : 0;
      }
      $html .=             $cgi->Tr($cgi->td({-colspan=>5, -align => 'CENTER'},
                                    [$cgi->hr({-width=>"100%"})]))."\n";

      $html .=           $cgi->end_table()."\n";
      # --- host view sub-table ---

      $html .=         $cgi->end_td();
      $html .=       $cgi->end_Tr();

      $html .=       $cgi->start_Tr();
      $html .=         $cgi->td([$message->{'ddns_sel_host'},
                         $cgi->submit(-name =>'edit_host',
                                      -value=>$message->{'edit'},
                                      -class=>"button").
                         ' &nbsp; '.
                         $cgi->submit(-name =>'del_host',
                                      -value=>$message->{'delete'},
                                      -class=>"button").
                         $cgi->hidden(-name =>"tab",       -value=>$tab).
                         $cgi->hidden(-name =>"stab",      -value=>$stab).
                         $cgi->hidden(-name =>"sessionID", -value=>$sessionID)
                       ]);
      $html .=       $cgi->end_Tr();
      $html .=       $cgi->Tr($cgi->td({-colspan=>2, -align=>'CENTER'},["&nbsp"]));
      $html .=       $cgi->Tr($cgi->td({-colspan=>2, -align=>'CENTER'},
                              [$cgi->hr({-size=>2, -noshade=>, -width=>"100%"})]));

      $html .=       $cgi->end_form();
      # *** View Host Form ***
    }

    # *** Add Host Form ***
    $html .=         $cgi->start_form(-action=>$confParam->{cgi_path}."/dyndns.pl");
    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td([$message->{'ddns_service'},
                         $cgi->popup_menu(-name     => 'ddns_service',
                                          -values   => [keys %ddns_services],
                                          -default  => $ddns_dservice,
                                          -labels   => \%ddns_services)
                       ])."\n";
    $html .=         $cgi->end_Tr()."\n";
    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td([$message->{'ddns_new_host'},
                         $cgi->submit(-name =>'new_host',
                                      -value=>$message->{'new'},
                                      -class=>"button").
                         $cgi->hidden(-name =>"tab",       -value=>$tab).
                         $cgi->hidden(-name =>"stab",      -value=>$stab).
                         $cgi->hidden(-name =>"sessionID", -value=>$sessionID)
                       ])."\n";
    $html .=         $cgi->end_Tr()."\n";
    $html .=         $cgi->end_form();
    # *** Add Host Form ***


    # -----------------
    $html .=       $cgi->end_table();
    $html .=     $cgi->end_td();
    $html .=   $cgi->end_Tr();
    $html .= $cgi->end_table();

    $this->SUPER::display($html);
}

sub edit_host {
    my $this      = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"DYNDNS"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $html      = '';
    my $ret;
    my ($val, $cur);

    # retrive config from session
    my $conf_host = $confParam->{'conf_host'} || {};
    my $conf_file = '/etc/ddclient.conf';

    # check main cgi args...
    my $service   = $cgi->param('ddns_service');
    my $old_hosts = $cgi->param('ddns_hosts') || '';
    if($old_hosts and exists($conf_host->{$old_hosts})) {
      $service = $conf_host->{$old_hosts}->{'protocol'} || $ddns_dservice;
    }
    unless($service and exists($ddns_services{$service})) {
      $this->display_error($message->{'ddns_invalid_service'},
                           "$confParam->{cgi_path}/dyndns.pl?".
                           "sessionID=$sessionID\&tab=$tab\&stab=$stab");
      exit(1);
    }

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>2, -width=>"100%"});
    $html .=         $this->help_th(2, $message->{'dyndns_title'}, "DYNDNS");

    $html .=         $cgi->start_Tr();
    if($cgi->param('new_host')) {
      $html .=         $cgi->td({-class=>'AdminSubHeader', -colspan => 2},
                                 $message->{'dyndns_head_newhost'}." ".$ddns_services{$service});
    } else {
      $html .=         $cgi->td({-class=>'AdminSubHeader', -colspan => 2},
                                 $message->{'dyndns_head_edithost'}." ".$ddns_services{$service});
    }
    $html .=         $cgi->end_Tr();

    # *** Edit Host Form ****
    $html .=         $cgi->start_form(-action=>$confParam->{cgi_path}."/dyndns.pl");
    $html .=         $cgi->Tr( $cgi->td({-colspan=>2, -align => "center"}, ["&nbsp"]));

    # ... common fields ...
    $val = $ddns_settings{$service}->{'login'};
    if($old_hosts and exists($conf_host->{$old_hosts}->{'login'})) {
       $val = $conf_host->{$old_hosts}->{'login'};
    }
    $html .=         $cgi->Tr( $cgi->td([$message->{'ddns_login'},
                         $cgi->textfield(-name     => 'ddns_login',
                                         -value    => $val,
                                        )."\n"
                     ]))."\n";

    $val = $ddns_settings{$service}->{'password'};
    if($old_hosts and exists($conf_host->{$old_hosts}->{'password'})) {
       $val = $conf_host->{$old_hosts}->{'password'};
    }
    $html .=         $cgi->Tr( $cgi->td([$message->{'ddns_password'},
                         $cgi->password_field(-name     => 'ddns_password',
                                              -value    => $val,
                                             )."\n"
                     ]))."\n";

    $val = '';
    $val = $old_hosts if($old_hosts);
    $html .=         $cgi->Tr( $cgi->td([$message->{'ddns_hostname'},
                         $cgi->textfield(-name     => 'ddns_hostname',
                                         -value    => $val,
                                        )."\n"
                     ]))."\n";
    # ... common fields ...

    if(exists($ddns_settings{$service}->{'wildcard'})) {
      $val =  $ddns_settings{$service}->{'wildcard'};
      $cur = 0;
      if($old_hosts and exists($conf_host->{$old_hosts}->{'wildcard'})) {
        $cur = (lc($conf_host->{$old_hosts}->{'wildcard'}) eq $val) ? 1 : 0;
      }

      $html .=       $cgi->Tr( $cgi->td(['&nbsp;',
                         $cgi->checkbox(-name     => 'ddns_wildcard',
                                        -label    => $message->{'ddns_wildcard'},
                                        -checked  => $cur,
                                        -value    => $val)."\n"
                     ]))."\n";
    }
    $html .=         $cgi->Tr( $cgi->td({-colspan=>2, -align => "center"}, ['&nbsp;']))."\n";

    if(exists($ddns_settings{$service}->{'mx'})) {
      $val =  $ddns_settings{$service}->{'mx'};
      if($old_hosts and exists($conf_host->{$old_hosts}->{'mx'})) {
         $val = $conf_host->{$old_hosts}->{'mx'};
      }
      $html .=       $cgi->Tr( $cgi->td([$message->{'ddns_mx'},
                         $cgi->textfield(-name     => 'ddns_mx',
                                         -value    => $val,
                                         -maxlength=>64)."\n"
                     ]))."\n";

      if(exists($ddns_settings{$service}->{'backupmx'})) {
        $val =  $ddns_settings{$service}->{'backupmx'};
        $cur = 0;
        if($old_hosts and exists($conf_host->{$old_hosts}->{'backupmx'})) {
          $cur = (lc($conf_host->{$old_hosts}->{'backupmx'}) eq $val) ? 1 : 0;
        }
        $html .=     $cgi->Tr( $cgi->td(['&nbsp;',
                         $cgi->checkbox(-name     => 'ddns_backupmx',
                                        -label    => $message->{'ddns_backupmx'},
                                        -checked  => $cur,
                                        -value    => $val)."\n"
                     ]))."\n";
      }

      $html .=       $cgi->Tr( $cgi->td({-colspan=>2, -align=>"center"}, ['&nbsp;']))."\n";
    }

    if(exists($ddns_settings{$service}->{'system'})) {
      $val =  $ddns_settings{$service}->{'system'};
      $cur = "dyndns";
      if($old_hosts) {
         $cur = "custom" if(exists($conf_host->{$old_hosts}->{'custom'}) and
                            lc($conf_host->{$old_hosts}->{'custom'}) eq 'yes');
         $cur = "static" if(exists($conf_host->{$old_hosts}->{'static'}) and
                            lc($conf_host->{$old_hosts}->{'static'}) eq 'yes');
      }
      $html .=       $cgi->Tr( $cgi->td([$message->{'ddns_system'},
                         $cgi->popup_menu(-name     => 'ddns_system',
                                          -values   => $val,
                                          -default  => $cur)
                       ]))."\n";
    }

    # ... update-server name ...
### ==> see hidden bellow
#    $val = $ddns_settings{$service}->{'server'};
#    if($old_hosts) {
#      $val = $conf_host->{$old_hosts}->{'server'};
#    }
#    $html .=         $cgi->Tr( $cgi->td([$message->{'ddns_server'},
#                           $cgi->textfield(-name     => 'ddns_server',
#                                           -value    => $val,
#                                           -maxlength=>64)."\n"
#                     ]))."\n";

    $html .=         $cgi->Tr( $cgi->td({-colspan=>2, -align => "center"}, ['&nbsp;']))."\n";

    # ... submit button ...
    $html .=         $cgi->Tr( $cgi->td({-colspan=>2, -align => "center"}, [
                         $cgi->submit(-name => 'save_host',
                                      -value=> $message->{'save'},
                                      -class=>"button")."\n"
                     ]));

    $val = $ddns_settings{$service}->{'server'};
    if($old_hosts) {
      $val = $conf_host->{$old_hosts}->{'server'};
    }
    $html .=         $cgi->hidden(-name =>"ddns_server",  -value=>$val)."\n";
    $html .=         $cgi->hidden(-name =>"ddns_service", -value=>$service)."\n";
    $html .=         $cgi->hidden(-name =>"ddns_hosts",   -value=>$old_hosts)."\n";
    $html .=         $cgi->hidden(-name =>"tab",       -value=>$tab)."\n";
    $html .=         $cgi->hidden(-name =>"stab",      -value=>$stab)."\n";
    $html .=         $cgi->hidden(-name =>"sessionID", -value=>$sessionID)."\n";
    $html .=         $cgi->end_form();
    # *** Edit Host Form ****

    $html .=       $cgi->end_table();
    $html .=     $cgi->end_td();
    $html .=   $cgi->end_Tr();
    $html .= $cgi->end_table();
    $this->SUPER::display($html);
}

sub save_host {
    my $this      = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"DYNDNS"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $html      = '';
    my $ret;

    # retrive config from session
    my $conf_host = $confParam->{'conf_host'} || {};
    my $conf_file = '/etc/ddclient.conf';
    my $conf_data = undef;
    my %conf_save = {};

    # check main cgi args...
    my $service   = $cgi->param('ddns_service')  || '';
    my $new_hosts = $cgi->param('ddns_hostname') || '';
    my $old_hosts = $cgi->param('ddns_hosts')    || '';
    if($old_hosts and exists($conf_host->{$old_hosts})) {
      $service   = $conf_host->{$old_hosts}->{'protocol'} || $ddns_dservice;
    }
    unless($service and exists($ddns_services{$service})) {
      $this->display_error($message->{'ddns_invalid_service'},
                           "$confParam->{cgi_path}/dyndns.pl?".
                           "sessionID=$sessionID\&tab=$tab\&stab=$stab");
      exit(1);
    }
    unless($cgi->param('del_host')) {
      # some basic host-list cleanup
      $new_hosts =~ s/\s*,\s*/,/g;
      $new_hosts =~ s/^[\s,]+//;
      $new_hosts =~ s/[\s|,]+$//;
      # simple syntax check - should be a host[,host] list
      # FIXME: dslreports1 exception - numeric ID is used
      unless($new_hosts =~ /^[\w|-]+(?:\.[\w|-]+)+(?:,[\w|-]+(?:\.[\w|-]+)+)*$/
             or ($service eq 'dslreports1' and $new_hosts =~ /^\d+$/)) {
        $this->display_error($message->{'ddns_invalid_value'}." ".$message->{'ddns_hostname'},
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      }
      # check ddns update-server name
      unless($cgi->param('ddns_server') =~ /^\s*[\w|-]+(?:\.[\w|-]+)+(?:\:\d{1,5})*\s*$/) {
        $this->display_error($message->{'ddns_invalid_value'}." ".$message->{'ddns_server'},
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      }
      # check other mandatory params
      unless($cgi->param('ddns_login') =~ /\S+/) {
        $this->display_error($message->{'ddns_invalid_value'}." ".$message->{'ddns_login'},
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      }
      unless($cgi->param('ddns_password') =~ /\S+/) {
        $this->display_error($message->{'ddns_invalid_value'}." ".$message->{'ddns_password'},
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      }
      # check the optional mx host param
      if($cgi->param('ddns_mx')) {
        unless($cgi->param('ddns_mx') =~ /^\s*[\w|-]+(?:\.[\w|-]+)+\s*$/) {
          $this->display_error($message->{'ddns_invalid_value'}." ".$message->{'ddns_mx'},
                               "$confParam->{cgi_path}/dyndns.pl?".
                               "sessionID=$sessionID\&tab=$tab\&stab=$stab");
          exit(1);
        }
      } else {
        # backupmx not allowed without mx host
        if(defined($cgi->param('ddns_backupmx')) and
           ($cgi->param('ddns_backupmx') =~ /yes/i)) {
          $this->display_error($message->{'ddns_invalid_no_mx'},
                               "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
          exit(1);
        }
      }
    }

    # OK, fetch config from session
    $ret = $session->save_read2session($conf_file, $conf_file);
    if($ret->code() eq "OK") {
      $conf_data = $ret->data() || {};
    } else {
      if($ret->code() eq "MD5SUM") {
        $this->display_error($conf_file.": ".$message->{modified},
                             "$confParam->{cgi_path}/dyndns.pl?".
                             "sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit(1);
      } else {
        if(-f $conf_file) {
          $this->display_error($ret->code(),
                               "$confParam->{cgi_path}/menu.pl?"
                               ."sessionID=$sessionID");
          exit(1);
        }
      }
    }
    # reset config in session
    $ret = $session->modify({'conf_host' => ''});

    if($old_hosts and exists($conf_host->{$old_hosts})) {
      %conf_save = %{$conf_host->{$old_hosts}};
      delete($conf_host->{$old_hosts});
    }
    unless($cgi->param('del_host')) {
      $conf_save{'protocol'} = $service;
      foreach my $key (keys %{$ddns_settings{$service}}) {
        next unless(defined($cgi->param('ddns_'.$key)));
        my $val = $cgi->param('ddns_'.$key);
           $val =~ s/^\s+//;
           $val =~ s/\s+$//;
        if(($key eq 'wildcard') or ($key eq 'backupmx')) {
          $conf_save{$key} = ($val eq 'yes') ? 'yes' : 'no';
        } elsif($key eq 'system') {
          foreach my $v (@{$ddns_settings{$service}->{$key}}) {
            $conf_save{$v} = ($val eq $v and $v ne 'dyndns') ? 'yes' : '';
          }
        } else {
          $conf_save{$key} = $val;
        }
      }

      # (re-)add using new hostname
      $conf_host->{$new_hosts} = \%conf_save;
    }

    my $data = $this->ddclient_write_conf($conf_data, $conf_host);
    $ret = $session->suad_save($data, $conf_file);
    unless($ret and $ret->code() eq "OK" ) {
      $this->display_error($message->{'ddns_cfg_not_writable'}." ".$conf_file,
                           "$confParam->{cgi_path}/dyndns.pl?".
                           "sessionID=$sessionID\&tab=$tab\&stab=$stab");
      exit(1);
    }
    $ret = $session->save_clear2session($conf_file);
    unless($ret and $ret->code() eq "OK" ) {
      $this->display_error($ret->code(),
                           "$confParam->{cgi_path}/dyndns.pl?".
                           "sessionID=$sessionID\&tab=$tab\&stab=$stab");
      exit(1);
    }

    my %ppp_scripts = (
       'script-link'=> '../scripts/dyndns',
       'script-path'=> '/etc/ppp/scripts/dyndns',
       'dyndns-up'   => '/etc/ppp/ip-up.d/dyndns-up',
    );

    my $msg = $message->{'saved_ok'};

    if(0 < scalar(keys %{$conf_host})) {

      ### make sure, link exists

      $ret = $session->suad_read($ppp_scripts{'script-path'});
      if($ret and $ret->code() eq 'OK') {
	$ret = $session->suad_symlink($ppp_scripts{'script-link'},
                                      $ppp_scripts{'dyndns-up'});
        unless($ret and $ret->code() eq "OK" ) {
          $this->display_error($msg."<br>".$message->{'warn_symlink'}.
                               ": ".$ppp_scripts{'dyndns-up'},
                               "$confParam->{cgi_path}/dyndns.pl?".
                               "sessionID=$sessionID\&tab=$tab\&stab=$stab");
           exit(1);
        }
        $msg .= " ".$message->{'ddns_up_reconnect'};
      }

    } else {

      ### empty config - remove link

      $ret = $session->suad_read($ppp_scripts{'dyndns-up'});
      if($ret and $ret->code() eq 'OK') {
        $ret = $session->suad_unlink($ppp_scripts{'dyndns-up'});
        unless($ret and $ret->code() eq "OK" ) {
          $this->display_error($msg."<br>".$message->{'warn_unlink'}.
                               ": ".$ppp_scripts{'dyndns-up'},
                               "$confParam->{cgi_path}/dyndns.pl?".
                               "sessionID=$sessionID\&tab=$tab\&stab=$stab");
          exit(1);
        }
        $msg .= " ".$message->{'ddns_up_disabled'};
      }

    }

    ### OK, done.
    $this->display_msg($msg,
                       "$confParam->{cgi_path}/dyndns.pl?".
                       "sessionID=$sessionID\&tab=$tab\&stab=$stab");
}

###
### ddclient utilities
###
my $ddclient_marker = '### ddns web-frontend';
my $ddclient_global = <<EOF_DDCLIENT_GLOBALS;
######################################################################
## 
## Define default global variables with lines like:
##      var=value [, var=value]*
## These values will be used for each following host unless overridden
## with a local variable definition.
##
## Define local variables for one or more hosts with:
##      var=value [, var=value]* host.and.domain[,host2.and.domain...]
##
## Lines can be continued on the following line by ending the line
## with a \
##
######################################################################
daemon=300				# check every 300 seconds
syslog=yes				# log update msgs to syslog
#mail=root				# mail all msgs to root
mail-failure=root			# mail failed update msgs to root
pid=/var/run/ddclient.pid		# record PID in file.

EOF_DDCLIENT_GLOBALS

sub ddclient_parse_vars {
  my $this = shift;
  my $data = shift;
  my %vars = ();

  while($data =~ s/^\s*([a-z][a-z_-]*)=//i) {
    my $key = $1;
    my $val = '';
    if($data =~ /^([\"|\'])/) {
      my $sep = $1;
      $data =~ s/^$sep//;
      while($data =~ s/^([^$sep]+$sep)//) {
        $val .= $1;
        last if($val !~ /\\$sep$/);
      }
      $val  =~ s/\\$sep/$sep/g;
      $val  =~ s/$sep$//;
      $data =~ s/^\s*,\s*//;
    } else {
      $data =~ s/^(\S+)\s*//;
      $val  = $1;
      $val =~ s/\s*,\s*$//;
    }
    #print STDERR "VARS += KEY='$key', VAL='$val'\n";
    $vars{$key} = $val;
  }
  #print STDERR "HOST := '$data'\n";
  return ($data, %vars);
}

sub ddclient_parse_conf
{
  my $this = shift;
  my $data = shift;
  my $conf = {};
  my $prev = '';
  my $skip = 1;

  for (@{$data}) {
    if(/^$ddclient_marker/) {
      $skip = (0 == $skip) ? 1 : 0;
      next;
    }
    next if($skip);

    s/#.*//;
    $_ = "$prev$_";
    if(/\\$/) {
      chop;
      $prev = $_;
      next;
    } $prev = '';
    s/^\s+//;
    s/\s+$//;
    s/\s+/ /g;
    next if /^$/;

    my %vars;
    ($_, %vars) = $this->ddclient_parse_vars($_);
    s/\s*,\s*/,/g;
    if($_ =~ /^\S+$/) {
      $conf->{$_} = \%vars;
    }
  }
  return $conf;
}

sub ddclient_write_conf
{
  my $this = shift;
  my $last = shift || [split("\n", $ddclient_global)];
  my $conf = shift || {};
  my @data = ();
  my $skip = 0;

  for (@{$last}) {
    if(/^$ddclient_marker/) {
      $skip = (0 == $skip) ? 1 : 0;
      next;
    }
    next if($skip);
    push(@data, $_);
  }
  push(@data, $ddclient_marker . ' - begin');
  push(@data, '# '. localtime(), '#');
  push(@data, '# note: manual changes may get lost!','');
  push(@data, $this->ddclient_conf_dump($conf));
  push(@data, $ddclient_marker . ' - finish');
  return \@data;
}

sub ddclient_conf_dump
{
  my $this = shift;
  my $conf = shift;
  my @data;

  foreach my $host (keys %{$conf}) {
    next unless($host =~ /\S+/);
    my @list = ();
    foreach my $key ('protocol', 'dyndns', 'custom', 'static',
                     'server', 'login', 'password', 'wildcard',
                     'backupmx', 'mx') {
      next unless(exists($conf->{$host}->{$key}) and
                  $conf->{$host}->{$key} =~ /\S+/);
      my $val = $conf->{$host}->{$key};
      if($val =~ /\s+/) {
         $val =~ s/\"/\\\"/g;
         $val = '"'.$val.'"';
      }
      push(@list, "$key=$val");
      delete($conf->{$host}->{$key});
    }
    foreach my $key (sort keys %{$conf->{$host}}) {
      my $val = $conf->{$host}->{$key} || '';
      next unless($val =~ /\S+/);
      if($val =~ /\s+/) {
         $val =~ s/\"/\\\"/g;
         $val = '"'.$val.'"';
      }
      push(@list, "$key=$val");
    }
    if(scalar(@list)) {
      push(@data, join(", \\\n", @list)." \\", "$host", "");
    }
  }
  return @data;
}

1; # End of Package.
