#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_acl.pm,v 1.20 2004/09/16 21:39:12 varkoly Exp $
#

package edit_acl;
use Encode;
#use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use LDAPUtils;
use Display;
use File::Basename;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


use constant ROOTPATH_ADMIN => "/home";
use constant ROOTPATH_USER  => "/home";

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $nob  = $cgi->param('nob') || '';
    my $path = $cgi->param('path');
    my $file = $cgi->param("file");
    my $change = $cgi->param('change');
    my $rights = $cgi->param("rights");
    my $download= $cgi->param("download");
    my $upload = $cgi->param("upload");
    my $tab    = $cgi->param('tab');
    my $stab   = $cgi->param('stab');
    #my $rootpath  = $cgi->param('rootpath');

    if(defined $change && $change ne "") {
	if ( $file eq '..' ){
		my @lpath = split /\//, $path; 
		my $depth = (scalar(@lpath)-1);
		$path = '/';
		my $i;
		for($i=1;  $i < $depth; $i++) {
			$path .= $lpath[$i].'/';
		}
		# remove not needed last '/'
		if ( length $path > 1 ) {
			chop $path;
		}
		$this->startup($path);
	} elsif( ! ($file =~ /.*\//) ) {
		$this->startup($path);
	} else {
		$path = $path.'/'.$file;
		$path =~ s|//|/|;
		# remove not needed last '/'
		chop $path;
		$this->startup($path);
	}	
    } elsif(defined $upload && $upload ne "") {
		$this->upload();
    } elsif(defined $download && $download ne "") {
	if ( $file eq '..'  || $file =~ /.*\//){
		$this->display_error("Invalid file name",
                          "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&path=$path",2);
		exit();
	}
		$this->download();
    } elsif(defined $rights && $rights ne "") {
	if ( $file eq '..' ){
		$this->display_error("Invalid file name",
                          "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&path=$path",2);
		exit();
	}
		$this->acl_rights();
    } else {
		$this->startup();
    }
}

sub startup {
    my $this = shift;
    my $path = shift || '';

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    
    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_ACL"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');

    my $url  = "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";
    my $ch_lang = lc("$confParam->{LANG}");
    if("$ch_lang" != "de" || "$ch_lang" != "en" || "$ch_lang" != "es" || "$ch_lang" != "it" ||
       "$ch_lang" != "cz" || "$ch_lang" != "hu" || "$ch_lang" != "ch" || "$ch_lang" != "ro" ) {
      $ch_lang = "en";
    }
    my %fs_charset = ( 
                      'de' => 'iso-8859-15',
                      'en' => 'iso-8859-15',
                      'es' => 'iso-8859-15',
                      'it' => 'iso-8859-15',
                      'cz' => 'iso-8859-2',
                      'hu' => 'iso-8859-2',
                      'ro' => 'iso-8859-2',
                      'ch' => 'iso-8859-1'
                     );

    if ( ! defined $path || $path eq '' ) {
	if( defined $q->param('path') && $q->param('path') ne '' ){
	    $path = $q->param('path');
	} else {
	    if( $ADMINuid eq 'cyrus' ) {
		$path = '/home';
		#$q->param('rootpath',$path);
	    } else {
              # searching homeDirectory
              my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
              if(!defined $ldap) {
                  $this->display_error("can't contact LDAP Server",
                                       "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
                  exit;
              }

              my $mesg = $ldap->bind ("uid=".$confParam->{uid}.", ".$confParam->{baseDN}, password=>$confParam->{passwd});
              if($mesg->code != 0) {
                  my $errs = "bind $message->{failed}\n\n";
                  $errs .= &LDAPerror($mesg); $this->display_error($errs, "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
                  exit;
              }
              $mesg  = $ldap->search( base  => "uid=".$ADMINuid.",".$ldapbase,
                                       scope => 'base',
                                       filter=> "uid=".$ADMINuid,
                                       attrs=> ['homedirectory']
                                 ); 
              if($mesg->code == 0 && $mesg->count > 0) {                        
                  $path = $mesg->entry(0)->get_value('homedirectory');
              } else {
                   $path = '/home';
              }
	    }
	}	
    }
    my $rootpath  = ( $ADMINuid eq 'cyrus' ? ROOTPATH_ADMIN : ROOTPATH_USER );

    my @fn = ();
    my $text = "";
    my $button_width = 50;


    if( length($path) < length($rootpath) ||
	substr($path,0,length($rootpath)) ne $rootpath ) {
	$path  = ( $ADMINuid eq 'cyrus' ? ROOTPATH_ADMIN : ROOTPATH_USER );
    }

    if( $path ne $rootpath ) {
	push @fn, '..';
    }

    my $tmpPath = $path;
    Encode::from_to($tmpPath, "utf-8", "$fs_charset{$ch_lang}");
    my $ret = $session->suad_listdir($tmpPath); 
    
    if( $ret->code() =~ /ERROR:\s(.*)/ms ) {
	my $err = $1;
	$path =~ s/^(.*\/).*/$1/;
        $this->display_error("$err","$url\&path=$path");
        exit;
    }
    $ret->code() =~ /OK:\s(.*)/ms;
    foreach my $i (sort (split /\n/, $1)) { 
	if($i ne '' && $i ne "\n" && $i !~ /^\./ && $i !~ /^aquota/ ) {
          Encode::from_to($i, "$fs_charset{$ch_lang}" , "utf-8");
	    push @fn, $i; 
	}
    }	
    my $tmpPath = $path;
    Encode::from_to($tmpPath, "utf-8", "$fs_charset{$ch_lang}");
    $ret = $session->suad_listfile($tmpPath); 
    $ret->code() =~ /OK:\s(.*)/ms;
    foreach my $i (sort (split /\n/, $1)) { 
	if($i ne '' && $i ne "\n" && $i !~ /^\./ && $i !~ /^aquota/ ) {
          Encode::from_to($i, "$fs_charset{$ch_lang}", "utf-8");
          push @fn, $i; 
	}
    }	
    
    my $html = "";
    $q->param(-name=>'path', -value=>"$path");

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});

    $html .=                 $q->Tr(
				    $this->help_th(2, $message->{edit_acl},"EDIT_ACL")
				    );
    $html .=                 $q->Tr(
				    $q->td({-colspan => 2, -class=>'AdminSubHeader'},
					   $message->{select_file})
				    );

    $html .=					 $q->Tr($q->td({-align=>"center",-width=>"50%"},$message->{path}.': '.$path));
    $html .=                     $q->start_Tr();
    $html .=			 $q->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl"),
    $html .=                     $q->td({-align=>"center",-width=>"50%"},
								 $q->scrolling_list(-name=>"file",
							   -value=>[@fn],
							   -size=>15,
							   -width=>30,
							   #-default=>$fn[0]
							   )
					);

    $html .=                     $q->start_td();
    $html .=                     $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    
    $html .=                     $q->Tr(
					[
						 $q->td({-align=>"center"},
							$q->submit(-class=>"BlockButton",-name=>"change",
								   -value=>"$message->{change}",
								   -width=>$button_width)
							),
						 $q->td({-align=>"center"},
							$q->submit(-class=>"BlockButton",-name=>"rights",
								   -value=>"$message->{set_rights}",
								   -width=>$button_width).
							$q->hidden(-name=>"sessionID", -value=>"$sessionID").
							$q->hidden(-name=>"path", -value=>"$path").
							#$q->hidden(-name=>"rootpath", -value=>"$rootpath").
							$q->hidden(-name=>"tab", -value=>"$tab").
							$q->hidden(-name=>"stab", -value=>"$stab")
							),
						 $q->td({-align=>"center"},
							$q->submit(-class=>"BlockButton",-name=>"download",
								   -value=>"$message->{download}",
								   -width=>$button_width)
							),
						 $q->td({-align=>"center"},'<hr>'),
    				         $q->end_form(),
					 ]
					);
    if ($confParam->{uid} eq "cyrus" || $confParam->{admin} eq "1" ) {
         $html .=                $q->Tr(
					[
    					 $q->start_multipart_form(-action=>$confParam->{cgi_path}."/edit_acl.pl"),
						 $q->td({-align=>"center"},
							$q->filefield(-name=>'save_file',-size=>$button_width/2).'<br>',
							$q->submit(-class=>"BlockButton",-name=>"upload",
								   -value=>"$message->{upload}",
								   -width=>$button_width).
							$q->hidden(-name=>"sessionID", -value=>"$sessionID").
							$q->hidden(-name=>"path", -value=>"$path").
							#$q->hidden(-name=>"rootpath", -value=>"$rootpath").
							$q->hidden(-name=>"tab", -value=>"$tab").
							$q->hidden(-name=>"stab", -value=>"$stab")
							),
    				         $q->end_form()
					 ]
					);
    }
    $html .=                     $q->end_table();
    $html .=                     $q->end_td();
    $html .=                     $q->end_Tr();


    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();
    $html .= $q->end_table();


    $this->SUPER::display($html);
}

sub download {
    my $this = shift;
    my $cgi = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_ACL"))->data();
    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $Action    = $cgi->param('Action') || '';
    my $doit      = $cgi->param('doit') || '';
    my $path      = $cgi->param('path');
    my $file      = $cgi->param("file");
    my $Folder    = $path.'/'.$file;
       $Folder =~ s|//|/|;


    my $ret = $session->suad_read("$Folder");
    if($ret->code() =~ /^OK/) {
          print "Content-type: application/octet-stream\n";
          print "Content-length:".length($ret->data())."\n";
          print "Content-Disposition: attachment; filename=\"$file\"\n\n";
          print $ret->data();
          print $cgi->header(-type=>"text/html");
    }
    exit;
       
}
sub upload {
    my $this = shift;
    my $cgi = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $ADMINuid  = $confParam->{uid};

    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_ACL"))->data();
    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $Action    = $cgi->param('Action') || '';
    my $doit      = $cgi->param('doit') || '';
    my $path      = $cgi->param('path');
    my $file      = $cgi->param("save_file");
    my $url  = "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&path=$path";

    #-- reading the file
    my $buffer = ""; my $bytesread=0;
    fileparse_set_fstype('MSWin32');
    my $file_name = basename($file);
    #-- may he do it
    if ( $ADMINuid ne "cyrus" ) { 
	my $ret = $session->suad_stdout_exec("su $ADMINuid -c \'touch $path/$file_name\ && rm $path/$file_name\'");
	if($ret->code() !~ /OK: 0/) {
		$this->display_error("You have no permission to write into $path","$url");
        	exit;		
	}
    }
    open (OUTFILE,">/tmp/$file_name.$ADMINuid");
    while ( $bytesread=read($file,$buffer,1024)) {
        print OUTFILE $buffer;
    }
    close OUTFILE;
    my $MESSAGE = ''; 
    my $ret = $session->suad_copy("/tmp/$file_name.$ADMINuid","$path/$file_name");
    if(  $ret->code() ne "OK" ) {
         $MESSAGE .= "<b>Failed to save file $path/$file_name</b><br>";
    } else {
	 $MESSAGE .= $message->{saved_ok};
    }
    if ( $ADMINuid ne "cyrus" ) { 
    	$ret = $session->suad_chown("$path/$file_name",$ADMINuid,$confParam->{gidnumber});
    }
    system("rm /tmp/$file_name.$ADMINuid");
    $this->display_msg($MESSAGE, $url, 2);
    exit;
       
}

sub acl_rights {
    my $this = shift;
    my $cgi = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_ACL"))->data();

    my $ch_lang = lc("$confParam->{LANG}");
    if("$ch_lang" != "de" || "$ch_lang" != "en" || "$ch_lang" != "es" || "$ch_lang" != "it" ||
       "$ch_lang" != "cz" || "$ch_lang" != "hu" || "$ch_lang" != "ch" || "$ch_lang" != "ro" ) {
      $ch_lang = "en";
    }
    my %fs_charset = ( 
                      'de' => 'iso-8859-15',
                      'en' => 'iso-8859-15',
                      'es' => 'iso-8859-15',
                      'it' => 'iso-8859-15',
                      'cz' => 'iso-8859-2',
                      'hu' => 'iso-8859-2',
                      'ro' => 'iso-8859-2',
		      'ch' => 'iso-8859-1' 
                     );

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $Action    = $cgi->param('Action') || '';
    my $doit      = $cgi->param('doit') || '';
    my $path      = $cgi->param('path');
    my $file      = $cgi->param("file");
    my $Folder    = $path.'/'.$file;
       $Folder =~ s|//|/|;
    my $IsDirectory = '';
    if( $file =~ /.*\// ) {
	$IsDirectory = '_d';
    }
    my $User      = $cgi->param('User') || '';
    my $Group     = $cgi->param('Group') || '';
    my $Filter    = $cgi->param('Filter') || '*';
    my $recursive = $cgi->param("Recursive") || ''; 
    my $Permissions = join('', $cgi->param('Permission')) || '0'; 
    $cgi->delete('Permission');
    my %labels=("0"=>"-- ".$message->{set_filter_first}." --");
    my @user=("0");

    my $LOGINuid      = $confParam->{uid};
    my $LOGINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server",
                             "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    $ldap->bind ("uid=".$confParam->{uid}.", ".$confParam->{baseDN},
                 password=>$confParam->{passwd});

    # User wants to CHANGE an existing permissions
    if($Action eq $message->{'set'} && $Folder ne '' && $User ne '' && $doit eq 'set_old') {
	my $option = '-m';
	if ($recursive eq 'R') {
		$option = '-Rm';
	}
        my $tmpFolder = $Folder;
        Encode::from_to($tmpFolder, "utf-8", "$fs_charset{$ch_lang}");
        my $ret = $session->suad_setfacl($tmpFolder, "$User:$Permissions", $option);
        if($ret->code() eq "OK") {
            $Folder = $cgi->escape("$Folder");
            $path = $cgi->escape("$path");
            $file = $cgi->escape("$file");
            my $hintRecursive = ($recursive eq 'R') ? " - $message->{'recursive'} - " : "";
            my $uri = "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&rights=righst\&path=$path\&file=$file";
            $this->display_msg($message->{'set_access_for'}.
                               " <i>$User</i> ".$message->{'set_access_to'}.
                               " <i>$Permissions</i> ".$hintRecursive,
                               $uri, 3);
            $ldap->unbind;
            exit;
        } else {
            $this->display_error("SETFACL $message->{failed}! Folder:$Folder User:$User Permissions:$Permissions\n$ret->code()",
                                 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
            $ldap->unbind;
            exit;
        }
    } elsif($Action eq $message->{'set'} && $Folder ne '' && $User ne '' && $User ne "-- ".$message->{set_filter_first}." --") {
    	# User wants to SET permissions for an USER
	my $option = '-m';
	if ($recursive eq 'R') {
		$option = '-Rm';
	}
        my $tmpFolder = $Folder;
        Encode::from_to($tmpFolder, "utf-8", "$fs_charset{$ch_lang}");
        my $ret = $session->suad_setfacl($tmpFolder, "user:$User:$Permissions", $option);
        if($ret->code() eq "OK") {
            $Folder = $cgi->escape("$Folder");
            $path = $cgi->escape("$path");
            $file = $cgi->escape("$file");
            my $hintRecursive = ($recursive eq 'R') ? " - $message->{'recursive'} - " : "";
            my $uri = "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&rights=righst\&path=$path\&file=$file";
            $this->display_msg($message->{'set_access_for'}." <i>$User</i> ".
                               $message->{'set_access_to'}.
                               " <i>$Permissions</i> ".$hintRecursive, 
                               $uri, 3);
            $ldap->unbind;
            exit;
        } else {
            $this->display_error("SETFACL $message->{failed}! File:$Folder User:$User Permissions:$Permissions\n$ret->code()",
                                 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
            $ldap->unbind;
            exit;
        }
    } elsif($Action eq $message->{'set'} && $Folder ne '' && $Group ne '') {
        # User wants to SET permissions for a GROUP
	my $option = '-m';
	if ($recursive eq 'R') {
		$option = '-Rm';
	}
        my $tmpFolder = $Folder;
        Encode::from_to($tmpFolder, "utf-8", "$fs_charset{$ch_lang}");
        my $ret = $session->suad_setfacl($tmpFolder, "group:$Group:$Permissions", $option);
        if($ret->code()  eq "OK") {
            $path = $cgi->escape("$path");
            $file = $cgi->escape("$file");
            my $hintRecursive = ($recursive eq 'R') ? " - $message->{'recursive'} - " : "";
            my $uri = "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&rights=righst\&path=$path\&file=$file";
            $this->display_msg($message->{'set_access_for_group'}." <i>$Group</i> ".
                               $message->{'set_access_to'}.
                               " <i>$Permissions</i>".$hintRecursive,
                               $uri , 3);
            $ldap->unbind;
            exit;
        } else {
            $this->display_error(
                          "SETFACL $message->{failed}! File:$Folder $Group Permissions:$Permissions\n$ret->code()",
                          "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
            $ldap->unbind;
            exit;
        }
    } elsif($Action eq $message->{'b_delete'} && $Folder ne '' && $User ne '') {
        # User wants to DELETE permissions for an user or a group
	my $option = '-x';
	if ($recursive eq 'R') {
		$option = '-Rx';
	}
        my $tmpFolder = $Folder;
        Encode::from_to($tmpFolder, "utf-8", "$fs_charset{$ch_lang}");
        my $ret = $session->suad_setfacl($tmpFolder, $User, $option);
        if($ret->code()  eq "OK") {
            $path = $cgi->escape("$path");
            $file = $cgi->escape("$file");
            my $hintRecursive = ($recursive eq 'R') ? " - $message->{'recursive'} - " : "";
            my $uri = "$confParam->{cgi_path}/edit_acl.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&rights=righst\&path=$path\&file=$file";
            $this->display_msg($message->{'delete_access_for'}." $User$Group".$hintRecursive, $uri , 3);
            $ldap->unbind;
            exit;
        } else {
            $this->display_error(
                          "DELETEACL $message->{failed}! File:$Folder $User Permissions:$Permissions\n$ret->code()",
                          "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
            $ldap->unbind;
            exit;
        }
    } 

    ########################################################################################
    #       Generating of the HTML-Code
    ########################################################################################

    # get the user-list
    my $exist;
    my $entry;
    my $uid;
    my $cn;
    my $i;


    $exist=$ldap->search(base=>"$confParam->{baseDN}",
                         scope  => "one",
                         attrs => ['uid', 'cn'],
                         filter=>"(&(uid=*)(objectclass=SuSEeMailObject)(objectclass=posixAccount)(!(gidnumber=103)))"
    	);

    if ($exist->count!=0) {
        @user=();
        %labels= ();

        for ($i=0; $i<$exist->count; $i++) {
            $entry=$exist->entry($i);
            $uid=$entry->get_value("uid");
            $cn=$entry->get_value("cn");
	    if($uid ne 'cyrus' &&  $uid ne 'mailadmin') {
            	push @user,$uid;
		$labels{$uid} = "$uid ($cn)";
	    }
        }
        @user = sort @user;
        # --- add anyone to set rights to everybody :-)
    }
    
    # get the group-list
    my $result = $ldap->search(base => $confParam->{baseDN},
                               scope  => "one",
                               attrs => ['cn'],
                               filter => "(&(cn=*)(objectclass=posixGroup))");
    my @cn = ();

    if($result->code == 0) {
        foreach my $entry ($result->all_entries) {
            push @cn, $entry->get_value("cn");
        }
        @cn = sort @cn;
    } else {
        my $err = "$message->{err_grouplist}!\n".&LDAPerror($result);
        $this->display_error("$err",
                      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
        $ldap->unbind;
        exit;
    }

    $ldap->unbind;

    my $tmpFolder = $Folder;
    Encode::from_to($tmpFolder, "utf-8", "$fs_charset{$ch_lang}");
    my $ret = $session->suad_getfacl($tmpFolder);
    $ret->code() =~ /(^.*?):\s(.*)/ms;
    if( $1 ne 'OK' ) {
        $this->display_error("$message->{fetch_acl} $Folder $message->{failed}: Serverresponse:$2",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			     3);
        exit;
    } else {
        my $html = "";
        $cgi->delete('User');
        $cgi->delete('Action');
    	# fetch all the permissions already given
	$this->{"acl"} = ();
	$this->{"effective"} = ();
	foreach my $i (split /\n/, $2) {
		$i =~ s/\s//g;
		if ( $i =~ /^#(\w+):(.*)/ ) {
			$this->{"head:$1"} = $2;
		  } elsif ( $i =~ /(\w+)::(.*)/ )  {
			$this->{"head_r:$1"} = $2;
		  } elsif( $i =~ /(.*):(.*):(.*)#effective:(.*)/ ) {
			  $this->{"acl"}->{"$1:$2"} = $3;
			  $this->{"effective"}->{"$1:$2"} = $4;
		  } elsif( $i =~ /(.*):(.*):(.*)/ ) {
			  $this->{"acl"}->{"$1:$2"} = $3;
			  $this->{"effective"}->{"$1:$2"} = $3;
		  }
	}


        $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
        $html .= $cgi->start_Tr();
        $html .= $cgi->start_td();
        ####### existing permissions section #######
        $html .= $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
        $html .= $cgi->Tr(
                          [
                           $this->help_th(1, $message->{'existing'},
                                          "PERMISSION_EXIST"),
                           $cgi->td({-class=>'AdminSubHeader'},
                                    $message->{'title'.$IsDirectory}.": $Folder")
                           ]
                          );
        $html .= $cgi->Tr(
                          $cgi->td({-align=>"center"},
                                   $this->ExistingPermissionsList())
                          );
        $html .= $cgi->end_table();
        $html .= $cgi->end_td();
        $html .= $cgi->end_Tr();
        $html .= $cgi->end_table();

        $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
        ########## add permissions section ##########
        $html .= $cgi->start_Tr();
        $html .= $cgi->start_td();
        $html .= $cgi->start_table({-cellspacing=>0, -width => "100%", -cellpadding=>3});
        $html .= $cgi->Tr(
                          [
                           $this->help_th(3, $message->{'add_permissions'},
                                          "PERMISSION_ADD"),
                           $cgi->td({-class=>'AdminSubHeader', -colspan=>3
                                     }, $message->{'title'.$IsDirectory}.": $Folder")
                           ]
                          );
	my $rowspan = 3;
	if( $IsDirectory eq '_d' ) {
		$rowspan = 4;
	} 

        ########## permission for users ##################
        $html .= $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl");
        $html .= $cgi->Tr(
                          $cgi->td({-align=>"center"}, $message->{'user'})
			);
        $html .= $cgi->Tr(
                           $cgi->td({-align=>"center", -rowspan=>$rowspan},
                                   $cgi->scrolling_list(-name=>"User",
                                                        -value=>\@user,
                                                        -default=>$user[2],
                                                        -size=>5,
                                                        -labels=>\%labels,
                                                        -width=>200)
				),
			   $cgi->td({-width=>'20%'},
						   $cgi->checkbox(-name=>'Permission',
								  -value=>'r',
								  -label=>$message->{'read'})),
			   $cgi->td(
						   $message->{'desc_read_b'.$IsDirectory})
		         );
			$html .= $cgi->Tr(
					  $cgi->td({-width=>'20%'},
						   $cgi->checkbox(-name=>'Permission',
								  -value=>'w',
								  -label=>$message->{'write'})),
					  $cgi->td($message->{'desc_write_b'.$IsDirectory})
					  );
			$html .= $cgi->Tr(
						  $cgi->td({-width=>'20%'},
							   $cgi->checkbox(-name=>'Permission',
									  -value=>'x',
									  -label=>$message->{'execute'})),
						  $cgi->td($message->{'desc_execute_b'.$IsDirectory})
						  );
			if($IsDirectory eq '_d' ) {
				$html .= $cgi->Tr(
						  $cgi->td({-width=>'20%'},
							   $cgi->checkbox(-name=>'Recursive',
									  -value=>'R',
									  -label=>$message->{'recursive'})),
						  $cgi->td($message->{'desc_recursive'})
						  
						  );
			}
			$html .= $cgi->Tr(
					  $cgi->td({-align=>"center", -colspan => 3},
						   $cgi->submit(-class=>"button",-name=>'Action',
								-value=>$message->{'set'}).
						   $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
						   $cgi->hidden(-name=>'path', -default=>$path).
						   $cgi->hidden(-name=>'file', -default=>$file).
						   $cgi->hidden(-name=>'Filter', -default=>$Filter).
						   $cgi->hidden(-name=>"tab", -value=>$tab).
						   $cgi->hidden(-name=>'rights', -value=>'rights').
						   $cgi->hidden(-name=>'doit', -value=>'set_new').
						   $cgi->hidden(-name=>"stab", -value=>$stab).
						   $cgi->end_form()
						   )
					  );
        ########## permission for groups ##################
        $html .= $cgi->Tr(
                          $cgi->td({-align=>"center",-colspan=>3}, $cgi->hr)
			);
        $html .= $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl");
        $html .= $cgi->Tr(
                          $cgi->td({-align=>"center"}, $message->{'group'})
			);
        $html .= $cgi->Tr(
                          $cgi->td({-align=>"center", -rowspan=>$rowspan},
                                   $cgi->scrolling_list(-name=>"Group",
                                                        -value=>\@cn,
                                                        -size=>5,
                                                        -width=>200)
				),
		           $cgi->td({-width=>'20%'},
				   $cgi->checkbox(-name=>'Permission',
							  -value=>'r',
							  -label=>$message->{'read'})),
			   $cgi->td(
					   $message->{'desc_read_g'.$IsDirectory})
			  );
			$html .= $cgi->Tr(
					  $cgi->td({-width=>'20%'},
						   $cgi->checkbox(-name=>'Permission',
								  -value=>'w',
								  -label=>$message->{'write'})),
					  $cgi->td($message->{'desc_write_g'.$IsDirectory})
					  );
			$html .= $cgi->Tr(
						  $cgi->td({-width=>'20%'},
							   $cgi->checkbox(-name=>'Permission',
									  -value=>'x',
									  -label=>$message->{'execute'})),
						  $cgi->td($message->{'desc_execute_g'.$IsDirectory})
						  );
			if($IsDirectory eq '_d' ) {
				$html .= $cgi->Tr(
						  $cgi->td({-width=>'20%'},
							   $cgi->checkbox(-name=>'Recursive',
									  -value=>'R',
									  -label=>$message->{'recursive'})),
						  $cgi->td($message->{'desc_recursive'})
						  
						  );
			}
			$html .= $cgi->Tr(
					  $cgi->td({-align=>"center", -colspan => 3},
						   $cgi->submit(-class=>"button",-name=>'Action',
								-value=>$message->{'set'}).
						   $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
						   $cgi->hidden(-name=>'path', -default=>$path).
						   $cgi->hidden(-name=>'file', -default=>$file).
						   $cgi->hidden(-name=>'Filter', -default=>$Filter).
						   $cgi->hidden(-name=>"tab", -value=>$tab).
						   $cgi->hidden(-name=>'rights', -value=>'rights').
						   $cgi->hidden(-name=>'doit', -value=>'set_new').
						   $cgi->hidden(-name=>"stab", -value=>$stab).
						   $cgi->end_form()
						   )
					  );

        $html .= $cgi->end_table();
        $html .= $cgi->end_td();
        $html .= $cgi->end_Tr();
        $html .= $cgi->end_table();

        $this->SUPER::display($html);
    }
}

sub ExistingPermissionsList {
    my $this = shift;
    my $cgi = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_ACL"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');
    my $path      = $cgi->param('path');
    my $file 	  = $cgi->param("file");
    my $IsDirectory = '';
    if( $file =~ /.*\// ) {
	$IsDirectory = '_d';
    }
    my $User      = $cgi->param('User') || '';
    my $Group     = $cgi->param('Group') || '';
    my @aclarray  = ();

    my $LOGINuid      = $confParam->{uid};

    my $pers;
    my $effective = '';
    my $HTMLList = $cgi->start_table({-cellspacing=>0, -cellpadding=>5, -width=>"100%"})."\n";
    $HTMLList .= $cgi->Tr($cgi->th({-align=>"center", -width=>'30%', -nowrap=>undef },  $message->{'user'}.'/'.$message->{'group'},),
    			  $cgi->th({-align=>"center", -width=>'30%', -nowrap=>undef },  $message->{'rights'}),
    			  $cgi->th({-align=>"center", -width=>'30%', -nowrap=>undef },  $message->{'actions'}),
    			  $cgi->th({-align=>"center", -width=>'10%', -nowrap=>undef },  $message->{'effective_rights'})
			  ).
		 $cgi->Tr($cgi->td({-align=>"center", -colspan=>4}, '<hr noshade size="2">'));

    # Creating the head
   
    @aclarray = mkarray( $this->{'head_r:user'} );
    $effective = '<b>'.join(" ", @aclarray).'</b>';
    $HTMLList .= $cgi->Tr($cgi->td({-align=>"left", -width=>'30%', -nowrap=>undef }, "$message->{'owner'} <b>$this->{'head:owner'}</b>"),
                                  $cgi->td({-align=>"left"},
                                           $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl")."\n".
                                           $cgi->checkbox_group(-name=>'Permission',
                                                                -values=>[ 'r','w','x'],
                                                                -labels=>{'r' => 'r ',
                                                                          'w' => 'w ',
                                                                          'x' => 'x '},
                                                                -defaults=>\@aclarray).
                                           $cgi->hidden(-name=>'User', -default=>'user:').
                                           $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
                                           $cgi->hidden(-name=>'path', -default=>$path).
                                           $cgi->hidden(-name=>'file', -default=>$file).
                                   	   $cgi->hidden(-name=>'rights', -value=>'rights').
                                   	   $cgi->hidden(-name=>'doit', -value=>'set_old').
                                           $cgi->hidden(-name=>"tab", -value=>$tab).
                                           $cgi->hidden(-name=>"stab", -value=>$stab)
                                          ),
				  $cgi->td({-align=>"left"},
                                           $cgi->submit(-class=>"button",-name=>'Action', -value=>$message->{'set'}).
                                           $cgi->end_form()
					 ),  
				   $cgi->td({-align=>"center"}, $effective)
				  	
                                  );
    @aclarray = mkarray( $this->{'head_r:group'} );
    $effective = '<b>'.join(" ", @aclarray).'</b>';
    $HTMLList .= $cgi->Tr($cgi->td({-align=>"left", -width=>'30%' ,-nowrap=>undef }, "$message->{'group'} <b>$this->{'head:group'}</b>"),
                                  $cgi->td({-align=>"left"},
                                           $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl")."\n".
                                           $cgi->checkbox_group(-name=>'Permission',
                                                                -values=>[ 'r','w','x'],
                                                                -labels=>{'r' => 'r ',
                                                                          'w' => 'w ',
                                                                          'x' => 'x '},
                                                                -defaults=>\@aclarray).
                                           $cgi->hidden(-name=>'User', -default=>'group:').
                                           $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
                                           $cgi->hidden(-name=>'path', -default=>$path).
                                           $cgi->hidden(-name=>'file', -default=>$file).
                                   	   $cgi->hidden(-name=>'rights', -value=>'rights').
                                   	   $cgi->hidden(-name=>'doit', -value=>'set_old').
                                           $cgi->hidden(-name=>"tab", -value=>$tab).
                                           $cgi->hidden(-name=>"stab", -value=>$stab)
                                          ),
				  $cgi->td({-align=>"left"},
                                           $cgi->submit(-class=>"button",-name=>'Action', -value=>$message->{'set'}).
                                           $cgi->end_form()
					 ),  
				   $cgi->td({-align=>"center"}, $effective)
				  );
    @aclarray = mkarray( $this->{'head_r:other'} );
    $effective = '<b>'.join(" ", @aclarray).'</b>';
    $HTMLList .= $cgi->Tr($cgi->td({-align=>"left", -width=>'30%' ,-nowrap=>undef }, "$message->{'other'}"),
                                  $cgi->td({-align=>"left"},
                                           $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl")."\n".
                                           $cgi->checkbox_group(-name=>'Permission',
                                                                -values=>[ 'r','w','x'],
                                                                -labels=>{'r' => 'r ',
                                                                          'w' => 'w ',
                                                                          'x' => 'x '},
                                                                -defaults=>\@aclarray).
                                           $cgi->hidden(-name=>'User', -default=>'other:').
                                           $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
                                           $cgi->hidden(-name=>'path', -default=>$path).
                                           $cgi->hidden(-name=>'file', -default=>$file).
                                   	   $cgi->hidden(-name=>'rights', -value=>'rights').
                                   	   $cgi->hidden(-name=>'doit', -value=>'set_old').
                                           $cgi->hidden(-name=>"tab", -value=>$tab).
                                           $cgi->hidden(-name=>"stab", -value=>$stab)
                                          ),
				  $cgi->td({-align=>"left"},
                                           $cgi->submit(-class=>"button",-name=>'Action', -value=>$message->{'set'}).
                                           $cgi->end_form()
					 ),  
				   $cgi->td({-align=>"center"}, $effective)
                                  );

    if( defined $this->{'head_r:mask'} && $this->{'head_r:mask'} ne '' ) {
    	@aclarray = mkarray( $this->{'head_r:mask'} );
	$HTMLList .= $cgi->Tr($cgi->td({-align=>"left", -width=>'30%' ,-nowrap=>undef }, "<font >$message->{'mask'}</font>"),
                                  $cgi->td({-align=>"left"},
                                           $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl")."\n".
                                           $cgi->checkbox_group(-name=>'Permission',
                                                                -values=>[ 'r','w','x'],
                                                                -labels=>{'r' => 'r ',
                                                                          'w' => 'w ',
                                                                          'x' => 'x '},
                                                                -defaults=>\@aclarray).
                                           $cgi->hidden(-name=>'User', -default=>'mask:').
                                           $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
                                           $cgi->hidden(-name=>'path', -default=>$path).
                                           $cgi->hidden(-name=>'file', -default=>$file).
                                           $cgi->hidden(-name=>"tab", -value=>$tab).
                                   	   $cgi->hidden(-name=>'doit', -value=>'set_old').
                                   	   $cgi->hidden(-name=>'rights', -value=>'rights').
                                           $cgi->hidden(-name=>"stab", -value=>$stab)
                                          ),
				    $cgi->td({-align=>"left"},
                                           $cgi->submit(-class=>"button",-name=>'Action', -value=>$message->{'set'}).
                                           $cgi->end_form()
					 )  
				    	
				);
    }
    my $acl = $this->{"acl"};
    foreach $pers (keys %$acl ) {
      	my $effective = '';
        unless($pers eq 'cyrus' && $LOGINuid ne 'cyrus') {
            @aclarray = mkarray( $this->{"acl"}->{$pers} );
	    my $isdir = '&nbsp';
	    if($IsDirectory eq '_d' ) {
		$isdir .=  $cgi->checkbox(-name=>'Recursive',
					  -value=>'R',
					  -label=>$message->{'recursive'});
	    }
	    if( defined $this->{'effective'}->{$pers} && $this->{'effective'}->{$pers} ne '' ) {
	      $effective = join ' ', (split //,$this->{'effective'}->{$pers});
	      $effective = '<b>'.$effective.'<b>';
	    }  
            $HTMLList .= $cgi->Tr($cgi->td({-align=>"left",
                                            -width=>'30%'}, "<font >$pers</font>"),
                                  $cgi->td({-align=>"left"},
                                           $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_acl.pl")."\n".
                                           $cgi->checkbox_group(-name=>'Permission',
                                                                -values=>[ 'r','w','x'],
                                                                -labels=>{'r' => 'r ',
                                                                          'w' => 'w ',
                                                                          'x' => 'x '},
                                                                -defaults=>\@aclarray).$isdir.
                                           $cgi->hidden(-name=>'User', -default=>$pers).
                                           $cgi->hidden(-name=>'sessionID', -default=>$sessionID).
                                           $cgi->hidden(-name=>'path', -default=>$path).
                                           $cgi->hidden(-name=>'file', -default=>$file).
                                   	   $cgi->hidden(-name=>'doit', -value=>'set_old').
                                   	   $cgi->hidden(-name=>'rights', -value=>'rights').
                                           $cgi->hidden(-name=>"tab", -value=>$tab).
                                           $cgi->hidden(-name=>"stab", -value=>$stab)
                                          ),
				    $cgi->td({-align=>"left"},
                                           $cgi->submit(-class=>"button",-name=>'Action', -value=>$message->{'set'}).' '.
                                           $cgi->submit(-class=>"button",-name=>'Action', -value=>$message->{'b_delete'}).
                                           $cgi->end_form()
					 ),  
				   $cgi->td({-align=>"center"}, $effective)
                                 );
        }
    }

    $HTMLList .= $cgi->end_table();

    return $HTMLList;
}

sub mkarray($) {
    my ($string) = @_;
    my @array;
    my $i;

    for($i = 0; $i < length($string); $i++) {
        push(@array, substr($string, $i, 1));
    }

    return @array;
}

;
