#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_cyrus_data.pm,v 1.4 2003/10/29 10:35:39 varkoly Exp $
#
package edit_cyrus_data;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use Net::IMAP;
use cfreader;
use LDAPUtils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $JavaScript=<<EOF;
    function open_help_win( win_location ) {
        parem='width=540,height=500,directories=no,menubar=no,toolbar=no,resizable=yes';   contacts_window=window.open(win_location, 'ImapHelpWin', parem);
        if (!contacts_window.opener) contacts_window.opener=self;
    }
    function close_help_win() {
        document.all['ImapHelpWin'].close();
    }
EOF


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit   = $cgi->param('doit');
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $tab        = $cgi->param('tab');
    my $stab       = $cgi->param('stab');

    if(defined $doit && $doit eq "edit") {
	if( defined $cgi->param("password") ) {
                print $cgi->header;
                print "<script language=javascript>\n";
                print "window.location.href=\"";
                print "/imap-bin/change_passwd_cyrus.pl?sessionID=$sessionID&tab=$tab&stab=$stab";
                print "\";</script>\n";
	  
	} else {
	  $this->update_user();
	}
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_CYRUS"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $uid        = $q->param('uid');
    my $sn         = $q->param('sn');
    my $givenname  = $q->param('givenname');
    my $o          = $q->param('o');
    my $c          = $q->param('c');
    my $maildomain = $q->param('maildomain');
    my $iserver    = $q->param('iserver');
    my $iport      = $q->param('iport');
    my $sport      = $q->param('sport');
    my $sserver    = $q->param('sserver');
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $filter     = $q->param('filter');
    
    if(!defined $uid || $uid eq "" || $uid eq "0") {
	$uid="cyrus";
    }
    
    my @group = ();
    my %g_label = ();
    my $check = "";
    my $errs = "";

# -- search for Groups
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;

    my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($mesg->code != 0) {
	$errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $c_dn = "uid=$uid,$ldapbase";

    $mesg = $ldap->search (  # perform a search
			     base   => "$c_dn",
			     scope => "base",
			     attrs => ['uid', 'sn', 'givenname', 'o',
				       'c', 'maildomain', 'imapserver', 
				       'imapport', 'sieveport', 'smtpserver'],
			     filter => "uid=cyrus"
			     );
    
    if($mesg->code == 0) {
	
	my %struct = %{$mesg->as_struct};

	$uid       = join "", @{$struct{$c_dn}{uid}};
	$sn        = join "", @{$struct{$c_dn}{sn}};
	if(defined @{$struct{$c_dn}{givenname}}) {
	    $givenname  = join "", @{$struct{$c_dn}{givenname}};
	}
	if(defined @{$struct{$c_dn}{o}}) { 
	    $o         = join "", @{$struct{$c_dn}{o}};
	}
	if(defined @{$struct{$c_dn}{c}}) {
	    $c         = join "", @{$struct{$c_dn}{c}};
	}
	if(defined @{$struct{$c_dn}{maildomain}}) {
	    $maildomain      = join "", @{$struct{$c_dn}{maildomain}};
	}
	if(defined @{$struct{$c_dn}{imapserver}}) {
	    $iserver      = join "", @{$struct{$c_dn}{imapserver}};
	}
	if(defined @{$struct{$c_dn}{smtpserver}}) {
	    $sserver      = join "", @{$struct{$c_dn}{smtpserver}};
	}
	if(defined @{$struct{$c_dn}{imapport}}) {
	    $iport      = join "", @{$struct{$c_dn}{imapport}};
	}
	if(defined @{$struct{$c_dn}{sieveport}}) {
	    $sport      = join "", @{$struct{$c_dn}{sieveport}};
	}

    } else {
	$errs = "search $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	$ldap->unbind;   # take down session
	exit;
    }

    $ldap->unbind;   # take down session

    my $html = $q->start_form(-action=>$confParam->{cgi_path}."/edit_cyrus_data.pl",
			      -name=>"form");
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $this->help_th(2, $message->{edit_cyrus}, "EDIT_CYRUS"),
					     $q->td({-colspan=>2, -class=>'AdminSubHeader'},
						    ["$message->{star_fields}"]),
					     $q->td({-width => "50%"},
						    ["$message->{uid} *",        $uid ]  ),
					     $q->td(
						    ["$message->{sn} *",
						     $q->textfield(-name=>'sn',
								   -size=>20,
								   -default=>$sn)]  ),
					     $q->td(
						    ["$message->{givenname}",
						     $q->textfield(-name=>'givenname',
								   -size=>20,
								   -default=>$givenname)]),
					     $q->td(
						    ["$message->{company} *",
						     $q->textfield(-name=>'o',
								   -size=>20,
								   -default=>$o)]),
					     $q->td(
						    ["$message->{country} *",
						     $q->textfield(-name=>"c",
								   -override=>0,
								   -size=>20,
								   -maxlength=>2,
								   -value=>$c).
						     $q->a({-href=>"javascript:void(0);",
							    -onclick=>"$JavaScript; open_help_win('$confParam->{cgi_path}/country_codes.pl?sessionID=$sessionID')"},
							   $q->img({-border=>0,
								    -src=>"$confParam->{image_path}/help1.gif",
								    -width=>18,
								    -height=>18,
								    -alt=>"Help"
								    })
							   )
						     ]),
					     $q->td(
						    ["$message->{sserver} *",
						     $q->textfield(-name=>'sserver',
								   -size=>20,
								   -default=>$sserver)]),
					     $q->td(
						    ["$message->{maildomain} *",
						     $q->textfield(-name=>'maildomain',
								   -size=>20,
								   -default=>$maildomain)]),
					     $q->td(
						    ["$message->{iserver} *",
						     $q->textfield(-name=>'iserver',
								   -size=>20,
								   -default=>$iserver)]),
					     $q->td(
						    ["$message->{iport} *",
						     $q->textfield(-name=>'iport',
								   -size=>20,
								   -default=>$iport)]),
					     $q->td(
						    ["$message->{sport} *",
						     $q->textfield(-name=>'sport',
								   -size=>20,
								   -default=>$sport)]),
					     $q->td({-colspan=>2, -align=>"center"},
						    [$q->submit(-class=>"button",-name=>"$message->{update}")]),
					     $q->td({-colspan=>2, -align=>"center"},
						    [$q->submit(-class=>"button",-name=>'password',-value=>$message->{set_password}).
						     $q->hidden(-name=>"tab", -value=>$tab).
						     $q->hidden(-name=>"stab", -value=>$stab).
						     $q->hidden(-name=>"uid", -value=>$uid).
						     $q->hidden(-name=>"doit", -value=>"edit").
						     $q->hidden(-name=>"sessionID", -value=>$sessionID).
						     $q->hidden(-name=>"filter", -value=>$filter).
						     $q->end_form()
						     ])
					     ]
					    )
				     )
			   )
		    );
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub update_user {
    my $this = shift;
    
    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_CYRUS"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $imaphost      = $confParam->{IMAPserver}; 
    my $imapport      = $confParam->{IMAPport};

    my $uid        = $q->param('uid');
    my $sn         = $q->param('sn');
    my $givenname  = $q->param('givenname');
    my $o          = $q->param('o');
    my $c          = $q->param('c');
    my $maildomain = $q->param('maildomain');
    my $iserver    = $q->param('iserver');
    my $sserver    = $q->param('sserver');
    my $iport      = $q->param('iport');
    my $sport      = $q->param('sport');
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $filter	   = $q->param('filter');

    my $errs = "";

    if(!defined $uid || $uid eq "" || $uid eq "0") {
	$uid="cyrus";
    }

    if($uid eq "" || $sn eq "" || $o eq "" || $c eq "" ||
       $maildomain eq "" || $iserver eq "" || $sserver eq "" || $iport eq "" || $sport eq "") {
	
	$this->display_error($message->{miss_some_values},
			     "$confParam->{cgi_path}/edit_cyrus_data.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			     3);
	exit;
    } else {

	# check some values

	if($iserver ne $imaphost) {
	    my $imap = "";
	    
	    if($imap = new Net::IMAP($iserver, Debug => 0)) {
		my $resp = $imap->login($ADMINuid, $ADMINpasswd);
		if($$resp{Status} ne "ok") {
		    $errs = "login $message->{failed}\n\n";
		    $errs .= "Serverresponse:$$resp{Status} => $$resp{Text}";
		    $this->display_error($errs,
					 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		    exit;
		}
		$imap->logout();
	    } else {
		$errs = "$message->{connect_to} $iserver $message->{failed}\n\n";
		$this->display_error($errs,
				     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		exit;

	    }
	}
	
	if( ! open(IN, "< /etc/postfix/main.cf") ) {
	    $this->display_error($message->{postfix_exp_not_readable}."/etc/postfix/main.cf: $?",
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $myhostname = "";
	my $mydestination = "";

	while(<IN>) {
	    if($_ =~ /^mydestination\s?=\s?(.*)$/) {
		$mydestination = $1;
	    }
	    if($_ =~ /^myhostname\s?=\s?(.*)$/) {
		$myhostname = $1;
	    }
	}
	chomp($mydestination);
	chomp($myhostname);
	close(IN);

#	print STDERR "$mydestination$myhostname\n";
	
	if($myhostname !~ /^[\w\d]*\.$maildomain$/)  {
#	    print STDERR "find maildomain NOT in myhostname\n";
	
	    if($mydestination !~ /$maildomain/)  {
#		print STDERR "find maildomain NOT in mydestination\n";
		$errs = "$maildomain: $message->{maildomain_not_found}\n\n";
		$this->display_error($errs,
				     "$confParam->{cgi_path}/edit_cyrus_data.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
		exit;
	    }
	}
	

	my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
	
	my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);
	if(!defined $ldap) {
	    $this->display_error("can't contact LDAP Server",
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $mesg = $ldap->bind (   # bind to a directory with dn and password
				dn       => "$bind_dn",
				password => "$ADMINpasswd"
			       );
	
	if($mesg->code != 0) {
	    $errs = "bind $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $this->display_error($errs,
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}

	$mesg =
	  $ldap->modify( "uid=$uid,$ldapbase",
			 changes => [
				     replace => 
				     [ sn => ( $sn eq "" ? [] : [$sn] ) ],
				     replace =>
				     [ givenname =>
				       ( $givenname eq "" ?
					 [] : [$givenname] ) ],
				     replace =>
				     [ o => ( $o eq "" ? [] : [$o] ) ],
				     replace =>
				     [ c => ( $c eq "" ? [] : [$c] ) ],
				     replace => [ cn => "$givenname $sn" ],
				     replace => [ maildomain => $maildomain ],
				     replace => [ imapserver => $iserver ],
				     replace => [ smtpserver => $sserver ],
				     replace => [ imapport => $iport ],
				     replace => [ sieveport => $sport ]
				    ]
		       );
	
	if($mesg->code != 0) {
	    $errs = "modify $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $this->display_error($errs,
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    $ldap->unbind;   # take down session
	    exit;
	}

	$ldap->unbind;   # take down session

	$this->display_msg($message->{user_edit_ok},
			   "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID".
			   "\&tab=$tab\&stab=$stab&filter=$filter&filtered=1",
			   2);

	$q->delete('uid');
	$q->delete('sn');
	$q->delete('givenname');
	$q->delete('o');
	$q->delete('c');
	$q->delete('maildomain');
	$q->delete('iserver');
	$q->delete('sserver');
	$q->delete('iport');
	$q->delete('sport');
    }
}

1;
