#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_defaultaci.pm,v 1.1.1.1 2003/03/25 10:31:40 ray Exp $
#
package edit_defaultaci;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP qw(:all);
use Display;
use Session;
use LDAPUtils;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $javascript=<<EOF;
  function toggleButtons(name) {
    c = document.form.markall.checked;

    a = document.form.elements;
    l = a.length - 1; 
    for (var i = 0; i < l; i++){
      if (a[i].type == 'checkbox'){
	a[i].checked = c;
      }
    }
  }
EOF

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};

    my $changeaci = $cgi->param("changeaci");
    my $deleteaci = $cgi->param("deleteaci");
    if( defined $changeaci && $changeaci ne "" ) {
	$this->update_aci;
    } elsif( defined $deleteaci && $deleteaci ne "") {
	$this->delete_aci;
    } else {
	$this->startup;
    }

}

sub startup{
    my $this = shift;
    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER", "EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    my $filter = $cgi->param('filter');
    my $aci;


    my @attribs = ("cn", "initials", "title", "ou", "l", 
		   "description", "street", "postalcode", "st", "c", "homephone",
		   "mobile", "pager", "facsimiletelephonenumber", "telephonenumber",
		   "labeleduri");
    my @write_access = ();
    my $dn = "uid=".$confParam->{'uid'}.",".$confParam->{'baseDN'};
    my ($err, $entry) = LDAP_read_entry( $confParam,$dn,"defaultuseraci");
    if($err == 0){
	$aci = $entry->get_value("defaultuseraci");
	if(! $aci ){
	    @write_access = @attribs;
	}else{
	    @write_access = split / /, $aci;
	}
    }else{
	my $errs = "search $message->{failed}\n\n";
	$errs .=  $entry;
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $errs = "";

    my %labels = ( );
    foreach my $key (@attribs){
	$labels{$key} = $message->{$key};
    }
    $cgi->delete("ldapaci"); 
    my $html ="";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$cgi->start_Tr();
    $html .=	    $cgi->start_td();
    $html .=	    $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_defaultaci.pl",
				    -name=>"form");
    $html .=		$cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=		    $cgi->Tr( $this->help_th(2,  $message->{'edit_default_aci'}, "EDIT_DEFAULT_ACI") );
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->td({-colspan=>2, -class=>'AdminSubHeader'},
				    [ $message->{'edit_default_aci_subtitle'} ]);
    $html .=		    $cgi->end_Tr();
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->start_td({-width => "40%"});
    $html .=			$cgi->end_td();
    $html .=			$cgi->start_td();
    $html .=			    $cgi->checkbox_group(-name => "ldapaci",
							-values => \@attribs,
							-labels => \%labels,
							-defaults => \@write_access,
							-linebreak => "true",
							-override => 1
							);
    $html .=			    "<br>".$cgi->checkbox(-name => "markall",
						-label => $message->{'edit_aci_select_all'},
						-onClick => "$javascript; toggleButtons('ldapaci')",
						);
    $html .=			$cgi->end_td();
    $html .=		    $cgi->end_Tr();
    $html .=		    $cgi->start_Tr();
    if( defined($aci) && $aci ne "" ){
	$html .=		$cgi->start_td({-align=>"center"});
	$html .=		    $cgi->hidden(-name => "sessionID",
					    -value => $sessionID);
	$html .=		    $cgi->hidden(-name => "tab",
					    -value => $tab);
	$html .=		    $cgi->hidden(-name => "stab",
					    -value => $stab);
        $html .=		    $cgi->submit(-class=>"button",-name => "deleteaci",
					-value => $message->{'aci_delete'});
	$html .=		$cgi->end_td();
	$html .=		$cgi->start_td({-align=>"center"});
	$html .=		    $cgi->submit(-class=>"button",-name => "changeaci",
					    -value => $message->{'update'});
	$html .=		$cgi->end_td();
    }else{
	$html .=		$cgi->start_td({-align=>"center", -colspan=>2});
	$html .=		    $cgi->hidden(-name => "sessionID",
					    -value => $sessionID);
	$html .=		    $cgi->hidden(-name => "tab",
					    -value => $tab);
	$html .=		    $cgi->hidden(-name => "stab",
					    -value => $stab);
	$html .=		    $cgi->submit(-class=>"button",-name => "changeaci",
					    -value => $message->{'update'});
	$html .=		$cgi->end_td();
    }
    $html .=		    $cgi->end_Tr();
    $html .=		$cgi->end_table();
    $html .=	    $cgi->end_form();
    $html .=	    $cgi->end_td();
    $html .=	$cgi->end_Tr();
    $html .= $cgi->end_table();
    
    $this->SUPER::display($html);
}

sub update_aci{
    my $this = shift;
    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    my $errs ="";

    my @write_access = $cgi->param('ldapaci');
    if( grep /^cn$/, @write_access ){
	push @write_access, ("sn", "givenname");
    }
    push @write_access, ("preferredLanguage");
    #print STDERR "change attrs:". join( " ", @write_access)."\n";
    my $acistring = join( " ", @write_access);
    
    my $bind_dn = "uid=".$confParam->{'uid'}.",".$confParam->{'baseDN'};

    my $ldap = Net::LDAP->new($confParam->{'LDAPserver'}, port => $confParam->{'LDAPport'}, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$confParam->{'passwd'}"
			   );
    

    if($mesg->code != LDAP_SUCCESS) {
	$errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    $errs="";
    $mesg = $ldap->modify($bind_dn, replace => {"defaultuseraci" => $acistring});
    if($mesg->code != LDAP_SUCCESS){
	$errs .= $message->{'set_default_aci_failed'}."\n";
	$errs .= LDAPerror($mesg);
	$this->display_error($errs,$confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID".
		"&tab=$tab");
	exit;
    }else{
	$this->display_msg($message->{'set_default_aci_success'},
		$confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID".
		"&tab=$tab",1);
    }
    exit;
	
}

sub delete_aci{
    my $this = shift;
    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    
    my $bind_dn = "uid=".$confParam->{'uid'}.",".$confParam->{'baseDN'};

    my $ldap = Net::LDAP->new($confParam->{'LDAPserver'}, port=>$confParam->{'LDAPport'}, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$confParam->{'passwd'}"
			   );
    
    my $errs = "";
    if($mesg->code != LDAP_SUCCESS) {
	$errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    $errs="";
    $mesg = $ldap->modify($bind_dn, delete => "defaultuseraci" );
    if($mesg->code != LDAP_SUCCESS){
	$errs .= $message->{'del_default_aci_failed'}."\n";
	$errs .= LDAPerror($mesg);
	$this->display_error($errs,$confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID".
		"&tab=$tab");
	exit;
    }else{
	$this->display_msg($message->{'del_default_aci_success'},
		$confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID".
		"&tab=$tab",1);
    }
    exit;

}
1;
