#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_resource_group.pm,v 1.3 2003/10/29 10:35:39 varkoly Exp $
#
package edit_resource_group;
use strict;
use CGI qw(-no_xhtml);
#use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use LDAPUtils;
use Display;
use Session;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"RESOURCES"))->data();

    my $cgi = $this->{"cgi"};

    my $commit=$message->{"commit"};
    $commit=~s/&auml;//g;
    my $delete=$message->{"b_delete"};
    $delete=~s/&ouml;//g;

    if ((!defined $cgi->param("run")) or
        ($cgi->param("resgrp_grp_name") eq $message->{"resgrp_no_entries"})) {
	#print listbox
	$this->selection;
    }
    elsif ($cgi->param("run") eq $message->{"edit"}) {
	#edit resource - mainscreen
	$this->edit_mask;
    }
    elsif ($cgi->param("run") eq $commit) {
	#apply changes from editing resource
	$this->do_changes;
    }
    elsif ($cgi->param("run") eq $delete) {
	#delete resource
	$this->delete;
    }
}

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

sub selection {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"RESOURCES"))->data();

    my $cgi = $this->{"cgi"};

    my $tab       = $cgi->param("tab");
    my $stab      = $cgi->param("stab");

    my $url = "$confParam->{cgi_path}/edit_resource_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server", $url);
        exit;
    }
    my $result = $ldap->bind(dn=>"uid=".$confParam->{uid}.",".$confParam->{baseDN},
			     password=>$confParam->{"passwd"});
    if($result->code != 0) {
        my $errs = "bind $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
        exit;
    }
    $result = $ldap->search(base=>$confParam->{"baseDN"},
			    scope=>"one",
			    filter=>"(&(resourceGroupName=*)(objectclass=SuSEResourceGroupObject))");
    if($result->code != 0) {
        my $errs = "search $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
	$ldap->unbind;
        exit;
    }
    $ldap->unbind;

    my @entries=$result->entries;
    my @list=();
    my %labels=();
    foreach my $i (@entries) {
	push @list,$i->get_value("resourceGroupName");
	my $resource=$i->get_value("resourceGroupName");
	$labels{$i->get_value("resourceGroupName")}=$resource;
    }
    if (!defined $list[0]) {
	push @list,$message->{"resgrp_no_entries"};
	$labels{$message->{"resgrp_no_entries"}}=$message->{"resgrp_no_entries"};
    }
    @list = sort @list;

    my $html = "";

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=         $cgi->Tr( $this->help_th(1, $message->{"resgrp_edit_title"}, "EDIT_RESOURCE_GROUP") );
    $html .=         $cgi->Tr( $cgi->td({-class=>'AdminSubHeader'},
                                        $message->{"resgrp_choose_grp"}) );
    $html .=         $cgi->Tr( $cgi->td({-align=>"center"},
					$cgi->start_form().
                                        $cgi->scrolling_list(-name   => "resgrp_grp_name",
                                                             -values => \@list,
                                                             -labels => \%labels,
                                                             -size   => 10,
                                                             -width  => 200)));
    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td({-align=>"center"},
                                $cgi->submit(-class=>"button",-name=>"run",-value=>$message->{"b_delete"})." &nbsp;".
                                $cgi->submit(-class=>"button",-name=>"run",-value=>$message->{"edit"}). 
                                $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
                                $cgi->hidden(-name=>"tab", -value=>$tab).
                                $cgi->hidden(-name=>"stab", -value=>$stab).
				$cgi->end_form() );
    $html .=         $cgi->end_Tr();
    $html .=       $cgi->end_table();
    $html .=     $cgi->end_td();
    $html .=   $cgi->end_Tr();
    $html .= $cgi->end_table();

    $this->SUPER::display($html);
}

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

sub edit_mask {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"RESOURCES"))->data();

    my $cgi = $this->{"cgi"};

    my $tab       = $cgi->param("tab");
    my $stab      = $cgi->param("stab");

    my $url = "$confParam->{cgi_path}/edit_resource_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    my $group     = $cgi->param("resgrp_grp_name");
    
    if( (! defined($group)) || ( $group eq "" ) ){
	$this->display_error($message->{'no_group_selected'}, 
		$confParam->{'cgi_path'}."/edit_resource_group.pl?sessionID=$sessionID&tab=$tab&stab=$stab");
	exit;
    }

    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port=>$confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server", $url);
        exit;
    }
    my $result = $ldap->bind(dn=>"uid=".$confParam->{uid}.",".$confParam->{baseDN},
			     password=>$confParam->{"passwd"});
    if($result->code != 0) {
        my $errs = "bind $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
        exit;
    }

    # search for attributes below selected SuSEResourceGroupObject
    $group = LDAP_filter_escape($group);
    $group =~ s/\*/\\2a/g;
    $result = $ldap->search(base=>$confParam->{"baseDN"},
			    scope=>"one",
			    filter=>"(&(resourceGroupName=$group)(objectclass=SuSEResourceGroupObject))",
			    attrs=> [ 'resourceGroupName' , 'resourceGroupMember' ]);
    if(($result->code != 0) || ($result->count() == 0) ) {
        my $errs = "search $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
	$ldap->unbind;
        exit;
    }

    my $entry=$result->entry(0);
    my $resource=$entry->get_value("resourceGroupName");

    my $members;
    foreach my $i ($entry->get_value("resourceGroupMember")) {
	push @$members,$i;
    }
    @$members = sort @$members if defined $members;
    
    # search for SuSEResourceObject
    $result = $ldap->search(base=>$confParam->{"baseDN"},
			    scope=>"one",
			    filter=>"(&(resourceName=*)(objectclass=SuSEResourceObject))",
			    attrs=> [ 'resourceName' ]);
    if($result->code != 0) {
        my $errs = "search $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
	$ldap->unbind;
        exit;
    }
    $ldap->unbind;

    my $resources;
    my $all = $result->count;
    for(my $i=0; $i<$all; $i++) {
	$entry = $result->entry($i);
	my $r = join("", $entry->get_value('resourceName'));
	push @$resources, $r;
    }
    @$resources = sort @$resources if defined $resources;
    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=         $cgi->Tr( $this->help_th(2, $message->{"resgrp_edit_title"}, "EDIT_RESOURCE_GROUP") );
    $html .=         $cgi->start_multipart_form(-method=> "post", -enctype => "multipart/date");
    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td({-valign=>"middle", -align=>"left"}, $message->{"resgrp_name"}.":");
    $html .=           $cgi->td({}, $resource);
    $html .=         $cgi->end_Tr();
    $html .=         $cgi->start_Tr();
    $html .=         $cgi->td({-valign=>"top", -align=>"left"}, $message->{"resgrp_resources"}.":");
    $html .=         $cgi->td({},
			      $cgi->scrolling_list(-name   => "resource_sel",
						   -multiple => 'true',
						   -values => $resources,
						   -default => $members,
						   -width  => 200,
						   -override => 1));
    $html .=         $cgi->end_Tr();
    $html .=         $cgi->start_Tr();
    $html .=           $cgi->td({-colspan=>2, -align=>"center"},
                                $cgi->reset(-class=>"button",-name=>$message->{'reset'})." &nbsp;".
                                $cgi->button(-class=>"button",-value=>$message->{"resgrp_back"},
                                             -onClick=>"location.href='$confParam->{cgi_path}/edit_resource_group.pl?".
						    "sessionID=$sessionID\&tab=$tab\&stab=$stab'"
					    )." &nbsp;".
                                $cgi->submit(-class=>"button",-name=>"run",-value=>$message->{"commit"}).
                                $cgi->hidden(-name=>"resgrp_grp_name", -value=>$group).
                                $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
                                $cgi->hidden(-name=>"tab", -value=>$tab).
                                $cgi->hidden(-name=>"stab", -value=>$stab) );
    $html .=         $cgi->end_Tr();
    $html .=         $cgi->end_form();
    $html .=       $cgi->end_table();
    $html .=     $cgi->end_td();
    $html .=   $cgi->end_Tr();
    $html .= $cgi->end_table();    

    $this->SUPER::display($html);
}

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

sub do_changes {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_RESOURCE"))->data();

    my $cgi   = $this->{"cgi"};

    my $tab   = $cgi->param("tab");
    my $stab  = $cgi->param("stab");

    my @resource_sel = $cgi->param('resource_sel');
    my $group        = $cgi->param("resgrp_grp_name");

    my $url   = "$confParam->{cgi_path}/edit_resource_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    my $ldap = Net::LDAP->new($confParam->{LDAPserver}, port=>$confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server", $url);
        exit;
    }
    my $result = $ldap->bind(dn=>"uid=".$confParam->{uid}.",".$confParam->{baseDN},
			     password=>$confParam->{"passwd"});
    if($result->code != 0) {
        my $errs = "bind $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
        exit;
    }

    my $uc_sel;
    foreach my $sel ( @resource_sel ) {
	print STDERR  "SELECTED: $sel\n";
	push @$uc_sel, $sel;
    }

    if( defined $uc_sel->[0] ) {
	$result = $ldap->modify( dn => "resourceGroupName=$group,".$confParam->{baseDN},
				 replace=>{"resourceGroupMember"=>$uc_sel});
    } else {
	$result = $ldap->modify( dn => "resourceGroupName=$group,".$confParam->{baseDN},
				 delete=>{"resourceGroupMember" =>[] });
    }

    if($result->code != 0) {
	my $errs = "modify (replace) $message->{failed}\n\n";
	$errs .= &LDAPerror($result);
	$this->display_error($errs, $url);
	$ldap->unbind;
	exit;
    }
    $ldap->unbind;
    
    $this->display_msg($message->{"succ_completed"},
		       "$confParam->{cgi_path}/edit_resource_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       1);
}

#=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

sub delete {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"RESOURCES"))->data();

    my $cgi = $this->{"cgi"};

    my $tab       = $cgi->param("tab");
    my $stab      = $cgi->param("stab");

    my $url = "$confParam->{cgi_path}/edit_resource_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port=>$confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server", $url);
        exit;
    }
    my $result = $ldap->bind(dn=>"uid=".$confParam->{uid}.",".$confParam->{baseDN},
			     password=>$confParam->{"passwd"});
    if($result->code != 0) {
        my $errs = "bind $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
        exit;
    }
    $result = $ldap->delete( dn => "resourceGroupName=".
			     $cgi->param("resgrp_grp_name").",".$confParam->{baseDN} );
    if($result->code != 0) {
        my $errs = "bind $message->{failed}\n\n";
        $errs .= &LDAPerror($result);
        $this->display_error($errs, $url);
	$ldap->unbind;
        exit;
    }
    $ldap->unbind;
    
    $this->display_msg($message->{"succ_completed"}, "$confParam->{cgi_path}/edit_resource_group.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",1);
}


1;
