#!/usr/bin/perl -w
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_sieve.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#
#


package edit_sieve;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(thaw freeze);
use Display;
use ManageSieve;
use vars qw(@ISA $confParam);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

##############################################
#display
#
sub display{
    my $this = shift;
    my $session=$this->{"session"};
    my $confParam= $session->{"confParam"};
    my $sessionID = $confParam->{'sessionID'};
    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_SIEVE"))->data();
    $this->{'filtername'}="filter.sieve";

    my $q = $this->{"cgi"};
    my $tab = $q->param('tab');
    my $save_but = $q->param('save_but');
    my $cancel_but = $q->param('cancel_but');

    if( defined $save_but){
	$this->save();
    }elsif(defined $cancel_but){
	$this->display_msg($message->{'sedit_redirecting'}, $confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID&tab=$tab",1);
    }else{
	$this->edit();
    }
}

sub edit{
    my $this = shift;
    $this->{'filtername'}="filter.sieve";

    my $q = $this->{"cgi"};
    my $session=$this->{"session"};
    my $confParam= $session->{"confParam"};
    my $sessionID = $confParam->{'sessionID'};
    my $uid = $confParam->{'uid'};
    my $passwd = $confParam->{'passwd'};
    my $imapserver = $confParam->{'IMAPserver'};
    my $sieveport = $confParam->{"SIEVEport"};
    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_SIEVE"))->data();
    my $tab = $q->param('tab');
    my $stab = $q->param('stab');

    my $sieve="";
    my $frozen = $confParam->{"filterScript"};
    if( (defined $frozen) && ($frozen ne "") ){
        $frozen = pack('H*',$frozen); # convert back to binary
	my $sieve_ref = thaw($frozen);     # melt down... :-)
	$sieve = $$sieve_ref;
        my $s_reply = $session->modify( {"filterScript" => ""} );
        if( $s_reply->code() ne "OK" ) {
	    $this->display_error("unable to modify session", $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID.
                    "&tab=$tab");
            exit;
        }
    }else{
        my $sieve_obj = ManageSieve->new($imapserver, $sieveport);
	my ($res, $msg) = $sieve_obj->connect();
	if ($res ne "OK"){
	    $this->display_error($message->{'sedit_load_failed'}.":<BR> $msg", 
				 $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
	    exit;
	}
	($res, $msg) = $sieve_obj->authplain($uid,$uid,$passwd);
	if ($res ne "OK"){
	    $this->display_error($message->{'sedit_load_failed'}.":<BR> $msg",
				 $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
	    exit;
	}
	($res, $msg) = $sieve_obj->getScript($this->{'filtername'});
	if ($res ne "OK"){
	    $sieve="";
	}else{
	    $sieve=$msg;
	}
	$sieve_obj->logout();
    }
    my $html = "";
    $html .= "\n".$q->start_table({-class=>'AdminBorder', -cellspacing => 2, -width=>"100%", -cellpadding=>0});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -width=>"100%",-cellpadding=>3});
    $html .=                 $q->Tr([$this->help_th(1, $message->{'sedit_sieve_editor'},'SIEVE_EDITOR' )]);
    $html .=                 $q->start_Tr();
    $html .=                     $q->start_td({-height=>25, -class=>'AdminSubHeaderRed', -align=>"center"});
    $html .=                         $message->{'sedit_warn'};
    $html .=                     $q->end_td();
    $html .=                 $q->end_Tr();
    $html .=                 $q->start_Tr();
    $html .=                     $q->start_td({-align=>"center", -valign=>"middle"});
    $html .=                         $q->start_form(-action=>$confParam->{cgi_path}.'/edit_sieve.pl');
    $html .=     			$q->textarea( -name => "script",
						      -default => $sieve,
						      -override => 1,
						      -rows => 20,
						      -columns => 75,
						      -wrap => "off");
    $html .=			$q->end_td();
    $html .=		    $q->end_Tr();
    $html .=		    $q->start_Tr();
    $html .=			$q->start_td({-align=>"right"});
    $html .=                             $q->hidden(-name=>'sessionID',
						    -value=>$sessionID,
						    -override=>1);
    $html .=                             $q->hidden(-name=>'rule_num',
						    -value => 0,
						    -override => 1);
    $html .=                             $q->hidden(-name=>'tab',
						    -value=>$tab,
                                         	    -override=>1);
    $html .=                             $q->hidden(-name=>'stab',
						    -value=>$stab,
                                         	    -override=>1);
    $html .=                             $q->hidden(-name=>'mode',
						    -value => 'append',
                                         	    -override => 1);
    $html .=                             $q->submit(-class=>"button",-name => "cancel_but",
						    -value => $message->{'sedit_cancel'})." ";
    $html .=                             $q->submit(-class=>"button",-name => "save_but",
						    -value => $message->{'sedit_save'});
    $html .=                         $q->end_form;
    $html .=                     $q->end_td;
    $html .=                 $q->end_Tr;
    $html .=             $q->end_table;
    $html .=         $q->end_td;
    $html .=     $q->end_Tr;
    $html .= $q->end_table;
    $this->SUPER::display($html);
    exit;
}

sub save{
    my $this = shift;
    
    my $q = $this->{"cgi"};
    my $session=$this->{"session"};
    my $confParam= $session->{"confParam"};
    my $sessionID = $confParam->{'sessionID'};
    my $uid = $confParam->{'uid'};
    my $passwd = $confParam->{'passwd'};
    my $imapserver = $confParam->{'IMAPserver'};
    my $sieveport = $confParam->{"SIEVEport"};
    my $message = ($session->getLanguage($confParam->{LANG},"EDIT_SIEVE"))->data();
    my $tab = $q->param('tab');
    my $stab = $q->param('stab');
    my $script = $q->param('script');
    my $sieve; 
    my $sieve_obj = ManageSieve->new($imapserver, $sieveport);
    my ($res, $msg) = $sieve_obj->connect();
    if ($res ne "OK"){
        $this->display_error($message->{'sedit_save_failed'}.":<BR><BR>$msg", 
			     $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->authplain($uid,$uid,$passwd);
    if ($res ne "OK"){
        $this->display_error($message->{'sedit_save_failed'}.":<BR><BR>$msg",
			     $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->putScript($this->{'filtername'}, $script );
    if ($res ne "OK"){
        $this->display_error($message->{'sedit_save_failed'}.":<BR><BR>$msg", 
			     $confParam->{'cgi_path'}."/edit_sieve.pl?sessionID=$sessionID&mode=display&tab=$tab&stab=$stab");
#        print STDERR "Script parsed!\n";
        my $frozen = freeze \$script;      #freeze data
        $frozen = unpack('H*',$frozen);   #convert to ASCII
        my %tmp = ( "filterScript" => $frozen );
        my $s_reply=$session->modify(\%tmp);
        if( $s_reply->code() ne "OK" ) {
	    $this->display_error("unable to modify session", $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID.
                    "&tab=$tab");
            exit;
        }else {
#            print STDERR "Data saved\n" ;
        }
        exit;
    }else{
	$this->display_msg($message->{'sedit_script_saved'}, $confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID&tab=$tab",3);
    }
}
1;
