#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_user4admin.pm,v 1.9 2004/01/12 08:21:13 varkoly Exp $
# 

$| = 1; # do not buffer stdout

package edit_user4admin;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(freeze thaw);
use DBI;
use Date::Calc qw(check_date);
use LDAPUtils;
use IMAPUtils;
use Utils;
use Net::LDAP qw( :all );
use Net::IMAP;
use Image::Magick;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $JavaScript=<<EOF;
    function open_help_win( win_location ) {
        parem='width=540,height=500,directories=no,menubar=no,toolbar=no,resizable=yes';   contacts_window=window.open(win_location, 'ImapHelpWin', parem);
        if (!contacts_window.opener) contacts_window.opener=self;
    }
    function close_help_win() {
        document.all['ImapHelpWin'].close();
    }
EOF

sub new {
    my $this = shift;
    my $self = new Display(@_);
# C SCHULSERVER
#    $self->{'attr_short'} = ['uid', 'sn', 'givenname', 'alias', 'mail', 'vaddress', 'o', 'c', 
#			 'susetimezone', 'preferredlanguage', 'gidnumber', 'writeglobaladdress' ];
#   $self->{'attr_long'} =  ['uid', 'sn', 'givenname', 'alias', 'mail', 'vaddress', 'o', 'c', 
#		      'susetimezone', 'preferredlanguage', 'ou', 'title',
#		      'initials', 'birthday','description', 'homephone',
#		      'mobile', 'telephonenumber', 'facsimiletelephonenumber',
#		      'pager', 'labeleduri', 'street', 'postalcode', 'l', 'st',
#		      'jpegphoto', 'gidnumber', 'writeglobaladdress', 'logindestination' ];
    $self->{'attr_short'} = ['uid', 'sn', 'givenname', 'gidnumber', 'alias', 'mail', 'vaddress', 
			     'o', 'c', 'preferredlanguage', 'admin' ];
    $self->{'attr_long'} =  ['uid', 'sn', 'givenname', 'gidnumber', 'alias', 'mail', 'vaddress', 'o',
			     'c', 'susetimezone', 'preferredlanguage', 'ou', 'title',
		      'initials', 'birthday','description', 'homephone',
		      'mobile', 'telephonenumber', 'facsimiletelephonenumber',
		      'pager', 'labeleduri', 'street', 'postalcode', 'l', 'st',
		      'jpegphoto', 'admin', 'rasAccess' ];
# E SCHULSERVER
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit = $cgi->param('doit');
    my $switch_attr = $cgi->param('switch_attr');
    my $displayphoto = $cgi->param('displayphoto');
    if(defined $doit && $doit ne "") {
	$this->update_user();
    }elsif(defined $switch_attr && $switch_attr ne ""){
	#print STDERR "switchattr\n";
	$this->startup();
    }elsif(defined $displayphoto && $displayphoto ne ""){
	$this->printimage();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_USER", "EDIT_USER"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $imaphost      = $confParam->{IMAPserver}; 
    my $imapport      = $confParam->{IMAPport};
    my $params = ();
    my $cgi_params = ();
    my $read_from_session = $q->param('read_from_session');
    
    if( defined $read_from_session && $read_from_session == 1){
	$cgi_params = $this->session_to_form;
	$this->cleanupsession();
    }else{
	$cgi_params = $q->Vars();
    }
    my $read_attrs = $this->{'attr_short'};
    if( $cgi_params->{'switch_attr'} || ($cgi_params->{'all_attrs'} && (! $cgi_params->{'less_attr'})) ){
	$read_attrs = $this->{'attr_long'};
    }
    
    my @must_attrs = ('uid', 'sn', 'o', 'c');
    my %must_attrs = ();
    foreach my $attr (@must_attrs){
	$must_attrs{$attr} = 1;
    }

    my $mail       = $cgi_params->{'mail'};
    my $fq_val     = "0";
    my $fq_used    = "0";
    my $q_val      = $cgi_params->{'q_val'};
    my $tab        = $cgi_params->{'tab'};
    my $stab       = $cgi_params->{'stab'};
    my $filter     = $cgi_params->{'filter'};
    
    my @group = ();
    my %g_label = ();
    my @alias_arr = ();
    my $check = "";
# I SCHULSERVER
    my $admincheck = "";
# E SCHULSERVER
    my $errs = "";
    my $q_used;

# -- search for mail domains
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;

    my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($mesg->code != 0) {
	$errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

# -- search for Domains

    $mesg = $ldap->search( base => "o=DNS,".$confParam->{baseDN},
                           scope => 'sub',
                           attrs => [ 'zoneName' ],
                           filter => "(&(relativeDomainName=@)(MTALocaldomain=true))" );
    if ($mesg->code != 0) {
        my $text = "search failed\n".&LDAPerror($mesg);
        $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        $ldap->unbind;
        exit;
    }

    my @doms;
    push @doms, $confParam->{mailDomain};
    foreach my $i ($mesg->entries) {
        my @zones = $i->get_value('zoneName');
        foreach my $zn ( @zones ) {
            if( $zn !~ /IN-ADDR\.ARPA/i && $zn ne $confParam->{mailDomain} ) {
                push @doms, $zn;
            }
        }
    }
    @doms = sort(@doms);

# -- search for Groups
   
# -- C SCHULSERVER          
    $mesg = $ldap->search (  # perform a search
                           base   => "$ldapbase",
                           scope  => "one",
                           attrs => ['cn', 'gidNumber', 'description'],
                           filter => "(&(objectclass=posixgroup)(!(objectclass=SuSESchoolGroup))(!(objectclass=SuSESchoolClass)))"
                          );

    if($mesg->code == 0) {
        foreach my $entry ($mesg->all_entries) {
            my $key = $entry->get_value("gidNumber");
            my $desc = $entry->get_value("description");
            my $cn   = $entry->get_value("cn");
            if( $key == 103) {
                next;
            } else {
                 push @group, $key;
                 if( defined $desc && $desc ne '' ) {
                    $g_label{$key} = $desc;
                 } else {
                    $g_label{$key} = $cn;
                 }
            }
# -- E SCHULSERVER
       }
    } else {
	$errs = "search $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    @group = sort(@group);
    my $user_dn = "uid=".$cgi_params->{'uid'}.",$ldapbase";

    $mesg = $ldap->search (  # perform a search
			     base   => $user_dn,
			     scope => "base",
			     attrs => $read_attrs, 
			     filter => "objectclass=posixAccount"
			     );
    
    my $jpegphoto;
    my @mail_addresses = ();
    if($mesg->code == 0) {
	my $entry = $mesg->entry(0);
	foreach my $attr (@{$read_attrs}){
	    my $tmpattr = $entry->get_value($attr);
	    if( $attr eq "jpegphoto" ) {
		$jpegphoto = $tmpattr;
	    } else {
		$params->{$attr} = $tmpattr;
	    }
	    if($params->{$attr}){
		$params->{$attr} =~ s/\"/&quot;/g;
	    }
	    if( defined( $cgi_params->{$attr}) ){
		$params->{$attr} = $cgi_params->{$attr};
	    }
	}

	# get all combinations of possible email-addresses for this user
	my @aliases = $entry->get_value('alias');
	push @alias_arr, $params->{'uid'};
	push @alias_arr, @aliases;	
	$params->{'alias'} = join " ", @aliases;
	my @vaddress = $entry->get_value('vaddress');
	$params->{'vaddress'} = \@vaddress;
	foreach my $localpart (@alias_arr){
	    foreach my $domain (@doms){
		push @mail_addresses, $localpart."@".$domain;
	    }
	}
	foreach my $act_vaddress ( @vaddress ){
	    if( ! grep /^$act_vaddress$/, @mail_addresses ){
		push @mail_addresses, $act_vaddress;
	    }
	}
	@mail_addresses = sort(@mail_addresses);

    } else {
	$errs = "search $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$ldap->unbind;   # take down session
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    $mesg = $ldap->search (  # perform a search
			   base   => "cn=AddressAdmins,o=AddressBook,".$confParam->{'baseDN'},
			   scope => "base",
			   attrs => ['member'],
			   filter => "member=$user_dn"
			     );
    if( $mesg->code != LDAP_SUCCESS ){
	$errs = "search $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$ldap->unbind;   # take down session
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    if( $mesg->count > 0 ){
	$check = 1;
    }else{
	$check = 0;
    }

# SCHULSERVER I
    $mesg = $ldap->search (  # perform a search
                           base   => "cn=Admins,".$confParam->{'baseDN'},
                           scope => "base",
                           attrs => ['member'],
                           filter => "member=$user_dn"
                             );
    if( $mesg->code != LDAP_SUCCESS ){
        $errs = "search $message->{failed}\n\n";
        $errs .= &LDAPerror($mesg);
        $ldap->unbind;   # take down session
        $this->display_error($errs,
                      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    if( $mesg->count > 0 ){
        $admincheck = 1;
    }else{
        $admincheck = 0;
    }

    $ldap->unbind;   # take down session

    if ($confParam->{uid} eq "cyrus") {
# --- SCHULSERVER E
# --- SCHULSERVER C
	    my $imap = new Net::IMAP($imaphost, Debug => 0);
	    if( ! $imap ){
		$this->display_error("can't connect to $imaphost: $!\n",
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		exit;
	    }
	    
	    my $resp = $imap->login($ADMINuid, $ADMINpasswd);
	    if($$resp{Status} ne "ok") {
		$errs = "login failed: Serverresponse: $$resp{Status} => $$resp{Text}\n";
		$this->display_error($errs,
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		exit;
	    }    
	    
	    # anonymous function for this callback shit
	    my $anf = sub {
		my $self = shift;
		my $resp = shift;
		
		$q_val  = $resp->limit("STORAGE");
		$q_used = $resp->usage("STORAGE");
	    };
	    
	    $imap->set_untagged_callback('quota', $anf);
	    
	    my $namespaces = &IMAPUtils::namespace($ADMINuid, $ADMINpasswd, $imaphost);
	    my @users_ns= $namespaces->other_users();
	    my $delimiter = $namespaces->other_users($users_ns[0]); 
	    
	    $resp = $imap->getquotaroot("user".$delimiter.$params->{'uid'});
	    if($$resp{Status} ne "ok") {
		$errs = "getquotaroot failed: Serverresponse:$$resp{Status} => $$resp{Text}\n";
		$imap->logout;
		$this->display_error($errs,
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		exit;
	    }    
	    $imap->logout;
    }
# --- SCHULSERVER E
    # reading fs quota 
    my $ret = $session->suad_getfquota('/home',$params->{'uid'});
    #print STDERR 'RET:'.$ret->code()."\n";
    $ret->code() =~ /OK:\s(-*\d+?)\s(\d+?)\s(.*)/ms;
    if( !defined $fq_val || $fq_val eq '0' ) {
       $fq_val = $2;
    }
    $fq_used = $3;
 
    my $size = 20;
    $size -= length($params->{'uid'}); 
    $size -= 1;

    my $langs;
    foreach my $l ( keys %$::lmsg ) {
	push @$langs, $l;
    }

    my @timezones = getTimeZones();

    my $html = "";

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$q->start_Tr();
    $html .=	    $q->start_td();
    $html .=		$q->start_multipart_form(
				-action => $confParam->{'cgi_path'}."/edit_user4admin.pl",
				-name => "form");
    $html .=		    $q->start_table({-cellspacing => 0, -cellpadding=>3, -width=>"100%"});
    $html .=			$q->start_Tr();
    $html .=			    $this->help_th(2, $message->{edit_user}, "EDIT_USER_ADMIN");
    $html .=			$q->end_Tr();
    $html .=			$q->start_Tr();
    $html .=			    $q->td({-colspan => 2, -class=>'AdminSubHeader'},
					   $message->{star_fields} );
    $html .=			$q->end_Tr();
    foreach my $attr ( @{$read_attrs} ){
	if($attr eq "vaddress"){
	    next;
	}
	if( $attr eq "admin" && $params->{gidnumber} ne 102){
		next;
	}
	$html .=		$q->start_Tr();
	$html .=		    $q->start_td();
	$html .=			$message->{$attr};
	if( $must_attrs{$attr} ){
	    $html .=			'*';
	}
	if( $attr eq "alias" ){
	    $html .=			"<BR><FONT SIZE=2 COLOR=#FF3333>(".$message->{'space_separated'}.")</FONT>"
	}
	$html .=		    $q->end_td();
	$html .=		    $q->start_td();
	if($attr eq "uid"){
	    $html .=			$params->{$attr};
	}elsif($attr eq "c"){
	    $html .=			$q->textfield(-name=>"c",
                                                      -override=>0,
						      -size=>5,
						      -maxlength=>2,
						      -value=>$params->{$attr}).
					$q->a({-href=>"javascript:void(0);",
					       -onclick=>"$JavaScript; open_help_win('$confParam->{cgi_path}/country_codes.pl?sessionID=$sessionID')"},
					       $q->img({-border=>0,
							-src=>"$confParam->{image_path}/help1.gif",
							-width=>18,
							-height=>18,
							-alt=>"Help"
							})
					       );
	}elsif($attr eq "preferredlanguage"){
	    $html .=			$q->popup_menu(-name=>'preferredlanguage',
                                                       -values=>$langs,
                                                       -default=>$params->{$attr},
                                                       -width=>160);
	}elsif($attr eq "gidnumber"){
	    $html .=			$q->popup_menu(-name=>'gidnumber',
                                                       -values=>\@group,
                                                       -labels=>\%g_label,
                                                       -default=>$params->{$attr},
                                                       -width=>160);
	}elsif( $attr eq "writeglobaladdress" ){
	    $html .=			$q->checkbox(-name=>$attr,
						 -checked=>$check,
						 -label=>""
						 );
	}elsif($attr eq "description"){
	    $html .=			$q->textarea(-name=>$attr,
                                                       -default=>$params->{$attr},
                                                       -rows => 4,
						       -columns => 30);
	}elsif($attr eq "mail"){
	    $html .=                    $q->popup_menu(-name=>'mail',  
						    -values=>\@mail_addresses,  
						    -default=>$params->{$attr},  
						    -width=>100);
# SCHULSERVER I
        }elsif( $attr eq "rasAccess" ){
            $html .=                    $q->checkbox(-name=>$attr,
                                                 -checked=>$params->{$attr},
                                                 -label=>""
                                                 );
        }elsif( $attr eq "admin" ){
	    if($params->{gidnumber} eq 102) {
	            $html .=                    $q->checkbox(-name=>$attr,
                                                 -checked=>$admincheck,
                                                 -label=>""
                                                 );
	     }
	}elsif($attr eq "logindestination"){
	    $html .=                    $q->popup_menu(-name=>$attr,  
						       -values => ['groupware', 'webmail', 'config'],
						       -labels => { 'groupware' => $message->{'groupware'},
								    'webmail' => $message->{'webmail'},
								    'config'    => $message->{'config'} },
						       -default => $params->{$attr},
                                                      -override=>0);
	}elsif($attr eq "jpegphoto"){
	    $html .=			$q->img({-src => $confParam->{'cgi_path'}.
							 "/edit_user4admin.pl?displayphoto=1&uid=".
							 $params->{'uid'}."&sessionID=$sessionID",
						 -alt => $message->{'no_image_present'} }).$q->br();
	    $html .=		    $q->end_td();
	    $html .=		$q->end_Tr();
	    $html .=		$q->start_Tr();
	    $html .=		    $q->start_td();
	    $html .=		    $q->end_td();
	    $html .=		    $q->start_td();
	    $html .=			$q->filefield(-name=>$attr, -default => "");
	}elsif($attr eq "susetimezone"){
	    if(! $params->{$attr}){
		my @dflt_timezone = parse_file("/etc/sysconfig/clock", "TIMEZONE=");
		$params->{$attr} = $dflt_timezone[0]; 
		$params->{$attr} =~ s/\"//g;
	    }
	    $html .=			$q->popup_menu(-name=>"susetimezone",
						      -values => \@timezones,
						      -default => $params->{$attr},
                                                      -override=>0);
	}elsif($attr eq "birthday"){
            my $month = [ '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12' ],
            my $days  = [ '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12',
		    '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24',
	    	    '25', '26', '27', '28', '29', '30', '31'];
	    my ($birth_year, $birth_month, $birth_day) = split /-/, $params->{$attr};
	    $html .=			$message->{'year'}.": ".$q->textfield(-name =>"birth_year",
						      -size => 5,
						      -default => $birth_year);
	    $html .=			" ".$message->{'month'}.": ".$q->popup_menu(-name=>"birth_month",
						      -values => $month,
						      -default => $birth_month,
                                                      -override=>0);
	    $html .=			" ".$message->{'day'}.": ".$q->popup_menu(-name=>"birth_day",
						      -values => $days,
						      -default => $birth_day,
                                                      -override=>0);
	}else{
	    $html .=			$q->textfield(-name => $attr, -size => 30 , -default => $params->{$attr});
	}
	$html .=		    $q->end_td();
	$html .=		$q->end_Tr();
    }
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td();
    $html .=				$message->{'quota'};
    $html .=			    $q->end_td();
    $html .=			    $q->start_td();
    $html .=				$q->textfield(-name => "quota", -size => 15, -default => $q_val);
    $html .=				"KB (".$q_used." ".$message->{'quota_inuse'}.")";
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .=                    $q->start_Tr();
    $html .=                       $q->start_td();
    $html .=                           $message->{'fquota'};
    $html .=                       $q->end_td();
    $html .=                       $q->start_td();
    $html .=                           $q->textfield(-name => "fq_val", -size => 15, -default => $fq_val);
    $html .=                              "MB (".$fq_used." ".$message->{'quota_inuse'}.")";
    $html .=                       $q->end_td();
    $html .=                       $q->end_Tr();
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-align => "center"});
    if( $cgi_params->{'switch_attr'} || ($cgi_params->{'all_attrs'} && (! $cgi_params->{'less_attr'})) ){
	$html .=				$q->submit(-class=>"button",-name=>"less_attr", -value=>$message->{"less_attr"});
	$html .=				$q->hidden(-name=>"all_attrs", -value => 1);
    }else{
        $html .=				$q->submit(-class=>"button",-name=>"switch_attr", -value=>$message->{"more_attr"});
    }
    $html .=			    $q->end_td();
    $html .=			    $q->start_td({-align => "center"});
    $html .=				$q->submit(-class=>"button",-name=>"doit", -value=>$message->{update});
    $html .=				$q->hidden(-name=>"uid", -value=>$params->{'uid'});
    $html .=				$q->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .=				$q->hidden(-name=>"filter", -value=>$filter);
    $html .=				$q->hidden(-name=>"filtered", -value=>1);
    $html .=				$q->hidden(-name=>"tab", -value=>$tab);
    $html .=				$q->hidden(-name=>"stab", -value=>$stab);
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .=		    $q->end_table();
    $html .=		$q->end_form();
    $html .=	    $q->end_td();
    $html .=	$q->end_Tr();
    $html .= $q->end_table();
			
    $this->back_url("$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter\&filtered=1");
    $this->SUPER::display($html);
}

sub update_user {
    my $this = shift;
    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_USER", "EDIT_USER"))->data();
    my $sessionID = $confParam->{"sessionID"};
    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $imaphost      = $confParam->{IMAPserver}; 
    my $imapport      = $confParam->{IMAPport};
    my $oldgid = 0;
    my $newgid = 0;
    my $uid        = $q->param('uid');
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $filter     = $q->param('filter');
    if( $this->form_to_session() ne "OK"){
	$this->display_error($message->{'write2session_failed'},
			     "$confParam->{cgi_path}/create_user.pl?sessionID=$sessionID".
			     "\&tab=$tab\&stab=$stab");
	exit;
    };
    my $cgi_params = $q->Vars();
    my $attrs = [];
    if( defined $cgi_params->{'all_attrs'} ){
	$attrs = $this->{'attr_long'};
    }else{
	$attrs = $this->{'attr_short'};
    }
    
    foreach my $p ( keys %$cgi_params ) {
	if( $p eq 'homephone' ||
	    $p eq 'mobile' ||
	    $p eq 'facsimiletelephonenumber' ||
	    $p eq 'pager' ||
	    $p eq 'telephonenumber' ) {
	    next if $cgi_params->{$p} eq "";
	    if( $cgi_params->{$p} !~ /[^-\s]/ ) {		
		$this->display_error("$p $message->{invalid_number}",
				     "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
				     "\&tab=$tab\&stab=$stab&read_from_session=1\&uid=$uid");
		exit;
	    }
	}
    }

    if($cgi_params->{'telephonenumber'} =~ /[^a-zA-Z0-9-+.()\/ ]+/ ) {
	$this->display_error($message->{false_value}.": ".$message->{'telephonenumber'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	exit;
    }
    if($cgi_params->{'facsimiletelephonenumber'} =~ /[^a-zA-Z0-9-+.()\/ ]+/ ) {
	$this->display_error($message->{false_value}.": ".$message->{'facsimiletelephonenumber'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	exit;
    }
    if($cgi_params->{'mobile'} =~ /[^a-zA-Z0-9-+.()\/ ]+/ ) {
	$this->display_error($message->{false_value}.": ".$message->{'mobile'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	exit;
    }
    if($cgi_params->{'homephone'} =~ /[^a-zA-Z0-9-+.()\/ ]+/ ) {
	$this->display_error($message->{false_value}.": ".$message->{'homephone'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	exit;
    }
    if($cgi_params->{'pager'} =~ /[^a-zA-Z0-9-+.()\/ ]+/ ) {
	$this->display_error($message->{false_value}.": ".$message->{'pager'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	exit;
    }
    # some basic validy check for the birthdate
    if( $cgi_params->{'birth_year'} != "" ){
	if( $cgi_params->{'birth_year'} !~ /^\d{4}$/ ){
	    $this->display_error($message->{'year_four_digit'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	    exit;
	}elsif( ! check_date($cgi_params->{'birth_year'},$cgi_params->{'birth_month'},$cgi_params->{'birth_day'}) ){
	    $this->display_error($message->{'invalid_birth_date'},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
		      "\&tab=$tab\&stab=$stab\&read_from_session=1\&uid=$uid");
	    exit;
	}else{
	    $cgi_params->{'birthday'} = $cgi_params->{'birth_year'}."-".$cgi_params->{'birth_month'}.
				    "-".$cgi_params->{'birth_day'};
	}
    }

    my $errs = "";

    if($cgi_params->{'uid'} eq "" || $cgi_params->{'sn'} eq "" 
            || $cgi_params->{'o'} eq "" 
	    || $cgi_params->{'c'} eq "") {
	$this->display_error($message->{miss_some_values},
		      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
				"&tab=$tab&stab=$stab&uid=$uid&read_from_session=1", 3);
	exit;

    } else {
	if($cgi_params->{'mail'} !~ /\./) {  
	    $this->display_error($message->{incorrect_mail_address},  
                           "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".  
                           "\&read_form_from_session=1\&tab=$tab\&stab=$stab\&uid=$uid",  
                           3);  
	    exit;  
        }  

	if($cgi_params->{'alias'} =~ /\@/) {
	    $this->display_error($message->{incorrect_mail_alias},
			  "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID".
			  "\&read_from_session=1\&filtered=1\&tab=$tab\&stab=$stab\&uid=$uid",
			  3);
	    exit;
	}

	my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
	
	my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);
	if(!defined $ldap) {
	    $this->display_error("can't contact LDAP Server",
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $mesg = $ldap->bind (   # bind to a directory with dn and password
				dn       => "$bind_dn",
				password => "$ADMINpasswd"
			       );
	
	if($mesg->code != 0) {
	    $errs = "bind $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $this->display_error($errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}

	my @al = split(/ /, $cgi_params->{'alias'});
	
	foreach my $a (@al) {
	    if($a =~ /[^a-zA-Z0-9-_.&]+/ ) {  #   Match a non-word character
		$this->display_error($a.": ".$message->{default_alias_not_set},
				     $confParam->{'cgi_path'}."/edit_user4admin.pl?sessionID=$sessionID".
				     "&read_from_session=1&tab=$tab&stab=$stab&uid=$uid");
		exit;
	    }
	    if(!is_address_unique($ldap, $a, $uid, $ldapbase)){
		$errs = "$a: $message->{alias_exist}";
		$ldap->unbind();
		$this->display_error($errs,
			      "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID&uid=$uid".
			      "&read_from_session=1&tab=$tab&stab=$stab");
		exit;
	    }
	}

	## get the old and the new primary group
	$newgid = $cgi_params->{'gidnumber'};
	$mesg = $ldap->search(
			base => "uid=".$uid.",".$ldapbase,
			scope => "base",
			attrs => [ "gidnumber" ],
			filter => "objectclass=posixAccount"
		);
	if($mesg->code != 0) {
	    $errs = "Search $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $this->display_error($errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}else{
	    if( $mesg->count == 1 ){
	   	my $entry = $mesg->entry(0);
		$oldgid = $entry->get_value("gidnumber");
	    }
	}

	## change LDAP data
	my %changes = ();
	foreach my $attr (@$attrs){
	    if( $attr eq "writeglobaladdress") {
		next;
	    }
	    if( $attr eq "vaddress"){
		next;
	    }
	# I SCHULSERVER
	    if( $attr eq "admin"){
		next;
	    }
	# E SCHULSERVER
	    #print STDERR "$attr = ".$cgi_params->{$attr}."\n";	    
	    if( $attr ne "jpegphoto" ) {
		$changes{$attr} = ($cgi_params->{$attr} ? [$cgi_params->{$attr}] : [] );
	    } else {
		my $jpegfile = $q->upload('jpegphoto');
		if( $jpegfile ){
		    #print STDERR $q->uploadInfo($jpegfile)->{'Content-Type'}."\n";
		    if( $q->uploadInfo($jpegfile)->{'Content-Type'} =~ /image\/p*jpeg/i ){
			my $buf = "";
			my $bytesread;
			my $jpegdata = "";
			while ($bytesread=read($jpegfile,$buf,1024)) {
			    $jpegdata .= $buf;
			}
			my @blob = ( $jpegdata );
			my $image = Image::Magick->new('magick' => 'jpg');
			$image->BlobToImage(@blob);
			my $act_width = $image->Get('width');
			my $act_height = $image->Get('height');
			my $new_width = int( $::CONF_GLOBAL{'GENERAL'}{'UserJpegPhotoMaxWidth'} ) || 150; 
			my $new_height = int( $::CONF_GLOBAL{'GENERAL'}{'UserJpegPhotoMaxHeight'} ) || 200;
			# scale the image	
			if( ( $act_height > $new_height )  || ( $act_width > $new_width ) ){
			    my $scale_w = $new_width / $act_width;	
			    my $scale_h = $new_height / $act_height;
			    my $scale = ($scale_w < $scale_h) ? $scale_w : $scale_h;
			    $new_width = $act_width * $scale;
			    $new_height = $act_height * $scale;
			    $image->Scale('width' => $new_width, 'height' => $new_height);
			}
			@blob = $image->ImageToBlob();
			$changes{$attr} = ( $blob[0] ne "" ? [$blob[0]] : [] );
		    }else{
			$this->display_error($message->{'no_jpeg'},
				  "$confParam->{cgi_path}/edit_user4admin.pl?sessionID=$sessionID&uid=$uid".
				  "&read_from_session=1&tab=$tab&stab=$stab");
			exit;
		    
		    }
		}
	    }
	}
	if(defined $cgi_params->{'givenname'} && $cgi_params->{'givenname'} ne ""){
	    if ( $confParam->{LANG} eq "HU" ) {
	       $changes{'cn'} = to_ascii($cgi_params->{'sn'})." ".to_ascii($cgi_params->{'givenname'});
	    } else {
	       $changes{'cn'} = to_ascii($cgi_params->{'givenname'})." ".to_ascii($cgi_params->{'sn'});
	    }
	}else{
	    $changes{'cn'} = $cgi_params->{'sn'};
	}
	$changes{'alias'} = \@al;
	$mesg = $ldap->modify( "uid=$uid,$ldapbase",
				replace => \%changes );
	
	if($mesg->code != 0) {
	    $errs = "modify $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $ldap->unbind;   # take down session
	    $this->display_error($errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	if( $newgid ne $oldgid ){
	    my @changes = ();
	    $mesg = $ldap->search( 'base' => "$ldapbase", 
				   'scope' => 'one',
				   'filter' => "(&(objectclass=posixGroup)".
						  "(gidNumber=$oldgid)".
						  "(memberUid=$uid))",
				   'attrs' => [ "gidNumber" ]
				);
	    if($mesg->code != 0){
		    my $text = "search $message->{failed}\n\n";
		    $text .= &LDAPerror($mesg);
		    $ldap->unbind;   # take down session
		    $this->display_error($text,
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		    exit;
	    }
	    if($mesg->count == 0){
		push @changes, delete => ['comfireGroupId' => $oldgid];
	    }
	    $mesg = $ldap->search( 'base' => "$ldapbase", 
				   'scope' => 'one',
				   'filter' => "(&(objectclass=posixGroup)".
						  "(gidNumber=$newgid)".
						  "(memberUid=$uid))",
				   'attrs' => [ "gidNumber" ]
				);
	    if($mesg->code != 0){
		    my $text = "search $message->{failed}\n\n";
		    $text .= &LDAPerror($mesg);
		    $ldap->unbind;   # take down session
		    $this->display_error($text,
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		    exit;
	    }
	    if($mesg->count == 0){
		push @changes, add => ['comfireGroupId' => $newgid];
	    }
	    if(@changes){
		$mesg = $ldap->modify( "uid=$uid,$ldapbase",
					changes => \@changes );
		
		if($mesg->code != 0) {
		    $errs = "modify $message->{failed}\n\n";
		    $errs .= &LDAPerror($mesg);
		    $ldap->unbind;   # take down session
		    $this->display_error($errs,
				  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		    exit;
		}
	    }
	}
	
	## update Admins for Global Address Book
	$mesg = $ldap->search (  # perform a search
			       base   => "cn=AddressAdmins,o=AddressBook,".$confParam->{'baseDN'},
			       scope => "base",
			       attrs => ['member'],
			       filter => "member=uid=$uid,".$confParam->{'baseDN'}
			      );
	if( $mesg->code != LDAP_SUCCESS ){
	    $errs = "search $message->{failed}\n\n";
	    $errs .= &LDAPerror($mesg);
	    $ldap->unbind;   # take down session
	    $this->display_error($errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}

	if( $mesg->count > 0 ){
	    if( (!defined $cgi_params->{'writeglobaladdress'}) || ($cgi_params->{'writeglobaladdress'} ne "on") ){
		$ldap->modify( "cn=AddressAdmins,o=AddressBook,".$confParam->{'baseDN'},
				delete => {"member" => "uid=$uid,".$confParam->{'baseDN'} }
			     );
	    }
	}else{
	    if( (defined $cgi_params->{'writeglobaladdress'}) && ($cgi_params->{'writeglobaladdress'} eq "on") ){
		$ldap->modify( "cn=AddressAdmins,o=AddressBook,".$confParam->{'baseDN'},
				add => {"member" => "uid=$uid,".$confParam->{'baseDN'} }
			     );
	    }
	}

# SCHULSERVER I
        ## update Admins 
        $mesg = $ldap->search (  # perform a search
                               base   => "cn=Admins,".$confParam->{'baseDN'},
                               scope => "base",
                               attrs => ['member'],
                               filter => "member=uid=$uid,".$confParam->{'baseDN'}
                              );
        if( $mesg->code != LDAP_SUCCESS ){
            $errs = "search $message->{failed}\n\n";
            $errs .= &LDAPerror($mesg);
            $ldap->unbind;   # take down session
            $this->display_error($errs,
                          "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
        if( $mesg->count > 0 ){
            if( (!defined $cgi_params->{'admin'}) || ($cgi_params->{'admin'} ne "on") ){
                $ldap->modify( "cn=Admins,".$confParam->{'baseDN'},
                                delete => {"member" => "uid=$uid,".$confParam->{'baseDN'} }
                             );
            }
        }else{
            if( (defined $cgi_params->{'admin'}) && ($cgi_params->{'admin'} eq "on") ){
                $ldap->modify( "cn=Admins,".$confParam->{'baseDN'},
                                add => {"member" => "uid=$uid,".$confParam->{'baseDN'} }
                             );
            }
        }
# SCHULSERVER E

	$ldap->unbind;   # take down session

	my $imap = new Net::IMAP($imaphost, Debug => 0);
	if(!defined $imap) {
	    $this->display_error("can't connect to $imaphost: $!",
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $resp = $imap->login($ADMINuid, $ADMINpasswd);
	if($$resp{Status} ne "ok") {
	    $errs = "login failed: Serverresponse: $$resp{Status} => $$resp{Text}\n";
	    $this->display_error($errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}    
	
	if( defined $cgi_params->{'quota'} ) {
	    my $namespaces = &IMAPUtils::namespace($ADMINuid, $ADMINpasswd, $imaphost);
	    my @users_ns= $namespaces->other_users();
	    my $delimiter = $namespaces->other_users($users_ns[0]); 

	    my $q_root = "user".$delimiter.$uid;
	    my @qarray;
	    if( ($cgi_params->{'quota'} eq "") || ($cgi_params->{'quota'} eq "0") ){
		@qarray = ();
	    }else{
		@qarray = ("STORAGE", $cgi_params->{'quota'});
	    }
	    $resp = $imap->setquota($q_root, @qarray);
	    $imap->logout();
	    
	    if($$resp{Status} ne "ok") {
		$errs = "setquota failed: Serverresponse:$$resp{Status} => $$resp{Text}\n";
		$this->display_error($errs,
				     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		exit;
	    }
	}
        my $fq_val = $cgi_params->{'fq_val'};
        if(defined $fq_val && (!($fq_val =~ /[^\d]+/)) && $fq_val ne '') {
            $session->suad_setfquota('/home',$uid,$fq_val);
        }
        $q->delete('fq_val');
	$q->delete('uid');
	$q->delete('sn');
	$q->delete('givenname');
	$q->delete('o');
	$q->delete('ou');
	$q->delete('l');
	$q->delete('c');
	$q->delete('aliases');
	$q->delete('q_val');
	$q->delete('language');
	$q->delete('jpegphoto');
	$q->delete('group');
	$q->delete('writeglobaladdress');
# C SCHULSERVER
#	my ($exit_comfire, $errs) = sync_comfire_contact($uid);
#	my $text = "";
#	if($exit_comfire != 0) {
#	    $text .= "insUpdSystemUser $uid $message->{failed}<BR>\n\n";
#	} else {	
#	    $text .= "insUpdSystemUser $uid $message->{success}<BR>\n";
#	}
	$this->display_msg($message->{user_edit_ok}."\n",
		    "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&filter=$filter".
		    "\&filtered=1\&tab=$tab\&stab=$stab", 3);
# E SCHULSERVER 
	$this->cleanupsession();
    }
}

sub form_to_session{
    my $this = shift;
    my $session = $this->{"session"};
    my $cgi = $this->{'cgi'};

    my %cgi_params = $cgi->Vars();
    # create birthday string
    $cgi_params{'birthday'} = $cgi_params{'birth_year'}."-".$cgi_params{'birth_month'}."-".$cgi_params{'birth_day'};
    my $frozen = freeze (\%cgi_params);
    $frozen = unpack('H*',$frozen);

    my %tmp = ( "formdata" => $frozen );
    my $s_reply=$session->modify(\%tmp);
    if( $s_reply->code() ne "OK" ) {
	return "ERR"
    }else {
	return "OK";
    }

}

sub session_to_form{
    my $this = shift;
    my $session = $this->{"session"};
    my $confParam = $session->{'confParam'};

    my $frozen = $confParam->{'formdata'};
    $frozen = pack('H*',$frozen);
    my $formdata = thaw($frozen);
    return $formdata;
}

sub cleanupsession{
    my $this = shift;
    my $session = $this->{"session"};
    my $reply = $session->modify({"formdata" => "" });
}

sub printimage{
    my $this = shift;
    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"CREATE_USER", "EDIT_USER"))->data();
    my $sessionID = $confParam->{"sessionID"};
    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $uid        = $q->param('uid');
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;

    my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($mesg->code != 0) {
	my $errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    $mesg = $ldap->search( base => "uid=$uid,".$confParam->{baseDN},
			   scope => 'base',
			   attrs => [ 'jpegphoto' ],
			   filter => "objectclass=*" );
    if ($mesg->count == 0) {
        my $text = "search failed\n".&LDAPerror($mesg);
        $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	$ldap->unbind;
        exit;
    }
    my $photo = $mesg->entry(0)->get_value('jpegPhoto');
    print $q->header("image/jpeg");
    binmode STDOUT;
    print $photo;
}

1;
