#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_useraci.pm,v 1.2 2003/11/25 22:09:58 varkoly Exp $
#
package edit_useraci;
use strict;
use Storable qw(thaw freeze);
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP qw(:all);
use Display;
use Session;
use LDAPUtils;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $javascript=<<EOF;
  function toggleButtons(name) {
    c = document.form.markall.checked;

    a = document.form.elements;
    l = a.length - 1; 
    for (var i = 0; i < l; i++){
      if (a[i].type == 'checkbox'){
	a[i].checked = c;
      }
    }
  }
EOF

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;

    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};


    my $changeaci = $cgi->param("changeaci");

    if( defined $changeaci && $changeaci ne "" ) {
	$this->update_aci;
    } else {
	$this->startup;
    }

}

sub startup{
    my $this = shift;
    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER", "EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    my $filter = $cgi->param('filter');


    #load list of users from session
    my $frozen = $confParam->{"usersToMod"};
    if( (! defined $frozen) || ($frozen eq "") ){
	$this->display_error($message->{'error_reading_session'},
	    	      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    $frozen = pack('H*',$frozen); # convert back to binary
    my $user_ref = thaw($frozen);     # melt down... :-)
    my @users    = @{$user_ref};
    my $uid = "";
    if( scalar(@users) == 1 ){
	$uid = $users[0];
    }
    my @attribs = ("cn", "initials", "mail", "title", "ou", "l", 
		   "birthday", "description", "street", "postalcode", "st",
		   "c", "susetimezone", "homephone", "mobile", "pager",
		   "facsimiletelephonenumber", "telephonenumber", "labeleduri",
		   "jpegphoto");
    my @write_access = ();
    my $errs = "";
    if($uid ne ""){
	my ($code, $entry) = LDAP_read_entry($confParam, "uid=".$uid.",".$confParam->{'baseDN'}, ["openldapaci"]);
	if($code == 0){
	    my $aci = $entry->get_value("openldapaci");
	    if(! $aci ){
		@write_access = @attribs;
	    }else{
		@write_access = $this->get_attributes_by_access("w", $aci);
	    }
	}else{
	    $errs = "search $message->{failed}\n\n";
	    $errs .=  $entry;
	    $this->display_error($errs,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my %labels = ( );
    foreach my $key (@attribs){
	$labels{$key} = $message->{$key};
    }
   
    $cgi->delete("ldapaci"); 
    my $html ="";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$cgi->start_Tr();
    $html .=	    $cgi->start_td();
    $html .=	    $cgi->start_form(-action=>$confParam->{cgi_path}."/edit_useraci.pl",
				    -name=>"form");
    $html .=		$cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    if( $uid ne "" ){
        $html .=	    $cgi->Tr( $this->help_th(2,  $message->{'edit_aci_for_user'}.": $uid", "EDIT_USER_ACI") );
    }else{
        $html .=	    $cgi->Tr( $this->help_th(2,  $message->{'edit_aci_multiuser'}, "EDIT_USER_ACI") );
    }
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->td({-colspan=>2, -class=>'AdminSubHeader'},
				     $message->{'edit_aci_subtitle'} );
    $html .=		    $cgi->end_Tr();
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->start_td({-width => "40%"});
    $html .=			$cgi->end_td();
    $html .=			$cgi->start_td();
    $html .=			    $cgi->checkbox_group(-name => "ldapaci",
							-values => \@attribs,
							-labels => \%labels,
							-defaults => \@write_access,
							-linebreak => "true",
							-override => 1
							);
    $html .=			    "<br>".$cgi->checkbox(-name => "markall",
						-label => $message->{'edit_aci_select_all'},
						-onClick => "$javascript; toggleButtons('ldapaci')",
						);
    $html .=			$cgi->end_td();
    $html .=		    $cgi->end_Tr();
    $html .=		    $cgi->start_Tr();
    $html .=			$cgi->start_td({-colspan=>2, -align=>"center"});
    $html .=			    $cgi->hidden(-name => "sessionID",
						-value => $sessionID);
    $html .=			    $cgi->hidden(-name => "uid",
						-value => $uid);
    $html .=			    $cgi->hidden(-name => "tab",
						-value => $tab);
    $html .=			    $cgi->hidden(-name => "stab",
						-value => $stab);
    $html .=			    $cgi->hidden(-name => "filter",
						-value => $filter);
    $html .=			    $cgi->submit(-class=>"button",-name => "changeaci",
						-value => $message->{'update'});
    $html .=			$cgi->end_td();
    $html .=		    $cgi->end_Tr();
    $html .=		$cgi->end_table();
    $html .=	    $cgi->end_td();
    $html .=	$cgi->end_Tr();
    $html .= $cgi->end_table();
    
    $this->back_url("$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter\&filtered=1");
    $this->SUPER::display($html);
}

sub get_attributes_by_access(){
    my ($this, $right, $aci) = @_;
    my ($oid, $scope, $rights, $type, $subject) = split /#/, $aci;
    my @rights_arr = split /;/, $rights;
    my @attrs = ();
    my $action = shift(@rights_arr);
    #print STDERR "ACTION $action\n";
    if($type ne "self"){
	return ();
    }
    for( my $i=0; $i < scalar(@rights_arr); $i+=2){
	#print STDERR "rights: $rights_arr[$i]\n";
	if( $rights_arr[$i] =~ /w/ ){
	    push @attrs, (split /,/, lc($rights_arr[$i+1]) );
	}
	#print STDERR "target: $rights_arr[$i+1]\n";
    }
    #print STDERR "attrs: ". join(" ", @attrs)."\n";
    return @attrs;
}

sub update_aci{
    my $this = shift;
    my $session    = $this->{"session"};
    my $confParam  = $session->{"confParam"};
    my $sessionID  = $confParam->{"sessionID"};
    my $message    = ($session->getLanguage($confParam->{LANG},"EDIT_USER_ACI"))->data();

    my $cgi = $this->{"cgi"};
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    my $filter = $cgi->param('filter');
    #load list of users from session
    my $frozen = $confParam->{"usersToMod"};
    if( (! defined $frozen) || ($frozen eq "") ){
	$this->display_error($message->{'error_reading_session'},
	    	      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    $frozen = pack('H*',$frozen); # convert back to binary
    my $user_ref = thaw($frozen);     # melt down... :-)
    my @users    = @{$user_ref};
    my $uid = "";
    if( scalar(@users) == 1 ){
	$uid = $users[0];
    }
    my $errs ="";

    my @write_access = $cgi->param('ldapaci');
    if( grep /^cn$/, @write_access ){
	push @write_access, ("sn", "givenname");
    }
    #print STDERR "change attrs:". join( " ", @write_access)."\n";
    my $acistring = "";
    $acistring = "1#entry#grant;r,w,s,c;";
    $acistring .= join(",",@write_access);
    $acistring .= ";r,s,c;[all]#self#";
    
    my $bind_dn = "uid=".$confParam->{'uid'}.",".$confParam->{'baseDN'};

    my $ldap = Net::LDAP->new($confParam->{'LDAPserver'}, port => $confParam->{'LDAPport'}, version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$confParam->{'passwd'}"
			   );
    

    if($mesg->code != LDAP_SUCCESS) {
	$errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($mesg);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    $errs="";
    foreach my $user ( @users ){
        my $user_dn = "uid=$user".",".$confParam->{'baseDN'};
	if( $acistring ne ""){
	    $mesg = $ldap->modify($user_dn,
			    replace => {"openldapaci" => $acistring});
	}else{
	    $mesg = $ldap->modify($user_dn, delete => ["openldapaci"] );
	}
	if($mesg->code != LDAP_SUCCESS){
	    $errs .= "<font color=red>".$message->{'set_aci_failed'}.":  $user</font>\n";
	    $errs .= LDAPerror($mesg);
	}else{
	    $errs .= $message->{'set_aci_success'}.":  $user\n";
	}
    }
    $this->display_msg($errs,
   	    $confParam->{'cgi_path'}."/browse_user.pl?sessionID=$sessionID".
	    "&tab=$tab&stab=$stab&filter=$filter&filtered=1",2);
    exit;
	
}
1;
