#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: edit_vuser.pm,v 1.4 2003/10/29 10:35:39 varkoly Exp $
#
package edit_vuser;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use LDAPUtils;
use Display;
use Filterlist;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_VUSER"))->data();
    
    my $vedit = $cgi->param($message->{'vedit_edit'});
    my $vdelete = $cgi->param($message->{'vedit_delete'});
    my $vupdate = $cgi->param($message->{'vedit_update'});
    
    if( defined($vupdate) && ($vupdate ne "") ){
        $this->change_receivers();
    }elsif( (defined($vedit)) && ($vedit ne "") ){
        $this->edit();
    }elsif( (defined($vdelete)) && ($vdelete ne "") ){
        $this->del();
    }else{
        $this->browse();
    }
}

sub browse {
    my $this = shift;

    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_VUSER"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');

    #Do LDAP lookup
    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server",
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my $mesg;
    my @vaddress;
    $mesg = $ldap->bind ("uid=".$ADMINuid.",".$ldapbase, password=>$ADMINpasswd);
	if($mesg->code != 0) {
	    my $text .= "bind failed\n";
	    $text .=  &LDAPerror($mesg);
	    $this->display_error($text,
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    $mesg = $ldap->search(base=>"$confParam->{baseDN}",
                             scope  => "one",
                             attrs => ['vaddress'],
                             filter=>"(objectclass=SuSEVirtUserObject)"
                            );
    if( ($mesg->code == 0) && ($mesg->count!=0) ){
        my $uid;
        my $entry;
        my $cn;
        my %unique;

        for (my $i=0; $i < $mesg->count; $i++) {
            $entry = $mesg->entry($i);
            @vaddress = $entry->get_value("vaddress");
            my $temp;
            foreach $temp (@vaddress){
                $unique{$temp} = "$temp";
            }
            @vaddress = keys %unique;
        }
        @vaddress = sort @vaddress;
    }elsif( $mesg->code != 0){
         my $text .= "search failed\n";
         $text .=  &LDAPerror($mesg);
         $this->display_error($text,
               "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
         exit;
    }
    if(scalar(@vaddress) == 0){
	$this->display_msg($message->{'vedit_no_vemail'},
		$confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID&tab=$tab",3);
	exit;
    }
    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->start_Tr().
            $q->start_td().
		$q->start_form(-action=>$confParam->{cgi_path}."/edit_vuser.pl", -name=>"form").
		    $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"}).
                        $q->start_Tr().
                            $this->help_th(2, $message->{'vedit_title'},"EDIT_VUSER").
                        $q->end_Tr().
                        $q->start_Tr().
                             $q->td({-colspan => 2, -class=>'AdminSubHeader'},
                                $message->{'vedit_select_vuser'} 
                             ).
                        $q->end_Tr(). 
                        $q->start_Tr().
                            $q->td({-colspan => 2, -align=>'center'}, 
                                $q->scrolling_list(-name    => "vemail" ,
                                                   -values   => \@vaddress,
                                                   -size    => 10,
                                                   -width   => 30,
                                                   -multiple=> 0)
                                ).
                        $q->end_Tr().    
                        $q->start_Tr().
                            $q->td({-align=>"center", -width=> "50%"},
                               $q->submit(-class=>"button",-name=>$message->{'vedit_delete'})
                               ).
                            $q->td({-align=>"center", -width => "50%"},
                               $q->submit(-class=>"button",-name=>$message->{'vedit_edit'})
                               ).
                        $q->end_Tr().
                    $q->end_table().
                    $q->hidden(-name=>"sessionID", -value=>$sessionID).
                    $q->hidden(-name=>"tab", -value=>$tab).
                    $q->hidden(-name=>"stab", -value=>$stab).
	    	$q->end_form().
            $q->end_td().
        $q->end_Tr().
     $q->end_table();
    $this->SUPER::display($html);
}

sub del{
    my $this = shift;

    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_VUSER"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $vemail     = $q->param('vemail');
    my $really     = $q->param('really');

    if( (! defined($vemail)) || ($vemail eq "") ){
        $this->display_error($message->{'vedit_no_user_selected'},
              "$confParam->{cgi_path}/edit_vuser.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
        exit;
    }
    
    if( (defined($really)) && ($really ne "") ){
        #DO IT NOW
    
        my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
        if(!defined $ldap) {
            $this->display_error("can't contact LDAP Server",
                  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
        my $mesg = $ldap->bind ("uid=".$ADMINuid.",".$ldapbase, password=>$ADMINpasswd);
        if($mesg->code != 0) {
            my $text .= "bind failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
	my $maildomain="";
        $mesg = $ldap->search(base=>"uid=".$ADMINuid.",".$ldapbase,
                              scope  => "base",
                              attrs => ['maildomain'],
                              filter=>"(objectclass=*)"
                             );
        if ($mesg->code==0) {
            my $entry = $mesg->entry(0);
	    $maildomain = $entry->get_value("maildomain");
        }else{
            my $text .= "search failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }

	my $text = "";
        $mesg = $ldap->search(base=>$ldapbase,
                              scope  => "one",
                              attrs => ['vaddress', 'mail', 'uid'],
                              filter=>"(& (objectclass=SuSEVirtUserObject) (vaddress=$vemail))"
                             );
        if ($mesg->code==0) {
            my @entries = $mesg->entries();
            my @vaddress;
	    
            foreach my $entry (@entries){
		my @modifications = ();
		my $mail = $entry->get_value("mail");
		my $uid = $entry->get_value("uid");
		my %change_mail = ();
		if( $mail eq $vemail ){
		    push @modifications, "replace" => ['mail' => $uid."@".$maildomain];
		    $text .= "<br>".$message->{'vedit_mailattribute_of'}." $uid ".
				   $message->{'vedit_replace_with'}." ".$uid."@".$maildomain;
		}
                push @modifications, "delete" => ['vaddress' => $vemail]; 
                my $dn = $entry->dn();
                @vaddress = $entry->get_value("vaddress");
                if(scalar(@vaddress) == 1){
                    push @modifications, "delete" => [ 'objectClass' => 'SuSEVirtUserObject'];
                }
                $mesg = $ldap->modify( $dn, changes => \@modifications );
                if($mesg->code != 0){
                    my $text .= "modification failed\n";
                    $text .=  &LDAPerror($mesg);
                    $this->display_error($text,
                          "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
                    exit;
                }
            }
        }else{
            my $text .= "search failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
        $this->display_msg($message->{'vedit_the_vuser'}." <i>$vemail</i> ".$message->{'vedit_deleted'}.$text,
	
                       "$confParam->{cgi_path}/edit_vuser.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",3);

    }else{
        #Ask for confirmation
        my $html = "";
        $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
        $html .= $q->start_Tr().
                $q->start_td().
                $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"}).
                    $q->start_Tr().
                    $q->td({-class=>'AdminSubHeaderRed', -colspan=>2 },
                             "<b>$message->{vedit_delete_really}</b>"
                        ).
                    $q->end_Tr().
                    $q->start_Tr().
                    $q->start_td({-colspan=>2, -align=>"center"});
                        $html .= $message->{'vedit_should_vemail'}." ".$vemail." ".$message->{'vedit_really_delete'}.
                    $q->end_td().
                    $q->end_Tr().   
                    $q->start_Tr().
                    $q->td({-align=>"center"},
                        $q->start_form(-action=>$confParam->{cgi_path}."/edit_vuser.pl").
                            $q->submit(-class=>"button",-name=>$message->{'no'}).
                            $q->hidden(-name=>'sessionID', -value=>$sessionID).
                            $q->hidden(-name=>'tab', -value=>$tab).
                            $q->hidden(-name=>'stab', -value=>$stab).
                            $q->hidden(-name=>'vemail', -value=>$vemail).
                        $q->end_form()    
                    ).
                    $q->td({-align=>"center"},
                        $q->start_form(-action=>$confParam->{cgi_path}."/edit_vuser.pl").
                            $q->submit(-class=>"button",-name=>$message->{'yes'}).
                            $q->hidden(-name=>'sessionID', -value=>$sessionID).
                            $q->hidden(-name=>'tab', -value=>$tab).
                            $q->hidden(-name=>'stab', -value=>$stab).
                            $q->hidden(-name=>'really', -value=>1).
                            $q->hidden(-name=>$message->{'vedit_delete'}, -value=>1).
                            $q->hidden(-name=>'vemail', -value=>$vemail).
                        $q->end_form()    
                    ).
                    $q->end_Tr().
                $q->end_table().
                $q->end_td().
            $q->end_Tr().    
            $q->end_table();
        
        $this->SUPER::display($html);
    }
}

sub edit{
    my $this=shift;
    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_VUSER"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $filter     = $q->param('filter') || "*";
    $filter = LDAP_filter_escape($filter);
    my $vemail     = $q->param('vemail');

    if( (!(defined $vemail)) || ($vemail eq "") ){
        $this->display_error($message->{'vedit_no_email_selected'},
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID&tab=$tab&");
        exit;
    }
    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server",
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my $mesg = $ldap->bind ("uid=".$ADMINuid.",".$ldapbase, password=>$ADMINpasswd);
    if($mesg->code != 0) {
        my $text .= "bind failed\n";
        $text .=  &LDAPerror($mesg);
        $this->display_error($text,
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my $filterlist = Filterlist->new($q, $session, $ldap, $this);

    my $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->start_Tr();
    $html .=    $q->start_td();
    $html .=	    $q->start_form(-action=>$confParam->{cgi_path}."/edit_vuser.pl", -name=>"form");
    $html .=	    $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=            $q->start_Tr();
    $html .=                $this->help_th(3, $message->{'vedit_title'},"EDIT_VUSER");
    $html .=            $q->end_Tr();
    $html .=            $q->start_Tr();
    $html .=                $q->td({-colspan => 3, -class=>'AdminSubHeader'},
				    $message->{'vedit_select_receiver'}." ".$q->i($vemail)
				  );
    $html .=            $q->end_Tr(); 
    $html .=            $filterlist->make_filter_view({"textfield"    => "filter",
                                              "textlabel"    => $message->{'filter'},
                                              "listname"     => "uids",
                                              "listlabel_left" => $message->{'user'},
                                              "buttonlabel"  => $message->{'apply_filter'},
                                              "nofilter-msg" => $message->{'set_filter_first'},
                                              "listfilter"   => "(&(objectclass=posixAccount)(objectclass=SuSEeMailObject)(!(gidNumber=103))(|(sn=$filter)(givenname=$filter)(uid=$filter)))",
					      "listattrs"    => ['uid','cn'],
                                              "selectedfilter" => "(&(objectclass=posixAccount)(objectclass=SuSEeMailObject)(!(gidNumber=103))(|(sn=$filter)(givenname=$filter)(uid=$filter))(vaddress=$vemail))",
					      "selectedregex" => ['uid','(.*)'],
                                              "multiple"     => "MULTIPLE",
                                              "error-url"    => "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID",
                                              "labelexp"     => ["\$\$ ","uid","(\$\$) ","cn"],
                                              "width"        => "30",
                                              "height"       => "10"
                                             }
			);
    $html .=            $q->start_Tr().
                        $q->start_td({-colspan=>3, -align=>"center"}).
                           $q->submit(-class=>"button",-name=>"$message->{vedit_update}").
			   $q->hidden(-name=>'sessionID', -value=>$sessionID).
                           $q->hidden(-name=>'tab', -value=>$tab).
                           $q->hidden(-name=>'stab', -value=>$stab).
                           $q->hidden(-name=>'vemail', -value=>$vemail).
                           $q->hidden(-name=>$message->{'vedit_edit'}, -value=>1).
			$q->end_td().
                     $q->end_Tr().   
                $q->end_table().
		$q->end_form().
            $q->end_td().
        $q->end_Tr().
        $q->end_table();

    $this->SUPER::display($html);
}

sub change_receivers{
    my $this=shift;
    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"EDIT_VUSER"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $filter     = $q->param('filter');
    my $vemail     = $q->param('vemail');
    my @sel_uids   = $q->param('uids');

    if( !(defined $q->param('filtered')) ){
        $this->display_msg($message->{'vedit_set_filter'},
              "$confParam->{cgi_path}/edit_vuser.pl?sessionID=$sessionID&tab=$tab&stab=$stab&vemail=$vemail&$message->{'vedit_edit'}=1",3);
        exit;
    }

    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3);
    if(!defined $ldap) {
        $this->display_error("can't contact LDAP Server",
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my $mesg = $ldap->bind ("uid=".$ADMINuid.",".$ldapbase, password=>$ADMINpasswd);
    if($mesg->code != 0) {
        my $text .= "bind failed\n";
        $text .=  &LDAPerror($mesg);
        $this->display_error($text,
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    
    # Get the actual receivers for the virtual Account
    $mesg = $ldap->search( "base" => $ldapbase,
                           "scope" => "one",
                           "filter" => "(&(objectClass=posixAccount)(uid=$filter)(vaddress=$vemail))",
                           "attrs" => ['uid']
                          );
    if($mesg->code != 0) {
        my $text .= "search failed\n";
        $text .=  &LDAPerror($mesg);
        $this->display_error($text,
              "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }
    my @entries = $mesg->entries();
    my @act_uids;
    my %act_uids_hash;
    foreach my $entry (@entries){
        my $act_uid=$entry->get_value('uid');
        push @act_uids, $act_uid;
        $act_uids_hash{$act_uid} = 1;
    }
    # For all uids which are in $sel_uid (selected in scrolling list) but not in @act_uids we have to add 
    # the vemail to the LDAP entry of uid
    my @add_uids;
    foreach my $sel_uid (@sel_uids){
        if( ! (defined $act_uids_hash{$sel_uid}) ){
            push @add_uids, $sel_uid;
        }
    }

    # For all uids which are in @act_uids but not in @sel_uids, we have to delete
    # the vemail from the LDAP entry of uid
    my %sel_uids_hash;
    foreach my $sel_uid (@sel_uids){
        $sel_uids_hash{$sel_uid} = 1;
    }
    my @del_uids;
    foreach my $act_uid (@act_uids){
        if( ! (defined $sel_uids_hash{$act_uid} ) ){
            push @del_uids, $act_uid;
        }
    }
    if( (scalar(@add_uids) == 0) && (scalar(@del_uids) == 0) ){
        $this->display_msg($message->{'vedit_nothing_changed'},
                      "$confParam->{cgi_path}/edit_vuser.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",3);
        exit;
    }
    
    foreach my $uid (@add_uids){
        #check if user has objectClass SuSEVirtUserObject already
        my %mod = ( "vaddress" => $vemail);
        $mesg = $ldap->search( base => "uid=".$uid.",".$ldapbase,
                               scope => "base",
                               filter => "(objectClass=SuSEVirtUserObject)",
                               attrs => []
                             );
        if( ($mesg->code == 0) && ($mesg->count == 0) ){
            $mod{'objectClass'} = "SuSEVirtUserObject";
        }elsif( $mesg->code != 0 ){
            my $text .= "search failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
        $mesg = $ldap->modify( "uid=".$uid.",".$ldapbase ,
                               add => \%mod
                             );
        if( $mesg->code != 0 ){
            my $text .= "modification failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
    }
    foreach my $uid (@del_uids){
        my %mod = ( "vaddress" => $vemail );
        # Check if Objectclass=SuSEVirtUserObject has to be removed as well
        $mesg = $ldap->search( base => "uid=".$uid.",".$ldapbase,
                               scope => "base",
                               filter => "(objectClass=SuSEVirtUserObject)",
                               attrs => "vaddress"
                              );
        if( $mesg->code != 0 ){
            my $text .= "search failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }else{
            my $entry = $mesg->entry(0);
            my @v_addresses = $entry->get_value('vaddress');
            if( scalar(@v_addresses) == 1 ){
                $mod{'objectClass'} = "SuSEVirtUserObject";
            }
        }
        $mesg = $ldap->modify( "uid=".$uid.",".$ldapbase,
                                "delete" => \%mod
                             );   
        if( $mesg->code != 0 ){
            my $text .= "modification failed\n";
            $text .=  &LDAPerror($mesg);
            $this->display_error($text,
                      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            exit;
        }
    }
    $this->display_msg($message->{'vedit_changed'},
                      "$confParam->{cgi_path}/edit_vuser.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",3);
}
1;
