#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: expert_postfix.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#
package expert_postfix;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use cfreader;
use strict;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $button_width = 150;


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit      = $cgi->param('doit');
    my $reset     = $cgi->param('reset');
    my $add       = $cgi->param('add');
    my $add_sel   = $cgi->param('add_sel');
    my $add_these = $cgi->param('add_these');
    my $yesb      = $cgi->param('yesb');
    
    if(defined $doit) {
	$this->modify();
    } elsif( defined $add ){
	$this->add_param();
    } elsif( defined $add_sel ){
	$this->edit_param();
    } elsif( defined $add_these ){
	$this->add_these();
    } elsif( defined $reset ){
	$this->confirm_restore();
    } elsif( defined $yesb && $yesb ne "" ){
	$this->restore();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $html = "";
    my $inbetween = "";

    my $cf = "/etc/postfix/main.cf";
    
    my $cfr = new cfreader("=");
    
    my $com = $cfr->getCommands("/usr/sbin/postconf");
    if( ! defined $com ) {
	$this->display_error($message->{postfix_exp_no_commands},
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    if( ! open(IN, "< $cf") ) {
	$this->display_error("$message->{postfix_exp_not_readable} $cf: $?",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = <IN>;
    chomp(@raw);
    close(IN);
    
    #my $start = (times)[0];
    my $r = $cfr->CF2HASH(\@raw, $com);
    #my $delta = (times)[0] - $start;

    #print STDERR "Zeit=$delta\n";

    # store data into session
    my $msg = $session->save_store2session("$cf", $cf, $r);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{postfix_file_modified},
				 "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg-code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    
    my $nr_display = $q->param('ndisp') || 4;
    my $mark = $q->param('mark') || 0;
    my $i;
    my $cnt = 0;
    my $ac = $cfr->getAllArray($r);
    my $nr = @$ac;

    if( defined $q->param('prev.x') ) {
	$i = ( $mark >= 2*$nr_display ? $mark - 2*$nr_display : 0 );
    } elsif( defined $q->param('first.x') ) {
	$i = 0;
    } elsif( defined $q->param('next.x') ) {
	$i = $mark;
    } elsif( defined $q->param('last.x') ) {
	$i = $nr_display * int($nr / $nr_display);
    } else {
	$i = $mark;
    }
    
    my $search = $q->param('searchfor') || "";
    if( $search ne "" ) {
	my $c = 0;
	for($c=0; $c < @$ac; $c++ ) {
	    if( $ac->[$c]->{cmd} =~ /$search/ ) {
		$i = $c;
		last;
	    }
	}
	if( $c == $nr ) { # nothing found
	    $search = "NOT FOUND";
	}
    }

    for(; $cnt < $nr_display; $i++ ) {
	
	last if $i == $nr;

	if( $ac->[$i]->{status} eq "CMD" ) {
	    # these are regular commands
	    if( $ac->[$i]->{multi} ) {
		# this is a multiline value
		$inbetween .=  $q->Tr(
				      $q->td(
					     "<b>".
					     $ac->[$i]->{cmd}.":&nbsp;</b>"
					     ),
				      $q->td(
					     $q->textarea(-name=>$ac->[$i]->{cmd},
							  -value=>$ac->[$i]->{value},
							  -rows=>$ac->[$i]->{multi}+1,
							  -columns=>50)
					     )
				      );
	    } else {
		$inbetween .= $q->Tr(
				     $q->td(
					    "<b>".
					    $ac->[$i]->{cmd}.":&nbsp;</b>"
					    ),
				     $q->td(
					    $q->textfield(-name=>$ac->[$i]->{cmd},
							  -value=>$ac->[$i]->{value},
							  -size=>50)."<br>".
					    $q->checkbox(-name=>"CB_".$ac->[$i]->{cmd},
							 -label=>" $message->{postfix_exp_comment}",
							 -value=>"selected").
					    "<font color='red'>".
					    $q->checkbox(-name=>"DCB_".$ac->[$i]->{cmd},
							 -label=>" $message->{postfix_exp_remove}",
							 -value=>"selected")."</font><br>"
					    )
				     );
	    }
	} elsif( $ac->[$i]->{status} eq "C_CMD" ) {
	    # these are commented commands
	    $inbetween .= $q->Tr(
				 $q->td({-class=>'list-dark'},
					"<b>".
					$ac->[$i]->{cmd}.":&nbsp;</b>"
					),
				 $q->td({-class=>'list-dark'},
					$q->textfield(-name=>$ac->[$i]->{cmd},
						      -value=>$ac->[$i]->{value},
						      -size=>50)."<br>".
					$q->checkbox(-name=>"CB_".$ac->[$i]->{cmd},
						     #-checked=>"checked",
						     -label=>" $message->{postfix_exp_uncomment}",
						     -value=>"selected").
					"<font color='red'>".
					$q->checkbox(-name=>"DCB_".$ac->[$i]->{cmd},
						     -label=>" $message->{postfix_exp_remove}",
						     -value=>"selected"), "</font><br>",
					)
				 
				 );
	}
	$cnt++;
    }
    $mark = $i;

    
    my $navi = $q->start_table({-cellspacing=>0, -cellpadding=>3,
				-width=>"100%"});
    $navi .= $q->start_multipart_form(-method=>"get",
		    -action=>$confParam->{cgi_path}."/expert_postfix.pl");
    $navi .= $q->Tr(
		    $q->td({-align=>"center"},
			   $q->td({-align=>"center", -width=>"10%"},
				  $q->image_button(-name=>"first",
						   -src=>"$confParam->{image_path}/arrow_first.gif",
						   -align=>'MIDDLE',
						   -border=>0
						   )
				  ),
			   $q->td({-align=>"center", -width=>"10%"},
				  $q->image_button(-name=>"prev",
						   -src=>"$confParam->{image_path}/arrow_prev.gif",
						   -align=>'MIDDLE',
						   -border=>0
						   )
				  ),
			   $q->td({-align=>"center", -width=>"60%"},
				  "$message->{postfix_exp_nrrows}: ".
				  $q->textfield(-name=>"ndisp",
						-value=>$nr_display,
						-size=>3),
				  ),
			   $q->td({-align=>"center", -width=>"10%"},
				  $q->image_button(-name=>"next",
					      -src=>"$confParam->{image_path}/arrow_next.gif",
					      -align=>'MIDDLE',
					      -border=>0
					      )
				  ),
			   $q->td({-align=>"center", -width=>"10%"},
				  $q->image_button(-name=>"last",
						   -src=>"$confParam->{image_path}/arrow_last.gif",
						   -align=>'MIDDLE',
						   -border=>0
						   ).
				  $q->hidden(-name=>"sessionID", -value=>"$sessionID").
				  $q->hidden(-name=>"mark", -value=>"$mark", -override=>1).
				  $q->hidden(-name=>"tab", -value=>"$tab").
				  $q->hidden(-name=>"stab", -value=>"$stab")
				  )
			   )
		    );
    $navi .=	$q->start_Tr();
    $navi .=	    $q->start_td({-align => "center", -colspan => 6});
    $navi .=		"$message->{postfix_exp_search} ";
    $navi .=		$q->textfield(-name=>"searchfor",
				-value=>$search,
				-override=>1,
				-size=>20);
    $navi .=	    $q->end_td();
    $navi .=	$q->end_Tr();
    $navi .=   $q->end_form();
    $navi .= $q->end_table();
    
    
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $this->help_th(2, $message->{postfix_exp_head},
							    "POSTFIX_EXPERT"),
					     $q->td({-colspan=>2,
						     -class=>'AdminSubHeaderRed'},
						    $message->{postfix_exp_warn}.
						    "<br><a href=/doc/postfix/html/basic.html target=pfmanual>$message->{postfix_exp_olink}</a>")
					     ]
					    ),
				     $q->Tr(
					    $q->td({-colspan=>2, -align=>"center"},
						   $navi
						   )
					    ),
				     $q->Tr(
					    $q->start_multipart_form(-method=>"get",
								     -action=>$confParam->{cgi_path}."/expert_postfix.pl"),
					    $q->td({-colspan=>2, -align=>"center"},
						   $q->submit(-class=>"button",-name=>'add',
							      -width=>$button_width,
							      -value=>$message->{postfix_exp_add}).
						   $q->hidden(-name=>"sessionID", -value=>$sessionID).
						   $q->hidden(-name=>"tab", -value=>$tab).
						   $q->hidden(-name=>"stab", -value=>$stab)
						   ),
					    $q->end_form()
					    ),
				     $q->start_multipart_form(-method=>"get",
							      -action=>$confParam->{cgi_path}."/expert_postfix.pl"),
#
#  insert the above generated html code here:
#
				     $inbetween,


				     $q->td({-colspan=>2, -align=>"center"},
					    $q->start_table({-cellspacing=>0, -cellpadding=>0, -width=>"100%"}),
					    $q->td({},
						   $q->Tr(
							  $q->td({-align=>"center", -width=>"80%"},
								 $q->submit(-class=>"button",-name=>'doit',
									    -width=>$button_width,
									    -value=>$message->{postfix_doit}),
								 $q->hidden(-name=>"sessionID", -value=>$sessionID),
								 $q->hidden(-name=>"mark", -value=>"$mark", -override=>1),
								 $q->hidden(-name=>"ndisp", -value=>"$nr_display", -override=>1),
								 $q->hidden(-name=>"tab", -value=>$tab),
								 $q->hidden(-name=>"stab", -value=>$stab)
								 ),
							  $q->end_form(),
							  $q->start_form(-method=>"get",
									 -action=>$confParam->{cgi_path}."/expert_postfix.pl"),
							  $q->td({-align=>"right", -width=>"20%"},
								 $q->submit(-class=>"button",-name=>'reset',
									    #-width=>$button_width,
									    -value=>"$message->{postfix_exp_restore}"),
								 $q->hidden(-name=>"sessionID", -value=>$sessionID),
								 $q->hidden(-name=>"tab", -value=>$tab),
								 $q->hidden(-name=>"stab", -value=>$stab)
								 ),
							  $q->end_form()
							  )
						   ),
					    $q->end_table()
					    )
				     )
			   )
		    );
    
    $html .= $q->end_table();
    
    $this->SUPER::display($html);
}

sub add_param {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $list;
    my $html = "";
    my $cf = "/etc/postfix/main.cf";
    
    my $msg = $session->save_read2session("$cf", $cf);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{postfix_file_modified},
				 "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg-code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    
    my $r = $msg->data();

    my $cfr = new cfreader("=");

    # get all used keys
    my $all = $cfr->getAllCMD($r);

    my $com = $cfr->getCommands("/usr/sbin/postconf");
    if( ! defined $com ) {
	$this->display_error($message->{postfix_exp_no_commands},
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    # only unused commands may be added
    foreach my $c (@$com) {
	if( ! defined $all->{$c} ) {
	    push @$list, $c;
	}
    }

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr({},[
					    $q->td({-class=>'AdminHeader', -height => 35},
						   "<b>$message->{postfix_exp_choose}</b>"),
					    $q->td({-class=>'AdminSubHeader'},
						   "$message->{postfix_exp_choose}")
					    ]),
				     $q->Tr(
					    [
					     $q->start_multipart_form(-method=>"get",
								      -action=>$confParam->{cgi_path}."/expert_postfix.pl"),
					     $q->td({-align=>"center"},
						    $q->scrolling_list(-name=>'commands',
								       -value=>$list,
								       -multiple=>'true',
								       -size=>20)),
					     $q->td({-align=>"center"},
						    $q->submit(-class=>"button",-name=>'add_sel',
							       -width=>$button_width,
							       -value=>$message->{postfix_exp_edit}),
						    $q->hidden(-name=>"sessionID", -value=>$sessionID),
						    $q->hidden(-name=>"tab", -value=>$tab),
						    $q->hidden(-name=>"stab", -value=>$stab)
						    ),
					     $q->end_form()
					     ]
					    )
				     )
			   )
		    );
    
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub edit_param {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $html = "";
    my $inbetween = "";
    my @selected = $q->param('commands');
    if( ! defined $selected[0] ) {
	$this->display_error($message->{postfix_exp_err_noparm},
			     "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&add=foo");
	exit;
    }

    # get defaults from postconf
    my $plist = join(" ", @selected);
    open(IN, "/usr/sbin/postconf $plist|");
    my @kvlist = <IN>;
    close(IN);
    chomp(@kvlist);
    my $ph;
    foreach my $k ( @kvlist ) {
	$k =~ /(.*)\s+=\s+(.*)/;
	$ph->{$1} = $2;
    }

    foreach my $sel ( @selected ) {
	$inbetween .= $q->Tr({},
			     $q->td(
				    "<b>$sel</font></b><br>",
				    $q->textfield(-name=>"NEW_PARAM".$sel,
						  -value=>$ph->{$sel},
						  -size=>50)
				    
				    )
			     );
    }
    
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $q->td({-class=>'AdminSubHeader'},
						    "<b>$message->{postfix_exp_entervalues}</b>"),
					     #$q->td({-bgcolor=>$Display::__yellow, -align=>"center", -height => "25"},
						#    $message->{postfix_exp_help})
					     ]
					    ),
				     $q->start_multipart_form(-method=>"get",
							      -action=>$confParam->{cgi_path}."/expert_postfix.pl"),
#
# Insert code from above
#
				     $inbetween,
				     $q->Tr(
					    $q->td({-align=>"center"},
						   $q->submit(-class=>"button",-name=>'add_these',
							      -width=>$button_width,
							      -value=>$message->{postfix_doit}),
						   $q->hidden(-name=>"sessionID", -value=>$sessionID),
						   $q->hidden(-name=>"tab", -value=>$tab),
						   $q->hidden(-name=>"stab", -value=>$stab)
						   )
					    ),
				     $q->end_form()
				     )
			   )
		    );

    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub add_these {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $cf = "/etc/postfix/main.cf";
    
    my $msg = $session->save_read2session("$cf", $cf);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{postfix_file_modified},
				 "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $r = $msg->data();

    my @allp = $q->param();

    foreach my $p (@allp) {
	if( $p =~ /^NEW_PARAM/ ) {
	    my $value = $q->param($p);
	    $p =~ s/NEW_PARAM//;
	    #print STDERR "$p = $value\n";

	    push @$r, {
		status => "CMD",
		cmd => $p,
		value => $value,
		multi => 0 };
	}
    }

    my $cfr = new cfreader("=");

    my $ar = $cfr->HASH2CF($r);

    my $ret = $session->suad_save($ar, $cf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $ret = $session->suad_exec("pfreload");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("$cf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    
    $this->display_msg($cf.": ".$message->{postfix_saved_ok},
		       "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       1);
}

sub confirm_restore {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $html = "";

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->start_multipart_form(-method=>"get",
							      -action=>$confParam->{cgi_path}."/expert_postfix.pl"),
				     $q->start_center(),
				     $q->Tr(
					    [
					     $q->Tr({},
						    $q->td({-valign=>"TOP", -class=>'AdminHeader'
							    -colspan=>2}, 
							   "$message->{postfix_exp_confirm_restore_head}")
						    ),
					     $q->td({-colspan=>2,
						     -class=>'AdminSubHeaderRed'},
						    $message->{postfix_exp_confirm_restore}),
					     ]),
				     $q->Tr(
					    $q->td({-align=>"center"},
						   $q->submit(-class=>"button",-name=>"yesb",
							      -value=>"$message->{yes}",
							      -width=>$button_width) ),
					    $q->td({-align=>"center"},
						   $q->submit(-class=>"button",-name=>"nob",
							      -value=>"$message->{no}",
							      -width=>$button_width),
						   $q->hidden(-name=>'sessionID', -value=>$sessionID),
						   $q->hidden(-name=>"tab", -value=>$tab),
						   $q->hidden(-name=>"stab", -value=>$stab)
						   )
					    ),
				     $q->end_center(),
				     $q->end_form()
				     )
			   )
		    );
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub restore {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');

    # This function is dedicated to our support team... :-)
    my $bak = "/var/adm/backup/main.cf.bak";
    my $cf  = "/etc/postfix/main.cf";

    my $ret = $this->{session}->suad_copy($bak, $cf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    $this->{session}->suad_exec("pfreload");

    $this->display_msg($message->{postfix_exp_restoreok},
		       "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       2);
}

sub modify {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $cf = "/etc/postfix/main.cf";
    
    my $msg = $session->save_read2session("$cf", $cf);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{postfix_file_modified},
				 "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $rr = $msg->data();

    my $cfr = new cfreader("=");

    my $ar = $cfr->getAllArray($rr);

    my $total = $q->param('mark');
    my $nr_display = $q->param('ndisp');


    my $cnt = 0;
    for(my $i = $total - $nr_display; $i<$total; $i++) {
	
	if( defined $q->param("DCB_".$ar->[$i]->{cmd}) ) {
	    # we want to delete this parameter
	    $ar->[$i] = undef;
	    next;
	}
	$ar->[$i]->{status} =
	    ( defined $q->param("CB_".$ar->[$i]->{cmd}) ? 
	      ( $ar->[$i]->{status} eq "CMD" ? "C_CMD" : "CMD" ) : $ar->[$i]->{status} );
	$ar->[$i]->{value} = 
	    ( defined $q->param($ar->[$i]->{cmd}) ? $q->param($ar->[$i]->{cmd}) : "" );
	# print STDERR "CB=".$q->param("CB_".$r->{$_}->{cmd})."\n";
	$ar->[$i]->{value} =~ s/\r//g; # remove \r
    }

    $cfr->setAllArray($ar, $rr);

    my $sar = $cfr->HASH2CF($rr);

    my $ret = $session->suad_save($sar, $cf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $ret = $session->suad_exec("pfreload");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $ret = $session->suad_exec("fetchdreload");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("$cf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $mark = $total - $nr_display;

    $this->display_msg($cf.": ".$message->{postfix_saved_ok},
		       "$confParam->{cgi_path}/expert_postfix.pl?sessionID=$sessionID\&mark=$mark\&ndisp=$nr_display\&tab=$tab\&stab=$stab",
		       1);
    
}

1;
