#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: fetch_mail.pm,v 1.2 2003/05/06 11:30:44 varkoly Exp $
#
package fetch_mail;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Display;
use Socket;
use Storable qw(thaw freeze);
use Digest::MD5  qw(md5_hex);
use fetchd::FetchEntry;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi    = $this->{"cgi"};
    my $entry  = $cgi->param('entry');
    my $edit   = $cgi->param('edit');
    my $delete = $cgi->param('delete');
    my $save   = $cgi->param('save');
    my $new    = $cgi->param('new');
    my $stat   = $cgi->param('stat');

    my $fetchall = $cgi->param('fetchall');
    
    if( ( defined $edit && $edit ne "" ) &&
	( defined $entry && $entry ne "" ) ) {
	$this->edit();
    } elsif( defined $new && $new ne "" ) {
	$this->edit();
    } elsif( defined $fetchall && $fetchall ne "" ) {
	$this->fetchall();
    } elsif( defined $delete && $delete ne "" ) {
	$this->delete();
    } elsif( defined $save && $save ne "" ) {
	$this->save();
    } elsif( defined $stat && $stat ne "" ) {
	$this->stat();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $button_width = 150;

    $this->fetchJobs();
    
    my $entries;

    $entries .= $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $entries .= $cgi->Tr(
			 $cgi->td(
				  [
				   "<b>$message->{fetchmail_userhost}</b>",
				   "<b>$message->{fetchmail_proto}</b>",
				   "<b>$message->{fetchmail_destaddr}</b>",
				   "&nbsp"
				   ]
				  )
			 );
    $entries .= $cgi->Tr({},
			 $cgi->td({-colspan=>5},
				  $cgi->hr({-with=>"100%"})
				  )
			 );
    
    foreach my $ef ( @{$this->{"jobs"}} ) {
	my $eh = $ef->get();
	$entries .= $cgi->Tr({},
			     $cgi->td(
				      "$eh->{user}\@$eh->{host}"
				      ),
			     $cgi->td(
				      "$eh->{proto}"
				      ),
			     $cgi->td(
				      "$eh->{localaddr}"
				      ),
			     $cgi->start_form(-action=>$confParam->{cgi_path}."/fetch_mail.pl"),
			     $cgi->td({-align=>"center"},
				      $cgi->submit(-class=>"button",-name=>"stat", -value=>"$message->{fetchmail_test}").
				      $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
				      $cgi->hidden(-name=>"tab", -value=>$tab).
				      $cgi->hidden(-name=>"stab", -value=>$stab).
				      $cgi->hidden(-name=>"entry",-value=>"$eh->{id}")
				      ),
			     $cgi->end_form(),
			     $cgi->start_form(-action=>$confParam->{cgi_path}."/fetch_mail.pl"),
			     $cgi->td({-align=>"center"},
				      $cgi->submit(-class=>"button",-name=>"edit", -value=>"$message->{fetchmail_edit}").
				      $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
				      $cgi->hidden(-name=>"tab", -value=>$tab).
				      $cgi->hidden(-name=>"stab", -value=>$stab).
				      $cgi->hidden(-name=>"entry",-value=>"$eh->{id}")
				      ),
			     $cgi->end_form()
			     );
	$entries .= $cgi->end_Tr();
    }

    if( ! defined @{$this->{jobs}} ) {
	$entries .= $cgi->Tr({},
			     $cgi->td({-colspan=>5},
				      "<i>$message->{fetchmail_emptylist}</i>"
				      )
			     );
    } else {
	$entries .= $cgi->Tr({},
			     $cgi->start_form(-action=>$confParam->{cgi_path}."/fetch_mail.pl"),
			     $cgi->td({-colspan=>5, -align=>"center"},
				      $cgi->submit(-class=>"button",-name=>"fetchall",
						   -value=>"$message->{fetchmail_fetchnow}").
				      $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
				      $cgi->hidden(-name=>"tab", -value=>$tab).
				      $cgi->hidden(-name=>"stab", -value=>$stab)
				      ),
			     $cgi->end_form()
			     );
    }

    $entries .= $cgi->Tr({},
			 $cgi->td({-colspan=>5},
				  $cgi->hr({-with=>"100%"})
				  )
			 );
    $entries .= $cgi->end_table();

    my $html = "";

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->Tr({},
		      $cgi->td({},
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->Tr(
						    $this->help_th(1, $message->{fetchmail_main_head},
								   "FETCHMAIL_START")
						    ),
					   $cgi->Tr(
						    $cgi->td({-class=>'AdminSubHeader'},
							     $message->{fetchmail_list_of})
						    ),
					   $cgi->Tr(
						    $cgi->td({
							      -align=>"center"},
							     $entries,
							     )
						    ),
					   $cgi->start_form(-action=>$confParam->{cgi_path}."/fetch_mail.pl"),
					   $cgi->Tr(
						    $cgi->td({
							      -align=>"center"},
							     $cgi->submit(-class=>"button",-name=>"new",
									  -value=>"$message->{fetchmail_new}").
							     $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
							     $cgi->hidden(-name=>"tab", -value=>$tab).
							     $cgi->hidden(-name=>"stab", -value=>$stab)
							     )
						    ),
					   $cgi->end_form
					   )
			       )
		      );
    $html .= $cgi->end_table();

    $this->SUPER::display($html);
}

sub fetchall {
    my $this = shift;
            
    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    
    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');

    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $socket = "/var/run/fetchd.sock";
    my $ret;

    if( ! socket(SOCK, PF_UNIX, SOCK_STREAM,0) ) { # || die("ERROR: socket: $!");
	$this->display_error("ERROR: socket: $!",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }
    if( ! connect(SOCK, sockaddr_un($socket)) ) { # || die("ERROR: connect: $!");
	$this->display_error("ERROR: connect: $!",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }
    print SOCK "fetchallnow\n";
    print SOCK "$ADMINuid\n";
    print SOCK "$ADMINpasswd\n";
    print SOCK "\0\n";
    SOCK->flush();
    while( <SOCK> ) {
	$ret .= $_;
	last if $_ =~ /\0/;
    }
    $ret =~ s/\0//;
    close(SOCK);

    if( $ret =~ /^OK:\s+(.*)/ms ) {
	$this->display_msg($1,
			   "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
    } else {
	$ret =~ s/</&lt;/g;
	$ret =~ s/>/&gt;/g;
	$this->display_error($ret,
			     "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab");
    }
}

sub stat {
    my $this = shift;
            
    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    
    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $entry   = $cgi->param('entry');
    my $edit    = $cgi->param('edit');
    my $new     = $cgi->param('new') || 0;

    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $socket = "/var/run/fetchd.sock";
    my $ret;

    $this->fetchJobs();

    foreach my $ef ( @{$this->{"jobs"}} ) {
	my $eh = $ef->get();
	if( $eh->{id} eq $entry ) {
	    my $feh = freeze($ef);
	    $feh = unpack('H*', $feh);
	    if( ! socket(SOCK, PF_UNIX, SOCK_STREAM,0) ) { # || die("ERROR: socket: $!");
		$this->display_error("ERROR: socket: $!",
				     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
		exit;
	    }
	    if( ! connect(SOCK, sockaddr_un($socket)) ) { # || die("ERROR: connect: $!");
		$this->display_error("ERROR: connect: $!",
				     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
		exit;
	    }
	    print SOCK "statentry\n";
	    print SOCK "$ADMINuid\n";
	    print SOCK "$ADMINpasswd\n";
	    print SOCK "$feh\n";
	    print SOCK "\0\n";
	    SOCK->flush();
	    while( <SOCK> ) {
		$ret .= $_;
		last if $_ =~ /\0/;
	    }
	    close(SOCK);
	    $ret =~ s/\0//;
	}
    }
    if( $ret =~ /^OK:\s+(.*)/ms ) {
	$this->display_msg($1,
			   "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
    } else {
	$ret =~ s/</&lt;/g;
	$ret =~ s/>/&gt;/g;
	$this->display_error($ret,
			     "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
    }
}

sub edit {
    my $this = shift;
            
    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    
    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $entry   = $cgi->param('entry');
    my $edit    = $cgi->param('edit');
    my $new     = $cgi->param('new') || 0;

    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $button_width = 150;

    my $darr = [
		$message->{fetchmail_mo},
		$message->{fetchmail_di},
		$message->{fetchmail_mi},
		$message->{fetchmail_do},
		$message->{fetchmail_fr},
		$message->{fetchmail_sa},
		$message->{fetchmail_so}
		];
    my $harr;
    for(my $i=0; $i<24; $i++ ) {
	push @$harr, $i;
    }
    
    my $te;
    
    if( ! $new ) {
	$this->fetchJobs();
	foreach my $ef ( @{$this->{"jobs"}} ) {
	    my $eh = $ef->get();
	    if( $eh->{id} eq $entry ) {
		$te = $eh;
	    }
	}
    } else {
	my $rand = rand((time)*$$);
	my $id = md5_hex($rand.$sessionID);

	$te = { 
		id => $id,
		host => "",
		user => "",
		passwd => "",
		localaddr => "",
		proto => "pop",
		multidrop => 0,
		weekdays => [ 1, 2, 3, 4, 5 ],
		timetable => [8, 18, 5],
		qmailprefix => ""
		};
    }
    
    my $dselected;
    foreach my $d ( @{$te->{weekdays}} ) {
	push @$dselected, $darr->[$d-1];
    }
    
    my $fdefault = $harr->[($te->{timetable}->[0])];
    my $tdefault = $harr->[($te->{timetable}->[1])];
    
    my $html;
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->Tr({},
		      $cgi->td({},
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->Tr(
						    $this->help_th(2, $message->{fetchmail_main_edit},
								   "FETCHMAIL_NEW")
						    ),
					   $cgi->Tr(
						    $cgi->td({-colspan=>2, -class=>'AdminSubHeader'},
							     $message->{fetchmail_be_careful})
						    ),
					   $cgi->start_form(-action=>$confParam->{cgi_path}."/fetch_mail.pl"),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_server}",
							      $cgi->textfield(-name=>"host",
									      -value=>$te->{host},
									      -size=>50)
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_user}",
							      $cgi->textfield(-name=>"user",
									      -value=>$te->{user},
									      -size=>50)
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_passwd}",
							      $cgi->password_field(-name=>"password1",
										   -value=>$te->{passwd},
										   -size=>50)
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_passwd_reenter}",
							      $cgi->password_field(-name=>"password2",
										   -value=>$te->{passwd},
										   -size=>50)
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_recipient}",
							      $cgi->textfield(-name=>"localaddr",
									      -value=>$te->{localaddr},
									      -size=>50)
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_qmailprefix}",
							      $cgi->textfield(-name=>"qmailprefix",
									      -value=>$te->{qmailprefix},
									      -size=>50)
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_protocol}",
							      $cgi->popup_menu(-name=>"proto",
									       -value=>[ "pop", "imap" ],
									       -default=>$te->{proto})
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_multidrop}",
							      $cgi->checkbox(-name=>"multidrop",
									     -checked=>( $te->{multidrop} ?
											 "checked" : "" ))
							      ]
							     )
						    ),
					   $cgi->Tr(
						    $cgi->td(
							      "$message->{fetchmail_weekdays}"
							     ),
						    $cgi->td(
							     $cgi->checkbox_group(-name=>'weekdays',
										  -values=>$darr,
										  -defaults=>$dselected)
							     )
						    ),
					   $cgi->start_Tr(),
					   $cgi->start_td({-colspan=>2
							   }),
					   $cgi->start_table({-border=>0, -cellspacing=>0, -cellpadding=>0,
							      -width=>"100%"}),
					   $cgi->Tr(
						    $cgi->td(
							     [
							      "$message->{fetchmail_from}",
							      $cgi->popup_menu(-name=>"from",
									       -value=>$harr,
									       -default=>$fdefault).
							      "$message->{fetchmail_hour}",
							      "$message->{fetchmail_to}",
							      $cgi->popup_menu(-name=>"to",
									       -value=>$harr,
									       -default=>$tdefault).
							      "$message->{fetchmail_hour}",
							      "$message->{fetchmail_all}",
							      $cgi->textfield(-name=>"interval",
									      -value=>$te->{timetable}->[2],
									      -size=>3).
							      "$message->{fetchmail_minutes}"
							      ]
							     )
						    ),
					   $cgi->end_table,
					   $cgi->end_td,
					   $cgi->end_Tr,
					   $cgi->Tr(
						    $cgi->td(
							     $cgi->submit(-class=>"button",-name=>"save",
									  -value=>"$message->{fetchmail_save}").
							     $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
							     $cgi->hidden(-name=>"tab", -value=>$tab).
							     $cgi->hidden(-name=>"stab", -value=>$stab).
							     $cgi->hidden(-name=>"entry",-value=>"$te->{id}").
							     $cgi->hidden(-name=>"isnew",-value=>"$new").
							     $cgi->end_form
							     ),
						    $cgi->td({-align=>"center"},
							     $cgi->start_form(-action=>$confParam->{cgi_path}."/fetch_mail.pl"),
							     $cgi->submit(-class=>"button",-name=>"delete",
									  -value=>"$message->{fetchmail_delete}").
							     $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
							     $cgi->hidden(-name=>"tab", -value=>$tab).
							     $cgi->hidden(-name=>"stab", -value=>$stab).
							     $cgi->hidden(-name=>"entry",-value=>"$te->{id}").
							     $cgi->end_form
							     )
						    )
					   )
			       )
		      );
    $html .= $cgi->end_table();
    
    $this->SUPER::display($html);
}

sub delete {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    
    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $entry   = $cgi->param('entry');
    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();
    
    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    $this->fetchJobs();
    
    my $socket = "/var/run/fetchd.sock";

    my $ret;
    foreach my $ef ( @{$this->{"jobs"}} ) {
	my $eh = $ef->get();
	if( $eh->{id} eq $entry ) {
	    my $feh = freeze($ef);
	    $feh = unpack('H*', $feh);
	    if( ! socket(SOCK, PF_UNIX, SOCK_STREAM,0) ) { # || die("ERROR: socket: $!");
		$this->display_error("ERROR: socket: $!",
				     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
		exit;
	    }
	    if( ! connect(SOCK, sockaddr_un($socket)) ) { # || die("ERROR: connect: $!");
		$this->display_error("ERROR: connect: $!",
				     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
		exit;
	    }
	    print SOCK "removeentry\n";
	    print SOCK "$ADMINuid\n";
	    print SOCK "$ADMINpasswd\n";
	    print SOCK "$feh\n";
	    print SOCK "\0\n";
	    SOCK->flush();
	    $ret = <SOCK>;
	    close(SOCK);
	    $ret =~ s/\0//;
	}
    }
    if( $ret =~ /^OK/ ) {
	$this->display_msg($message->{fetchmail_job_deleted},
			   "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			   1);
    } else {
	$this->display_error($ret,
			     "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab",
			     3);
    }
}

sub save {
    my $this = shift;
    
    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    
    my $tab         = $cgi->param('tab');
    my $stab        = $cgi->param('stab');
    my $entry       = $cgi->param('entry');
    my $host        = $cgi->param('host');
    my $user        = $cgi->param('user');
    my $pass1       = $cgi->param('password1');
    my $pass2       = $cgi->param('password2');
    my $localaddr   = $cgi->param('localaddr');
    my $qmailprefix = $cgi->param('qmailprefix') || "";
    my $proto       = $cgi->param('proto');
    my $interval    = $cgi->param('interval');

    my $isnew = $cgi->param('isnew');

    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};

    my $err_url = "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";
    if( $isnew ) {
	$err_url .= "\&new=$isnew";
    } else {
	$err_url .= "\&edit=1\&entry=$entry";
    }

#    if( length($pass1) < 5 ) {
#	$this->display_error($message->{fetchmail_pass2short}, $err_url, 3);
#	exit;
#    }
    if( $pass1 ne $pass2 ) {
	$this->display_error($message->{fetchmail_passnotequal}, $err_url, 3);
	exit;
    }

    my $multidrop = ( defined $cgi->param('multidrop') ? 1 : 0 );
    if( $multidrop && $proto ne "pop" ) {
	$this->display_error($message->{fetchmail_multidrop_pop}, $err_url, 3);
	exit;
    }

    if( ! defined $host || $host eq "" ||
	! defined $user || $user eq "" ||
	( $multidrop ? 0 : ( ! defined $localaddr || $localaddr eq "" ) ) ||
	! defined $proto || $proto eq "" ||
	! defined $interval || $interval eq "" )
    {
	$this->display_error($message->{fetchmail_incomplete}, $err_url, 3);
	exit;
    }
    

    $host =~ /[a-zA-Z0-9\.-]*(.*)/;

    if( defined $1 && $1 ne "" ) {
	$this->display_error($message->{fetchmail_invalid_hostname}, $err_url, 3);
	exit;
    }

    my $fromhour = $cgi->param('from');
    my $tohour   = $cgi->param('to');

    if( int($interval/60) >= ($tohour - $fromhour) ) {
	$this->display_error($message->{fetchmail_invalid_interval}, $err_url, 3);
	exit;
    }

    my $dh = {
	$message->{fetchmail_mo} => 1,
	$message->{fetchmail_di} => 2,
	$message->{fetchmail_mi} => 3,
	$message->{fetchmail_do} => 4,
	$message->{fetchmail_fr} => 5,
	$message->{fetchmail_sa} => 6,
	$message->{fetchmail_so} => 7
	};
    
    my @wd = $cgi->param('weekdays');
    my $wds;
    foreach my $d ( @wd ) {
	push @$wds, $dh->{$d};
    }
	
    my $eh = { 
	id => $entry,
	host => $cgi->param('host'),
	user => $cgi->param('user'),
	passwd => $pass1,
	localaddr => $cgi->param('localaddr'),
	proto => $cgi->param('proto'),
	multidrop => $multidrop,
	weekdays => $wds,
	timetable => [ $fromhour, $tohour, $interval ],
	qmailprefix => $qmailprefix
	}; 

    #print STDERR "$fromday, $today, $interval\n";

    my $fe = new FetchEntry($eh);
    
    my $socket = "/var/run/fetchd.sock";
    
    my $feh = freeze($fe);
    $feh = unpack('H*', $feh);
    
    if( ! socket(SOCK, PF_UNIX, SOCK_STREAM,0) ) { # || die("ERROR: socket: $!");
	$this->display_error("ERROR: socket: $!",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }
    if( ! connect(SOCK, sockaddr_un($socket)) ) { # || die("ERROR: connect: $!");
	$this->display_error("ERROR: connect: $!",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }
    print SOCK "newentry\n";
    print SOCK "$ADMINuid\n";
    print SOCK "$ADMINpasswd\n";
    print SOCK "$feh\n";
    print SOCK "\0\n";
    SOCK->flush();
    my $ret = <SOCK>;
    close(SOCK);
    $ret =~ s/\0//;

    if( $ret =~ /^OK/ ) {
	$this->display_msg($message->{fetchmail_job_saved},
			   "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			   1);
    } else {
	$this->display_error($ret,
			     "$confParam->{cgi_path}/fetch_mail.pl?sessionID=$sessionID\&tab=$tab",
			     3);
    }
}

sub fetchJobs {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"FETCHMAIL"))->data();

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};

    my $socket = "/var/run/fetchd.sock";

    if( ! socket(SOCK, PF_UNIX, SOCK_STREAM,0) ) { # || die("ERROR: socket: $!");
	$this->display_error("ERROR: socket: $!",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }
    if( ! connect(SOCK, sockaddr_un($socket)) ) { # || die("ERROR: connect: $!");
	$this->display_error("ERROR: connect: $!",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }

    print SOCK "getentries\n";
    print SOCK "$ADMINuid\n";
    print SOCK "$ADMINpasswd\n";
    print SOCK "\0\n";
    SOCK->flush();
    my $line = "";
    while( 1 ) {
	$line = <SOCK>;
	last if $line =~ /\0/;
	chomp($line);
	if( $line =~ /^ERROR/ ) {
	    $line =~ s/\0//;
	    $this->display_error("$line",
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	    exit;
	}
	my $up = pack('H*', $line);
	$up = thaw($up);
	push @{$this->{"jobs"}}, $up;
    }
    close(SOCK);
}

1;
