#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: file_edit.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#
package file_edit;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

# Only these files are allowed to be modified


sub new {
    my $this = shift;
    my $self = new Display(@_);

    return bless $self, $this;
}


sub display {
    my $this = shift;

    $this->{"configfiles"} = [
			      "/etc/openldap/slapd.conf",
			      "/etc/named.conf.in",
			      "/etc/imapd.conf",
			      "/etc/cyrus.conf",
			      "/etc/postfix/main.cf",
			      "/etc/postfix/master.cf",
			      "/etc/httpd/httpd.conf",
			      "/etc/ssl/openssl_imap.cnf",
			      "/etc/hosts" ];

    if( defined $::CONF_GLOBAL{'GENERAL'}{'EnableSamba'} &&
        $::CONF_GLOBAL{'GENERAL'}{'EnableSamba'} eq "true" ){
	push @{$this->{"configfiles"}}, "/etc/samba/smb.conf";
# I SCHULSERVER
	push @{$this->{"configfiles"}}, "/etc/samba/smb.printserver.conf";
# E SCHULSERVER
    }

    if( -f "/etc/dhcpd.conf" ) {
	push @{$this->{"configfiles"}}, "/etc/dhcpd.conf";
    }

    my $cgi = $this->{"cgi"};
    my $file = $cgi->param('file');
    my $save = $cgi->param('save');

    if(defined $save && $save ne "") {
        $this->save_file();
    } elsif( defined $file && $file ne "") {
        $this->edit($file);
    } else {
        $this->startup();
    }
}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $cgi       = $this->{"cgi"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"FILEEDIT"))->data();


    my $maxdepth;
    my $mindepth = 100;
    my $pa;
    foreach my $file ( @{$this->{"configfiles"}} ) {
	my $depth = (scalar(split(/\//,$file))-1);
	$maxdepth = ($depth > $maxdepth ? $depth : $maxdepth);
	$mindepth = ($depth < $mindepth ? $depth : $mindepth);
	push @{$pa->[$depth]}, $file;
    }

    my $html = "";
    
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=     $cgi->start_Tr();
    $html .=         $cgi->start_td();
    $html .=             $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=                 $cgi->Tr( $this->help_th($maxdepth, "$message->{fedit_head}", "FILEEDIT" ));
    $html .=                 $cgi->Tr( $cgi->td({-class=>'AdminSubHeader', -colspan =>$maxdepth},
						"$message->{fedit_help}"));
    $html .=                 $cgi->start_Tr();
    $html .=                     $cgi->start_td();
    $html .=                         $cgi->start_table({-cellspacing=>0, -cellpadding=>3});
    
    for(my $i=$mindepth; $i<=$maxdepth; $i++ ) {
	my $beenhere;
	foreach my $file ( sort @{$pa->[$i]} ) {
	    my $top = "/".(split(/\//,$file))[$i-1];
	    my $relfile = (split(/\//,$file))[$i];
	    if( ! defined $beenhere->{$top} ) {
		my $rows;
		for(my $x=$mindepth; $x<=$maxdepth; $x++) {
		    if( $x == $i ) {
			push @$rows, $cgi->img({-src=>'/images/folder_blue_open.png',
						-align=>"middle", -border=>0})."&nbsp;<b>$top</b>";
		    } else {
			push @$rows, "&nbsp;";
		    }
		}
		$html .=  $cgi->Tr($cgi->td($rows));
	    }
	    my $rows;
	    for(my $x=1; $x<=$maxdepth; $x++) {
		if( $x == $i ) {
		    push @$rows, $cgi->img({-src=>'/images/document2.png',
					    -align=>"middle", -border=>0}).'&nbsp;'.
						$cgi->a({-href=>$confParam->{cgi_path}."/file_edit.pl?tab=$tab\&stab=$stab\&sessionID=$sessionID\&file=$file"},
							"$relfile");
		} else {
		    push @$rows, "&nbsp;";
		}
	    }
	    $html .=  $cgi->Tr($cgi->td($rows));
	    $beenhere->{$top} = 1;
	}
    }


    $html .=                         $cgi->end_table();
    $html .=                     $cgi->end_td();
    $html .=                 $cgi->end_Tr();

    $html .=             $cgi->end_table;
    $html .=         $cgi->end_td;
    $html .=     $cgi->end_Tr;
    $html .= $cgi->end_table;

    $this->SUPER::display($html);
}

sub edit {
    my $this = shift;

    my $file = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"FILEEDIT"))->data();

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');

    my $valid = 0;
    foreach my $f ( @{$this->{"configfiles"}} ) {
        $valid = 1 if $f eq $file;
    }

    if( ! $valid ) {
        $this->display_error("$message->{fedit_invalid}: $file",
            "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    my $ret = $session->suad_read($file);

    if( $ret->code() =~ /^ERROR:(.*)/ ) {
	$this->display_error("$message->{fedit_read_error}: $file: $1",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my $data = $ret->data();
    
    # store data into session
    my $msg = $session->save_store2session("$file", $file, $data);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($file.": ".$message->{fedit_modified},
				 "$confParam->{cgi_path}/file_edit.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&file=$file");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $html = "";

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2,
				-cellpadding=>0, -width=>"100%"});
    $html .=    $cgi->start_Tr({});
    $html .=       $cgi->start_td({});
    $html .=          $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=             $cgi->Tr({},[
				      $this->help_th(3, "$message->{fedit_head}",
						     "FILEEDIT" ),
				      $cgi->td({-class=>'AdminSubHeader', -colspan => 3},
					       "<b>$file</b>"
					       )
				      ]);
    $html .=                $cgi->start_multipart_form(-method=>"get",
						       -action=>$confParam->{cgi_path}."/file_edit.pl");
    $html .=                $cgi->Tr({},
				     $cgi->td({-align=>'center'},
					      $cgi->textarea(-name=>'file_content',
							     -value=>$data,
							     -cols=>75,
							     -rows=>25,
							     -wrap=>"off"
							     )
					      )
				     );
    $html .=                $cgi->Tr({},
				     $cgi->td({-align=>'center'},
					      $cgi->button(-class=>"button",-name=>'back', -value=>"$message->{back}",
							   -onClick=>"location.href='$confParam->{cgi_path}/file_edit.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab'"),
					      $cgi->reset(-class=>"button",-name=>"$message->{reset}"),
					      $cgi->submit(-class=>"button",-name=>'save', -value=>"$message->{save}").
					      $cgi->hidden(-name=>'sessionID', -value=>"$sessionID").
					      $cgi->hidden(-name=>'file', -value=>"$file").
					      $cgi->hidden(-name=>'tab', -value=>"$tab").
					      $cgi->hidden(-name=>'stab', -value=>"$stab")
					      )
				     );
    $html .=          $cgi->end_form;
    $html .=          $cgi->end_table;
    $html .=       $cgi->end_td;
    $html .=    $cgi->end_Tr;
    $html .= $cgi->end_table;

    $this->SUPER::display($html);
}

sub save_file {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"FILEEDIT"))->data();

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $file    = $cgi->param('file');

    my $valid = 0;
    foreach my $f ( @{$this->{"configfiles"}} ) {
	$valid = 1 if $f eq $file;
    }

    if( ! $valid ) {
	$this->display_error("$message->{fedit_invalid}: $file",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $msg = $session->save_read2session("$file", $file);
    
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($file.": ".$message->{fedit_modified},
				 "$confParam->{cgi_path}/file_edit.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&file=$file");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my @content = $cgi->param('file_content');
    my $raw;
    foreach my $l ( @content ) {
	$l =~ s/\r//g;
	push @$raw, $l;
    }

    my $ret = $session->suad_save($raw, $file);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("$file");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    $this->display_msg("$file $message->{saved}",
		       "$confParam->{cgi_path}/file_edit.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");

    exit;
}
1;
