#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: firewall.pm,v 1.3 2004/03/28 14:02:13 varkoly Exp $
#
package firewall;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use Net::IMAP;
use cfreader;
use LDAPUtils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $JavaScript=<<EOF;
    function open_help_win( win_location ) {
        parem='width=540,height=500,directories=no,menubar=no,toolbar=no,resizable=yes';   contacts_window=window.open(win_location, 'ImapHelpWin', parem);
        if (!contacts_window.opener) contacts_window.opener=self;
    }
    function close_help_win() {
        document.all['ImapHelpWin'].close();
    }
EOF


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $q = $this->{"cgi"};
    
    my $doit   = $q->param('doit');
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');

    if(defined $doit && $doit eq "edit") {
	$this->update_firewall();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"FIREWALL"))->data();

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');

    my $ssh		= 0;
    my $admin		= 0;
    my $schoolserver	= 0;
    my $smtp		= 0;


    # reading SuSEfirewall
    my $data = $session->suad_read('/etc/sysconfig/SuSEfirewall2');
    my @raw = split(/\n/, $data->data());
    foreach (@raw){
	if(/^FW_SERVICES_EXT_TCP="(.*)"/){
		my $TMP = $1;
		if ($TMP =~ /ssh/)   { $ssh 	= 1; }	
		if ($TMP =~ /444/)   { $admin 	= 1; }	
		if ($TMP =~ /https/) { $schoolserver= 1; }	
		if ($TMP =~ /smtp/)  { $smtp    = 1; }	
	}
    }

    my $html = $q->start_form(-action=>$confParam->{cgi_path}."/firewall.pl",
			      -name=>"form");
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $this->help_th(2, $message->{firewall}, "FIREWALL"),
					     $q->td(
						    ["$message->{ssh}",
						     $q->checkbox(-name=>'ssh',
								  -label=>'',
								  -checked=>$ssh)]  ),
					     $q->td(
						    ["$message->{admin}",
						     $q->checkbox(-name=>'admin',
								  -label=>'',
								  -checked=>$admin)]),
					     $q->td(
						    ["$message->{schoolserver}",
						     $q->checkbox(-name=>'schoolserver',
								  -label=>'',
								  -checked=>$schoolserver)]),
					     $q->td(
						    ["$message->{smtp}",
						     $q->checkbox(-name=>'smtp',
								  -label=>'',
								  -checked=>$smtp)]),
					     $q->td({-colspan=>2, -align=>"center"},
						    [$q->submit(-class=>"button",-name=>'password',-value=>$message->{set}).
						     $q->hidden(-name=>"tab", -value=>$tab).
						     $q->hidden(-name=>"stab", -value=>$stab).
						     $q->hidden(-name=>"doit", -value=>"edit").
						     $q->hidden(-name=>"sessionID", -value=>$sessionID).
						     $q->end_form()
						     ])
					     ]
					    )
				     )
			   )
		    );
    $html .= $q->end_table();

    $this->SUPER::display($html);
}

sub update_firewall {
    my $this = shift;
    
    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"FIREWALL"))->data();
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');

    my @EXT_TCP   = ('domain');

    if($q->param('ssh'))	  { push @EXT_TCP, "ssh"; }
    if($q->param('admin'))	  { push @EXT_TCP, "444"; }
    if($q->param('schoolserver')) { push @EXT_TCP, "https"; }
    if($q->param('smtp'))         { push @EXT_TCP, "smtp"; }

    my $ACCES = join " ",@EXT_TCP;

    my  $ret = $session->suad_stdout_exec("perl -pi -e 's/^FW_SERVICES_EXT_TCP=.*\$/FW_SERVICES_EXT_TCP=\"$ACCES\"/' /etc/sysconfig/SuSEfirewall2"); 
	$ret = $session->suad_stdout_exec("/sbin/SuSEfirewall2 stop");
	$ret = $session->suad_stdout_exec("/sbin/SuSEfirewall2 start");
    $q->delete('ssh');
    $q->delete('admin');
    $q->delete('schoolserver');
    $q->delete('smtp');

    $this->display_msg($message->{firewall_saved_ok},
                       "$confParam->{cgi_path}/firewall.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
                       1);

}

1;
