#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
#
#
# $Id: get_file.pm,v 1.9 2004/03/16 21:49:31 varkoly Exp $
#
package get_file;
#use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(freeze thaw);
use Net::LDAP;
use Net::Netmask;
use Digest::MD5;
use MIME::Base64;
use LDAPUtils;
use Utils;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);

    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit = $cgi->param('doit');

    if(defined $doit && $doit ne "") {
	    $this->get_it();
    } else {
	    $this->startup();
    }
}

 sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"GET_FILE"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
    my $cgi_params = ();
    my $read_from_session = $q->param('read_from_session');
    my %labels  = ();
    my @classes = ();
    my $class_room = "";
    my $sort_dir   = 1;
    
    if( defined $read_from_session && $read_from_session == 1){
	    $cgi_params = $this->session_to_form;
	    #print STDERR "Read data from sesssion:\n";
	    foreach my $key ( keys %$cgi_params){
	        #print STDERR "        $key: ".$cgi_params->{$key}."\n";
	    }
    }else{
	    $cgi_params = $q->Vars();
    }
   
    my $tab        = $cgi_params->{'tab'};
    my $stab       = $cgi_params->{'stab'};

# -- search for classes

    my $ldap = Net::LDAP->new("$ldaphost",port=>$ldapport,version => 3);
    if(!defined $ldap) {
	    $this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }

    my $result = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($result->code != 0) {
	    $errs = "bind $message->{failed}\n\n";
	    $errs .= &LDAPerror($result);
	    $this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }

    # Zuerst Schauen wir mal wo wir sind
    if ( $q->remote_addr =~ /(\d+).(\d+).(\d+).(\d+)/){
        my $network = "$1.$2.$3.$4/26";
        my $block = new Net::Netmask($network);
        $network = $block->base();
        $result = $ldap->search ( # perform a search
                              base   => "o=DHCP,$ldapbase",
                              attrs => ['description'],
                              filter => "dhcpRange=$network"
                              );
        if( $result->count > 0 ) {
            $class_room = $result->entry(0)->get_value('description');
            if($class_room ne ''){
                push @classes, $message->{class_room}.": ".$class_room;
            }
        }
    }
    # Jetzt sammeln wir die Klassen
    $result = $ldap->search (  # perform a search
                       base   => "$ldapbase",
                       scope  => "one",
                       attrs => ['cn', 'gidNumber','description'],
		       filter => "(&(|(objectclass=SuSESchoolClass)(objectclass=SuSESchoolGroup))(memberuid=$ADMINuid))"
                      );
    if($result->code == 0) {
      foreach my $entry ($result->all_entries) {
        my $key = $entry->get_value("gidNumber");
        my $val = $entry->get_value("cn");
        my $desc = $entry->get_value("description");
        push @classes, $val;
        if( defined $desc && $desc ne '' ) {
                   $labels{$val} = $desc.': '.$val;
        } else {
                   $labels{$val} = $val;
        }
      }
    }
    $result = $ldap->search (  # perform a search
                       base   => "$ldapbase",
		       scope  => "one",
                       attrs => ['importSortInDirectory'],
		       filter => "(&(objectclass=SuSESchoolAccount)(uid=$ADMINuid))"
                      );
    if($result->code == 0) {
	if($result->entry(0)->exists('importSortInDirectory')) {
           $sort_dir = $result->entry(0)->get_value('importSortInDirectory');
	} else {
	   $result = $ldap->modify ( "$bind_dn", add => { 'importSortInDirectory' => '1' } );
        }
    }

    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= "\n";
    $html .=	$q->start_Tr();
    $html .=	    $q->start_td();
    $html .=		$q->start_multipart_form(
				-action => $confParam->{'cgi_path'}."/get_file.pl", -name => "form" );
    $html .=		    $q->start_table({-border=>0, -cellspacing => 0, -cellpadding=>3, -width=>"100%"});
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $this->help_th(2, $message->{get_file}, "GET_FILE");
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-align => "right"});
    $html .=                           $message->{"classe"};
    $html .=			    $q->end_td();
    $html .=			    $q->start_td({-align => "left"});
    $html .=                        $q->popup_menu(    -name=>'classe',
                                                       -values=>\@classes,
						       -labels=>\%labels,
						       -default=>$classes[0],
                                                       -width=>160);
    $html .=			    $q->end_td();
    $html .= "\n";
    $html .=                    $q->start_Tr();
    $html .=                        $q->start_td({-colspan => 2, -align => "center"});
    $html .=                        $q->checkbox(-name=>'sort_dir',
                                                 -checked=>$sort_dir,
                                                 -label=>"$message->{'sort_dir'}"
                                                 );
    $html .=                        $q->end_td();
    $html .=                    $q->end_Tr();
    $html .= "\n";
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-colspan => 2, -align => "center"});
    $html .=				$q->submit(-name=>"doit", -value=>$message->{'get_it'});
    $html .=				$q->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .=				$q->hidden(-name=>"tab", -value=>$tab);
    $html .=				$q->hidden(-name=>"stab", -value=>$stab);
    $html .=				$q->hidden(-name=>"class_room", -value=>$class_room);
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=		    $q->end_table();
    $html .=		$q->end_form();
    $html .=	    $q->end_td();
    $html .=	$q->end_Tr();
    $html .= $q->end_table();
			
    $this->back_url("$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
    $this->SUPER::display($html);
}

sub get_it {
    my $this = shift;

    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"GET_FILE"))->data();

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $classe     = $q->param('classe');
    my $class_room = $q->param('class_room');
    my $sort_dir   = $q->param('sort_dir') || '0';

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;

    my @users	   = ();
    my @lines	   = ();
    my $MESSAGE    = "";
    my $ret        = "";
    my $url = "$confParam->{cgi_path}/get_file.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    my $ldap = Net::LDAP->new("$ldaphost",port=>$ldapport,version => 3);
    if(!defined $ldap) {
	    $this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }

    my $result = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($result->code != 0) {
	my $errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($result);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    # Save the value of sort_dir
    $result = $ldap->modify( $bind_dn,replace => { 'importSortInDirectory' =>  $sort_dir } );

    $result = $ldap->search (  # perform a search
                       base   => "$ldapbase",
                       scope  => "one",
                       attrs => ['homeDirectory'],
                       filter => "uid=$ADMINuid"
                      );
    if($result->code != 0) {
	my $text = "search failed\n".&LDAPerror($result);
	$this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	$ldap->unbind;
	exit;
    }
    my $myHome = $result->entry(0)->get_value('homeDirectory');
   
    if( $classe eq $message->{class_room}.": ".$class_room ) {
       $result = $ldap->search (  # perform a search
                           base   => "$ldapbase",
                           scope  => "one",
                           attrs => ['uid',"homeDirectory"],
                           filter => "uid=$class_room-*"
                          );
        if($result->code != 0) {
            my $text = "search failed\n".&LDAPerror($result);
            $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            $ldap->unbind;
            exit;
        }
	foreach my $entry ($result->all_entries) {
                my $uid  = $entry->get_value('uid');
                my $home = $entry->get_value('homeDirectory');
		if($uid =~ /\$$/) {
                        next;
                }
		if($sort_dir) {
			$ret = $session->suad_mkdir("$myHome/Import/$uid","700");
			$ret = $session->suad_copydir("$home/Export/","$myHome/Import/$uid");
			if(  $ret->code() ne "OK" ) {
				   $MESSAGE .= "<b>Failed to copy files from $home/Export</b><br>";
			} else {
				   $MESSAGE .= "Succesfull saved files from $home/Export<br>";
			}
		} else {
	           $ret = $session->suad_stdout_exec('N=1; for i in `find '.$home.'/Export/ -type f -printf "%f "`; do echo $i; cp '.$home.'/Export/$i '."$myHome/Import/$uid-".'$i; N=0; done; exit $N');
		   if($ret->code() !~ /OK: 0/) {
			$MESSAGE .= "<b>Failed to copy files from $home/Export</b><br>";
                   } else {
                        $MESSAGE .= "Succesfull saved files from $home/Export<br>";
                   }
		}
	}
    } else { 
	# Wer alles ist in der Klasse ???
	$result = $ldap->search (  # perform a search
			   base   => "$ldapbase",
			   scope  => "one",
			   attrs => ['memberUid'],
			   filter => "(&(cn=$classe)(objectclass=posixgroup))"
			  );
	if($result->code != 0) {
	    my $text = "search failed\n".&LDAPerror($result);
	    $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    $ldap->unbind;
	    exit;
	}
	@users = $result->entry(0)->get_value('memberUid');
	foreach my $uid (@users) {
	    $result = $ldap->search (  # perform a search
			       base   => "uid=$uid,$ldapbase",
			       scope  => "base",
			       attrs => ['homeDirectory'],
			       filter => "(&(uid=$uid)(gidNumber=100))"
			      );
	    if($result->count == 1) {
		my $home = $result->entry(0)->get_value('homeDirectory');
		#print STDERR "$home\n";
		if($sort_dir) {
			$ret = $session->suad_mkdir("$myHome/Import/$uid","700");
			$ret = $session->suad_copydir("$home/Export/","$myHome/Import/$uid");
			if(  $ret->code() ne "OK" ) {
			   $MESSAGE .= "<b>Failed to copy files from $home/Export</b><br>";
			} else {
			   $MESSAGE .= "Succesfull saved files from $home/Export<br>";
			}
		} else {
	           $ret = $session->suad_stdout_exec('N=1; for i in `find '.$home.'/Export/ -type f -printf "%f "`; do echo $i; cp '.$home.'/Export/$i '."$myHome/Import/$uid-".'$i; N=0; done; exit $N');
		   if($ret->code() !~ /OK: 0/) {
			$MESSAGE .= "<b>Failed to copy files from $home/Export</b><br>";
                   } else {
                        $MESSAGE .= "Succesfull saved files from $home/Export<br>";
                   }
		}
	    }
	}
    }
    $ret = $session->suad_chown("$myHome/Import","$ADMINuid","102");
    if(  $ret->code() ne "OK" ) {
       $MESSAGE .= "<b>Failed to chown file $myHome/Import</b><br>";
    } 
    $this->display_msg($MESSAGE, $url, 30);
}

1;
