#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: hosts_edit.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#
package hosts_edit;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Socket;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

my $button_width = 150;


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;

    my $cgi = $this->{"cgi"};
    
    my $doit      = $cgi->param('doit');

    if(defined $doit && $doit eq "add") {
	$this->modify();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"HOSTS_EDIT"))->data();

    my $hostname = $q->param('host');
    my $iaddr    = $q->param('ip');
    
    my $html = "";

    $iaddr = gethostbyname($hostname);
    if( ! defined $iaddr ) {
	$iaddr = "";
    } else {
	$iaddr = inet_ntoa($iaddr);
    }

    my $h  = "/etc/hosts";

    if( ! open(IN, "< $h") ) {
	$this->display_error("$message->{hedit_not_readable} $h: $?",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = <IN>;
    chomp(@raw);
    close(IN);

    # store data into session
    my $msg = $session->save_store2session("$h", $h, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($h.": ".$message->{hosts_file_modified},
				 "$confParam->{cgi_path}/hosts_edit.pl?sessionID=$sessionID\&host=$hostname\&ip=$iaddr\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg-code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $tfsize = 40;

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $q->start_form(-method=>"get",
							    -action=>$confParam->{cgi_path}."/hosts_edit.pl"),
					     $this->help_th(2, $message->{hedit_head},"HOSTS_EDIT" ),
					     $q->td({-colspan=>2, -class=>'AdminSubHeader',
						     },
						    "$message->{hedit_warn}"),
					     $q->td(
						    [$message->{hedit_hostname},
						     $q->textfield(-name=>'host',
								   -value=>$hostname,
								   -size=>$tfsize)]  ),
					     $q->td(
						    [$message->{hedit_ip},
						     $q->textfield(-name=>'ip',
								   -value=>$iaddr,
								   -size=>$tfsize)]  ),
					     $q->td({-colspan=>2,
						     -align=>"center"},
						    $q->submit(-class=>"button",-name=>$message->{hedit_doit}),
						    $q->hidden(-name=>"doit", -value=>"add"),
						    $q->hidden(-name=>"sessionID", -value=>$sessionID),
						    $q->hidden(-name=>"tab", -value=>$tab),
						    $q->hidden(-name=>"stab", -value=>$stab)
						    ),
					     $q->end_form()
					     ]
					    )
				     )
			   )
		    );
    
    $html .= $q->end_table();
    
    $this->SUPER::display($html);
}

sub modify {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"HOSTS_EDIT"))->data();

    my $hostname = $q->param('host');
    my $iaddr    = $q->param('ip');

    my $h  = "/etc/hosts";

    
    if( $iaddr eq "" || $hostname eq "" ) {
	$this->display_error($message->{hedit_enter_hostip},
			     "$confParam->{cgi_path}/hosts_edit.pl?sessionID=$sessionID\&host=$hostname\&ip=$iaddr\&tab=$tab\&stab=$stab" ,3);
	exit;
    }
    
    my $msg = $session->save_read2session("$h", $h);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($h.": ".$message->{hosts_file_modified},
				 "$confParam->{cgi_path}/hosts_edit.pl?sessionID=$sessionID\&host=$hostname\&ip=$iaddr\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    
    my $raw = $msg->data();
    my @new;
    foreach my $l ( @$raw ) {
	# if this host is already present, skip it
	next if $l =~ $hostname;
	push @new, $l;
    }
    push @new,"$iaddr\t$hostname"; 

    my $ret = $session->suad_save(\@new, $h);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $msg = $session->save_clear2session("$h");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $this->display_msg($message->{hedit_saved},
		       "$confParam->{cgi_path}/postfix.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       3);
    exit;
}

1;
