#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: imap_conf.pm,v 1.4 2003/09/25 16:19:08 varkoly Exp $
#
package imap_conf;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use cfreader;
use strict;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit    = $cgi->param('doit');

    if(defined $doit && $doit eq "add") {
	$this->modify();
    } else {
	$this->startup();
    }

}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $cgi       = $this->{"cgi"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"IMAP"))->data();

    my $cf = "/etc/imapd.conf";
    my $html = "";
    
    my $data = $session->suad_read($cf);

    #print STDERR $data->data();

    if( $data->code() =~ /^ERROR:(.*)/ ) {
	$this->display_error("$message->{imap_not_readable} $cf: $1",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = split(/\n/, $data->data());
    
    # set delimiter to ":" for cfreader
    my $cfr = new cfreader(":");
    my $r   = $cfr->CF2HASH(\@raw, undef);

    # store data into session
    my $msg = $session->save_store2session("$cf", $cf, \@$r);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{imap_file_modified},
				 $confParam->{cgi_path}."/imap_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    
    my $all = $cfr->getAllCMD($r);

    my $defquota     = $all->{autocreatequota};
    my $quotawarn    = $all->{quotawarn};
    my $timeout      = $all->{timeout};
    my $poptimeout   = $all->{poptimeout};
    my $lmtpfail     = ( $all->{lmtp_overquota_perm_failure} =~
			 /yes/i ? $message->{yes} : $message->{no} );
    my $unixhiersep  = ( $all->{unixhierarchysep} =~ /yes/i ? $message->{on} : $message->{off} );
    my $altnamespace = ( $all->{altnamespace} =~ /yes/i ? $message->{on} : $message->{off} );
    my $luserrelay  = $all->{lmtp_luser_relay} || "";

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->start_form(-action=>$confParam->{cgi_path}."/imap_conf.pl");
    $html .= $cgi->Tr({},
		      $cgi->td({},
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->Tr({},[
						    $this->help_th(2, $message->{mail}." ".$message->{config},
								   "IMAPCONF" ),
						    $cgi->td({-class=>'AdminSubHeader',
							      -colspan => 2},
							      $message->{'imap_config_long'}
							    )
						    ]),
#					   $cgi->Tr({},
#						    $cgi->td(
#							     $message->{set_def_quota}
#							     ),
#						    $cgi->td(
#							     $cgi->textfield(-name    => "defquota",
#									     -default => $defquota,
#									     -size    => 10),
#							     " kB"
#							     )
#						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{set_quota_warn}
							     ),
						    $cgi->td(
							     $cgi->textfield(-name    => "quotawarn",
									     -default => $quotawarn,
									     -size    => 10,
									     -maxlength =>2),
							     " %"
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{imap_timeout}
							     ),
						    $cgi->td(
							     $cgi->textfield(-name    => "timeout",
									     -default => $timeout,
									     -size    => 10),
							     " $message->{imap_minute_entity}"
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{imap_poptimeout}
							     ),
						    $cgi->td(
							     $cgi->textfield(-name    => "poptimeout",
									     -default => $poptimeout,
									     -size    => 10),
							     " $message->{imap_minute_entity}"
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{imap_overquota_fail}
							     ),
						    $cgi->td(
							     $cgi->popup_menu(-name    => "lmtpfail",
									      -values  => [$message->{yes}, $message->{no}],
									      -default => $lmtpfail)
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{imap_unixhierarchysep}
							     ),
						    $cgi->td(
							     $cgi->popup_menu(-name    => "unixhiersep",
									      -values  => [$message->{on}, $message->{off}],
									      -default => $unixhiersep)
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{imap_altnamespace}
							     ),
						    $cgi->td(
							     $cgi->popup_menu(-name    => "altnamespace",
									      -values  => [$message->{on}, $message->{off}],
									      -default => $altnamespace)
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td(
							     $message->{imap_luser_relay}
							     ),
						    $cgi->td(
							     $cgi->textfield(-name    => "luserrelay",
									     -default => $luserrelay,
									     -size    => 10)
							     )
						    ),
					   $cgi->Tr({},
						    $cgi->td({-colspan=>"2",
							      -align=>"center", -height=>"30"},
							     $cgi->submit({-class=>"button",
									   -name=>"modify",
									   -value=>$message->{commit}})
							     )
						    )
					   )
			       )
		      );
    
    $html .= $cgi->hidden(-name=>"doit", -value=>"add");
    $html .= $cgi->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .= $cgi->hidden(-name=>"tab", -value=>$tab);
    $html .= $cgi->hidden(-name=>"stab", -value=>$stab);
    $html .= $cgi->end_form;
    $html .= $cgi->end_table;

    $this->SUPER::display($html);
}

sub modify {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"IMAP"))->data();

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');

    my $cf = "/etc/imapd.conf";

    my $msg = $session->save_read2session("$cf", $cf);

    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($$cf.": ".$message->{imap_file_modified},
				 $confParam->{cgi_path}."/imap_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    my $r = $msg->data();

    my $cfr = new cfreader(":");
    # get all commands from main.cf
    my $all = $cfr->getAllCMD($r);
    

    # NEW FEATURE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if( ! defined $all->{unixhierarchysep} ) {
	push @$r,
	{ status => "CMD",
	  cmd => "unixhierarchysep",
	  value => "no",
	  multi => 0 };
    }
    $all->{unixhierarchysep} =
	( defined $cgi->param("unixhiersep") && $cgi->param("unixhiersep") eq "$message->{on}" ?
	  "yes" : "no" );
    # NEW FEATURE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    # NEW FEATURE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if( ! defined $all->{altnamespace} ) {
	push @$r,
	{ status => "CMD",
	  cmd => "altnamespace",
	  value => "no",
	  multi => 0 };
    }
    $all->{altnamespace} =
	( defined $cgi->param("altnamespace") && $cgi->param("altnamespace") eq "$message->{on}" ?
	  "yes" : "no" );
    # NEW FEATURE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


    $all->{autocreatequota} = ( defined $cgi->param("defquota") && $cgi->param("defquota") ne "" ?
				$cgi->param("defquota") : 0 );
    $all->{quotawarn}       = ( defined $cgi->param("quotawarn") && $cgi->param("quotawarn") ne "" ?
				$cgi->param("quotawarn") : 90 );
    $all->{timeout}         = $cgi->param("timeout");
    $all->{poptimeout}      = $cgi->param("poptimeout");
    $all->{lmtp_overquota_perm_failure} =
	( defined $cgi->param("lmtpfail") && $cgi->param("lmtpfail") eq "$message->{yes}" ?
	  "yes" : "no" );

    if( $all->{timeout} < 30 ) {
	$this->display_error($message->{imap_invalid_timeout}. " 30.",
			     $confParam->{cgi_path}."/imap_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }
     if( $all->{poptimeout} < 10 ) {
	$this->display_error($message->{imap_invalid_poptimeout}. " 10.",
			     $confParam->{cgi_path}."/imap_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	exit;
    }
    
    my $deact = undef;
    my $luserrelay = $cgi->param("luserrelay");
    $luserrelay =~ s/\s//g if defined $luserrelay;

    if( defined $luserrelay && $luserrelay ne "" ) {
	if( ! getpwnam($luserrelay) ) {
	    $this->display_error($message->{imap_unknown_luser}.": $luserrelay",
				 $confParam->{cgi_path}."/imap_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	}
	
	if( ! defined $all->{lmtp_luser_relay} ) {
	    push @$r,
	    { status => "CMD",
	      cmd => "lmtp_luser_relay",
	      value => $luserrelay,
	      multi => 0 };
	}
	$all->{lmtp_luser_relay} = $luserrelay;
    } else {
	for(my $i=0; $i<scalar(@$r); $i++) {
	    if( $r->[$i]->{cmd} eq "lmtp_luser_relay" ) {
		$r->[$i] = undef;
	    }
	}
    }

    $cfr->setAllCMD($all, $r, undef, undef);

    my $ar = $cfr->HASH2CF($r);

    my $ret = $session->suad_save($ar, $cf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $msg = $session->save_clear2session("$cf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $msg = $session->suad_service_exec("cyrus", "restart");
    $msg->code() =~ /OK:\s(\d+?)\s(.*)/ms;
    if( $1 != 0 ) {
	$this->display_error("reloading cyrus failed<br>$2",
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $this->display_msg($cf.": ".$message->{imap_saved_ok},
		       $confParam->{cgi_path}."/imap_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       1);
}


1;
