#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: license.pm,v 1.1.1.1 2003/03/25 10:31:40 ray Exp $
#
package license;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use cfreader;
use strict;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit    = $cgi->param('doit');

    if(defined $doit && $doit eq "add") {
	$this->modify();
    } else {
	$this->startup();
    }

}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $cgi       = $this->{"cgi"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"LICENSE"))->data();

    my $nasiconf_group = "/opt/comfire/application/nasi.conf";
    my $nasiconf_web   = "/opt/comfire/application/webmail/nasi.conf";
    my $html = "";
    

    my $data = $session->suad_read($nasiconf_group);
    

    if( $data->code() =~ /^ERROR:(.*)/ ) {
	$this->display_error("$message->{nasi_not_readable} $nasiconf_group: $1",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = split(/\n/, $data->data());
    
    # store data into session
    my $msg = $session->save_store2session("$nasiconf_group", $nasiconf_group, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($nasiconf_group.": ".$message->{nasi_file_modified},
				 $confParam->{cgi_path}."/license.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    $data = $session->suad_read($nasiconf_web);
    
    if( $data->code() =~ /^ERROR:(.*)/ ) {
	$this->display_error("$message->{nasi_not_readable} $nasiconf_web: $1",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    @raw = split(/\n/, $data->data());
    
    $msg = $session->save_store2session("$nasiconf_web", $nasiconf_web, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($nasiconf_web.": ".$message->{nasi_file_modified},
				 $confParam->{cgi_path}."/license.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    
    my $regcode = "";
    foreach my $l ( @raw ) {
	next if $l !~ /^NAS_LIZENZ/;
	$l =~ /NAS_LIZENZ:\s+(.*)/;
	$regcode = $1;
	$regcode =~ s/\s//g;
    }

    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->start_form(-action=>$confParam->{cgi_path}."/license.pl");
    $html .= $cgi->Tr({},
		      $cgi->td({},
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->Tr({},[
							$this->help_th(1, "$message->{license_head}",
								       "LICENSE" ),
							$cgi->td({-class=>'AdminSubHeader',
								  -colspan => 1},
								 "$message->{license_help}"
								 )
							]),
					   $cgi->Tr({},
						    [
						    $cgi->td(" "),
						    $cgi->td({-align=>"center"},
							     $cgi->textfield(-name => "regcode",
									     -default => "$regcode",
									     -size=>"100%",
									     -override=>1
									     )
							     ),
						     $cgi->td(" ")
						     ]
						    ),
					   $cgi->Tr({},
						    $cgi->td({-colspan=>"1",
							      -align=>"center", -height=>"30"},
							     $cgi->submit({-class=>"button",
									   -name=>"modify",
									   -value=>$message->{commit}})
							     )
						    )
					   )
			       )
		      );
    
    $html .= $cgi->hidden(-name=>"doit", -value=>"add");
    $html .= $cgi->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .= $cgi->hidden(-name=>"tab", -value=>$tab);
    $html .= $cgi->hidden(-name=>"stab", -value=>$stab);
    $html .= $cgi->end_form;
    $html .= $cgi->end_table;

    $this->SUPER::display($html);
}

sub modify {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"LICENSE"))->data();

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    
    my $nasiconf_group = "/opt/comfire/application/nasi.conf";
    my $nasiconf_web   = "/opt/comfire/application/webmail/nasi.conf";

    my $regcode = $cgi->param('regcode');
    
    my $msg = $session->save_read2session("$nasiconf_group", $nasiconf_group);
    
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($nasiconf_group.": ".$message->{nasi_file_modified},
				 $confParam->{cgi_path}."/license.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $ar;
    my $r = $msg->data();

    foreach my $l ( @$r ) {
	if( $l =~ /^NAS_LIZENZ/ ) {
	    push @$ar, "NAS_LIZENZ: $regcode";
	} else {
	    push @$ar, $l;
	}
    }

    my $ret = $session->suad_save($ar, $nasiconf_group);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $msg = $session->save_clear2session("$nasiconf_group");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    # ---------------------------------------------------------------------

    $msg = $session->save_read2session("$nasiconf_web", $nasiconf_web);
    
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($nasiconf_web.": ".$message->{nasi_file_modified},
				 $confParam->{cgi_path}."/license.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    $r = $msg->data();
    $ar = undef;

    foreach my $l ( @$r ) {
	if( $l =~ /^NAS_LIZENZ/ ) {
	    push @$ar, "NAS_LIZENZ: $regcode";
	} else {
	    push @$ar, $l;
	}
    }

    $ret = $session->suad_save($ar, $nasiconf_web);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $msg = $session->save_clear2session("$nasiconf_web");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->suad_exec("groupwarerestart");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $this->display_msg($nasiconf_group."\n".$nasiconf_web."\n".$message->{nasi_saved_ok},
		       $confParam->{cgi_path}."/license.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
		       1);
}


1;
