#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: login.pm,v 1.17 2004/03/15 11:28:49 varkoly Exp $
#
package login;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use CGI::Pretty;
use Net::LDAP;
use Digest::MD5  qw(md5_hex);
use Time::Local;
use LDAPUtils;
use Utils;
use Display;
use Session;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $uid     = lc($cgi->param('uid'));
    $uid =~ s/^\s*(.*?)\s*$/$1/;
    my $passwd  = $cgi->param('passwd');
    my $lang    = $cgi->param('lang');

    my $message = ($this->{"session"}->getLanguage("$lang", "LOGIN", "CREATE_USER"))->data(); 

    if (defined $uid && ($uid eq "admin"  || $uid eq "administrator" )) {
	$cgi->param('uid','cyrus');
    } 
    if (defined $uid && $uid ne "") {
        $this->check_login('go_conf');    
    } else { 
	$this->login();
    }
}

sub login {
    my $this = shift;

    my $cgi = $this->{"cgi"};
    my $lang = $cgi->param('lang');

    if(!defined $lang || $lang eq "") {
# C SCHULSERVER
#	$lang = "EN";
# E SCHULSERVER
        $lang = "DE";
    }

    my $message = ($this->{"session"}->getLanguage("$lang", "LOGIN", "CREATE_USER"))->data(); 

    my $row_span = 7;
    $row_span = 8 if -e "/srv/www/htdocs/cacert.der";

    print $cgi->header(-charset=> 'utf-8');
    print $cgi->start_html(-title=>"$message->{login}", -bgcolor=>"#ffffff", -align=>"center",
			   -style =>{'src'=>'/stylesheetAdmin.css'});
	print '<center><br><br><br><br><br>';
    print $cgi->start_form(-action=>'/suse/login.pl', -target=>'_top', -name=>'login_form');
    print $cgi->start_table({-class=>"LoginBorder", -cellspacing=>0, -cellpadding=>0, width=>650});
    print   $cgi->start_Tr();
    print	$cgi->start_td({-class => "LoginTop", -valign=>'top', -width=>'156'});
    print	    $cgi->img({-src=>"/images/email_logo_whitebg.png", -width=>'156', -height=>'138'});
    print	$cgi->end_td();
    print	$cgi->start_td({-bgcolor=>'#EEEEEE', -rowspan=>'2'});
    #print	    $cgi->start_table({-border=>0, -cellspacing=>15, -background=>"/images/big_bg.jpg", -width=>'492', -height=>'363'});
    print	    $cgi->start_table({-border=>0, -cellspacing=>15, -height=>'363'});
# I SCHULSERVER
    print               $cgi->Tr( $cgi->td({-height=>'80'}, '<img src="/images/suliszerver'.$lang.'.gif" align="right"><br><br><br>',
							    '<font size=+2><div align=right>Administration</div></font>'));
# E SCHULSERVER
#    print		$cgi->start_Tr();
#    print		    $cgi->start_td({-valign=>'top', -align=>'right'});
#    print			$cgi->img({-src=>"/images/suse_logo_greybg.png"});
#    print		    $cgi->end_td();
#    print		$cgi->end_Tr();
    print		$cgi->Tr( $cgi->td({-height=>'60'}, '&nbsp;<br>'));
    print		$cgi->start_Tr();
    print		    $cgi->start_td({-valign=>'top'});
    print			$cgi->start_table({-border=>0, -cellspacing=>0, -cellpadding=>"10"});
    print			    $cgi->start_Tr();
    print				$cgi->start_td({-align=>"right", -valign=>"middle"});
    print				    $cgi->font({-face=>"Arial, Helvetica, sans-serif", -size=>"+1"},
						"$message->{user}: ");
    print				$cgi->end_td();
    print				$cgi->start_td({-valign=>"middle"});
    print				    $cgi->textfield(
							    -name           => 'uid',
							    -maxlength      => 35,
							    -size	    => 30);
    print				    "<script>document.login_form.uid.focus()</script>";	
    print				$cgi->end_td();
    print			    $cgi->end_Tr();
    print			    $cgi->start_Tr();
    print				$cgi->start_td({-align=>"right", -valign=>"middle"});
    print				    $cgi->font({-face=>"Arial, Helvetica, sans-serif", -size=>"+1"},
						"$message->{password}: ");
    print				$cgi->end_td();
    print				$cgi->start_td({-valign=>"middle"});
    print				    $cgi->password_field(
							    -name           => 'passwd',
							    -maxlength      => 35,
							    -size	    => 30);
    print				$cgi->end_td();
    print			    $cgi->end_Tr();
    print			    $cgi->start_Tr();
    print				$cgi->start_td({-align=>"right", -valign=>"middle"});
    print				    "&nbsp;";
    print				$cgi->end_td();
    print				$cgi->start_td({-valign=>"middle"});
    print				    $cgi->submit(-class=>"button",-name=>'login', -value=>" $message->{login_button} ");
    print				    $cgi->hidden(-name=>'lang', -value=>"$lang");
    print				$cgi->end_td();
    print			    $cgi->end_Tr();
    if ( -e "/srv/www/htdocs/cacert.der" ) {
	print			    $cgi->start_Tr();
# C SCHULSERVER
#	print				$cgi->td({-align=>'center', -valign=>'bottom', -colspan=>2},
#					    '<br>Download: '.$cgi->a({-href=>"/cacert.der"}, "SuSE Linux Openexchange Server CA"));
# E SCHULSERVER
	print				$cgi->td({-align=>'center', -valign=>'bottom', -colspan=>2},
					    '<br>Download: '.$cgi->a({-href=>"/cacert.der"}, "SuSE Linux School Server CA"));
	print			    $cgi->end_Tr();
    }
    print			$cgi->end_table();
    print		    $cgi->end_td();
    print		$cgi->end_Tr();
    print	    $cgi->end_table();
    print	$cgi->end_td();
    print   $cgi->end_Tr();
    print   $cgi->start_Tr();
    print	$cgi->start_td({-class=>"LoginBottom", -width=>156});
    print	    $cgi->img({-src=>"/images/puzzle.png"});
    print	$cgi->end_td();
    print   $cgi->end_Tr();
    print   $cgi->start_Tr();
    print	$cgi->start_td({-class=>'LoginGray', -width=>156});
    print	    $cgi->img({-src=>"/images/sl_text.png"});
    print	$cgi->end_td();
    print	$cgi->start_td({-class=>'LoginGray'});
    print	    $cgi->img({-src=>"/images/ots_text.png"});
    print	$cgi->end_td();
    print   $cgi->end_Tr();
    print $cgi->end_table();
	print '</center>';
    print $cgi->end_html();
#    if ( -e "/srv/www/cacert.der" ) {
#	print $cgi->start_Tr({-bgcolor=>'#e9e9e9'});
#	print $cgi->td({-align=>'center', -valign=>'bottom', -colspan=>2},
#		       '<br>Download: '.$cgi->a({-href=>"/cacert.der"}, "SuSE Linux Openexchange Server CA"));
#	print $cgi->end_Tr();
#    }
}

sub check_login {
    my ($this, $was_du_wollen) = @_;

    my $cgi = $this->{"cgi"};
    my $lang   = $cgi->param('lang');
    my $uid    = lc($cgi->param('uid'));
    $uid =~ s/^\s*(.*?)\s*$/$1/;
    my $passwd = $cgi->param('passwd');
    my $doit   = $cgi->param('doit');
    
    if(!defined $lang || $lang eq "") {
# C SCHULSERVER
#	$lang = "EN";
# E SCHULSERVER
        $lang = "DE";
    }

    my $message = ($this->{"session"}->getLanguage("$lang", "LOGIN", "CREATE_USER"))->data(); 

    my $text       = "";
    
    if ( $passwd eq "" ) {
	$text = $message->{'access_denied'};
	$this->disp_error($text, undef);
	exit;
    }

    my ($basedn, $ldapserver, $ldapport) = parse_file("/etc/openldap/ldap.conf", "BASE", "HOST", "PORT");
    $basedn =~ s/\s//g;
    
    if($basedn eq "") {
	$this->disp_error($message->{basedn_missed},undef);
	exit;
    }
    if($ldapserver eq "") {
	$ldapserver = "localhost";
    }
    if($ldapport eq "") {
	$ldapport = 389;
    }

    #-- open connection to LDAP
    my $ld;
    my $ldaphost;
    foreach my $host ( split(/\s/,$ldapserver) ) {
	$ldaphost = $host;
	$ld = Net::LDAP->new($host, port=>$ldapport, version => 3);
	last if defined $ld;
    }

    if (!defined $ld || $ld <= 0)
    {
	$text = $message->{'access_denied'};
	#$text = "$message->{user} $uid: $message->{connection_failed}";
	$this->disp_error($text, undef);
	exit;
    }
    
    #-- bind anonymous
    my $status = $ld->bind; 
    if ($status->code != 0)  {
	$text = $message->{'access_denied'};
	#$text = "$message->{user} $uid: $message->{bind_failed}";
	$this->disp_error($text, $status);
	exit;
    }
    
    #-- search for all accounts
    my $filter = "(&(uid=$uid)(objectclass=SuSEeMailObject)(!(disablelogin=yes)))";

    $status = $ld->search(
			  base => $basedn,
			  scope => "one",
			  attrs => ['dn'],
			  filter => $filter
			  );
    if ($status->code != 0) {
	$text = $message->{'access_denied'};
	#$text = "$message->{user} $uid: $message->{search_failed}";
	$ld->unbind;
	$this->disp_error($text, $status);
	exit;
    }
    #-- found more or less than one entry => error
    if ($status->count != 1) {
	$text = $message->{'access_denied'};
	#$text = "$message->{user} $uid: $message->{not_found}";
	$ld->unbind;
	$this->disp_error($text, undef);
	exit;
    }
    
    my $entry = $status->shift_entry;
    
    my $dn = $entry->dn;
    
    #-- bind as user
    $status = $ld->bind(
			dn => $dn,
			password => $passwd
			);
    if ($status->code != 0) {
	$text = $message->{'access_denied'};
	#$text = "$message->{user} $uid: $message->{pass_mismatch}";
	$ld->unbind;
	$this->disp_error($text, undef);
	exit;
    }  
    
    #-- search for shadowexpire(is user deactivated?) and the preferred Language
    $filter = "objectclass=SuSEeMailObject";
# C SCHULSERVER
#    $status = $ld->search(
#			  base => $dn,
#			  scope => "base",
#			  attrs => ['shadowLastChange', 'shadowMax',
#				    'shadowexpire', 'preferredLanguage', 'cn',
#				    'loginDestination'],
#			  filter => $filter
#			  );
# E SCHULSERVER
    $status = $ld->search(
			  base => $dn,
			  scope => "base",
			  attrs => ['shadowLastChange', 'shadowMax',
				    'shadowexpire', 'preferredLanguage', 'cn',
				    'loginDestination','gidNumber'],
			  filter => $filter
			  );
    if ($status->code != 0) {
	$text = $message->{'access_denied'};
	$ld->unbind;
	$this->disp_error($text, $status);
	exit;
    }
    
    my $result = $status->as_struct;
    my %result = %$result;

    my $shadowExpire;
    if( defined $result{$dn}{shadowexpire} ) {
	$shadowExpire = join "", @{$result{$dn}{shadowexpire}};
    }

# I SCHULSERVER
# Searching if it's a teacher 
    my $gidnumber = 100;
    if( defined $result{$dn}{gidnumber} ) {
        $gidnumber = join "", @{$result{$dn}{gidnumber}};
    }
    # don't allow Workstations User to login
    if ($gidnumber == 103) {
        $text = $message->{access_denied};
        $text = "$message->{user} $uid: $message->{access_denied}";
        $ld->unbind;
        $this->disp_error($text, undef);
        exit;
    }
# E SCHULSERVER

    my $shadowMax;
    if( defined $result{$dn}{shadowmax} ) {
	$shadowMax = join "", @{$result{$dn}{shadowmax}};
    }

    my $shadowLastChange;
    if( defined $result{$dn}{shadowlastchange} ) {
	$shadowLastChange = join "", @{$result{$dn}{shadowlastchange}};
    }

#    my $lang = "EN";
    if(defined $result{$dn}{preferredlanguage}) {
	$lang = join "", @{$result{$dn}{preferredlanguage}};
    }
    my $logindest = "";
    if(defined $result{$dn}{'logindestination'}) {
	$logindest = join "", @{$result{$dn}{'logindestination'}};
    }
    if( $logindest eq "" && $uid ne "cyrus" ) {
        $was_du_wollen = "go_groupware";
    }
    if( $uid ne "cyrus" && $logindest eq "config" ){
	$was_du_wollen = "go_conf";
    } elsif( $uid ne "cyrus" && $logindest eq "groupware" ){
	$was_du_wollen = "go_groupware";
    } elsif( $uid ne "cyrus" && $logindest eq "webmail" ){
	$was_du_wollen = "go_webmail";
    }
# I SCHULSERVER
# At the time only login to admin is possible on this site
    $was_du_wollen = "go_conf";
# E SCHULSERVER

    my $fullname = $uid;
    if(defined $result{$dn}{'cn'}) {
	$fullname = @{$result{$dn}{'cn'}}[0];
    }

    $dn = "uid=cyrus,".$basedn;

    #-- search for imapServer, imapPort and sievePort
    $status = $ld->search(
			  base => $dn,
			  scope => "base",
			  attrs => ['imapServer', 'imapPort', 'sievePort', 'mailDomain',
				    'smtpServer', 'groupwareDBServer', 'groupwareDBPort'],
			  filter => "objectclass=SuSEeMailObject"
			  );
    if ($status->code != 0) {
	$text = "$message->{user} $uid: $message->{ldap} $message->{search_failed}";
	$ld->unbind;
	$this->disp_error($text, $status);
	exit;
    }
    
    $result = $status->as_struct;
    %result = %$result;

    my $imapserver = "localhost"; 
    my $smtpserver = "localhost"; 
    my $maildomain = "linux.local";
    my $imapport = 143;
    my $sieveport = 2000;
    my $groupwaredbserver = "localhost";
    my $groupwaredbport = "5432";

    if(defined $result{$dn}{imapserver}) {
	$imapserver = join "", @{$result{$dn}{imapserver}};
    }
    if(defined $result{$dn}{smtpserver}) {
	$smtpserver = join "", @{$result{$dn}{smtpserver}};
    }
    if(defined $result{$dn}{imapport}) {
	$imapport = join "", @{$result{$dn}{imapport}};
    }
    if(defined $result{$dn}{sieveport}) {
	$sieveport = join "", @{$result{$dn}{sieveport}};
    }
    if(defined $result{$dn}{maildomain}) {
	$maildomain = join "", @{$result{$dn}{maildomain}};
    }
    if(defined $result{$dn}{groupwaredbserver}) {
	$groupwaredbserver = join "", @{$result{$dn}{groupwaredbserver}};
    }
    if(defined $result{$dn}{groupwaredbport}) {
	$groupwaredbport = join "", @{$result{$dn}{groupwaredbport}};
    }

    # --- Autentication successful

    if(!defined $lang || $lang eq "" ) {
# C SCHULSERVER
#	$lang = "EN";
# E SCHULSERVER
        $lang = "DE";
    }
    if(!defined $imapserver || $imapserver eq "") {
	$imapserver = "localhost";
    }
    if(!defined $smtpserver || $smtpserver eq "") {
	$smtpserver = "localhost";
    }
    if(!defined $imapport || $imapport eq "") {
	$imapport = 143;
    }
    if(!defined $sieveport || $sieveport eq "") {
	$sieveport = 2000;
    }
    
    #-- calculate if the account is expired
    my $days_since_1970 = int(timelocal(localtime()) / 3600 / 24);

    if( defined $shadowExpire && $shadowExpire ne "" && $shadowExpire < $days_since_1970) {
	$text = $message->{access_denied};
	$text = "$message->{user} $uid: $message->{access_denied}";
	$ld->unbind;
	$this->disp_error($text, undef);
	exit;
    }

    #-- add data to session
    my %data = ();
    $data{uid} = $uid; 
    $data{fullname} = $fullname;
    $data{passwd} = $passwd; 
    $data{LDAPserver} = $ldaphost; 
    $data{LDAPport} = $ldapport; 
    $data{baseDN} = $basedn;
    $data{SMTPserver} = $smtpserver; 
    $data{IMAPserver} = $imapserver; 
    $data{IMAPport} = $imapport; 
    $data{SIEVEport} = $sieveport; 
    $data{GroupwareDBserver} = $groupwaredbserver;
    $data{GroupwareDBport} = $groupwaredbport;
    $data{LANG} = $lang; 
    $data{mailDomain} = $maildomain;
    $data{loginDestination} = $logindest;

# I SCHULSERVER
    $data{gidnumber} = $gidnumber;
    # SCHULSERVER I
    my $mesg = $ld->search (  # perform a search
                           base   => "cn=Admins,".$basedn,
                           scope => "base",
                           attrs => ['member'],
                           filter => "member=uid=$uid,$basedn"
                             );
    if( $mesg->count > 0 ){
       $data{admin} = 1;
    }else{
       $data{admin} = 0;
    }
# E SCHULSERVER

    if( $uid ne "cyrus" ) {
	if( defined $shadowLastChange && defined $shadowMax ) {
	    if( $shadowMax > 0 && (( $days_since_1970 - $shadowLastChange ) >= $shadowMax) ) {
		$data{mustchangepasswd} = 1;
	    }
	}
	if( defined $shadowLastChange && $shadowLastChange == 0 ) {
	    $data{mustchangepasswd} = 1;
	}
    }

    my $session = Session->new();
    my $ret = $session->create(\%data);
    my $data = $ret->data();

    $ld->unbind;

    if($ret->code() =~ /FAILED:(.*)/) {
	$this->disp_error($message->{start_session_failed});
	exit;
    }

    #print STDERR "[$data]\n";

    $data =~ /^([a-z0-9]+)\|([a-z0-9]*)$/;
    
    my ( $sessionID, $replacedid ) = ($1, $2);
    
    if( defined $replacedid && length($replacedid) == 32 ) {
	print STDERR "Reusing old session with id=$replacedid\n";
	print STDERR "Finishing old groupware session\n";
	$session->comFireLogout($replacedid);
    }
    
#    print STDERR "sessionID:$sessionID\n";
    
    my $COOKIE = undef;
    if( $::CONF_GLOBAL{"SECURITY"}{"UseCookie"} eq "true" ) {
	my $rand = rand((time)*$$);
	my $cookie = md5_hex($rand.$sessionID);
	$ret = $session->setcookie($cookie, $sessionID);
	if( $ret->code() =~ /^OK/ ) {
	    if( defined $::CONF_GLOBAL{"GENERAL"}{"CookieDomain"} ) { 
		$COOKIE = $cgi->cookie(-name=>"sessionCookie-$uid-$sessionID",
				       -value=>$cookie,
				       -domain=>$::CONF_GLOBAL{"GENERAL"}{"CookieDomain"},
				       -path=>"/"
				       );
	    } else {
		$COOKIE = $cgi->cookie(-name=>"sessionCookie-$uid-$sessionID",
				       -value=>$cookie,
				       -path=>"/"
				       );
	    }
	} else {
	    $this->disp_error($ret->code());
	    exit;
	}
    }

# If needed update script will be executed
    if( $uid eq 'cyrus' ) {
	$this->{"confParam"} = ($session->load($sessionID))->data();
	my $do_update_release = `cat /var/adm/updates/do_update_release`;
	chomp $do_update_release;
	if($do_update_release ne '' && ! open(F,"/var/adm/updates/$do_update_release/done_update") ) {
		$ret =  $session->suad_read('/var/adm/updates/do_update');
		if($ret and $ret->code() eq 'OK') {
			my @data  = split("\n", $ret->data());
			my $report= "/var/adm/updates/$do_update_release/update_report";
			foreach(@data){
				if(!/^#/){
					$ret = $session->suad_stdout_exec("$_ \"$passwd\" \"$ldaphost\" \"$ldapport\" \"$basedn\" \"$maildomain\" \"$report\"");
				}	
			}
			$session->suad_move('/var/adm/updates/do_update',"/var/adm/updates/$do_update_release/done_update");
			$session->suad_unlink('/var/adm/updates/do_update_release');
		}
	} else {
		close(F);
	}
    }

    if( ( defined $::CONF_GLOBAL{'GENERAL'}{'DisableGroupwareLogin'} &&
	  $::CONF_GLOBAL{'GENERAL'}{'DisableGroupwareLogin'} eq "true" ) ||
	$was_du_wollen eq 'go_conf' || defined $data{mustchangepasswd} ) {
	if( defined $COOKIE ) {
	    print $cgi->header( -Refresh=>"0; URL=/suse/menu.pl?sessionID=$sessionID", -cookie=>[$COOKIE] );
	} else {
	    print $cgi->header( -Refresh=>"0; URL=/suse/menu.pl?sessionID=$sessionID" );
	}
    } elsif( $was_du_wollen eq 'go_webmail' ) {
	my $remotehost = $::CONF_GLOBAL{'GENERAL'}{'GroupwareHostname'};
	if( defined $remotehost && $remotehost ne "" ) {
	    $remotehost = &getPROTO().$remotehost;
	} else {
	    $remotehost = "";
	}
	if( defined $COOKIE ) {
	    print $cgi->header( -Refresh=>"0; URL=$remotehost/servlet/webmail?sessionID=$sessionID\&SITE=mauth", -cookie=>[$COOKIE] );
	} else {
	    print $cgi->header( -Refresh=>"0; URL=$remotehost/servlet/webmail?sessionID=$sessionID\&SITE=mauth" );
	}
    } elsif( $was_du_wollen eq 'go_groupware' ) {
	my $remotehost = $::CONF_GLOBAL{'GENERAL'}{'GroupwareHostname'};
	if( defined $remotehost && $remotehost ne "" ) {
	    $remotehost = &getPROTO().$remotehost;
	} else {
	    $remotehost = "";
	}
	if( defined $COOKIE ) {
	    print $cgi->header( -Refresh=>"0; URL=$remotehost/servlet/intranet?SITE=beforeAuth&sessionID=$sessionID", -cookie=>[$COOKIE] );
	} else {
	    print $cgi->header( -Refresh=>"0; URL=$remotehost/servlet/intranet?SITE=beforeAuth&sessionID=$sessionID" );
	}
    }
    
    if ( $lang eq "DE" ) {
	print $cgi->start_html( -title=>'redirect' );
	print '<p align="center">Sie werden weitergeleitet...</p>';
	print $cgi->end_html();
    } elsif ( $lang eq "HU" ) {
	print $cgi->start_html( -title=>'redirect' );
	print '<p align="center">Automatikus tovbbts, krem vrjon...</p>';
	print $cgi->end_html();
    } else {
	print $cgi->start_html( -title=>'redirect' );
	print '<p align="center">You will be redirected...</p>';
	print $cgi->end_html();
    }

    exit;
}

sub disp_error(){
    my $this = shift;

    my $cgi = $this->{"cgi"};
    my $lang   = $cgi->param('lang');

    my $session = $this->{"session"};

    if(!defined $lang || $lang eq "") {
# C SCHULSERVER
#	$lang = "EN";
# E SCHULSERVER
	$lang = "DE";
    }

    $this->{"session"}->{"confParam"}->{"LANG"} = $lang;

    my $text = shift;
    my $ld   = shift || "";

    if(defined $ld && $ld ne "") {
	$text .= LDAPerror($ld);
    }
    $this->display_error($text,
			 $session->cgi_path()."/login.pl?doit=login&lang=$lang", 3);
}

1;
