#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: mailq.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#

package mailq;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Socket;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;

    my $q = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"POSTFIX"))->data();

    my $html = "";
    my $inbetween = "";

    my $refr = "";
    
    if( defined $q->param('refresh') ) {
	$refr = $q->param('refresh');
	if( ! ( $refr =~ /^[1-9]+/ ) ) {
	    $q->param(-name=>'refresh', -value=>"");
	    $refr = undef;
	}
    }
    
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    
    my $flush = $q->param('flush');
    
    if( $refr eq "" ) {
	$refr = undef;
    }
    
    if( defined $flush && $flush ne "" ) {
	my $qtalk = "/var/spool/postfix/public/qmgr";
	
	# lets talk to postfix's qmgr :-)
	# I do it this way, because postfix sendmail does not want to
	# run as suid or called from a suid process
	# the qmgr FIFO/unixdomainsocket is world writable
	
	if( -p $qtalk ) {
	    if( !open(OUT,"> $qtalk") ) {
		$this->display_error($q,"unable to talk to qmgr: $!",
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    }
	} elsif( -S $qtalk ) {
	    if( ! socket(OUT, PF_UNIX, SOCK_STREAM, 0) ) {
		$this->display_error($q,"unable to open socket: $!",
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    }
	    if( ! connect(OUT, sockaddr_un($qtalk)) ) {
		$this->display_error($q,"unable to connect: $!",
			      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    }
	    
	}
	
	# IDFA:, see qmgr/qmgr.c
	#
	# I: QMGR_REQ_SCAN_INCOMING
	# D: QMGR_REQ_SCAN_DEFERRED
	# F: QMGR_REQ_FLUSH_DEAD
	# A: QMGR_REQ_SCAN_ALL
	
	print OUT "IDFA";
	
	close(OUT);
	
    }
    
    if( ! open(IN, "/usr/bin/mailq |") ) { #|| die "unable to run mailq: $?";
	$this->display_error($q,"$message->{postfix_remove_nomailq}: $!",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    #open(IN, "cat /tmp/mailq |");

    my @ar = <IN>;

    close(IN);

    chomp(@ar);


    my $mqr = {};
    my $i = 0;
    my $qid;
    my $tmp = "";
    
    while( $i < $#ar + 1 ) {
	if( $i ) {
	    if( $ar[$i] =~ /^\w+/ ) { # first line of one entry

		$ar[$i] =~ /(^[\w\*]+)\s+(.*)$/;
		$qid = $1;
		$tmp = $2;
		if( $tmp =~ /^\*.*/ ) {
		    $mqr->{$qid}->{qstate} = "active";
		} else {
		    $mqr->{$qid}->{qstate} = "deferred";
		}
		# remove the "*" indicator of mails in active queue
		$tmp =~ s/^\*\s*//;
		#print STDERR "QID=$qid, Rest=$tmp\n";

		$tmp =~ /(^[0-9]+)\s+(.*)$/;
		$mqr->{$qid}->{size} = $1;
		$tmp = $2;
		#print STDERR "SIZE=$1, Rest=$tmp\n";

		$tmp =~ /(^\w{3}\s\w{3}\s+[0-9]+\s[0-9]+:[0-9]+:[0-9]+)\s+(.*)$/;
		$mqr->{$qid}->{time} = $1;
		$mqr->{$qid}->{sender} = $2;
		#print STDERR "TIME=$1, Rest=$2\n";

		$i++; # goto next line

		# next line is error message?
		if( $ar[$i] =~ /[^\(]*\((.*)\).*/ ) {
		    $mqr->{$qid}->{error} = $1;
		    $i++;
		    $ar[$i] =~ /^\s+(.*)$/;
		    $mqr->{$qid}->{recipe} = $1;
		} elsif( $ar[$i] eq "" ) {
		    $mqr->{$qid}->{error} = "unknown";
		    $mqr->{$qid}->{recipe} = "unknown";
		} else {
		    if( $mqr->{$qid}->{qstate} eq "active" ) {
			$mqr->{$qid}->{error} = "active";
		    } else {
			$mqr->{$qid}->{error} = "defer";
		    }
		    $ar[$i] =~ /^\s+(.*)$/;
		    $mqr->{$qid}->{recipe} = $1;
		}
	    }
	} else {
	    # build header line
	}
	$i++;
    }

    foreach( keys %$mqr ) {
	
	$inbetween .= $q->Tr({},
			     $q->td(
				    [ $mqr->{$_}->{qstate} eq "active" || $mqr->{$_}->{error} eq "defer" ? 
				      "$_" :
				      "<A HREF=remove_mail.pl?sessionID=$sessionID\&qid=$_\&refresh=$refr\&tab=$tab\&stab=$stab>$_</A>",
				      $mqr->{$_}->{size},
				      $mqr->{$_}->{time},
				      $mqr->{$_}->{sender},
				      $mqr->{$_}->{recipe},
				      ] ),
			     );
	$inbetween .= $q->Tr({},
			     $q->td(
				    "&nbsp;"
				    ),
			     $q->td({-colspan=>5},
				    $mqr->{$_}->{error}
				    ),
			     );
    }

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->Tr({},
		    $q->td({},
			   $q->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
				     $q->Tr(
					    [
					     $this->help_th(5, $message->{postfix_mailq_head},
							    "MAILQUEUE"),
					     $q->td({-class=>'AdminSubHeader', -colspan=>5},
						    $message->{postfix_mailq_warn})
					     ]
					    ),
				     $q->Tr({},
					    # FORM REFRESH
					    $q->start_form(-method=>"get",
							   -action=>$confParam->{cgi_path}."/mailq.pl"),
					    $q->td({-colspan=>4},
						   $message->{postfix_mailq_refresh_txt}
						   ),
					    $q->td({
						    -align=>"center"},
						   $q->textfield(-name=>'refresh',
								 -value=>$refr, -size=>3).
						   $message->{postfix_mailq_seconds}.
						   $q->hidden(-name=>"sessionID", -value=>$sessionID).
						   $q->hidden(-name=>"refresh", -value=>$refr).
						   $q->hidden(-name=>"tab", -value=>$tab).
						   $q->hidden(-name=>"stab", -value=>$stab).
						   $q->end_form()
						   # FORM REFRESH
						   ),
					    ),
				     $q->Tr({},
					    $q->start_form(-method=>"get",
							   -action=>$confParam->{cgi_path}."/mailq.pl"),
					    $q->td(
						   [ "<b>".$message->{postfix_mailq_qid}."</b>",
						     "<b>".$message->{postfix_mailq_size}."</b>",
						     "<b>".$message->{postfix_mailq_time}."</b>",
						     "<b>".$message->{postfix_mailq_sender}."</b>",
						     "<b>".$message->{postfix_mailq_recipe}."</b>" ],
						   $q->hidden(-name=>"sessionID", -value=>$sessionID).
						   $q->hidden(-name=>"refresh", -value=>$refr).
						   $q->hidden(-name=>"tab", -value=>$tab).
						   $q->hidden(-name=>"stab", -value=>$stab)
						   )
					    ),
				     $q->Tr({},
					    $q->td({-colspan=>5},
						   $q->hr({-with=>"100%"})
						   )
					    ),
#
#  insert the above generated html code here:
#
				     $inbetween,
				     $q->end_form(),
				     # FORM FLUSH QUEUE
				     $q->start_form(-method=>"get",
						    -action=>$confParam->{cgi_path}."/mailq.pl"),
				     $q->Tr({},
					    $q->td({-colspan=>5,
						    -align=>"center"},
						   $q->submit(-class=>"button",-name=>'flush',
							      -value=>$message->{postfix_mailq_flush}).
						   $q->hidden(-name=>"sessionID", -value=>$sessionID).
						   $q->hidden(-name=>"refresh", -value=>$refr).
						   $q->hidden(-name=>"tab", -value=>$tab).
						   $q->hidden(-name=>"stab", -value=>$stab)
						   ),
					    $q->end_form()
					    ),
				     )
			   )
		    );
    $html .= $q->end_table();

    $this->SUPER::display($html,
			  "$confParam->{cgi_path}/mailq.pl?sessionID=$sessionID\&refresh=$refr\&tab=$tab\&stab=$stab",
			  $refr);
    
}

1;
