#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: manage_folder.pm,v 1.2 2003/05/06 11:30:44 varkoly Exp $
#

package manage_folder;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::IMAP;
use IMAPUtils;
use Utils;
use Display;
use URI::Escape;
use FileHandle;
use Socket;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"MANAGE_FOLDER"))->data();

    my $LOGINuid      = $confParam->{uid};
    my $LOGINpasswd   = $confParam->{passwd};
    my $imaphost      = $confParam->{IMAPserver};
    my $imapport      = $confParam->{IMAPport};

    my $View      = $cgi->param('View') || '';
    my $Action    = $cgi->param('Action') || '';
    my $ENCFolder = $cgi->param('Folder') || '';
    my $NewFolder = $cgi->param('NewFolder') || '';
    my $yesb      = $cgi->param('yesb') || '';
    my $nob       = $cgi->param('nob') || '';
    my $ryesb     = $cgi->param('ryesb');
    my $rnob      = $cgi->param('rnob');
    my $recursive = $cgi->param('recursive');
    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');

    $this->{"folder_hash"} = &IMAPUtils::getFolder($LOGINuid, 'lca' , $LOGINpasswd, $imaphost);
    $this->{"ownfol"} = undef;
    foreach ( keys %{$this->{"folder_hash"}} ) {
	push @{$this->{"ownfol"}}, $_;
    }

    my @ownfol = sort @{$this->{"ownfol"}};
   
    my $Folder    = $this->{"folder_hash"}->{$ENCFolder};
    my $namespaces = &IMAPUtils::namespace($LOGINuid, $LOGINpasswd, $imaphost);
    my @personal_ns= $namespaces->personal();
    
    # UGLY: Access the Namespace-Structuer directly, as the access method lowercase the values
    my $delimiter = $namespaces->{'Namespaces'}->{'personal'}->{$personal_ns[0]}; 

    if( $personal_ns[0] eq "" ){
	$Folder =~ s/^INBOX$delimiter??(.*)$/$1/i;
    }

    #print STDERR "FOLDER=$Folder, ENCFOLDER=$ENCFolder\n";
    
    if($Action eq $message->{'b_delete'} && $Folder ne '' && $yesb ne "" ) {

	my $imap = new Net::IMAP($imaphost, Debug => 0);
	if(!defined $imap) {
	    $this->display_error("can't connect to $imaphost: $!",
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	
	my $ret = $imap->login($LOGINuid, $LOGINpasswd);
	
	if($$ret{Status} ne "ok") {
	    $imap->logout();
	    $this->display_error("login $message->{failed}: Serverresponse:$$ret{Status} => $$ret{Text}\n",
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	} else {
	    my $error = 0;
	    my $msg = "";
	    my $errmsg = "";
	    if( defined $recursive && $recursive ne "" ) {
		foreach my $f (@ownfol) {
		    if( isSubFolder($ENCFolder,$f) || $ENCFolder eq $f ) {
			$ret = $imap->delete($this->{"folder_hash"}->{$f});
			if($$ret{Status} eq "ok") {
			    $msg .= "$f $message->{'succ_delete'}\n";
			    #$status = status($message->{succ_completed},
			    #		 "$f $message->{'succ_delete'}","OK");
			} else {
			    $error = 1;
			    $errmsg .= "$f $message->{'err_delete'}: $$ret{Text}\n";
			    #$this->display_error("$f $message->{'err_delete'}: $$ret{Text}",
			    #	      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
			}
		    }
		}
	    } else {
		$ret = $imap->delete($Folder);
		if($$ret{Status} eq "ok") {
		    $msg = "$ENCFolder $message->{'succ_delete'}";
		    #$status = status($message->{succ_completed},"$Folder $message->{'succ_delete'}","OK");
		} else {
		    $error = 1;
		    $errmsg = "$ENCFolder $message->{'err_delete'}: $$ret{Text}";
		    #$status = status($message->{error},
		    #		 "$Folder $message->{'err_delete'}: $$ret{Text}","ERR");
		}
	    }
	    
	    $imap->logout();
	    if( $error ) {
		$this->display_error($msg.$errmsg,
				     "$confParam->{cgi_path}/manage_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    } elsif( $msg ne "" ) {
		$this->display_msg($msg,
			    "$confParam->{cgi_path}/manage_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			    1);
	    }
	    exit;
	}
	
    } elsif ($Action eq $message->{'b_delete'} && $Folder ne '' && $yesb eq "" && $nob eq "" ) {
	my $cnt = 0;
	my $DECFolder = IMAPUtils::utf7_decode($Folder);
	foreach my $f (@ownfol) {
	    $cnt++ if isSubFolder($DECFolder,$f);
	}
	
	if( $cnt >= 1 && ! defined $ryesb && ! defined $rnob ) {
	    $this->confirm_recursive();
	} else {
	    $this->confirm($ryesb);
	}
	exit;
    } elsif($Action eq $message->{'rename'} && $Folder ne '' && $NewFolder ne '') {
	my $cnt = 0;
	foreach my $f (@ownfol) {
	    $cnt++ if isSubFolder($ENCFolder, $f);
	}

	if( $cnt >= 1  && ! defined $ryesb && ! defined $rnob ) {
	    $this->confirm_recursive();
	    exit;
	}
	
	my $imap = new Net::IMAP($imaphost, Debug => 0);
	if(!defined $imap) {
	    $this->display_error("can't connect to $imaphost: $!",
			  "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	my $ret = $imap->login($LOGINuid, $LOGINpasswd);
	
	if($$ret{Status} ne "ok") {
	    $imap->logout();
	    $this->display_error("login $message->{failed}: Serverresponse:$$ret{Status} => $$ret{Text}\n",
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	} else {
	    # get the prefix of the selected folder
	    my $match = "\\".$delimiter;
	    my $pre="";
	    if( $Folder =~ /(.*)$match.*/ ){
		$pre = $1;
	    }
	    if($pre ne ""){
		#print STDERR "PRE: $pre\n";
		$pre .= $delimiter;
	    }
	    my $ENCNewFolder = $pre.utf7_encode($NewFolder);
	    $NewFolder = $pre.$NewFolder;

	    my $error = 0;
	    my $msg = "";
	    my $errmsg = "";

	    if( ($cnt == 0) || ( ($cnt >= 1) && ( defined $ryesb )) ){
		$ret = $imap->rename($Folder, $ENCNewFolder);
		
		
		if($$ret{Status} eq "ok") {
		    $msg = "$ENCFolder $message->{'succ_rename'} $NewFolder";
		    &IMAPUtils::subscribe($LOGINuid, $LOGINpasswd, $NewFolder, $imaphost);
		    $cgi->delete('NewFolder');
		} else {
		    $error = 1;
		    $errmsg = "$ENCFolder $message->{'err_rename'} $NewFolder: $$ret{Text}";
		}
		
		$imap->logout();
		if( $error ) {
		    $this->display_error($msg.$errmsg,
				  "$confParam->{cgi_path}/manage_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
		} elsif( $msg ne "" ) {
		    $this->display_msg($msg,
				"$confParam->{cgi_path}/manage_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
				1);
		}
		exit;
	    }
	}
	
    } elsif($Action eq $message->{'new'} && $NewFolder ne '') {
	my $match = "\\".$delimiter;
	$NewFolder =~ s/^$match//;

	my $ENCNewFolder = utf7_encode($NewFolder);
	
	my $createfolder = $ENCNewFolder;
	if( $Folder ne "" ){
	    $createfolder = $Folder.$delimiter.$ENCNewFolder;
	}
	#print STDERR "create($createfolder)\n";
	
	
	if( $this->create_folder("$createfolder") == 0) {
	    $cgi->delete('NewFolder');
	    my $uri = "$confParam->{cgi_path}/manage_folder.pl?".
		"sessionID=$sessionID\&tab=$tab\&stab=$stab\&Folder=".uri_escape("$Folder.$NewFolder")."\&View=new";
	    $this->display_msg("$createfolder $message->{'succ_new'}", $uri , 1);
	    exit;
	} else {
	    my $uri = "$confParam->{cgi_path}/manage_folder.pl?".
		"sessionID=$sessionID\&tab=$tab\&stab=$stab\&Folder=".uri_escape("$Folder.$NewFolder")."\&View=new";
	    $this->display_error("$createfolder $message->{'err_new'}", $uri , 2);
	    exit;
	}
    } elsif($Action eq $message->{'permissions'} && $Folder ne '') {
	$Folder = $cgi->escape("$Folder");
	#print STDERR "MANAGE PERM OF <$Folder>\n";
	my $uri = "$confParam->{cgi_path}/manage_folder_permissions.pl?sessionID=$sessionID&Folder=$Folder\&tab=$tab\&stab=$stab";
	$this->display_msg($message->{goto_permissions}, $uri, 1);
	exit;
    }


    #@ownfol = IMAPUtils::getFolder($LOGINuid, 'lca' , $LOGINpasswd);

    if($View ne '') {
	$this->printNew();
    } else {
	$this->printModify();
    }
}

sub isSubFolder($$) {
    my ($from, $of) = @_;
    my $delimiter = &IMAPUtils::getDelimiter();
    $delimiter = "\\".$delimiter;
    
    $of =~ s/$from//;
    
    if( $of ne "" ) {
	if( $of =~ /^$delimiter/ ) {
	    return 1;
	} else {
	    return 0;
	}
    } else {
	return 0;
    }
}

sub confirm() {
    my $this = shift;
    my $recursive = shift;

    my $cgi = $this->{"cgi"};
    
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"MANAGE_FOLDER"))->data();

    my $Folder    = $cgi->param('Folder') || '';
    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');

    my $prefix;
    my $button_width=100;

    if( defined $recursive ) {
	$prefix = $message->{confirm_prefix};
    } else {
	$prefix = "";
    }

    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->Tr({},
		      $cgi->td({},
		      $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_folder.pl").
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->Tr(
						    [
						     $cgi->td({-class=>'AdminHeader', -colspan=>2 },
									 "<b>$message->{confirm_delete_head}&nbsp;$Folder</b>"
							      ),
						     $cgi->td({-colspan=>2, -class=>'AdminSubHeaderRed'},
							      [$message->{confirm_delete_warn} ])
						     ]),
					   $cgi->Tr(
						    $cgi->td({-align=>"center"},
							     $cgi->submit(-class=>"button",-name=>"nob",
									  -value=>"$message->{no}",
									  -width=>$button_width)
							    ),
						    $cgi->td({-align=>"center"},
							     $cgi->submit(-class=>"button",-name=>"yesb",
									  -value=>"$message->{yes}",
									  -width=>$button_width)
							     )
						    )
					   )
			       ).
		      $cgi->hidden(-name=>'sessionID', -value=>$sessionID).
		      $cgi->hidden(-name=>'Folder', -value=>$Folder).
		      $cgi->hidden(-name=>'tab', -value=>$tab).
		      $cgi->hidden(-name=>'stab', -value=>$stab).
		      $cgi->hidden(-name=>'recursive', -value=>$recursive).
		      $cgi->hidden(-name=>"Action", -value=>"$message->{'b_delete'}").
		      $cgi->end_form()
		     );
    $html .= $cgi->end_table();
    
    $this->SUPER::display($html);
}

sub confirm_recursive() {
    my $this = shift;

    my $cgi = $this->{"cgi"};

    my @ownfol = sort @{$this->{"ownfol"}};
    
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"MANAGE_FOLDER"))->data();

    my $View      = $cgi->param('View') || '';
    my $Action    = $cgi->param('Action') || '';
    my $Folder    = $cgi->param('Folder') || '';
    my $NewFolder = $cgi->param('NewFolder') || '';
    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');

    my $head;
    my $body;
    my $button_width=100;

    if( $Action eq $message->{'rename'} ) {
	$head = $message->{confirm_recursive_rename_head};
	$body = $message->{confirm_recursive_rename_warn};
    } else {
	$head = $message->{confirm_recursive_delete_head};
	$body = $message->{confirm_recursive_delete_warn};
    }

    my $ftxt = "<tr><td class='AdminSubHeader' colspan=2><p><b>";
    foreach my $f (@ownfol) {
	$ftxt.=$f."<br>" if isSubFolder($Folder, $f);
    }
    $ftxt .= "</b></td></tr>";

    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->Tr({},
		      $cgi->td({},
			   $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_folder.pl").
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->Tr(
						    [
						     $cgi->td({-class=>'AdminHeader', -colspan=>2 },
									 "<b>$head&nbsp;$Folder</b>"
							      ),
						     $cgi->td({-colspan=>2, -class=>'AdminSubHeaderRed'},
							      [$body.$ftxt]),
						     ]),
					   $cgi->Tr(
						    $cgi->td({-align=>"center"},
							     $cgi->submit(-class=>"button",-name=>"rnob",
									  -value=>"$message->{no}",
									  -width=>$button_width).
							     ( $Action eq $message->{'rename'} ?
							       $cgi->hidden(-name=>"NewFolder", -value=>$NewFolder) :
							       "" )),
						    $cgi->td({-align=>"center"},
							     $cgi->submit(-class=>"button",-name=>"ryesb",
									  -value=>"$message->{yes}",
									  -width=>$button_width)
							     )
						    )
					   )
			       ).
			   $cgi->hidden(-name=>'sessionID', -value=>$sessionID).
			   $cgi->hidden(-name=>'Folder', -value=>$Folder).
			   $cgi->hidden(-name=>"Action", -value=>$Action).
			   $cgi->hidden(-name=>"tab", -value=>$tab).
			   $cgi->hidden(-name=>"stab", -value=>$stab).
			   $cgi->end_form()
		      );
    $html .= $cgi->end_table();
    
    $this->SUPER::display($html);
}

sub printModify {
    my $this = shift;

    my $cgi = $this->{"cgi"};

    my @ownfol = sort @{$this->{"ownfol"}};
    
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"MANAGE_FOLDER"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');

    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->Tr({},
		      $cgi->td({},
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_folder.pl"),
					   $cgi->Tr(
						    $this->help_th(2, $message->{modify_folders},
								   "MODIFY_FOLDER")
						    ),
					   $cgi->Tr(
						    $cgi->td({-colspan => 2,
							      -class=>'AdminSubHeader'},
							     $message->{'modify_folders_long'})
						    ),
					   $cgi->Tr(
						    $cgi->td({-rowspan=>5},
							     $cgi->scrolling_list(-name=>'Folder',
										  -value=>\@ownfol,
										  -size=>"12",
										  -default=>['INBOX'],
										  -width=>200)),
						    $cgi->td({-align=>"right" },
							     $cgi->submit(-class=>"button",-name=>"Action",
									  -value=>"$message->{'b_delete'}",
									  -width=>150)),
						    ),
					   $cgi->Tr(
						    $cgi->td('<hr noshade size="2"')
						    ),
					   $cgi->Tr(
						    $cgi->td({-align=>"right" },
							     $cgi->textfield(-name=>"NewFolder", -value=>""),
							     $cgi->submit(-class=>"button",-name=>"Action",
									  -value=>"$message->{'rename'}", -width=>150))
						    ),
					   $cgi->Tr(
						    $cgi->td('<hr noshade size="2"')
						    ),
					   $cgi->Tr(
						    $cgi->td({-align=>"right"}, 
							     $cgi->submit(-class=>"button",-name=>"Action",
									  -value=>"$message->{'permissions'}",
									  -width=>150).
							     $cgi->hidden(-name=>'sessionID', -value=>$sessionID).
							     $cgi->hidden(-name=>'tab', -value=>$tab).
							     $cgi->hidden(-name=>'stab', -value=>$stab).
							     $cgi->end_form()
							     )
						    )
					   )
			       )
		      );

    $html .= $cgi->end_table();

    $this->SUPER::display($html);
}


sub printNew() {
    my $this = shift;

    my $cgi = $this->{"cgi"};

    my @ownfol = sort @{$this->{"ownfol"}};
    
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"MANAGE_FOLDER"))->data();

    my $tab       = $cgi->param('tab');
    my $stab      = $cgi->param('stab');


    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $cgi->Tr({},
		      $cgi->td({},
			       $cgi->table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"},
					   $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_folder.pl"),
					   $cgi->Tr(
						    $this->help_th(2, $message->{create_new_folder},
								   "CREATE_FOLDER")
						    ),
					   $cgi->Tr(
						    $cgi->td({-class=>'AdminSubHeader',
							      -colspan => 2},
							     $message->{select_folder_and_give_name})
						    ),
					   $cgi->Tr(
						    $cgi->td({-rowspan=>3},
							     $cgi->scrolling_list(-name=>'Folder',
										  -value=>\@ownfol,
										  -size=>"10",
										  -default=>['INBOX'],
										  -override=>1,
										  -width=>200)),
						    
						    $cgi->td(
							     "$message->{'new_sub_folder'}:<br>".
							     $cgi->textfield(-name=>"NewFolder", -value=>"")."&nbsp;".
							     $cgi->submit(-class=>"button",-name=>"Action", -value=>"$message->{'new'}").
							     $cgi->hidden(-name=>'sessionID', -value=>$sessionID).
							     $cgi->hidden(-name=>'View', -value=>'new').
							     $cgi->hidden(-name=>'tab', -value=>$tab).
							     $cgi->hidden(-name=>'stab', -value=>$stab).
							     $cgi->end_form()
							     )
						    ),
					   $cgi->Tr($cgi->td("&nbsp;")),
					   $cgi->Tr($cgi->td("&nbsp;"))
					   )
			       )
		      );
    $html .= $cgi->end_table();

    $this->SUPER::display($html);
}


sub create_folder($) {
    my $this = shift;
    my $folder = shift;

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};

    my $LOGINuid      = $confParam->{uid};
    my $LOGINpasswd   = $confParam->{passwd};
    my $imaphost      = $confParam->{IMAPserver};
    my $imapport      = $confParam->{IMAPport};

    my $errs    = "";
    my $command = $confParam->{bin_path}."/add_folder -";
    my $cmd_args  = "H=$imaphost\nP=$imapport\nal=cyrus\n";
       $cmd_args .= "ul=$LOGINuid\nup=$LOGINpasswd\nmb=$folder\n";

    $errs = cmd_pipe($command, $cmd_args);
    if($errs ne "") {
	return -1;
    }
    return 0;
}


1;
