#
# Copyright (c) 2003 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: manage_services.pm,v 1.3 2003/05/24 11:23:16 varkoly Exp $
#
package manage_services;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use cfreader;
use strict;
use Display;
use LDAPUtils;
use Net::LDAP qw(:all);
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);

    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};

    my @services;
    if( defined $::CONF_GLOBAL{'GENERAL'}{'MonitorServices'} &&
        $::CONF_GLOBAL{'GENERAL'}{'MonitorServices'} ne "" ){
	@services = split(/,/,$::CONF_GLOBAL{'GENERAL'}{'MonitorServices'});
    }
    if( defined @services ) {
	$this->{"services"} = \@services;
    } else {
	$this->{"services"} = [ "cups", "ffums"];
    }

    # NOTE: the order is important! a_lock has to be started first!
    $this->{"fax_services"} = [
			       "ffums_a_lock",
			       "ffums_a_ask",
			       "ffums_a_clean",
			       "ffums_a_cnv",
			       "ffums_a_cron",
			       "ffums_a_cut_header",
			       "ffums_a_dotvar",
			       "ffums_a_error",
			       "ffums_a_faxapi",
			       "ffums_a_frontpage",
			       "ffums_a_group",
			       "ffums_a_html",
			       "ffums_a_route",
			       "ffums_a_sms",
			       "ffums_a_smtp_rx",
			       "ffums_a_smtp_tx",
			       ];

    my $service_adjust = $cgi->param('service_adjust');

    my $fax_enable_all = $cgi->param('fax_enable_all');
    my $fax_start_all  = $cgi->param('fax_start_all');

    if( defined $service_adjust && $service_adjust ne "" ) {
	$this->adjust_service();
    } elsif( defined $fax_enable_all && $fax_enable_all ne "" ||
	     defined $fax_start_all && $fax_start_all ne "" ) {
	$this->fax_adjust();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $cgi       = $this->{"cgi"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SERVICES"))->data();

    my $showwhat = $cgi->param('showwhat') || "normal";

    my $url = "$confParam->{cgi_path}/manage_services.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showwhat=$showwhat";
    # get current runlevel
    open(RL,"/sbin/runlevel|");
    <RL> =~ /.\s(.)/;
    my $currentlevel = $1;
    close(RL);

    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=       $cgi->start_table({-border=>0, -cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    
    $html .=       $cgi->Tr( $this->help_th(5, "$message->{services_head}", "SERVICES") );
    $html .=       $cgi->td({-class=>'AdminSubHeader', -colspan => 5},
			    "$message->{services_help} <font color=green><b>$currentlevel</b></font>"
			    );

#    $html .=       $cgi->start_Tr();
#    $html .=         $cgi->start_td();
#    $html .=           $cgi->start_table({-width=>"100%"});
#    $html .=              $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_services.pl");
#    $html .=              $cgi->start_Tr();
#    $html .=                 $cgi->start_td({-size=>"1",-align=>"center"});
#    $html .=                    $cgi->popup_menu(-name=>"showwhat",
#						 -values=>[ 'normal', 'fax'],
#						 -default=>'normal',
#						 -labels=>{ 'normal' => "$message->{services_services}",
#							    'fax' => "$message->{services_fax}"} );
#    $html .=                 $cgi->start_td({-size=>"1",-align=>"center"});
#    $html .=                    $cgi->submit(-name=>"setview",
#					     -class=>"BlockButton",
#					     -value=>"$message->{services_set_view}").
#						 $cgi->hidden(-name=>"sessionID",
#							      -value=>"$sessionID").
#						 $cgi->hidden(-name=>"tab",-value=>"$tab").
#						 $cgi->hidden(-name=>"stab",-value=>"$stab").
#						 $cgi->end_form();
#    $html .=                 $cgi->end_td();
#    $html .=              $cgi->end_Tr();
#    $html .=           $cgi->end_table();
#    $html .=         $cgi->end_td();
#    $html .=       $cgi->end_Tr();

    $html .=       $cgi->start_Tr();
    $html .=         $cgi->start_td({-align=>"center"});
    $html .=           $cgi->start_table({-width=>"100%"});

    $html .= $cgi->start_Tr();
    $html .= $cgi->td({-colspan=>5, -align=>"center"},
		      $cgi->hr({-noshade => '1', -size => '1', -width=>'98%'}));
    $html .= $cgi->end_Tr();

    
    my $display = $this->{"services"};
    if( $showwhat eq "normal" ) {
	$display = $this->{"services"};
    } elsif( $showwhat eq "fax" ) {
	$display = $this->{"fax_services"};
    }

    my $sum_enabled = 0;
    my $sum_status  = 0;

    foreach my $service ( @$display ) {
	# check if service is enabled in current runlevel
	system("/sbin/chkconfig -c $service $currentlevel");
	my $enabled = $? >> 8;

	# get rc<service> status exit code:
        # 0 - service up and running
        # 1 - service dead, but /var/run/  pid  file exists
        # 2 - service dead, but /var/lock/ lock file exists
        # 3 - service not running (unused)
        # 4 - service status unknown :-(
        # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	my $ret = $session->suad_service_exec("$service","status");
	$ret->code() =~ /OK:\s(\d)/;
	my $status = $1;

	#print STDERR "Service: $service, enabled=<$enabled>, status=<$status>\n";

	my $color = ( $enabled == 0 && $status != 0  ? "red" : "green" );
	$html .= $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_services.pl");
	$html .= $cgi->start_Tr();
	$html .= $cgi->td({-nowrap=>undef},
			  [
			   "$message->{services_service} <b><i><font color=$color>$service</font></i>",
			   $cgi->popup_menu(-name=>"enabled_$service",
					    -values=>["$message->{active}", "$message->{inactive}"],
					    -default=>($enabled == 0 ? "$message->{active}" : "$message->{inactive}")
					    ),
			   "$message->{services_status}:",
			   $cgi->popup_menu(-name=>"running_$service",
					    -values=>["$message->{running}", "$message->{stopped}",
						      "$message->{services_reload}", "$message->{services_restart}"],
					    -default=>($status == 0 ? "$message->{running}" : "$message->{stopped}")
					    ),
			   $cgi->submit(#-class=>"BlockButton",
					-name=>"service_adjust",
					-value=>"$message->{service_set_status}").
			   $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
			   $cgi->hidden(-name=>"service", -value=>$service).
			   $cgi->hidden(-name=>"showwhat", -value=>$showwhat).
			   $cgi->hidden(-name=>"tab", -value=>$tab).
			   $cgi->hidden(-name=>"stab", -value=>$stab)
			   ]);
	$html .= $cgi->end_Tr();
	$html .= $cgi->end_form;

	$sum_enabled += $enabled;
	$sum_status  += $status;
    }

    if( $showwhat eq "fax" && ( $sum_enabled ne 0 || $sum_status ne 0 ) ) {

	#print STDERR "<$sum_enabled> <$sum_status>\n";
	
	$html .= $cgi->start_form(-action=>$confParam->{cgi_path}."/manage_services.pl");
	$html .= $cgi->start_Tr();

	if( $sum_enabled ne 0 ) {
	    $html .=     $cgi->td("&nbsp;");
	    $html .=     $cgi->start_td();
	    $html .=         $cgi->submit(-class=>"BlockButton", -name=>"fax_enable_all",
					  -value=>"$message->{services_enable_all}").
					      $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
					      $cgi->hidden(-name=>"showwhat", -value=>$showwhat).
					      $cgi->hidden(-name=>"tab", -value=>$tab).
					      $cgi->hidden(-name=>"stab", -value=>$stab);
	    $html .=     $cgi->end_td();
	}

	if( $sum_status ne 0 ) {
	    my $rows = $sum_enabled ne 0 ? 1 : 3;
	    for(my $i=0; $i<$rows; $i++ ) {
		$html .=     $cgi->td("&nbsp;");
	    }
	    $html .=     $cgi->start_td();
	    $html .=         $cgi->submit(-class=>"BlockButton", -name=>"fax_start_all",
					  -value=>"$message->{services_start_all}").
					      $cgi->hidden(-name=>"sessionID", -value=>$sessionID).
					      $cgi->hidden(-name=>"showwhat", -value=>$showwhat).
					      $cgi->hidden(-name=>"tab", -value=>$tab).
					      $cgi->hidden(-name=>"stab", -value=>$stab);
	    $html .=     $cgi->end_td();
	}

	$html .= $cgi->end_Tr();
	$html .= $cgi->end_form;
    }


    $html .=           $cgi->end_table;
    $html .=         $cgi->end_td;
    $html .=       $cgi->end_Tr;


    $html .=     $cgi->end_table;
    $html .=     $cgi->end_td;
    $html .=   $cgi->end_Tr;
    $html .= $cgi->end_table;

    $this->SUPER::display($html);
}


sub adjust_service {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $cgi       = $this->{"cgi"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SERVICES"))->data();

    my $service = $cgi->param('service');
    my $enabled = $cgi->param("enabled_$service");
    my $running = $cgi->param("running_$service");


    my $showwhat = $cgi->param('showwhat') || "normal";

    my $url = "$confParam->{cgi_path}/manage_services.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showwhat=$showwhat";

    #print STDERR "$enabled $running\n";

# Return values acc. to LSB for all commands but status:
# 0       - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
    my $ret;
    if( $running eq $message->{stopped} ) {
	$ret = $session->suad_service_exec("$service", "stop");
    } elsif( $running eq $message->{running} ) {
	$ret = $session->suad_service_exec("$service", "start");
    } elsif( $running eq $message->{services_restart} ) {
	$ret = $session->suad_service_exec("$service", "restart");
    } elsif( $running eq $message->{services_reload} ) {
	$ret = $session->suad_service_exec("$service", "reload");
    }
    my $code = $ret->code();
    if( $code =~ /^ERROR:/ ) {
	$this->display_msg("$code", $url);
	exit;
    }
    $code =~ /OK:\s(\d)/;

    if( $1 == 3 && $running eq $message->{services_reload} ) {
	$this->display_error("<b>$message->{services_reload}</b> $message->{services_not_implemented} <b>$service</b>", $url);
	exit;
    } elsif( $1 != 0 ) {
	$this->display_msg("$message->{services_exec_return} <b>$1</b>", $url);
	exit;
    }

    if( $enabled eq $message->{inactive} ) {
	$ret = $session->suad_service_exec("$service", "disable");
    } elsif( $enabled eq $message->{active} ) {
	$ret = $session->suad_service_exec("$service", "enable");
    }

    my $code = $ret->code();
    if( $code =~ /^ERROR:/ ) {
	$this->display_msg("$code", $url);
	exit;
    }
    $code =~ /OK:\s(\d)/;
    if( $1 != 0 ) {
	$this->display_msg("$message->{services_exec_return} <b>$1</b>", $url);
	exit;
    }

    $this->display_msg("$message->{service_status_set}",
		       $url,
		       1);
}

sub fax_adjust {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $cgi       = $this->{"cgi"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SERVICES"))->data();

    my $fax_enable_all = $cgi->param('fax_enable_all');
    my $fax_start_all  = $cgi->param('fax_start_all');


    my $showwhat = $cgi->param('showwhat') || "normal";

    my $url = "$confParam->{cgi_path}/manage_services.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showwhat=$showwhat";

    my $ret;
    my $text;
    foreach my $service ( @{$this->{"fax_services"}} ) {
	if( defined $fax_enable_all && $fax_enable_all ne "" ) {
	    #print STDERR "ALL ENABLE\n";
	    $ret = $session->suad_service_exec("$service", "enable", "--force");
	    $ret->code() =~ /OK:\s(\d)/;
	    if( $1 != 0 ) {
		$text .= "$message->{services_enable_failed} $service<br>";
	    }
	} elsif( defined $fax_start_all && $fax_start_all ne "" ) {
	    #print STDERR "ALL START\n";
	    $ret = $session->suad_service_exec("$service", "start");
	    $ret->code() =~ /OK:\s(\d)/;
	    if( $1 != 0 ) {
		$text .= "$message->{services_start_failed} $service<br>";
	    }
	}
    }

    
    if( defined $text ) {
	$this->display_error("$text",
			     $url);
    } else {
	$this->display_msg("$message->{service_status_set}",
			   $url,
			   1);
    }
}

1;
