#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: monitor.pm,v 1.2 2003/05/06 11:30:44 varkoly Exp $
#
package monitor;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Display;
use Socket;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $killsession = $cgi->param('killsession');

    if( defined $killsession && $killsession ne "" ) {
	$this->killsession($killsession);
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $showby  = $q->param('showby') || "";

    my $message = ($session->getLanguage($confParam->{LANG},"MONITOR"))->data();

    my $html = "";

    my $ret = $session->monitor();
    if( $ret->code() =~ /FAILED/ ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID\&tab=$tab");
	exit;
    }
    my $md = $ret->data();

    my @users;
    foreach my $id ( keys %$md ) {
	push @users, $md->{$id}->{uid};
    }

    my @sorted = sort(@users);


    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= $q->start_Tr({});
    $html .= $q->start_td({});
    $html .= $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .= $q->Tr( $this->help_th(5, $message->{mon_title}, "MONITOR") );
    $html .= $q->Tr( $q->td({-class=>'AdminSubHeader', -colspan=>5}, $message->{mon_help}.
			    "<br>$message->{nr_current} <font color=green><b>".($#sorted+1).
			    "</b></font>"));

    $html .= $q->start_Tr();
    $html .=    $q->start_td({-colspan=>5});
    $html .=       $q->start_table({-border=>1, -cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=          $q->start_Tr();

    my $class = $showby eq "*" ? "active" : "inactive";
    $html .= $q->td({-class=>"f_$class"}, 
		    $q->a({-class=>$class,
			   -href=>$confParam->{cgi_path}."/monitor.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showby=*"},"*"));
    foreach my $dec ( 65..90 ) {
	my $letter = chr($dec);
	$class = $showby eq $letter ? "active" : "inactive";
	$html .= $q->td({-class=>$class}, 
			$q->a({-class=>$class,
			       -href=>$confParam->{cgi_path}."/monitor.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showby=$letter"},"$letter"));
    }

    $html .=          $q->end_Tr();
    $html .=        $q->end_table();
    $html .=    $q->end_td();
    $html .= $q->end_Tr();

    $html .= $q->Tr(
		    $q->td(
			   [ "<b>$message->{uid}</b>", "<b>$message->{ip}</b>",
			     "<b>$message->{lang}</b>", "<b>$message->{size}</b>",
			     "<b>$message->{livetime}</b>"]
			   )
		    );
    $html .= $q->Tr(
		    $q->td({-colspan=>5},
			   $q->hr({-with=>"100%"})
			   )
		    );
    
    my $match = "";
    if( $showby eq "*" ) {
	$match = ".";
    } else {
	$match = $showby;
    }
    my $displayed;
    foreach my $uid ( @sorted ) {
	foreach my $id ( keys %$md ) {
	    next if $match eq "";
	    next if $md->{$id}->{uid} ne $uid;
	    next if defined $displayed->{$id};
	    next if $md->{$id}->{uid} !~ /^$match/i;

	    my $dsize = $md->{$id}->{dl};
	    my $ttl   = $md->{$id}->{ttl};
	    my $remote = "";
	    if( defined defined $::CONF_GLOBAL{'GENERAL'}{'MonitorResolveAddr'} &&
		$::CONF_GLOBAL{'GENERAL'}{'MonitorResolveAddr'} eq "true" ) {
		my $addr = $md->{$id}->{remoteaddr};
		$remote = gethostbyaddr(inet_aton($addr),AF_INET);
		if( ! defined $remote || $remote eq "" ) {
		    $remote = $addr;
		}
	    } else {
		$remote = $md->{$id}->{remoteaddr};
	    }
	    $dsize = ( $dsize > 9999 ? int($dsize/1024)." kByte" : $dsize." Byte" );
	    $ttl   = ( $ttl > 60 ? int($ttl/60)." $message->{minutes}" : $ttl." $message->{seconds}");
	    $html .= $q->Tr(
			    $q->td(
				   [ ( $id ne $sessionID ? 
				       $q->a({href=>$confParam->{cgi_path}."/monitor.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&killsession=$id\&showby=$showby"},
					     $uid)
				       :
				       $uid),
				     $remote,
				     $md->{$id}->{lang},
				     $dsize, $ttl ]
				   )
			    );
	    $displayed->{$id} = 1;
	}
    }
    
    $html .= $q->end_table();	    
    $html .= $q->end_td();	    
    $html .= $q->end_Tr();	    
    $html .= $q->end_table();
    
    $this->SUPER::display($html);
}

sub killsession {
    my $this = shift;

    my $killID = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $showby  = $q->param('showby') || "";
    my $message = ($session->getLanguage($confParam->{LANG},"MONITOR"))->data();

    $session->comFireLogout($killID);
    
    my $ret = $session->clear($killID);
    if( $ret->code() =~ /FAILED/ ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/monitor.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showby=$showby");
	exit;
    }

    $this->display_msg("$message->{session_cleared}",
		       $confParam->{cgi_path}."/monitor.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&showby=$showby",
		       1);
    exit;
}

1;
