#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
#
#
# $Id: post_file.pm,v 1.12 2004/03/15 20:20:58 varkoly Exp $
#
package post_file;
#use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(freeze thaw);
use Net::LDAP;
use Net::Netmask;
use Digest::MD5;
use MIME::Base64;
use LDAPUtils;
use Utils;
use Display;
use File::Basename;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);

    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $doit = $cgi->param('doit');

    if(defined $doit && $doit ne "") {
	    $this->post_it();
    } else {
	    $this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"POST_FILE"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;
    my $cgi_params = ();
    my $read_from_session = $q->param('read_from_session');
    my @classes = ();
    my %labels  = ();
    my $class_room = "";
    my $mailing  = $q->param("mailing");
    
    if( defined $read_from_session && $read_from_session == 1){
	    $cgi_params = $this->session_to_form;
	    #print STDERR "Read data from sesssion:\n";
	    foreach my $key ( keys %$cgi_params){
	        #print STDERR "        $key: ".$cgi_params->{$key}."\n";
	    }
    }else{
	    $cgi_params = $q->Vars();
    }
   
    my $tab        = $cgi_params->{'tab'};
    my $stab       = $cgi_params->{'stab'};

# -- search for classes

    my $ldap = Net::LDAP->new("$ldaphost",port=>$ldapport,version => 3);
    if(!defined $ldap) {
	    $this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }

    my $result = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($result->code != 0) {
	    $errs = "bind $message->{failed}\n\n";
	    $errs .= &LDAPerror($result);
	    $this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
    }

    # Zuerst Schauen wir mal wo wir sind
    $_ = $q->remote_addr;
    /(\d+).(\d+).(\d+).(\d+)/;
    my $network = "$1.$2.$3.$4/26";
    my $block = new Net::Netmask($network);
    $network = $block->base();
    $result = $ldap->search (  # perform a search
                       base   => "o=DHCP,$ldapbase",
                       attrs => ['description'],
                       filter => "dhcpRange=$network"
                      );
    if( $result->count > 0 ) {
	    $class_room = $result->entry(0)->get_value('description');
	    if($class_room ne ''){
		    push @classes, $message->{class_room}.": ".$class_room;
	    }
    }

    # Jetzt sammeln wir die Klassen
    $result = $ldap->search (  # perform a search
                       base   => "$ldapbase",
                       scope  => "one",
                       attrs => ['cn', 'gidNumber','description'],
                       filter => "(&(|(objectclass=SuSESchoolClass)(objectclass=SuSESchoolGroup))(memberuid=$ADMINuid))"
                      );

    if($result->code == 0) {
      foreach my $entry ($result->all_entries) {
        my $key = $entry->get_value("gidNumber");
        my $val = $entry->get_value("cn");
	my $desc = $entry->get_value("description");
	push @classes, $val;
	if( defined $desc && $desc ne '' ) { 
		$labels{$val} = $desc.': '.$val; 
        } else {
		$labels{$val} = $val;
	}
      }
    }


    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .= "\n";
    $html .=	$q->start_Tr();
    $html .=	    $q->start_td();
    $html .=		$q->start_multipart_form(
				-action => $confParam->{'cgi_path'}."/post_file.pl", -name => "form" );
    $html .=		    $q->start_table({-border=>0, -cellspacing => 0, -cellpadding=>3, -width=>"100%"});
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $this->help_th(2, $message->{post_file}, "POST_FILE");
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-align => "right"});
    $html .=                           $message->{"file"};
    $html .=			    $q->end_td();
    $html .=			    $q->start_td({-align => "left"});
    $html .=                           $q->filefield(-name=>'file_to_post',-size=>50);
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-align => "right"});
    $html .=                           $message->{"classe"};
    $html .=			    $q->end_td();
    $html .=			    $q->start_td({-align => "left"});
    $html .=                        $q->popup_menu(    -name=>'classe',
                                                       -values=>\@classes,
						       -labels=>\%labels,
						       -default=>$classes[0]
						  );
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-colspan => 2, -align => "center"});
    $html .=                        $q->checkbox(-name=>'clear_home',
                                                 -checked=>'checked',
                                                 -label=>"$message->{'clear_home'}"
                                                 );
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-colspan => 2, -align => "center"});
    $html .=				$q->submit(-name=>"doit", -value=>$message->{'post_it'});
    $html .=				$q->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .=				$q->hidden(-name=>"tab", -value=>$tab);
    $html .=				$q->hidden(-name=>"stab", -value=>$stab);
    $html .=				$q->hidden(-name=>"class_room", -value=>$class_room);
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    $html .= "\n";
    $html .=		    $q->end_table();
    $html .=		$q->end_form();
    $html .=	    $q->end_td();
    $html .=	$q->end_Tr();
    $html .= $q->end_table();
			
    $this->back_url("$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
    $this->SUPER::display($html);
} 

sub post_it {
    my $this = shift;

    my $q         = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message   = ($session->getLanguage($confParam->{LANG},"POST_FILE"))->data();

    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $classe     = $q->param('classe');
    my $class_room = $q->param('class_room');
    my $clear_home = $q->param('clear_home');
    my $file_to_post   = $q->upload('file_to_post');

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    my $bind_dn = "uid=".$ADMINuid.",".$ldapbase;

    my @users	   = ();
    my @lines	   = ();
    my $MESSAGE    = "";
    my $ret        = "";
    my $url = "$confParam->{cgi_path}/post_file.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab";

    #-- reading the file in a variable
    my $buffer = "";
    fileparse_set_fstype(MSWin32);
    my $file_name = basename($file_to_post); 
    open (OUTFILE,">/tmp/$file_name.$ADMINuid");
    while ( $bytesread=read($file_to_post,$buffer,1024)) {
	print OUTFILE $buffer;
    }
    close OUTFILE;
  
    my $ldap = Net::LDAP->new("$ldaphost",port=>$ldapport,version => 3);
    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $result = $ldap->bind (   # bind to a directory with dn and password
			    dn       => "$bind_dn",
			    password => "$ADMINpasswd"
			   );

    if($result->code != 0) {
	my $errs = "bind $message->{failed}\n\n";
	$errs .= &LDAPerror($result);
	$this->display_error($errs,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    if( $classe eq $message->{class_room}.": ".$class_room ) {
        $result = $ldap->search (  # perform a search
                           base   => "$ldapbase",
                           scope  => "one",
                           attrs => ['uid',"homeDirectory"],
                           filter => "uid=$class_room-*"
                          );
        if($result->code != 0) {
            my $text = "search failed\n".&LDAPerror($result);
            $this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
            $ldap->unbind;
            exit;
        }        
	foreach my $entry ($result->all_entries) {
		my $uid  = $entry->get_value('uid');
		my $home = $entry->get_value('homeDirectory');
		# Windows mashine account
		if($uid =~ /\$$/) {
                        next;
                }
		if($clear_home) {
			system("sudo $confParam->{bin_path}/clear_home $uid");
		}
		$ret = $session->suad_copy("/tmp/$file_name.$ADMINuid","$home/Import/$file_name");
                if(  $ret->code() ne "OK" ) {
                   $MESSAGE .= "<b>Failed to save file $home/Import/$file_name</b><br>";
                } else {
                        $ret = $session->suad_chown("$home/Import/$file_name","$uid","102");
                        if(  $ret->code() ne "OK" ) {
                           $MESSAGE .= "<b>Failed to chown file $home/Import/$file_name</b><br>";
                        } else {
                           $MESSAGE .= "Succesfull saved file $home/Import/$file_name<br>";
                        }
                }
	    }
    } else {
	    $result = $ldap->search (  # perform a search
			       base   => "$ldapbase",
			       scope  => "one",
			       attrs => ['memberUid'],
			       filter => "(&(cn=$classe)(objectclass=posixgroup))"
			      );
	    if($result->code != 0) {
		my $text = "search failed\n".&LDAPerror($result);
		$this->display_error($text,"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
		$ldap->unbind;
		exit;
	    }
	    @users = $result->entry(0)->get_value('memberUid');
	    foreach my $uid (@users) {
		$result = $ldap->search (  # perform a search
				       base   => "uid=$uid,$ldapbase",
				       scope  => "base",
				       attrs => ['homeDirectory'],
				       filter => "(&(uid=$uid)(gidNumber=100))"
				      );
		if($result->count == 1) {
			my $home = $result->entry(0)->get_value('homeDirectory');
			# print STDERR "$home\n";
			# let see if a pupil make a joke
			$ret = $session->suad_stdout_exec("if ! test -d $home/Import; then test -e $home/Import  && rm $home/Import; mkdir $home/Import; chown $uid.users $home/Import; fi");
			$ret = $session->suad_copy("/tmp/$file_name.$ADMINuid","$home/Import/$file_name");
			if(  $ret->code() ne "OK" ) {
			   $MESSAGE .= "<b>Failed to save file $home/Import/$file_name</b><br>";
			} else {
				$ret = $session->suad_chown("$home/Import/$file_name","$uid","102");
				if(  $ret->code() ne "OK" ) {
				   $MESSAGE .= "<b>Failed to chown file $home/Import/$file_name</b><br>";
				} else {
				   $MESSAGE .= "Succesfull saved file $home/Import/$file_name<br>";
				}
			}
		}
	    }
    }
    system("rm /tmp/$file_name.$ADMINuid");
    $this->display_msg($MESSAGE, $url, 30);
}

1;
