#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: readcert.pm,v 1.1.1.1 2003/03/25 10:31:40 ray Exp $
#

package readcert;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use Display;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};

    my $doit = $cgi->param('doit');

    if(defined $doit && $doit eq "fetchit") {
	$this->sendcert();
    } else {
	$this->startup();
    }

}

1;

sub startup {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $message = ($session->getLanguage($confParam->{LANG},"READCERT"))->data();

    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    
    my $data = $this->get_certdata();
    
    my $html = "";
    
    if ( $data eq "") {
	$this->display_msg($message->{'no_cert_yet'},
			   $confParam->{'cgi_path'}."/menu.pl?sessionID=$sessionID&tab=$tab");
    } else {
	my $res = $session->modify({ucert => "$data"});
	if( $res->code() ne "OK" ) {
	    $this->display_error($message->{write2session_failed},
				 "$confParam->{cgi_path}/readcert.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
				 3);
	    exit;
	} else {
	    $this->display_msg($message->{back2}."&nbsp;".
			       $cgi->a({href=>"$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab"},
				       $message->{menu}),
			       "$confParam->{cgi_path}/readcert.pl?sessionID=$sessionID\&doit=fetchit\&tab=$tab\&stab=$stab",
			       3, $message->{nodownload});
	    exit;
	}
    }

#    $this->SUPER::display($html);
}



sub get_certdata {
    my $this = shift;

    my $confParam = $this->{"session"}->{"confParam"};
    my $sessionID = $confParam->{sessionID};

    my $ret = "";
    my $ldap= Net::LDAP->new($confParam->{LDAPserver}, port => $confParam->{LDAPport}, version => 3); 

    $ldap->bind ("uid=".$confParam->{uid}.", ".$confParam->{baseDN}, password=>$confParam->{passwd});
 
    my $mesg = $ldap->search (base   => $confParam->{baseDN},
			      scope  => "one",
                              filter => "(uid=".$confParam->{uid}.")",
                              attrs  => ['userpkcs12']
			      );
    
    if( $mesg->code ) {
	$this->display_error($mesg->error,
			     "$confParam->{cgi_path}/readcert.pl?sessionID=$sessionID",
			     3);
	exit;
    }

    # print STDERR $mesg->error;
    my @entries = $mesg->entries;
    foreach ( @entries ) {
	if(defined $_->get_value('userpkcs12')) {
	    my ($pt) = $_->get_value('userpkcs12');
	    foreach my $ent ( $pt ) {
		$ret=$ent;
		#            print STDERR $ret;
	    }
	}
    }
    $ldap->unbind;   # take down session
    return $ret;
} 

sub sendcert {
    my $this = shift;

    print $this->{"cgi"}->header(-type => 'application/x-pkcs12',
				 -Content_disposition => "inline; filename=\"".
				 $this->{"session"}->{"confParam"}->{uid}.
				 ".p12\"" );
    print $this->{"session"}->{"confParam"}->{"ucert"};
}
