# 
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: spam_filter.pm,v 1.3 2004/07/28 07:41:23 varkoly Exp $
#

package spam_filter;

use strict;
use Storable qw(thaw freeze);
use CGI qw/:standard *table start_ul -no_xhtml/;
use CGI::Carp qw(fatalsToBrowser);
use Net::IMAP;
use Net::LDAP;
use Utils;
use LDAPUtils;
use IMAPUtils;
use Display;
use ManageSieve;
use sieve;
use vars qw(@ISA $confParam);

@ISA = qw(Display);

sub new{
    my $this = shift;
    my $self = new Display(@_);
    $self->{'filtername'} = "filter.sieve";
    return bless $self, $this;
}

####################################
# display
sub display{
    my $this = shift;
    $this->{'filtername'}= "filter.sieve";
    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $message = ($session->getLanguage($confParam->{LANG},"SPAM_FILTER"))->data();
    my $q = $this->{'cgi'};
    my $sessionID = $confParam->{'sessionID'};

    my $username= $confParam->{"uid"};
    my $passwd=$confParam->{"passwd"};
    my $imapserver=$confParam->{"IMAPserver"};
    if(! usesSPAMFilter() ){
	$this->display_msg($message->{'sf_not_running'}, $confParam->{'cgi_path'}.'/menu.pl?'.
			   "sessionID=$sessionID&tab=sieve",3);
	exit;
    }else{
	my $spam_submit = $q->param('spam_submit');
	if( $spam_submit && $spam_submit ne "" ){
	    $this->submit_changes();
	}
	$this->startup();
    }
}
# end display
###################################
sub startup{
    my $this = shift;
    my $q = $this->{'cgi'};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"SPAM_FILTER", "PROCMAIL"))->data();
    my $sessionID = $confParam->{"sessionID"};
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');

    my $parsed = $this->load_script_to_session();
    if(! $parsed ){
        $this->display_msg($message->{'procmail_unable_to_parse'}, 
			   $confParam->{'cgi_path'}.'/edit_sieve.pl?sessionID='.$sessionID."&tab=$tab&stab=sieve_edit", 3);
        exit;
    }
    my $spam_flag = "nothing";
    my $selected_folder = "INBOX.spam";

    if( $parsed->[3] && $parsed->[3]->{'action'} ){
	if($parsed->[3]->{'action'} eq "fileinto"){
	    $spam_flag = "file";
	    $selected_folder = $parsed->[3]->{'param'};
	}elsif($parsed->[3]->{'action'} eq "discard"){
	    $spam_flag = "discard";
	}
    }
    my $title_ext;
    if( $confParam->{'uid'} ne $confParam->{'proxy_uid'} ){
	$title_ext = "(".$message->{'user'}.": ".$confParam->{'proxy_uid'}.")";
    }
    my $folders = IMAPUtils::getFolder($confParam->{'uid'}, "p", $confParam->{'passwd'}, $confParam->{IMAPserver});
    my %FOLDERS = ();
    foreach (keys %{$folders}) {
 	if( /INBOX/ ) {
	   $FOLDERS{$_}=$folders->{$_};
	}
    }
    $folders = \%FOLDERS;
    my $radio_labels = { 'file' => $message->{'sf_fileinto'}." ".
				   $q->popup_menu(-name => "folder_popup", 
						  -values => $folders, 
						  -default => $selected_folder),
			 'discard' => $message->{'sf_discard'},
			 'nothing' => $message->{'sf_nothing'} };
    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$q->start_Tr();
    $html .=	    $q->start_td();
    $html .=		$q->start_multipart_form(
				-action => $confParam->{'cgi_path'}."/spam_filter.pl",
				-name => "form");
    $html .=		    $q->start_table({-cellspacing => 0, -cellpadding=>3, -width=>"100%"});
    $html .=			$q->start_Tr();
    $html .=			    $this->help_th(2, $message->{'sf_title'}." ".$title_ext, "SPAM_FILTER");
    $html .=			$q->end_Tr();
    $html .=			$q->start_Tr();
    $html .=			    $q->td({-class=>'AdminSubHeader', -colspan => 2}, $message->{'sf_sub_title'});
    $html .=			$q->end_Tr();
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-colspan=>2});
    $html .=				$message->{'sf_what_todo'};
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();

    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-width => "5%"});
    $html .=				" ";
    $html .=			    $q->end_td();
    $html .=			    $q->start_td();
    $q->autoEscape(undef);
    $html .=				$q->radio_group(-name => "spam_check",
							-values => ['file', 'discard', 'nothing' ],
							-linebreak => 'true',
							-labels => $radio_labels,
							-default => $spam_flag
							);
    $q->autoEscape();
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();
    
    $html .=			$q->start_Tr();
    $html .=			    $q->start_td({-colspan=>2, -align => "center"});
    $html .=				$q->submit(-class=>"button", -name => "spam_submit",
						    -value => $message->{'save'});
    $html .=				$q->hidden( -name => "sessionID",
						    -value => $sessionID).
					$q->hidden( -name => "tab",
						    -value => $tab).
					$q->hidden( -name => "stab",
						    -value => $stab);
    $html .=			    $q->end_td();
    $html .=			$q->end_Tr();

    $html .=		    $q->end_table();
    $html .=		$q->end_form();
    $html .=	    $q->end_td();
    $html .=	$q->end_Tr();
    $html .= $q->end_table();
			
    $this->SUPER::display($html);
}

sub submit_changes{
    my $this = shift;
    my $q = $this->{'cgi'};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"SPAM_FILTER", "PROCMAIL"))->data();
    my $sessionID = $confParam->{"sessionID"};
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');
    my $admin_uid = $confParam->{'uid'};
    my $proxy_uid = $confParam->{'proxy_uid'};
    if( (! defined $proxy_uid) || ($proxy_uid eq "" )){
	$proxy_uid = $admin_uid;
    }
    my $passwd = $confParam->{'passwd'};

    my $frozen = $confParam->{'sieveScript'};
    $frozen = pack('H*',$frozen); # convert back to binary
    my $script_ref = thaw($frozen);     # melt down... :-)

    if(! $script_ref ){
        $this->display_error($message->{'procmail_unable_to_parse'}, $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
        exit;
    }
    my $spam_check = $q->param('spam_check');
    my %spam_rule = ();
    if( defined $spam_check ){
	if( $spam_check eq "file" ){
	    $spam_rule{'action'} = "fileinto";
	    $spam_rule{'param'} = $q->param('folder_popup'); 
	}elsif( $spam_check eq "discard" ){
	    $spam_rule{'action'} = "discard";
	    $spam_rule{'param'} = undef;
	}
    }
    $script_ref->[3] = \%spam_rule;
    my $script = struct_to_script($script_ref);

    my $sieve_obj = ManageSieve->new($confParam->{'IMAPserver'}, $confParam->{'SIEVEport'});
    my ($res, $msg) = $sieve_obj->connect();
    if ($res ne "OK"){
        $this->display_error("connection failed: $msg", $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->authplain($proxy_uid,$admin_uid,$passwd);
    if ($res ne "OK"){
        $this->display_error("authentication failed: $msg", $confParam->{'cgi_path'}.'/spam_filter.pl?sessionID='.$sessionID.
                    "&mode=display&tab=$tab&stab=$stab", 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->putScript($this->{'filtername'}, $script);
    if ($res ne "OK"){
        $this->display_error("Sieve put failed: $msg", $confParam->{'cgi_path'}.'/spam_filter.pl?sessionID='.$sessionID.
                    "&mode=display&tab=$tab&stab=$stab", 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->setActive($this->{'filtername'});
    if ($res ne "OK"){
        $this->display_error("Sieve activate failed: $msg", $confParam->{'cgi_path'}.'/spam_filter.pl?sessionID='.$sessionID.
                    "&mode=display&tab=$tab&stab=$stab", 3);
        exit;
    }
    $sieve_obj->logout();
    my $text=$message->{'sf_successfully_enabled'};
    if( defined $spam_check && $spam_check eq "nothing" ){
	$text=$message->{'sf_successfully_disabled'};
    }
    if( $admin_uid eq $proxy_uid ){
	$this->display_msg($text, $confParam->{'cgi_path'}."/spam_filter.pl?sessionID=$sessionID&tab=$tab&stab=$stab",1);
    }else{
        $this->display_msg($text, $confParam->{'cgi_path'}."/browse_user.pl?sessionID=$sessionID&tab=$tab&stab=$stab",1);
    }
    my %tmp = ( "sieveScript" => "" ,
		"proxy_uid" => "");

    my $s_rep = $session->modify(\%tmp);
    if( $s_rep->code() ne "OK" ) {
	print STDERR "unable to store data in session\n";
    }
    exit;
}

#######################################
# like load_script_to_session() in mail_filter.pm, with the difference, that it
# returns a reference to the parsed script or undef instead of 0 or -1
sub load_script_to_session(){
    my $this = shift;
    my $q = $this->{'cgi'};
    my $filtername = $this->{'filtername'};
    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $imapserver = $confParam->{'IMAPserver'};
    my $sieveport = $confParam->{'SIEVEport'};
    my $admin_uid = $confParam->{"uid"};
    my $proxy_uid = $q->param('USER');
    if( (! defined $proxy_uid) || ($proxy_uid eq "" )){
	$proxy_uid = $admin_uid;
    }
    $confParam->{'proxy_uid'} = $proxy_uid;
    my $passwd = $confParam->{"passwd"};
    my $sessionID = $confParam->{'sessionID'};
    my $tab = $q->param('tab');
    my $stab = $q->param('stab');

    my $sieve="";
    my $sieve_obj = ManageSieve->new($imapserver, $sieveport);
    my ($res, $msg) = $sieve_obj->connect();
    if ($res ne "OK"){
        $this->display_error("connection failed: $msg", $confParam->{'cgi_path'}.'/menu.pl?sessionID='.$sessionID, 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->authplain($proxy_uid,$admin_uid,$passwd);
    if ($res ne "OK"){
        $this->display_error("authentication failed: $msg", $confParam->{'cgi_path'}.'/mail_filter.pl?sessionID='.$sessionID.
                    "&mode=display&tab=$tab&stab=$stab", 3);
        exit;
    }
    ($res, $msg) = $sieve_obj->getScript($filtername);
    if ($res ne "OK"){
	$sieve="";
    }else{
	$sieve=$msg;
    }
    $sieve_obj->logout();
    
    my $script_ref=parse_script($sieve);
    if(defined $script_ref){
        my $frozen = freeze $script_ref;      #freeze data
        $frozen = unpack('H*',$frozen);   #convert to ASCII
        my %tmp = ( "sieveScript" => $frozen,
		    "proxy_uid" => $proxy_uid);
        my $s_reply=$session->modify(\%tmp);
        if( $s_reply->code() ne "OK" ) {
            exit;
        }else {
	    return $script_ref;
        }
    }else{
	return ();
    }
}
#
#######################################

1;

