#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: squid_conf.pm,v 1.9 2003/10/20 13:19:15 varkoly Exp $
#

package squid_conf;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use LDAPUtils;
use Display;
use Storable qw(thaw freeze);
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi = $this->{'cgi'};
    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $sessionID = $confParam->{'sessionID'};

    my $restart     = $cgi->param('restart');
    my $define_acls = $cgi->param('define_acls');
    my $edit_acl    = $cgi->param('edit_acl');
    my $save_acl    = $cgi->param('save_acl');
    my $insert_acl  = $cgi->param('insert_acl');
    my $delete_acl  = $cgi->param('delete_acl');
    my $order_acls  = $cgi->param('order_acls');
    my $insert_access = $cgi->param('insert_access');
    my $delete_access = $cgi->param('delete_access');
    my $access_up = $cgi->param('access_up');
    my $access_down = $cgi->param('access_down');
    my $save_globals= $cgi->param('save_globals');
    my $tab    = $cgi->param('tab');
    my $stab   = $cgi->param('stab');

    if((defined $define_acls && $define_acls ne '') || (defined $edit_acl && $edit_acl ne '') ||
            (defined $save_acl && $save_acl ne '')) {
		$this->define_acls();
    } elsif(defined $order_acls && $order_acls ne '') {
		$this->order_acls();
    } elsif(defined $save_globals && $save_globals ne '') {
		$this->save('globals');
    } elsif((defined $insert_acl && $insert_acl ne '') || (defined $delete_acl && $delete_acl ne '')) {
		$this->save('acl');
    } elsif((defined $insert_access && $insert_access ne '') || (defined $delete_access && $delete_access ne '') || 
    	    (defined $access_up && $access_up ne '') || (defined $access_down && $access_down ne '')) {
		$this->save('access');
    } elsif (defined $restart && $restart ne '') {
        my $ret = $session->suad_service_exec('squid', 'restart');
        $ret->code() =~ /OK:\s(\d+?)\s(.*)/ms;
        if( $1 != 0 ){
            $this->display_error('restarting squid: failed'.$2,$confParam->{"cgi_path"}."/squid_conf.pl?sessionID=$sessionID&tab=$tab&stab=$stab");
        } else {
            $this->display_msg('restarting squid succesfully',$confParam->{"cgi_path"}."/squid_conf.pl?sessionID=$sessionID&tab=$tab&stab=$stab",1);
        }    
    }else {
		$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{'cgi'};

    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $sessionID = $confParam->{'sessionID'};
    
    my $message = ($session->getLanguage($confParam->{LANG},'SQUID'))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');

    # Reading squid configurations file
    $this->ReadSquidConf();

    my $html= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>'100%'});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>'100%'});
    $html .=                 $q->Tr( [
				    $this->help_th(2, $message->{squid_conf},'SQUID'),
				    $q->td({-class=>'AdminSubHeader',-colspan=>'2'}, $message->{global_setting})
				    ]);
    $html .=		 $q->start_form(-action=>$confParam->{cgi_path}.'/squid_conf.pl').
				$q->hidden(-name=>'sessionID', -value=>"$sessionID").
				$q->hidden(-name=>'tab', -value=>"$tab").
				$q->hidden(-name=>'stab', -value=>"$stab");
    for(my $i = 0; $i < $this->{'NRports'}; $i++)    { 
    	$html .=             $q->Tr( $q->td({-align=>'right'},'HTTP-Proxy-IP:'),
    				     $q->td({-align=>'left'},
				     		$q->textfield(-name=>'ip'.$i,-default=>$this->{"http_port:$i"}->{'ip'}).
						' Port:'.
				     		$q->textfield(-name=>'port'.$i,-default=>$this->{"http_port:$i"}->{'port'}))
				    );
    }
    my $portn = $this->{'NRports'};
    $html .=                $q->Tr( $q->td({-align=>'right'},$message->{new_port}.':'),
    				     $q->td({-align=>'left'},
				     		$q->textfield(-name=>'ip'.$portn,-default=>$this->{"http_port:$portn"}->{'ip'}).
						' Port:'.
				     		$q->textfield(-name=>'port'.$portn,-default=>$this->{"http_port:$portn"}->{'port'}))
				    );
    $html .=                 $q->Tr( $q->td({-align=>'right'},$message->{cache_size}.':'),
    				     $q->td({-align=>'left'}, 
				     		$q->textfield(-name=>'cache_size',-default=>$this->{'cache_dir'}->{'size'}))
				    );
    $html .=                 $q->Tr( $q->td({-align=>'right'},$message->{use_redirect}.':'),
    				     $q->td({-align=>'left'}, 
				     		$q->checkbox(-name=>'redirect',-checked=>$this->{'redirect'},-label=>''))
				    );
    $html .=                 $q->Tr( $q->td({-align=>'center', -colspan=>'2'},
    						$q->submit(-class=>"button",-name=>'restart', -value=>$message->{restart}),
    						$q->submit(-class=>"button",-name=>'save_globals', -value=>$message->{save_globals}),
    						$q->submit(-class=>"button",-name=>'define_acls', -value=>$message->{expert}))
				   );
    $html .=             $q->end_form();
    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();
    $html .= $q->end_table();
    $html .= $q->end_form();


    $this->SUPER::display($html);
}

sub order_acls {
    my $this = shift;
    my $path = shift || '';

    my $q = $this->{'cgi'};

    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $sessionID = $confParam->{'sessionID'};
    
    my $message = ($session->getLanguage($confParam->{LANG},'SQUID'))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');

    # Reading squid configurations file
    $this->ReadSquidConf();

    my @acl	  = ();
    for(my $i = 0; $i < $this->{'NRacl'}; $i++)    { push @acl, $this->{"acl:$i"}->{'name'}; }
    my @negacl	  = ();
    for(my $i = 0; $i < $this->{'NRacl'}; $i++)    { push @negacl, '!'.$this->{"acl:$i"}->{'name'}; }
    my @access	  = ();
    for(my $i = 0; $i < $this->{'NRaccess'}; $i++)    { push @access, $this->{"access:$i"}; }

    # Saving data into the Session
    my $faccess = freeze(\@access);
    $faccess = unpack('H*',$faccess);
    my %tmp = ( "access" => $faccess );
    my $s_reply=$session->modify(\%tmp);
    if( $s_reply->code() ne "OK" ) {
        $this->display_error($message->{'write2session_failed'}, "$confParam->{'cgi_path'}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $params="$confParam->{cgi_path}/squid_conf.pl?sessionID=$sessionID&tab=$tab&stab=$stab&";

    my $html= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>'100%'});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>'100%'});
    $html .=                 $q->Tr( [
				    $this->help_th(4, $message->{squid_conf},'SQUID'),
				    $q->td({-class=>'AdminSubHeader',-colspan=>'4'}, $message->{order_acls}.'<hr noshade size="2">')
				    ]);
    $html .=		 $q->start_form(-action=>$confParam->{cgi_path}.'/squid_conf.pl').
				$q->hidden(-name=>'sessionID', -value=>"$sessionID").
				$q->hidden(-name=>'tab', -value=>"$tab").
				$q->hidden(-name=>'stab', -value=>"$stab");
    $html .=             $q->Tr(
				$q->td({-align=>'center',-width=>'10%'}, $message->{action}),
				$q->td({-align=>'center',-width=>'40%'}, $message->{acls}),
				$q->td({-align=>'center',-width=>'40%'}, $message->{neg_acls})
			    );
    $html .=             $q->Tr(
                               $q->td({-align=>"center"},
                                      $q->scrolling_list(-name=>"yes_no",
                                                           -value=>['allow','deny'],
                                                           -size=>2
                                                         )
                                        ),
                               $q->td({-align=>"center"},
                                      $q->scrolling_list(-name=>"acl",
                                                           -value=>[@acl],
                                                           -size=>10,
							   -multiple=>1
                                                         )
                                        ),
                               $q->td({-align=>"center"},
                                      $q->scrolling_list(-name=>"negacl",
                                                           -value=>[@negacl],
                                                           -size=>10,
							   -multiple=>1
                                                         )
                                        ),
			       $q->td({-align=>"left"}, 
				      $q->submit(-class=>"button",-name=>'insert_access', -value=>$message->{insert})
				     )
			    );
    $html .=             $q->Tr( $q->td({-align=>"center",-colspan=>4},'<hr noshade size="2">'));
    $html .=             $q->Tr($q->td({-align=>"center"}),
				$q->td({-align=>"center",-colspan=>2},$message->{access})
			    );
    $html .=             $q->Tr($q->td({-align=>"right",-valign=>"middle",-colspan=>2},
                                      $q->scrolling_list(-name=>"access",
                                                           -value=>[@access],
                                                           -size=>10
                                                         ),
				),
				$q->td({-align=>"left",-valign=>"middle"},
				      $q->submit(-class=>"button",-name=>'delete_access', -value=>$message->{delete}).'<br>',
				      $q->submit(-class=>"button",-name=>'access_up', -value=>$message->{up}).'<br>',
				      $q->submit(-class=>"button",-name=>'access_down', -value=>$message->{down}).'<br>',
#				      $q->a({href=>$params.'action=up'},  $q->img({src=>'/images/arrow_up.gif',   border=>0})).'<br>',
#				      $q->a({href=>$params.'action=down'},$q->img({src=>'/images/arrow_down.gif', border=>0})).'<br>',
				)
			    );
    $html .=                 $q->Tr( $q->td({-align=>'center', -colspan=>'4'},
    						$q->submit(-class=>"button",-name=>'restart', -value=>$message->{restart}),
    						$q->submit(-class=>"button",-name=>'set_globals', -value=>$message->{set_globals}),
    						$q->submit(-class=>"button",-name=>'define_acls', -value=>$message->{define_acls}))
				   );
#    $html .=             $q->Tr( $q->td({-align=>"center",-colspan=>4},'<br><hr noshade size="2"><br>'));
#    $html .=             $q->Tr( $q->td({-align=>"center",-colspan=>4}, $q->submit(-class=>"button",-name=>'save_acces', -value=>$message->{save})));
    $html .=             $q->end_form();
    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();
    $html .= $q->end_table();
    $html .= $q->end_form();


    $this->SUPER::display($html);
}
sub define_acls {
    my $this = shift;

    my $q = $this->{'cgi'};

    my $session = $this->{'session'};
    my $confParam = $session->{'confParam'};
    my $sessionID = $confParam->{'sessionID'};
    
    my $message = ($session->getLanguage($confParam->{LANG},'SQUID'))->data();

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};

    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $edit_acl  = $q->param('edit_acl');
    my $save_acl  = $q->param('save_acl');
    my $data      = '';

    if((defined $edit_acl && $edit_acl ne '')||(defined $save_acl && $save_acl ne '')) {
	my $acl = $q->param('acl');
	($acl) = (split / : /,$acl)[0];
	if( $acl eq '' && $edit_acl ne '') {
              $this->display_error($message->{'choose_acl'}, "$confParam->{'cgi_path'}/squid_conf.pl?sessionID=$sessionID&tab=$tab&stab=$stab&define_acls=define_acls");
	      exit;
	}
	my $file = '/etc/squid/acl_'.$acl;
	if( defined $q->param('file') && $q->param('file') ne '') {
	   # there is a new acl
	   $file = $q->param('file');
	}
	if(defined $save_acl && $save_acl ne ''){
	    my @content = $q->param('file_content');
	    my @raw;
	    foreach my $l ( @content ) {
		$l =~ s/\r//mg;
		$l =~ s/\n\s+\n/\n/mg;
		$l =~ s/\n\n/\n/mg;
		push @raw, $l;
	    }
	    my $l = pop @raw;
	    chomp $l;
	    push @raw, $l;
	    my $ret = $session->suad_save(\@raw, $file);
	}
	my $ret = $session->suad_read($file);
        my $text= ''; 
	    if($ret->code() =~ /^OK/) {
	        $text= $ret->data();
	    }
    	$data =  $q->start_multipart_form(-action=>$confParam->{cgi_path}.'/squid_conf.pl').
				$q->hidden(-name=>'sessionID', -value=>"$sessionID").
				$q->hidden(-name=>'tab', -value=>"$tab").
				$q->hidden(-name=>'stab', -value=>"$stab").
                 $q->td({-align=>'center'}, 
			'File: '.$file.'<br>'.
#			$q->textarea(-name=>'file_content', -value=>$text, -cols=>40, -rows=>25, -wrap=>"off").'<br>'.
			'<textarea name="file_content" rows="10" cols="40" wrap="off">'.$text.'</textarea><br>'.
			$q->hidden(-name=>'file', -value=>"$file").
			$q->submit(-class=>"button",-name=>'save_acl',   -value=>$message->{save})
                     ).
		  $q->end_form();   
    }

    # Reading squid configurations file
    $this->ReadSquidConf();

    my @acl	  = ();
    my @acl_type   = ('src','dst','myip','srcdomain','dstdomain','srcdom_regex','dstdom_regex',
		     'time','url_regex','urlpath_regex','port','myport','proto','method','browser',
		     'ident','src_as','dst_as','proxy_auth','snmp_community','maxconn');

    @acl_type = sort @acl_type;

    for(my $i = 0; $i < $this->{'NRacl'}; $i++) { 
        my $acl_name = $this->{"acl:$i"}->{'name'} ;
        if( $acl_name !~ /FAS_FTP/ && $acl_name !~/FAS_HTTPS/ ) {
	        push @acl,  $this->{"acl:$i"}->{'name'}.' : '.$this->{"acl:$i"}->{'type'}; 
        }
    }

    # Saving data into the Session
    my $facl = freeze(\@acl);
    $facl = unpack('H*',$facl);
    my %tmp = ( "acls" => $facl );
    my $s_reply=$session->modify(\%tmp);
    if( $s_reply->code() ne "OK" ) {
        $this->display_error($message->{'write2session_failed'}, "$confParam->{'cgi_path'}/menu.pl?sessionID=$sessionID");
	    exit;
    }					     

    my $html= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>'100%'});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>'100%'});
    $html .=                 $q->Tr( [
				    $this->help_th(3, $message->{squid_conf},'SQUID')
				    ]);
    $html .=		 $q->start_multipart_form(-action=>$confParam->{cgi_path}.'/squid_conf.pl').
				$q->hidden(-name=>'sessionID', -value=>"$sessionID").
				$q->hidden(-name=>'tab', -value=>"$tab").
				$q->hidden(-name=>'stab', -value=>"$stab");
    $html .=             $q->Tr( $q->td({-class=>'AdminSubHeader',-colspan=>3},$message->{define_acls}.'<hr noshade size="2">'));
    $html .=             $q->Tr(
				$q->td({-align=>'center'}, $message->{name}),
				$q->td({-align=>'center'}, $message->{acl_type}),
			    );
    $html .=             $q->Tr(
				$q->td({-align=>'center'}, $q->textfield(-name=>'name')),
                                $q->td({-align=>"center"}, $q->scrolling_list(-name=>'type',
                                                           -value=>\@acl_type,
                                                           -size=>5
                                                         )
                                        ),
				$q->td({-align=>'center'},
 				    $q->submit(-class=>"button",-name=>'insert_acl', -value=>$message->{insert})
				)
			    );
    $html .=             $q->Tr( $q->td({-align=>"center",-colspan=>3},'<hr noshade size="2">'));
    $html .=             $q->Tr( $q->td({-align=>'center',-colspan=>3}, '<H3>'.$message->{edit_acls}.'</H3>'));
    $html .=             $q->Tr(
                               $q->td({-align=>"right"},
                                      $q->scrolling_list(-name=>"acl",
                                                           -value=>[@acl],
                                                           -size=>10
                                                         )
                                ),
				$q->td({-align=>'left'},
 				    $q->submit(-class=>"button",-name=>'edit_acl',   -value=>$message->{edit}).'<br>',
 				    $q->submit(-class=>"button",-name=>'delete_acl', -value=>$message->{delete}).'<br>',
				    $q->end_form()
				).$data,
			    );
    $html .=                 $q->Tr( $q->td({-align=>'center', -colspan=>'3'},
						$q->start_multipart_form(-action=>$confParam->{cgi_path}.'/squid_conf.pl'),
						$q->hidden(-name=>'sessionID', -value=>"$sessionID"),
						$q->hidden(-name=>'tab', -value=>"$tab"),
						$q->hidden(-name=>'stab', -value=>"$stab"),
    						$q->submit(-class=>"button",-name=>'restart', -value=>$message->{restart}),
    						$q->submit(-class=>"button",-name=>'set_globals', -value=>$message->{set_globals}),
    						$q->submit(-class=>"button",-name=>'order_acls', -value=>$message->{order_acls}))
				   );
    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();
    $html .= $q->end_table();
    $html .= $q->end_form();


    $this->SUPER::display($html);
}

sub ReadSquidConf {
    my $this = shift;
    my $cgi = $this->{"cgi"};

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $message = ($session->getLanguage($confParam->{LANG},"SQUID"))->data();

    my $data = $session->suad_read($::CONF_GLOBAL{"SQUID"}{"squid_conf_file"});
    my @squid_conf = split(/\n/, $data->data());
    my $NRacl    = 0;
    my $NRaccess = 0;
    my $NRports  = 0;
   
    $this->{'redirect'}		= '';
    foreach (@squid_conf){
    	# earasing leading white spaces
	s/^\s+//;
	# ignore comments
    	if( /^#/ || /^$/) {next;}
	# Finding squidGuard redirection
	if(/^redirect_program/) {
	  $this->{'redirect'} = 'on';
	}
	# Finding Http Port Definition
	if(/^http_port/){
	  # storing http port and ip Value
	  my $http_port = (split /\s+/)[1];
	  ($this->{"http_port:$NRports"}->{'ip'}, $this->{"http_port:$NRports"}->{'port'}) = (split /:/, $http_port);
	  $NRports++;
	  next;
	}
	# Finding Cache Directory Definition
	if(/^cache_dir/){
	  # storing cache_dir Value
	  ($this->{'cache_dir'}->{'type'}, $this->{'cache_dir'}->{'path'}, $this->{'cache_dir'}->{'size'},
	  	$this->{'cache_dir'}->{'level1'}, $this->{'cache_dir'}->{'level2'}) = (split /\s+/)[1,2,3,4,5];
	  next;
	}
	# finding an ACL
	if(/^acl /){
	  # storing ACL Values
	  ($this->{"acl:$NRacl"}->{'name'}, $this->{"acl:$NRacl"}->{'type'}, $this->{"acl:$NRacl"}->{'def'}) = (split /\s+/)[1,2,3];
	  $NRacl++;
	  next;
	}
	# Finding an Access Definition
	if(/^http_access /){
	  # storing Access Definition Values
	  $this->{"access:$NRaccess"} = (split /\s+/,$_,2)[1];
	  $NRaccess++;
	  next;
	}
    }
    $this->{'NRaccess'} = $NRaccess;
    $this->{'NRacl'} = $NRacl;
    $this->{'NRports'} = $NRports;

    return 1;
}

sub save {
    my $this = shift;
    my $what = shift;
    my $q = $this->{"cgi"};
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');

    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $NRports  = 0;
    my @acl_list = ();
    my @access_list = ();
    my @global_list = ();

    my $message = ($session->getLanguage($confParam->{LANG},"SQUID"))->data();
    my $ret = $session->suad_read($::CONF_GLOBAL{"SQUID"}{"squid_conf_file"});
    my @squid_conf = split(/\n/, $ret->data());
    my @squid_conf_new;

    foreach (@squid_conf){
    	# earasing leading white spaces
	    s/^\s+//;
	    # ignore comments
    	if( /^#/ || /^$/) {
#		    push @squid_conf_new, $_; 
		    next;
	    }
	    #first we clean up the conf file
	    if(/^acl /) {
		    # finding an ACL
		    if($what eq 'acl' && ! (/FAS_FTP/ || /FAS_HTTPS/)){ 
			    next; 
		    } else {
			    push @acl_list, $_;
			    next;
		    }
	    } elsif(/^http_access /) {
		    # Finding an Access Definition
		    if($what eq 'access'){ 
			    next; 
		    } else {
			    push @access_list, $_;
			    next;
		    }
	    } elsif( $what eq 'globals') { 
		    # Finding squidGuard redirection
		    if(/^redirect_program/) { next; }
		    # Finding Authenticate Program
		    # (not interesting, becouse only ldap_auth has a 'Sinn')
		    # Finding Http Port Definition
		    if(/^http_port/){ 
			    $NRports++;
			    next; 
		    }
		    # Finding Cache Directory Definition
		    if(/^cache_dir/){ next; }
	    }
	    push @global_list, $_;
    }
    if( $what eq 'globals') {
        my $redirect =  $q->param('redirect');
        for(my $i=0; $i < $NRports + 1; $i++) {
            my $ip   = $q->param('ip'.$i);    $ip   =~ s/\s//g;
            my $port = $q->param('port'.$i);  $port =~ s/\s//g;
	        if( $ip ne '' && $port ne '') {
	            push @global_list, 'http_port '.$ip.':'.$port;
	        } 
        }
        if( $q->param('redirect') eq 'on' || $q->param('redirect') eq 'checked') {
             push @global_list, 'redirect_program /usr/sbin/squidGuard -c /etc/squid/squidguard.conf';
        }
        push @global_list, 'cache_dir ufs /var/cache/squid '.$q->param('cache_size').' 16 256';
    } elsif($what eq 'acl') {
        my $facl     = $confParam->{'acls'};
        $facl        = pack('H*',$facl);
        my $acl      = thaw($facl);
        #do you want to delete one acl?
        my $acl_to_delete = '';
        if( defined $q->param('delete_acl') && $q->param('delete_acl') ne '' ) {
            $acl_to_delete = $q->param('acl');
        }
        foreach (@{$acl}) {
            my($name,$type) = (split / : /);
            if($acl_to_delete ne '' && $acl_to_delete eq $_ ) {
                my $ret = $session->suad_unlink('/etc/squid/acl_'.$name);
                next;
            }
            push @acl_list, "acl $name $type \"/etc/squid/acl_$name\"";
        }
        if( defined $q->param('insert_acl') && $q->param('insert_acl') ne '' ){
            if( defined $q->param('name') && $q->param('name') ne '' && defined $q->param('type') && $q->param('type') ) {
                push @acl_list, 'acl '.$q->param('name').' '.$q->param('type').' "/etc/squid/acl_'.$q->param('name').'"'; 
            } else {
        	$this->display_error($message->{'missing_parameter'}, "$confParam->{cgi_path}/squid_conf.pl?sessionID=$sessionID&tab=$tab&stab=$stab&define_acls=define_acls");
                exit();
            }
        }
    } elsif($what eq 'access') {
       my $faccess     = $confParam->{'access'};
       $faccess        = pack('H*',$faccess);
       my $access      = thaw($faccess);
       my $act_access  = $q->param('access');
       my $yes_no      = $q->param('yes_no');
       my @acl 	       = $q->param('acl');
       my @negacl      = $q->param('negacl');
       my $down	       = '';
       foreach (@{$access}) {
            if(defined $q->param('access_up') && $q->param('access_up') ne '') {
                if($_ eq $act_access) {
                    my $temp = pop @access_list;
                    push @access_list, 'http_access '.$_;
                    push @access_list, $temp;
                    next;
                }
            } elsif(defined $q->param('access_down') && $q->param('access_down') ne '') {
                if($_ eq $act_access) {
                    $down = $_;
                    next;
                } 
            } elsif(defined $q->param('insert_access') && $q->param('insert_access') ne '') {
                if($_ eq $act_access) {
                    my $tmp = $yes_no;
                    foreach my $i (@acl) {
                        $tmp .= ' '.$i;
                    }
                    foreach my $i (@negacl) {
                        $tmp .= ' '.$i;
                    }
                    push @access_list, 'http_access '.$tmp;
                }
            } elsif(defined $q->param('delete_access') && $q->param('delete_access') ne '') {
                if($_ eq $act_access) {
                    next;
                }
            }
            push @access_list, 'http_access '.$_;
            if ($down ne '' ) {
                push @access_list, 'http_access '.$down;
                $down = '';
            }
       }
       if ($down ne '' ) {
            push @access_list, 'http_access '.$down;
            $down = '';
       }
       if((scalar(@{$access}) == 0) && (defined $q->param('insert_access') && $q->param('insert_access') ne '')) {
          my $tmp = $yes_no;
          foreach my $i (@acl) {
              $tmp .= ' '.$i;
          }
          foreach my $i (@negacl) {
              $tmp .= ' '.$i;
          }
          push @access_list, 'http_access '.$tmp;
       }
    }
    
    push @squid_conf_new, ('#acls');
    push @squid_conf_new, @acl_list;
    push @squid_conf_new, ('#globals');
    push @squid_conf_new, @global_list;
    push @squid_conf_new, ('#access_lists');
    push @squid_conf_new, @access_list;

    $ret = $session->suad_save(\@squid_conf_new,$::CONF_GLOBAL{"SQUID"}{"squid_conf_file"});
    if( $what eq 'globals') {
        $this->display_msg($message->{'saved_globals'}, "$confParam->{cgi_path}/squid_conf.pl?sessionID=$sessionID&tab=$tab&stab=$stab&" , 2);
        exit;
    } elsif($what eq 'acl') {
        $this->define_acls();   
    } elsif($what eq 'access') {
        $this->order_acls();   
    }
    exit;
}

sub mkarray($) {
    my ($string) = @_;
    my @array;
    my $i;

    for($i = 0; $i < length($string); $i++) {
        push(@array, substr($string, $i, 1));
    }

    return @array;
}

;
