#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: ssl_conf.pm,v 1.3 2003/11/07 12:16:42 varkoly Exp $
#
package ssl_conf;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use Display;
use cfreader;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


my @apache_sslopts = ( "none",
		       "optional",
		       "require",
		       "optional_no_ca" );

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}


sub display {
    my $this = shift;
    
    my $cgi = $this->{"cgi"};
    
    my $saveApache = $cgi->param('saveApache');
    my $saveCyrus  = $cgi->param('saveCyrus');
    my $saveSLAPD  = $cgi->param('saveSLAPD');

    if(defined $saveApache && $saveApache ne "") {
	$this->modifyApache();
    } elsif( defined $saveCyrus && $saveCyrus ne "") {
	$this->modifyCyrus();
    } elsif( defined $saveSLAPD && $saveSLAPD ne "") {
	$this->modifySLAPD();
    } else {
	$this->startup();
    }

}

sub startup {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();

    my $html = "";
    my $tfsize = 10;

    #my $noCA = 1;
    my $noCA = ( -s "/etc/ssl/certs/cert.pem" ? 0 : 1 );
    

    # ***********************************************************************************
    # ************************************* APACHE **************************************
    # ***********************************************************************************
    $this->readApacheConfig();
    
    my $apassl;
    if ( $noCA ) {
	$apassl = "<font color='red'>$message->{creaca}</font>";
    } else {
# Apache have to run every time SSL on SLSS
	$apassl = $message->{on}.$q->hidden(-name=>"apache_sslon", -value=>1);
#	$apassl = $q->popup_menu(-name=>'apache_sslon', 
#				 -values=>["$message->{on}", "$message->{off}"],
#				 -default=>$this->{"apache"}->{sslon},
#				 -label=>"", -override=>1 );
   }
    
    $q->param(-name=>'apache_sslon', -value=>$this->{"apache"}->{sslon});
    $q->param(-name=>'apache_sslverifyclient', -value=>$this->{"apache"}->{sslverifyclient});
    $q->param(-name=>'apache_sslverifydepth', -value=>$this->{"apache"}->{sslverifydepth});
    
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=                 $q->Tr(
				    $this->help_th(2, $message->{apache_cfg_head}, "SSL_CONF")
				    );
    $html .=                 $q->Tr(
				    $q->td({-class=>"AdminSubHeaderRed", -colspan=>2},
					   ["$message->{apache_cfg_warn}"])
				    );
    $html .=                 $q->start_multipart_form(-method=>"get",
						      -action=>$confParam->{cgi_path}."/ssl_conf.pl");
    $html .=                 $q->Tr(
				    $q->td([$message->{apache_cfg_sslon}, $apassl ] )
				    );
    $html .=                 $q->Tr(
				    $q->td([$message->{apache_cfg_sslverifyclient},
					    $q->popup_menu(-name=>'apache_sslverifyclient',
							   -values=>\@apache_sslopts, )])
				    );
    $html .=                 $q->Tr(
				    $q->td([$message->{apache_cfg_sslverifydepth},
					    $q->textfield(-name=>'apache_sslverifydepth',
							  -value=>$this->{"apache"}->{sslverifydepth},
							  -size=>$tfsize)]  )
				    );
    $html .=                 $q->Tr(
				    $q->td({-colspan=>2 -align => "center"},
					   [ ( $noCA ? "&nbsp" :
					       $q->submit(-class=>"button",-name=>$message->{save}) ) 
					     ] )
				    );
    $html .=                 $q->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .=                 $q->hidden(-name=>"tab", -value=>$tab);
    $html .=                 $q->hidden(-name=>"stab", -value=>$stab);
    if( ! $noCA ) {
	$html .=             $q->hidden(-name=>"saveApache", -value=>"add");
    }
    $html .=                 $q->end_form();	    
    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();

    $html .= $q->end_table();

    # ***********************************************************************************
    # ************************************* CYRUS ***************************************
    # ***********************************************************************************

    $this->readCyrusConfig();
    
    my $cyrusssl_pop;
    my $cyrusssl_imap;
    if ( $noCA ) {
	$cyrusssl_pop = "<font color='red'>$message->{creaca}</font>";
	$cyrusssl_imap = "<font color='red'>$message->{creaca}</font>";
    } else {
	$cyrusssl_pop = $q->popup_menu(-name=>'cyrus_pop_sslon', 
				       -values=>["$message->{on}", "$message->{off}"],
				       -default=>$this->{"cyrus"}->{sslonpop},
				       -label=>"", -override=>1 );
	$cyrusssl_imap = $q->popup_menu(-name=>'cyrus_imap_sslon', 
					-values=>["$message->{on}", "$message->{off}"],
					-default=>$this->{"cyrus"}->{sslonimap},
					-label=>"", -override=>1 );
    }
    
    $q->param(-name=>'cyrus_pop_sslon', -value=>$this->{"cyrus"}->{sslonpop});
    $q->param(-name=>'cyrus_imap_sslon', -value=>$this->{"cyrus"}->{sslonimap});

    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=                 $q->Tr(
				    $this->help_th(2, "$message->{cyrus_cfg_head}", "SSL_CONF")
				    );
    $html .=                 $q->start_multipart_form(-method=>"get",
						      -action=>$confParam->{cgi_path}."/ssl_conf.pl");
    $html .=                 $q->Tr(
				    $q->td(["$message->{cyrus_pop_ssl}", $cyrusssl_pop ] )
				    );
    $html .=                 $q->Tr(
				    $q->td(["$message->{cyrus_imap_ssl}", $cyrusssl_imap ] )
				    );
    $html .=                 $q->Tr(
				    $q->td({-colspan=>2 -align => "center"},
					   [ ( $noCA ? "&nbsp" :
					       $q->submit(-class=>"button",-name=>"$message->{save}") ) 
					     ] )
				    );
    $html .=                 $q->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .=                 $q->hidden(-name=>"tab", -value=>$tab);
    $html .=                 $q->hidden(-name=>"stab", -value=>$stab);
    if( ! $noCA ) {
	$html .=             $q->hidden(-name=>"saveCyrus", -value=>"add");
    }
    $html .=                 $q->end_form();	    
    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();

    $html .= $q->end_table();


    # ***********************************************************************************
    # ************************************* SLAPD ***************************************
    # ***********************************************************************************

    $this->readSLAPDConfig();

    my $slapdssl;
    if ( $noCA ) {
	$slapdssl = "<font color='red'>$message->{creaca}</font>";
    } else {
	$slapdssl = $q->popup_menu(-name=>'slapd_sslon', 
				   -values=>["$message->{on}", "$message->{off}"],
				   -default=>$this->{"slapd"}->{sslon},
				   -label=>"", -override=>1 );
    }
    
    $q->param(-name=>'slapd_sslon', -value=>$this->{"slapd"}->{sslon});
    
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=     $q->start_Tr();
    $html .=         $q->start_td();
    $html .=             $q->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=                 $q->Tr(
				    $this->help_th(2, "$message->{slapd_cgf_head}", "SSL_CONF")
				    );
    $html .=                 $q->start_multipart_form(-method=>"get",
						      -action=>$confParam->{cgi_path}."/ssl_conf.pl");
    $html .=                 $q->Tr(
				    $q->td(["$message->{slapd_ssl}", $slapdssl ] )
				    );
    $html .=                 $q->Tr(
				    $q->td({-colspan=>2 -align => "center"},
					   [ ( $noCA ? "&nbsp" :
					       $q->submit(-class=>"button",-name=>"$message->{save}") ) 
					     ] )
				    );
    $html .=                 $q->hidden(-name=>"sessionID", -value=>$sessionID);
    $html .=                 $q->hidden(-name=>"tab", -value=>$tab);
    $html .=                 $q->hidden(-name=>"stab", -value=>$stab);
    if( ! $noCA ) {
	$html .=             $q->hidden(-name=>"saveSLAPD", -value=>"add");
    }
    $html .=                 $q->end_form();	    
    $html .=             $q->end_table();
    $html .=         $q->end_td();
    $html .=     $q->end_Tr();

    $html .= $q->end_table();
    $this->SUPER::display($html);
}

sub readSLAPDConfig {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();

    my $cf = "/etc/openldap/slapd.conf";
    
    my $data = $session->suad_read($cf);

    #print STDERR $data->data();

    if( $data->code() =~ /^ERROR:(.*)/ ) {
	$this->display_error("$message->{apache_cfg_not_readable} $cf: $1",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = split(/\n/, $data->data());
    
    # store data into session
    my $msg = $session->save_store2session("$cf", $cf, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    $this->{"slapd"}->{sslon} = $message->{off};
    
    my $sslcnt=0;
    foreach my $l ( @raw ) {
	$sslcnt++ if $l =~ /^TLSCertificateFile\s*\/etc\/ssl\/certs\/cert\.pem/;
	$sslcnt++ if $l =~ /^TLSCertificateKeyFile\s*\/etc\/ssl\/certs\/skey\.pem/;
	$sslcnt++ if $l =~ /^TLSCACertificateFile\s*\/etc\/ssl\/CA\/usedCA\.pem/;
    }

    $this->{"slapd"}->{sslon} = $message->{on} if $sslcnt == 3;
    
}

sub readCyrusConfig {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();
    
    my $cyruscf = "/etc/cyrus.conf";
    my $imapcf = "/etc/imapd.conf";
    
    if( ! open(IN, "< $imapcf") ) {
	$this->display_error("$message->{apache_cfg_not_readable} $imapcf: $?",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @imapraw = <IN>;
    chomp(@imapraw);
    close(IN);

    my $cfr = new cfreader(":");
    my $r = $cfr->CF2HASH(\@imapraw,
			  ["tls_ca_file", "tls_ca_path", "tls_cert_file", "tls_key_file"]);

    # store data into session
    my $msg = $session->save_store2session("$imapcf", $imapcf, \@$r);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($imapcf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }
    
    if( ! open(IN, "< $cyruscf") ) {
	$this->display_error("$message->{apache_cfg_not_readable} $cyruscf: $?",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = <IN>;
    chomp(@raw);
    close(IN);
    
    # store data into session
    my $msg = $session->save_store2session("$cyruscf", $cyruscf, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cyruscf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }


    $this->{"cyrus"}->{sslonpop} = $message->{off};
    $this->{"cyrus"}->{sslonimap} = $message->{off};

    foreach my $l ( @raw ) {
	if( $l =~ /^([\#]*)\s*imaps\s+cmd/ ) {
	    if( $1 eq "" ) {
		$this->{"cyrus"}->{sslonimap} = $message->{on};
	    }
	}
	if( $l =~ /^([\#]*)\s*pop3s\s+cmd/ ) {
	    if( $1 eq "" ) {
		$this->{"cyrus"}->{sslonpop} = $message->{on};
	    }
	}
    }

    my $all = $cfr->getAllSTATUS($r);
    foreach my $key ( ("tls_ca_file", "tls_ca_path", "tls_cert_file", "tls_key_file") ) {
	if( !defined $all->{$key} || $all->{$key} ne "CMD" ) {
	    $this->{"cyrus"}->{sslonpop} = $message->{off};
	    $this->{"cyrus"}->{sslonimap} = $message->{off};
	}
    }

    
}

sub readApacheConfig {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();

    my $cf = "/etc/httpd/admin_include.conf";

    if( ! open(IN, "< $cf") ) {
	$this->display_error("$message->{apache_cfg_not_readable} $cf: $?",
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    my @raw = <IN>;
    chomp(@raw);
    close(IN);
    
    # store data into session
    my $msg = $session->save_store2session("$cf", $cf, \@raw);
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    $this->{"apache"}->{sslon} = $message->{off};
    $this->{"apache"}->{sslverifyclient} = "";
    $this->{"apache"}->{sslverifydepth} = "";
    
    my $count = 0;
    foreach my $l ( @raw ) {
	#next if $l =~ /^\s*\#.*/;
	$count++ if $l =~ /^\s*SSLCertificateFile\s*\/etc\/ssl\/certs\/cert.pem/;
	$count++ if $l =~ /^\s*SSLCertificateKeyFile\s*\/etc\/ssl\/certs\/skey.pem/;
	$count++ if $l =~ /^\s*SSLCACertificateFile\s*\/etc\/ssl\/CA\/usedCA.pem/;
	$count++ if $l =~ /^\s*SSLCARevocationFile\s*\/etc\/ssl\/crl\/crl.pem/;
	$count++ if $l =~ /^\s*SSLEngine\s+on\s*/;
	
	if( $l =~ /^[\#\s]*SSLVerifyClient\s*.*/ ) {
	    $l =~ /^[\#\s]*SSLVerifyClient\s+([a-z_]+)\s*.*/;
	    $this->{"apache"}->{sslverifyclient} = $1;
	}
	if( $l =~ /^[\#\s]*SSLVerifyDepth\s*.*/ ) {
	    $l =~ /^[\#\s]*SSLVerifyDepth\s+([0-9]+)\s*.*/;
	    $this->{"apache"}->{sslverifydepth} = $1;
	}	
    }
    
    $this->{"apache"}->{sslon} = $message->{on} if $count == 5;
}


sub modifySLAPD {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();

    my $cf = "/etc/openldap/slapd.conf";
    my $syscf = "/etc/sysconfig/openldap";

    my $msg = $session->save_read2session("$cf", $cf);
    
    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $raw = $msg->data();

    foreach my $l ( @$raw ) {
	# activate commented path's to cert, key and cacert
	if( $l =~ /^[\#\s]*TLSCertificateFile\s+.*/ ) {
	    $l = ( $q->param('slapd_sslon') eq $message->{on} ? "" : "#" ).
		"TLSCertificateFile    /etc/ssl/certs/cert.pem";
	}
	if( $l =~ /^[\#\s]*TLSCertificateKeyFile\s+.*/ ) {
	    $l = ( $q->param('slapd_sslon') eq $message->{on} ? "" : "#" ).
		"TLSCertificateKeyFile /etc/ssl/certs/skey.pem";
	}
	if( $l =~ /^[\#\s]*TLSCACertificateFile\s+.*/ ) {
	    $l = ( $q->param('slapd_sslon') eq $message->{on} ? "" : "#" ).
		"TLSCACertificateFile  /etc/ssl/CA/usedCA.pem";
	}
    }
    
    my $ret = $session->suad_save($raw, $cf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("$cf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    # ------------------------------------------------------------------------------------

    my $data = $session->suad_read($syscf);

    #print STDERR $data->data();

    if( $data->code() =~ /^ERROR:(.*)/ ) {
        $this->display_error("$message->{apache_cfg_not_readable} $syscf: $1",
                             "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    @$raw = split(/\n/, $data->data());

    foreach my $l ( @$raw ) {
        if( $l =~ /^OPENLDAP_START_LDAPS/ ) {
            $l = "OPENLDAP_START_LDAPS=".
                ( $q->param('slapd_sslon') eq $message->{on} ? "yes" : "no" );
        }
    }

    $ret = $session->suad_save($raw, $syscf);
    if(  $ret->code() ne "OK" ) {
        $this->display_error($ret->code(),
                             $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
        exit;
    }

    $msg = $session->save_clear2session("$syscf");
    if( $msg->code() ne "OK" ) {
        $this->display_error($msg->code(),
                             "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }


    $ret = $session->suad_exec("slapdrestart");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $this->display_msg("$message->{saved_ok}",
		       "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");

    exit;
}

sub modifyCyrus {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();

    my $cyruscf = "/etc/cyrus.conf";
    my $imapcf = "/etc/imapd.conf";

    my $msg = $session->save_read2session("$imapcf", $imapcf);

    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($imapcf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $r = $msg->data();

    my $cfr = new cfreader(":");
    # get all commands from main.cf
    my $all = $cfr->getAllCMD($r);
    
    $all->{tls_ca_file} = "/etc/ssl/CA/usedCA.pem";
    $all->{tls_ca_path} = "/etc/ssl/CA";
    $all->{tls_cert_file} = "/etc/ssl/certs/cert.pem";
    $all->{tls_key_file} = "/etc/ssl/certs/skey.pem";

    if( $q->param('cyrus_imap_sslon') eq $message->{on} ||
	$q->param('cyrus_pop_sslon') eq $message->{on} ) {
	$cfr->setAllCMD($all, $r, undef,
			["tls_ca_file", "tls_ca_path", "tls_cert_file", "tls_key_file"]);
    } else {
	$cfr->setAllCMD($all, $r,
			["tls_ca_file", "tls_ca_path", "tls_cert_file", "tls_key_file"],
			undef);
    }
    
    my $ar = $cfr->HASH2CF($r);

    $msg = $session->suad_save($ar, $imapcf);
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("$imapcf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    # *************************   cyrus.conf
    $msg = $session->save_read2session("$cyruscf", $cyruscf);

    if( $msg->code() ne "OK" ) {
	if( $msg->code() eq "MD5SUM" ) {
	    $this->display_error($cyruscf.": ".$message->{modified},
				 "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");
	    exit;
	} else {
	    $this->display_error($msg->code(),
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }

    my $raw = $msg->data();

    foreach my $l ( @$raw ) {
	if( $l =~ /^([\#]*)\s*imaps\s+cmd/ ) {
	    if( $1 eq "" && $q->param('cyrus_imap_sslon') eq $message->{off} ) {
		$l = "#".$l;
	    }
	    if( $1 ne "" && $q->param('cyrus_imap_sslon') eq $message->{on} ) {
		$l =~ s/^\#//;
	    }
	}
	if( $l =~ /^([\#]*)\s*pop3s\s+cmd/ ) {
	    if( $1 eq "" && $q->param('cyrus_pop_sslon') eq $message->{off} ) {
		$l = "#".$l;
	    }
	    if( $1 ne "" && $q->param('cyrus_pop_sslon') eq $message->{on} ) {
		$l =~ s/^\#//;
	    }
	}
    }
    
    my $ret = $session->suad_save($raw, $cyruscf);
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }
    
    $msg = $session->save_clear2session("$cyruscf");
    if( $msg->code() ne "OK" ) {
	$this->display_error($msg->code(),
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    $ret = $session->suad_exec("cyrusrestart");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $this->display_msg("$message->{saved_ok}",
		       "$confParam->{cgi_path}/ssl_conf.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab");

    exit;
}

sub modifyApache {
    my $this = shift;

    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};
    my $q       = $this->{"cgi"};

    my $tab     = $q->param('tab');
    my $stab    = $q->param('stab');
    my $ret	= "";
    my $cf	= "";
    my $message = ($session->getLanguage($confParam->{LANG},"SSLCONF"))->data();


    if( $q->param('apache_sslon') eq $message->{on} ) {
	$cf = "/etc/sysconfig/apache";
	
	if( ! open(IN, "< $cf") ) {
	    $this->display_error("$cf: $?",
				 "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	    exit;
	}
	my @sysapa;
	while( <IN> ) {
	    chomp;
	    if( $_ =~ /^HTTPD_SEC_MOD_SSL/ ) {
		push @sysapa, "HTTPD_SEC_MOD_SSL=\"yes\"";
	    } else {
		push @sysapa, $_;
	    }
	}
	close(IN);
	
	$ret = $session->suad_save(\@sysapa, $cf);
	if(  $ret->code() ne "OK" ) {
	    $this->display_error($ret->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}

	$ret = $session->suad_exec("suseconfigapache");
	if(  $ret->code() ne "OK" ) {
	    $this->display_error($ret->code(),
				 $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	    exit;
	}
    }


    $ret = $session->suad_exec("apacherestart");
    if(  $ret->code() ne "OK" ) {
	$this->display_error($ret->code(),
			     $confParam->{cgi_path}."/menu.pl?sessionID=$sessionID");
	exit;
    }

    $this->display_msg($message->{apache_restart},
		       "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");

    exit;
}


1;
