#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: subscribe_folder.pm,v 1.2 2003/05/06 11:30:44 varkoly Exp $
#
package subscribe_folder;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Display;
use Socket;
use Storable qw(thaw freeze);
use IMAPUtils;
use Filterlist;
use vars qw(@ISA);
use subs qw(exit);
# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);

sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    
    my $cgi    = $this->{"cgi"};
    my $save   = $cgi->param("save");


    if( defined $save && $save ne "" ) {
	$this->save();
    } else {
	$this->startup();
    }
}

sub startup {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SUBSCRIBE_FOLDER"))->data();

    my $LOGINuid      = $confParam->{uid};
    my $LOGINpasswd   = $confParam->{passwd};
    my $imaphost      = $confParam->{IMAPserver};
    my $imapport      = $confParam->{IMAPport};

    my $filter = "*";
    my $url = "$confParam->{cgi_path}/subscribe_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter";

    my $all_folders = IMAPUtils::getFolderList($LOGINuid, $LOGINpasswd, "list", $imaphost);
    my $lsub_folders = IMAPUtils::getFolderList($LOGINuid, $LOGINpasswd, "lsub", $imaphost);
    # check if the user is subscribed to a folder, that he can't "see" any more
    foreach my $i (@$lsub_folders){
       if( ! grep( /^$i$/, @$all_folders )){
           push @$all_folders, $i;
       }
    }
    @$all_folders = sort(@$all_folders);


    my $filterlist = Filterlist->new($cgi, $session, undef, $this);
    my $actions = $cgi->start_table({-border=>0,-width=>"100%"});
    $actions .=   $cgi->Tr(
			   $cgi->td({-valign=>"top",-align=>"center"},
				    $cgi->submit(-class=>"button",
						 -name=>"save",
						 -value=>"$message->{save}",
						 -width=>"200")));
    $actions .=   $cgi->end_table();


    my $html = "";
    $html .= $cgi->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=   $cgi->start_Tr();
    $html .=     $cgi->start_td();
    $html .=     $cgi->start_form(-method=>"post",
				  -action=>$confParam->{cgi_path}."/subscribe_folder.pl");
    $html .=       $cgi->start_table({-cellspacing=>0, -cellpadding=>3, -width=>"100%"});
    $html .=         $cgi->Tr(
			      $this->help_th(3, $message->{head},"SUBSCRIBE_FOLDER")
			      );

    $html .=         $cgi->start_Tr();
    $html .=         $filterlist->make_filter_view({"textfield"    => "filter", #name textfield
                                                    "listname"     => "folderlist", #name list
                                                    "listlabel_left" => "$message->{not_subscribed}",
                                                    "listlabel_right" => $actions,
                                                    "nofilter-msg" => "$message->{aliases_nofilter}",
						    "listfilter"   => $all_folders,
                                                    "width"        => 30, #width of textfield
                                                    "height"       => 20, #length of list
                                                    "multiple"     => "MULTIPLE",
                                                    "selectedfilter"=> $lsub_folders,
                                                    "error-url"    => $this->{"url"} #url for errors
                     });
    $html .=         $cgi->hidden(-name=>'sessionID', -value=>$sessionID);
    $html .=         $cgi->hidden(-name=>'tab', -value=>$tab);
    $html .=         $cgi->hidden(-name=>'stab', -value=>$stab);
    $html .=         $cgi->end_Tr();
    $html .=       $cgi->end_table();
    $html .=     $cgi->end_form();
    $html .=     $cgi->end_td();
    $html .=   $cgi->end_Tr();
    $html .= $cgi->end_table();

    $this->SUPER::display($html);
}

sub save {
    my $this = shift;

    my $cgi       = $this->{"cgi"};
    my $session   = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $sessionID = $confParam->{"sessionID"};

    my $tab     = $cgi->param('tab');
    my $stab    = $cgi->param('stab');
    my $message = ($session->getLanguage($confParam->{LANG},"SUBSCRIBE_FOLDER"))->data();

    my $LOGINuid      = $confParam->{uid};
    my $LOGINpasswd   = $confParam->{passwd};
    my $imaphost      = $confParam->{IMAPserver};
    my $imapport      = $confParam->{IMAPport};

    my @newselected = $cgi->param("folderlist");

    my $all_folders = IMAPUtils::getFolderList($LOGINuid, $LOGINpasswd, "list", $imaphost);
    my $lsub_folders = IMAPUtils::getFolderList($LOGINuid, $LOGINpasswd, "lsub", $imaphost);
    # check if the user is subscribed to a folder, that he can't "see" any more

    my $foundinbox = 0;
    foreach my $f ( @newselected ) {
	if( lc($f) eq "inbox" ) {
	    $foundinbox = 1;
	}
    }

    if( ! $foundinbox ) {
	$this->display_error("$message->{dont_subscribe_inbox}",
			     "$confParam->{cgi_path}/subscribe_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			     0);
	exit;
    }

    foreach my $i (@$lsub_folders){
	if( ! grep( /^$i$/, @$all_folders )){
	    push @$all_folders, $i;
	}
    }

    @$all_folders = sort(@$all_folders);

    my $oldsub;
    foreach my $f ( @$lsub_folders ) {
	$oldsub->{$f} = 1;
    }
    my $newsub;
    foreach my $f ( @newselected ) {
	$newsub->{$f} = 1;
    }

    my $err;
    foreach my $f ( @$all_folders ) {
	if( defined $oldsub->{$f} && ! defined $newsub->{$f} ) {
	    $err .= &IMAPUtils::unsubscribe($LOGINuid, $LOGINpasswd, $f, $imaphost);
	}
	if( defined $newsub->{$f} && ! defined $oldsub->{$f} ) {
	    $err .= &IMAPUtils::subscribe($LOGINuid, $LOGINpasswd, $f, $imaphost);
	}
    }

    if( defined $err && $err ne "" ) {
	$this->display_error($err,
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID\&tab=$tab",
			     0);
    } else {
	$this->display_msg($message->{saved_ok},
			   "$confParam->{cgi_path}/subscribe_folder.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab",
			   1);
    }
    exit;
}

1;
