#!/usr/bin/perl -w
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: sysMonitor.pm,v 1.1.1.1 2003/03/25 10:31:40 ray Exp $
#

# based on: mailgraph -- a postfix statistics rrdtool frontend
# copyright (c) 2000, 2001, 2002 David Schweikert <dws@ee.ethz.ch>
# released under the GNU General Public License

package sysMonitor;

use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Display;
use vars qw(@ISA);
use subs qw(exit);

# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    return bless $self, $this;
}

sub display {
    my $this = shift;
    my $q 		= $this->{'cgi'};
    $this->print_html();
}

sub print_html() {
    my $this = shift;
    my $q = $this->{'cgi'};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"SYS_GRAPH"))->data();
    my $sessionID  = $confParam->{"sessionID"};
    my $tab        = $q->param('tab');
    my $stab       = $q->param('stab');

    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$q->start_Tr();
    $html .=	    $q->start_td();
    $html .=            $q->start_multipart_form(
                                -action => $confParam->{'cgi_path'}."/sysMonitor.pl",
                                -name => "form");
    $html .=		    $q->start_table({-cellspacing => 0, -cellpadding=>3, -width=>"100%"});
    $html .=			$q->Tr( $this->help_th(2, $message->{'title'}, "SYS_GRAPH"));
    $html .=			$q->Tr( $q->td({-class=>'AdminSubHeader', -colspan => 2}, $message->{'subheader'}));

    $html .=			__make_bunt($q, $message, $sessionID);
    
    $html .=		    $q->end_table();
    $html .=            $q->end_form();
    $html .=	    $q->end_td();
    $html .=	$q->end_Tr();
    $html .= $q->end_table();
			
    $this->SUPER::display($html);
}

sub __make_bunt {
	my ($q, $message, $sessionID) = @_;
    	my $tab          = $q->param('tab');
    	my $stab         = $q->param('stab');
    	my $which        = $q->param('which')     || 'system';
    	my $timeframe    = $q->param('timeframe') || 'hour';
	my $whichDef     = $which;
	my $timeframeDef = $timeframe;
	my $graphDIR     = '/srv/www/htdocs/sysMonitor';

	my $html =	$q->start_Tr();
	$html .=      		$q->start_td({width=>'50%', -align => "right", -valign => "middle"});
	$html .=      			$message->{'select'}." : ".
		  			$q->popup_menu( -name => "which",
		  		    			-values => ['system', 'diskio', 'part', 'traffic'],
		  		    			-labels => {
		  							'system' => $message->{'system'},
		  							'diskio' => $message->{'diskio'},
		  							'part' => $message->{'part'},
		  							'traffic' => $message->{'traffic'} },
		  		    			-default => $whichDef) . " ";
	$html .=      		$q->end_td();
	$html .=      		$q->start_td({-align => "left", -valign => "middle"});
	$html .=      			$q->popup_menu( -name => "timeframe",
		  		    			-values => ['hour', 'day', 'week', 'month', 'year'],
		  		    			-labels => {
		  							'hour' => $message->{'hour'},
		  							'day' => $message->{'day'},
		  							'week' => $message->{'week'},
		  							'month' => $message->{'month'},
		  							'year' => $message->{'year'} },
		  		    			-default => $timeframeDef);

	$html .=			$q->hidden( -name => "tab", -value => $tab );
    	$html .=                        $q->hidden( -name => "stab", -value => $stab );
    	$html .=                        $q->hidden( -name => "sessionID", -value => $sessionID )." ";
    	$html .=                        $q->submit(-class=>"button", -name => $message->{'view'});

	$html .=      		$q->end_td();
	$html .=  	$q->end_Tr();

	if ( (defined $which && defined $timeframe) ) {
		opendir(DIR, "$graphDIR/$which");
			my @images = grep (/$timeframe/, readdir(DIR));
		closedir(DIR);

		$html .= $q->start_Tr();
		$html .= 	$q->start_td({-colspan=>2, -align=>'center'});
		foreach my $i (sort @images) {
			next if ( $i =~ /cpu\d+/ );
			$html .= $q->img({-src=>"/sysMonitor/$which/$i", -alt=>"$i"})."<br>";
		}
		$html .= 	$q->end_td();
		$html .= $q->end_Tr();
	}

	# $html .= $q->Tr( $q->td( $q->Dump ) );

	return $html;
}

1;
