#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: toggle_samba.pm,v 1.1.1.1 2003/03/25 10:31:39 ray Exp $
#
package toggle_samba;
use strict;
use CGI qw(-no_xhtml);
use CGI::Carp qw(fatalsToBrowser);
use Storable qw(thaw freeze);
use MIME::Base64;
use Net::LDAP;
use LDAPUtils;
use cfreader;
use Display;
use vars qw(@ISA);
use subs qw(exit);

# Select the correct exit function
*exit = $ENV{MOD_PERL} ? \&Apache::exit : sub { CORE::exit };
@ISA = qw(Display);


sub new {
    my $this = shift;
    my $self = new Display(@_);
    
    return bless $self, $this;
}

sub display {
    my $this = shift;
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"TOGGLE_SAMBA"))->data();
    my $sessionID = $confParam->{"sessionID"};
    my $cgi = $this->{"cgi"};
    my $filter = $cgi->param('filter');
    my $tab = $cgi->param('tab');
    my $stab = $cgi->param('stab');
    
    my $delete_cancel = $cgi->param('delete_cancel');
    my $delete_ok = $cgi->param('delete_ok');
    my $create_cancel = $cgi->param('create_cancel');
    my $create_ok = $cgi->param('create_ok');
    if( (defined $delete_cancel) && ($delete_cancel ne "")){
    	$this->display_msg($message->{'delete_samba_account'}.": ".$message->{abort}, 
		    "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID&".
		    "filter=$filter&filtered=1\&tab=$tab\&stab=$stab" ,
		    1);
	exit;
    }elsif( (defined $create_cancel) && ($create_cancel ne "")){
    	$this->display_msg($message->{'create_samba_account'}.": ".$message->{abort}, 
		    "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID&".
		    "filter=$filter&filtered=1\&tab=$tab\&stab=$stab" ,
		    1);
	exit;
    }elsif( (defined $delete_ok) && ($delete_ok ne "") ){
	$this->delete_samba_account();
    }elsif( (defined $create_ok) && ($create_ok ne "") ){
	$this->create_samba_account();
    }else{
        $this->startup();
    }
}

sub startup {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"TOGGLE_SAMBA"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $doit      = $q->param('doit');
    my $filter    = $q->param('filter');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $user      = $q->param('USER');

    my $ADMINuid      = $confParam->{uid};
    my $ADMINpasswd   = $confParam->{passwd};
    
    my $ldapbase      = $confParam->{baseDN};
    my $ldaphost      = $confParam->{LDAPserver};
    my $ldapport      = $confParam->{LDAPport};
    #delete userlist from $confparm
    $session->modify( {'usersToMod' => undef} );

    my $text = "";
    
    my $ldap = Net::LDAP->new("$ldaphost", port => $ldapport, version => 3);

    if(!defined $ldap) {
	$this->display_error("can't contact LDAP Server",
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }

    my $mesg = $ldap->bind (   # bind to a directory with dn and password
			       dn       => "uid=$ADMINuid,$ldapbase",
			       password => "$ADMINpasswd"
			       );

    if($mesg->code != 0) {
        $text .= "bind failed\n";
        $text .=  &LDAPerror($mesg);
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
        exit;
    }

    my ($code,$errmsg) = LDAP_is_samba_user($confParam, $ldap, $user);
    $ldap->unbind;
    my $html = "";
    $html .= $q->start_table({-class=>'AdminBorder', -cellspacing=>2, -cellpadding=>0, -width=>"100%"});
    $html .=	$q->start_Tr();
    $html .=	    $q->start_td();
    $html .=		$q->start_multipart_form(
				-action => $confParam->{'cgi_path'}."/toggle_samba.pl",
				-name => "form");
    $html .=		    $q->start_table({-cellspacing => 0, -cellpadding=>3, -width=>"100%"});
    $html .=			$q->start_Tr();
    $html .=			    $this->help_th(2, $message->{'samba_title'}, "EDIT_USER_ADMIN");
    $html .=			$q->end_Tr();

    if($code == 0) {
	# create samba account
	$html .=		$q->start_Tr();
        $html .=		    $q->td({-colspan => 2, -class=>'AdminSubHeader'},
					    $message->{'create_samba_account'} );
	$html .=		$q->end_Tr();
	$html .=		$q->start_Tr();
	$html .=		    $q->start_td({-colspan => 2});
	$html .=			$message->{'create_description'};
	$html .=		    $q->end_td();
	$html .=		$q->end_Tr();
	$html .=		$q->start_Tr();
	$html .=		    $q->start_td({-align => "center", -width => "50%"});
	$html .=			$q->submit(-class=>"button",-name => "create_cancel",
						    -value => $message->{'sam_cancel'});
	$html .=		    $q->end_td();
	$html .=		    $q->start_td({-align => "center", -width => "50%"});
	$html .=			$q->submit(-class=>"button",-name => "create_ok",
						    -value => $message->{'sam_ok'});
	$html .=			$q->hidden(-name => "USER", -value => $user);
	$html .=			$q->hidden(-name => "sessionID", -value => $sessionID);
	$html .=			$q->hidden(-name => "filter", -value => $filter);
	$html .=			$q->hidden(-name => "filtered", -value => 1);
	$html .=			$q->hidden(-name => "tab", -value => $tab);
	$html .=			$q->hidden(-name => "stab", -value => $stab);
	$html .=		    $q->end_td();
	$html .=		$q->end_Tr();
    }elsif($code == 1){
	# delete samba account
	$html .=		$q->start_Tr();
        $html .=		    $q->td({-colspan => 2, -class=>'AdminSubHeader'},
					    [$message->{'delete_samba_account'}] );
	$html .=		$q->end_Tr();
	$html .=		$q->start_Tr();
	$html .=		    $q->start_td({-colspan => 2});
	$html .=			$q->br().$message->{'should_the_user'}.": \"$user\" ".
					    $message->{'really_delete_samba'}.$q->br().$q->br();
	$html .=		    $q->end_td();
	$html .=		$q->end_Tr();
	$html .=		$q->start_Tr();
	$html .=		    $q->start_td({-align => "center", -width => "50%"});
	$html .=			$q->submit(-class=>"button",-name => "delete_cancel",
						    -value => $message->{'sam_cancel'});
	$html .=		    $q->end_td();
	$html .=		    $q->start_td({-align => "center", -width => "50%"});
	$html .=			$q->submit(-class=>"button",-name => "delete_ok",
						    -value => $message->{'sam_ok'});
	$html .=			$q->hidden(-name => "USER", -value => $user);
	$html .=			$q->hidden(-name => "sessionID", -value => $sessionID);
	$html .=			$q->hidden(-name => "filter", -value => $filter);
	$html .=			$q->hidden(-name => "filtered", -value => 1);
	$html .=			$q->hidden(-name => "tab", -value => $tab);
	$html .=			$q->hidden(-name => "stab", -value => $stab);
	$html .=		    $q->end_td();
	$html .=		$q->end_Tr();
    }else{
	$text .= "search failed\n";
	$text .= $errmsg;
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }
    $html .=		    $q->end_table();
    $html .=		$q->end_form();
    $html .=	    $q->end_td();
    $html .=	$q->end_Tr();
    $html .= $q->end_table();
    

    $this->back_url("$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID\&tab=$tab\&stab=$stab\&filter=$filter\&filtered=1");
    $this->SUPER::display($html);
}


sub delete_samba_account {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"TOGGLE_SAMBA"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $doit      = $q->param('doit');
    my $filter    = $q->param('filter');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $user      = $q->param('USER');

    my $reply = $session->suad_smbdeluser($user);
    
    if($reply->code() ne "OK"){
	my $text .= $message->{'samba_delete_failed'}.":\n";
	$text .= $reply->code();
	$this->display_error($text,
		      "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }else{
    	$this->display_msg($message->{'samba_delete_success'}, 
		    "$confParam->{cgi_path}/browse_user.pl?sessionID=$sessionID&".
		    "filter=$filter&filtered=1\&tab=$tab\&stab=$stab" ,
		    1);
	exit;
    }
}

sub create_samba_account {
    my $this = shift;

    my $q = $this->{"cgi"};
    my $session = $this->{"session"};
    my $confParam = $session->{"confParam"};
    my $message = ($session->getLanguage($confParam->{LANG},"TOGGLE_SAMBA"))->data();
    my $sessionID = $confParam->{"sessionID"};

    my $doit      = $q->param('doit');
    my $filter    = $q->param('filter');
    my $tab       = $q->param('tab');
    my $stab      = $q->param('stab');
    my $user      = $q->param('USER');
    # generate a temp. random password
    my $passwd = "";
    for( my $i=0; $i < 8; $i++){
	$passwd .= pack( "C", int(rand(255)) );
    }
    $passwd = encode_base64($passwd, "");
    #my $reply = $session->suad_smbadduser($user,$passwd);
    
    my $homedir = "/home";
    my $skeldir = "/etc/skel";
    
    my $text = "";
    my $group = (getpwnam($user))[3];

    if( open(IN,"</etc/default/useradd") ) {
	my @data = <IN>;
	close(IN);
	my $cfr = new cfreader("=");
	my $dh = $cfr->CF2HASH(\@data,undef);
	my $keys = $cfr->getAllCMD($dh);
	$homedir = $keys->{"HOME"};
	$skeldir = $keys->{"SKEL"};
	chomp($homedir);
	chomp($skeldir);
    } else {
	$text .= "open ".$message->{'failed'}.": ".$!."\n";
    }
    
    my $reply = $session->suad_smbadduser($user, $passwd);
    my $smbaddcode = $reply->code();
    if( $smbaddcode ne "OK" ){
	$text .= "smb_adduser ".$message->{'failed'}.": ".$reply->code()."\n";
    }else{
	$text .= "smb_adduser ".$message->{'success'}."\n";
    }
    $reply = $session->suad_mkdir("$homedir/$user", "0755");
    if( $reply->code() ne "OK" ){
	$text .= "mkdir ".$message->{'failed'}.": ".$reply->code()."\n";
    }else{
	$text .= "mkdir ".$message->{'success'}."\n";
    }
    $reply = $session->suad_copydir($skeldir, "$homedir/$user");
    if( $reply->code() ne "OK" ){
	$text .= "copydir ".$message->{'failed'}.": ".$reply->code()."\n";
    }else{
	$text .= "copydir ".$message->{'success'}."\n";
    }
    $reply = $session->suad_chown("$homedir/$user", $user, $group);
    if( $reply->code() ne "OK" ){
	$text .= "chown ".$message->{'failed'}.": ".$reply->code()."\n";
    }else{
	$text .= "chown ".$message->{'success'}."\n";
    }

    if($smbaddcode ne "OK"){
	$this->display_error($message->{'samba_create_failed'}."\n".$text,
			     "$confParam->{cgi_path}/menu.pl?sessionID=$sessionID");
	exit;
    }else{
    	$this->display_msg($text.$message->{'samba_create_success'}."<br>".$message->{'change_passwd_to_activate'}, 
		    "$confParam->{cgi_path}/change_passwd.pl?sessionID=$sessionID&".
		    "USER=$user&filter=$filter&filtered=1\&tab=$tab\&stab=$stab");
	exit;
    }
}

1;
