#!/usr/bin/perl
#
# Copyright (c) 2000-2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: index.pl,v 1.2 2003/10/29 10:35:38 varkoly Exp $
#

BEGIN{
    push @INC,"/srv/www/lib"
}

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Net::LDAP;
use Utils;

my $jscript='if(top.frames.length > 0) top.location.href="/start/index.pl";';

my $q = new CGI;
my $lang;

my ($basedn, $ldapserver, $ldapport) =
    parse_file("/etc/openldap/ldap.conf", "BASE", "HOST", "PORT");

if($basedn eq "") {
    die "BaseDN is emtpy!!!";
}
if($ldapserver eq "") {
    $ldapserver = "localhost";
}
if($ldapport eq "") {
    $ldapport = 389;
}

my $ld;
foreach my $host ( split(/\s/,$ldapserver) ) {
    $ld = Net::LDAP->new($host, port=>$ldapport, version => 3);
    last if defined $ld;
}

if (!defined $ld || $ld <= 0)
{
    die "Connection to LDAP Server failed!";
}

my $filter = "preferredLanguage=*";
$status = $ld->search(
		      base => "uid=cyrus,".$basedn,
		      scope => "base",
		      attrs => ['preferredLanguage'],
		      filter => $filter
		      );

if ($status->code != 0) {
    $ld->unbind;
    die "LDAP Search failed!";
} else {
    my $entry = $status->entry(0);
    $lang = $entry->get_value("preferredlanguage");
}
$ld->unbind;

if( !defined $lang || $lang eq "") {
    $lang = "EN";
}

#my $acc_lang = lc($ENV{'HTTP_ACCEPT_LANGUAGE'});
## print STDERR "BROWSER LANGUAGE=<$acc_lang>\n";
#$acc_lang =~ s/^(.*?),.*/$1/;
#$acc_lang =~ s/^([a-z]+).*/$1/i;
#if( defined $acc_lang ) {
#    $lang = uc($acc_lang);
#    #print STDERR "SLEMS LANGUAGE=<$lang>\n";
#}

if ( $lang eq "DE" ) {
    print $q->header( -charset=>'iso-8859-15', -Refresh=>"0; URL=/suse/login.pl?doit=login&lang=DE" );
    print $q->start_html( -title=>'redirect', -script=>$jscript );
    print '<p align="center">Sie werden weitergeleitet...</p>';
    print $q->end_html();
} elsif ( $lang eq "HU" ) {
    print $q->header( -charset=>'iso-8859-2', -Refresh=>"0; URL=/suse/login.pl?doit=login&lang=HU" );
    print $q->start_html( -title=>'redirect', -script=>$jscript );
    print '<p align="center">Automatikus tovbbts, krem vrjon ...</p>';
    print $q->end_html();
} else {
    print $q->header( -Refresh=>"0; URL=/suse/login.pl?doit=login&lang=$lang" );
    print $q->start_html( -title=>'redirect', -script=>$jscript );
    print '<p align="center">You will be redirected...</p>';
    print $q->end_html();
}

