#!/usr/bin/perl -w
#
# $Id: SETUP.pl,v 1.1.1.1 2003/03/25 10:31:47 ray Exp $
#

my $debug = 1;
my $traffic_file = '/usr/lib/sysMonitor/data-traffic/settings';
my $diskio_file  = '/usr/lib/sysMonitor/data-diskio/settings';
my $system_file  = '/usr/lib/sysMonitor/data-system/settings';
my $part_file    = '/usr/lib/sysMonitor/data-part/settings';

print "delete all old webgraphs ...";
	`rm -rf /srv/www/htdocs/sysMonitor/*`;
print " done\n";

#
# setup data-part
#
print "setting up data-part...\n" if $debug;
my %parts;
open(IN, "/bin/mount |") || __error("can't open /bin/mount in pipe");
    while(<IN>) {
        next if (/proc|devpts|usbdevfs|automount|type nfs|iso9660/);
        m/^(.*)\s+on\s+(.*?)\s+.*/;
        $parts{$1} = $2;
        print "\t$1 ==> $2\n";
    }
close(IN);
open(CONF, ">$part_file") || __error("can't open $part_file");
    foreach my $i (keys %parts) {
        print CONF "DRIVE=$i,$parts{$i}\n";
    }
close(CONF);
print "done\n";

#
# setup data-traffic
#
print "setting up data-traffic...\n" if $debug;
my @netDev;
open(IN, "/bin/netstat -i |") || __error("can't open /bin/netstat in pipe");
	while(<IN>) {
		next unless ( $_ =~ / [0-9]+ / );
		m/^(.*?) .*/;
		next if ( $1 eq 'lo' );
		print "\tadd device ==> $1\n" if $debug;
		push @netDev, $1;
	}
close(IN);
open(CONF, ">$traffic_file") || __error("can't open $traffic_file");
	#print CONF 'STYLE="bits"'."\n";
	print CONF 'STYLE="bytes"'."\n";
	print CONF 'SWAPIO="no"'."\n";
	foreach my $i (@netDev) {
		#--         DEV=<device>,<max bytes/s input>,<max bytes/s output>,<description>
		#my ($descr, $speed) = __getIFspeed($i);
		#print CONF 'DEV="'.$i.','.$speed.','.$speed.','.$descr.'"'."\n";
		print CONF 'DEV="'.$i.',12500000,12500000,100 MBit ethernet"'."\n";
	}
	#-- exapmle snmp device
	#print CONF 'DEV="SNMP:192.168.1.1:2:public,12500000,12500000,100 MBit ethernet via SNMP (bulk)"'."\n";
	#print CONF 'DEV="SNMP:192.168.1.1:1:public:walk,1250000,1250000,10 MBit ethernet via SNMP (walk)"'."\n";
close(CONF);
print "done\n" if $debug;

#
# setup data-diskio
#
my @disks;
my @diskOUT;
print "scan for data-diskio...\n" if $debug;
open(IN, "</proc/stat") || __error("can't open /proc/stat");
	while(<IN>) {
		next unless ( $_ =~ /disk_io:.*/ );
		s/disk_io:\s*//;
		my @data = split;
		foreach my $i (@data) {
			m/^\((\d+),(\d+)\).*/;
			print "\tfound ==> $i\n" if $debug;
			push @disks, "$1_$2";
		}
	}
close(IN);
open(IN, "</proc/partitions") || error("can't open /proc/partitions");
	while(<IN>) {
		next unless ( $_ =~ /^ *\d.*/ );
		s/ +/ /g;
		s/^ //;
		my ($major, $minor, $blocks, $name, $rio, $rmerge, $rsect, $ruse, $wio, $wmerge, $wsect, $wuse, $running, $use, $aveq) = split;
		my $num = $major."_".$minor;
		if ( grep(/^$num$/, @disks) ) {
			print "\tadd   ==> DEV=$num,$name\n" if $debug;
			push @diskOUT, "DEV=$num,$name";
		}
	}
close(IN);
open(CONF, ">$diskio_file") || __error("can't open $diskio_file");
	print CONF 'KERNEL="2.4"'."\n";
	foreach my $i (@diskOUT) {
		print CONF "$i\n";
	}
close(CONF);
print "done\n" if $debug;

#
# setup data-system
#
print "setting up data-system... " if $debug;
my $cpus = 0;
open(CONF, ">$system_file") || __error("can't open $system_file");
	open(IN, "</proc/stat") || __error("can't open /proc/stat");
		while(<IN>) {
			next unless ( $_ =~ /cpu\d+ .*/ );
			$cpus++;
		}
	close(IN);
	print CONF 'NUMCPU="'.$cpus.'"'."\n";
	print CONF 'CPUGRAPH="percent"'."\n";
close(CONF);
print "done\n" if $debug;

#-- huhu
sub __error {
	my $msg = shift;
	print "ERROR: $msg\n";
	exit 128;
}

#
# zu einem netzwerkinterface den speed ermitteln
#
sub __getIFspeed {
	my $iface = shift;
	my $ret;
	my %speed = (
		10	=> '1250000',
		100 	=> '12500000'
	);
	open(IN, "</var/log/messages") || __error("can't open /var/log/messages");
		while(<IN>) {
			next unless ( $_ =~ / $iface / );
			m/^.*?(\d*) Mbps .*/;
			$ret = $1 if $1;
		}
	close(IN);
	return ("$ret Mbps", $speed{$ret});
}

