#! /usr/bin/perl

#use strict;
#use diagnostics;
#use warnings;
use File::Find;
use HotSaNIC;
#use Image::Magick;

my %CONFIG = get_config("/usr/lib/sysMonitor");
my $thumbsize = $CONFIG{THUMBSIZE} || "20%";
my $method = $CONFIG{CONVERTMETHOD} || "HTML";


if (index("ImgMgck I::M",$method) == -1) { exit 0; }

# for the convenience of &wanted calls, including -eval statements:
use vars qw/*name *dir *prune/;
*name   = *File::Find::name;
*dir    = *File::Find::dir;
*prune  = *File::Find::prune;

# Traverse desired filesystems
my @files;
my $cmd;
File::Find::find({wanted => \&wanted}, $CONFIG{WEBDIR});

foreach my $file ( @files ) {
  my $thumb=$file;
  $thumb=~ s/^(.+)\/(.+)-week\.(.+)$/$1\/thumb-$2\.$3/;
#  print "$file -> $thumb\n";

  if ($method eq "I::M") {
    print "Using Image::Magick perl-module\n";
    my $image = new Image::Magick;
    $image->Read($file);
    $image->Scale(geometry => "$thumbsize");
    $image->Write($thumb);
    }
  else {
    $cmd = "$CONFIG{CONVERTPATH} -geometry $thumbsize $file $thumb";
#    print "$cmd\n";
    system($cmd) == 0
    or warn "$0: could not convert $file to $thumb: $!";
    }
  }

exit;


sub wanted {
	my ($dev,$ino,$mode,$nlink,$uid,$gid);

	(($dev,$ino,$mode,$nlink,$uid,$gid) = lstat($_)) &&
	-f _ &&
	/^.*-week\..*\z/s &&
	push @files, $name;
}

