#!/usr/bin/perl -w

use lib "/usr/lib/sysMonitor";
use HotSaNIC;
use RRDs;

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

# read config-file to check which kernel-version is being used.
open (CF,"settings");
while (<CF>) {
  next if ! /KERNEL/;
  ($var,$value)=parse_line($_);
  next if $var eq "";
  if ($var eq "KERNEL") { $KERNEL=$value; last; }
  }
close CF;

if ( (! defined $KERNEL) || ($KERNEL eq "") ) {
  $release=`uname -r`;
  $KERNEL="2.2" if $release =~ /^2.1./;
  $KERNEL="2.2" if $release =~ /^2.2./;
  $KERNEL="2.4" if $release =~ /^2.3./;
  $KERNEL="2.4" if $release =~ /^2.4./;
  }

if ($KERNEL eq "2.4") {
  open FILE,"/proc/stat";
  while (<FILE>) { (undef,@stats)=split if /disk_io/; }
  close FILE;
  }
elsif ($KERNEL eq "2.2") {
  open FILE,"/proc/stat";
  while (<FILE>) {
    (undef,@overall)=split if /disk /;
    (undef,@readio)=split if /disk_rio/;
    (undef,@writeio)=split if /disk_wio/;
    (undef,@readblk)=split if /disk_rblk/;
    (undef,@writeblk)=split if /disk_wblk/;
    }
  close FILE;
  $num=0;
  while (@overall) {
    $all=shift @overall;
    $rio=shift @readio;
    $wio=shift @writeio;
    $rblk=shift @readblk;
    $wblk=shift @writeblk;
    push @stats,"($num):($all,$rio,$wio,$rblk,$wblk)";
    $num++;
    }
  }

# kernel 2.2.x
# disk 1494755 377215 221577 144318
# disk_rio 564538 286941 151189 77490
# disk_wio 930217 90274 70388 66828
# disk_rblk 1129538 573882 302378 154980
# disk_wblk 1860536 180548 140776 133656

# kernel 2.4.x
#  disk_io: (8,0):(985065,41330,436455,943735,13075448) (8,1):(12563,6363,333604,6200,167608) (8,2):(11194,11012,90140,182,3160)

if (-e "/var/lib/sysMonitor/data-diskio/last.dat") {
  open IN,"/var/lib/sysMonitor/data-diskio/last.dat";
  while (<IN>) {
    chomp;
    ($drive,$racc,$rbyt,$wacc,$wbyt)=split;
    if (defined $drive) {
      $RACC{$drive}=$racc;
      $WACC{$drive}=$wacc;
      $RBYT{$drive}=$rbyt;
      $WBYT{$drive}=$wbyt;
      }
    }
  close IN;
  }

open OUT,">/var/lib/sysMonitor/data-diskio/last.dat";
foreach (@stats) {
  s/[()]//g;
  ($drive,$stat)=split /:/;
  $drive =~ s/,/_/g;
  (undef,$racc,$rbyt,$wacc,$wbyt)=split /,/,$stat;
  $rbyt*=512;
  $wbyt*=512;
  if (defined $drive) {
    if ((defined $racc) && (defined $RACC{$drive})) { $dracc=($racc-$RACC{$drive}); } else { $dracc=0; }
    if ((defined $wacc) && (defined $WACC{$drive})) { $dwacc=($wacc-$WACC{$drive}); } else { $dwacc=0; }
    if ((defined $rbyt) && (defined $RBYT{$drive})) { $drbyt=($rbyt-$RBYT{$drive}); } else { $drbyt=0; }
    if ((defined $wbyt) && (defined $WBYT{$drive})) { $dwbyt=($wbyt-$WBYT{$drive}); } else { $dwbyt=0; }
    
    print OUT "$drive $racc $rbyt $wacc $wbyt\n";

    if ( ! -e "/var/lib/sysMonitor/data-diskio/rrd/$drive.rrd" ) { system("./makerrd","$drive","U") }
    RRDs::update "/var/lib/sysMonitor/data-diskio/rrd/$drive.rrd",time.":".$dracc.":".$drbyt.":".$dwacc.":".$dwbyt;  
    if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update `$drive.rrd': $ERROR"); }
    }
  }
close OUT;

dupe_control("stop",$ARGS{"MODNAME"},"");

