#!/usr/bin/perl -w

use lib "/usr/lib/sysMonitor";
use HotSaNIC;
use RRDs;
use strict;
use vars qw( %devmax %devuse $dev $max $use $name $old $d @arr @diskfree $ERROR %ARGS);

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

undef %devmax;
undef %devuse;

#  build summary of all mounted partitions with existing databases
#  assuming 0 values for each device because maybe it's unmounted
opendir(DIR, "/var/lib/sysMonitor/data-part/rrd") || dupe_control("die",$ARGS{"MODNAME"},": can't open dir $!");
@arr = grep(/\.rrd/,readdir(DIR));
closedir DIR;
foreach $_ (@arr) { 
  ($name) = split (".rrd");
  $devmax{$name}=0;
  $devuse{$name}=0;
  }

#  add/overwrite with summary of all currently available partitions
#  using "df" system command.
$old="";
@diskfree = grep(/\//,`df -k`);
foreach $_ (@diskfree) {
  chomp;
  ($dev, $max, $use) = split;
  $max*=1024 if defined $max;
  $use*=1024 if defined $use;
# check for line-break
  if ((!defined $max) || ($max eq "")) { $old=$dev; next; }
  if ($old ne "") {
    $use=$max if defined $max;
    $max=$dev if defined $dev;
    $dev=$old;
    $old="";
    }
  ($d, $d, $name) = split("/",$dev);
  $dev=~ s/\//_/g;
  $dev=~ s/:/_/g;
  $devmax{$dev}=$max;
  $devuse{$dev}=$use;
  }

# here begins the evaluation of all sampled data:
# check if the device shall really be sampled
# build new database if needed and update database
foreach $name (keys %devmax) {
  if ( ! -e "/var/lib/sysMonitor/data-part/rrd/$name.rrd" ) { system("./makerrd","$name","U") }
  RRDs::update "/var/lib/sysMonitor/data-part/rrd/$name.rrd",time.":".$devmax{$name}.":".$devuse{$name};  
  if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update `$name.rrd': $ERROR"); }
  }

dupe_control("stop",$ARGS{"MODNAME"},"");
