#!/usr/bin/perl -w

use lib "/usr/lib/sysMonitor";
use HotSaNIC;
use RRDs;

# get cmdline arguments (i.e. options passed by the daemon)
# and other global parameters
#
%ARGS=arg2opt(@ARGV);

dupe_control("start",$ARGS{"MODNAME"},"");

$OS_TYPE=$ARGS{"OSTYPE"};

# read module-specific settings
#

# build new database(s) if needed
  if ( ! -e "/var/lib/sysMonitor/data-system/rrd/loadavg.rrd" ) { system("./makerrd","loadavg") }
  if ( ! -e "/var/lib/sysMonitor/data-system/rrd/users.rrd" ) { system("./makerrd","users") }
  if ( ! -e "/var/lib/sysMonitor/data-system/rrd/proc.rrd" ) { system("./makerrd","proc") }
  if ( ! -e "/var/lib/sysMonitor/data-system/rrd/mem.rrd" ) { system("./makerrd","mem") }


$multicpu=0;

  open(IN,"/proc/stat");
  while(<IN>) {
    chomp;
    if( index($_,"cpu") >=0 ) {
      ($cpu, $cpu1, $cpu2, $cpu3, $cpu4)=split;
      $cpu1{$cpu}=$cpu1;
      $cpu2{$cpu}=$cpu2;
      $cpu3{$cpu}=$cpu3;
      $cpu4{$cpu}=$cpu4;
      $cpu5{$cpu}=0;
      $cpu1old{$cpu}=0;
      $cpu2old{$cpu}=0;
      $cpu3old{$cpu}=0;
      $cpu4old{$cpu}=0;
      $cpu5old{$cpu}=0;
      if ($cpu eq "cpu1") { $multicpu=1; }
      }
    }
  close(IN);

# read last state and store actual state
# usr nice sys idle int
if ( -e "/var/lib/sysMonitor/data-system/cpu.dat" ) {
  open(CPU,"/var/lib/sysMonitor/data-system/cpu.dat");
  while (<CPU>) {
    $line=$_." 0 0 0 0 0 0";
    ($cpu, $cpu1old, $cpu2old, $cpu3old, $cpu4old, $cpu5old)=split / /,$line;
  
    if ($cpu !~ /cpu/) {
      $cpu5old=$cpu4old;
      $cpu4old=$cpu3old;
      $cpu3old=$cpu2old;
      $cpu2old=$cpu1old;
      $cpu1old=$cpu;
      $cpu="cpu";
      }

    $cpu1old{$cpu}=$cpu1old;
    $cpu2old{$cpu}=$cpu2old;
    $cpu3old{$cpu}=$cpu3old;
    $cpu4old{$cpu}=$cpu4old;
    $cpu5old{$cpu}=$cpu5old;
    }
  close(CPU);
  }

open(CPU,">/var/lib/sysMonitor/data-system/cpu.dat");

foreach $cpu (keys %cpu1) {
  print CPU $cpu." ".$cpu1{$cpu}." ".$cpu2{$cpu}." ".$cpu3{$cpu}." ".$cpu4{$cpu}." ".$cpu5{$cpu}."\n";

# calculate everything....


  $all{$cpu}=($cpu1{$cpu}+$cpu2{$cpu}+$cpu3{$cpu}+$cpu4{$cpu}+$cpu5{$cpu})-($cpu1old{$cpu}+$cpu2old{$cpu}+$cpu3old{$cpu}+$cpu4old{$cpu}+$cpu5old{$cpu});

  $cpuusr{$cpu}=($cpu1{$cpu}-$cpu1old{$cpu})/$all{$cpu};
  $cpunic{$cpu}=($cpu2{$cpu}-$cpu2old{$cpu})/$all{$cpu};
  $cpusys{$cpu}=($cpu3{$cpu}-$cpu3old{$cpu})/$all{$cpu};
  $cpuidl{$cpu}=($cpu4{$cpu}-$cpu4old{$cpu})/$all{$cpu};
  #$cpuint{$cpu}=($cpu5{$cpu}-$cpu5old{$cpu})/$all{$cpu};

  if ( ! -e "/var/lib/sysMonitor/data-system/rrd/".$cpu.".rrd" ) { system("./makerrd",$cpu); }

  if ($OS_TYPE =~ /Linux/) {
    RRDs::update "/var/lib/sysMonitor/data-system/rrd/".$cpu.".rrd", time.":".$cpuusr{$cpu}.":".$cpunic{$cpu}.":".$cpusys{$cpu}.":".$cpuidl{$cpu};
    if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update cpu.rrd: $ERROR"); }
    }

# on single-cpu machines only the global database has to be updated.
  last if ($multicpu==0);

  }
close(CPU);

#####################################################################################
# here we go with the load-average value ...
#####################################################################################

  open(IN,"/proc/loadavg"); ($load1,$load5,$load15)=split(/ /,<IN>); close(IN);

RRDs::update "/var/lib/sysMonitor/data-system/rrd/loadavg.rrd", time.":".$load15.":".$load5.":".$load1;
if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update loadavg.rrd: $ERROR"); }


#####################################################################################
# now the processes. We have to check how many processes are sleeping,
# running, zombieng spwapped to disc or stopped. To do this we simply
# have to walk through the /proc tree, check all "stat" files of each
# process-id subdir and increment the according state-counter.
#
($procslp,$procrun,$proczmb,$procstp,$procdsc)=(0,0,0,0,0);

  opendir (DIR,"/proc");@dir=readdir (DIR);closedir(DIR);
  foreach $entry (@dir) {
    # check if entry is a numeric one
    if (($entry =~ /^\d+$/) && ( -e "/proc/$entry/stat" )) {
      open (STAT,"/proc/$entry/stat");$_=<STAT>;close(STAT);
      if (index($_," S ") >=0 ) { $procslp++ }
      elsif (index($_," D ") >=0 ) { $procdsc++ }
      elsif (index($_," R ") >=0 ) { $procrun++ }
      elsif (index($_," Z ") >=0 ) { $proczmb++ }
      elsif (index($_," T ") >=0 ) { $procstp++ }
      }
    }


# print "$procslp,$procrun,$proczmb,$procstp,$procdsc\n";

RRDs::update "/var/lib/sysMonitor/data-system/rrd/proc.rrd", time.":".$procslp.":".$procrun.":".$proczmb.":".$procstp.":".$procdsc;
if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update proc.rrd: $ERROR"); }


####################################################################################
# here we go with the memory and swapfile statistics...
#
  open(IN,"/proc/meminfo");
  while(<IN>) {
    chomp;
    if (index($_,"Mem:")>=0) { (undef,$memtot,undef,$memfre,$memshr,$membuf,$memcac)=split; }
    elsif (index($_,"Swap:")>=0) { (undef,undef,$swpuse,$swpfre)=split; }
    }
  close(IN);

  $memshr=$memtot-$memfre-$membuf-$memcac;

  RRDs::update "/var/lib/sysMonitor/data-system/rrd/mem.rrd", time.":".$memfre.":".$memshr.":".$membuf.":".$memcac.":".$swpfre.":".$swpuse;
  if ($ERROR = RRDs::error) { dupe_control("die",$ARGS{"MODNAME"},"unable to update `mem.rrd': $ERROR"); }


#
# users.rrd -> tty pty pts
# cpu.rrd -> cpuusr cpusys cpunic cpuidl
# loadavg.rrd -> load15 load5 load1
# proc.rrd -> procslp procrun proczmb procstp
# mem.rrd (Linux) -> memfre memshr membuf memcac swpfre swpuse
# mem.rrd (FreeBSD) -> memfree memwire memactv meminac memcach swpfre swpuse
# mem.rrd (NetBSD) -> memact meminac memwire memfree swpuse swpfree

dupe_control("stop",$ARGS{"MODNAME"},"");
