#! /usr/bin/perl
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
#
#
# $Id: create_certificate.pl,v 1.1 2003/07/24 08:52:42 varkoly Exp $
#
use strict;
#use warnings;
use lib qw(/srv/www/lib);
use openssl;
use File::Copy "cp";

if($#ARGV ne 6) {
	print STDERR "Usage: $0 cn fqhn slss-name passwd country org email\n";
	exit 1;
}

my $cn      = shift || '';
my $fqhn    = shift || '';
my $slss    = shift || '';
my $passwd  = shift || '';
my $country = shift || '';
#my $state   = shift || '';
my $state   = '';
#my $local   = shift || '';
my $local   = '';
my $org     = shift || '';
#my $orgu    = shift || '';
my $orgu    = '';
my $email   = shift || '';

my $dir           = "/etc/ssl";
my $cert_dir      = $dir."/certs";
my $CA_collection = $dir."/CA";
my $newcerts      = $dir."/newcerts";
my $CA_derForm    = "/srv/www/htdocs/cacert.der";
my $crl_dir       = $dir."/crl";


#first we clean up 

if ( -f "$CA_collection"."/ownCA.pem") {
    unlink("$CA_collection"."/ownCA.pem");
}
if ( -f "$CA_collection"."/usedCA.pem") {
    unlink("$CA_collection"."/usedCA.pem");
}
if ( -f "$CA_derForm") {
    unlink ("$CA_derForm");
}
if ( -f "$dir"."/private/cakey.pem") {
    unlink("$dir"."/private/cakey.pem");
}
if ( -f "$crl_dir"."/crl.pem") {
    unlink("$crl_dir"."/crl.pem");
}
open(FOO,">$crl_dir/crl.pem");
close(FOO);
if ( -f "$cert_dir"."/cert.pem") {
    unlink("$cert_dir"."/cert.pem");
}
if ( -f "$cert_dir"."/skey.pem") {
    unlink("$cert_dir"."/skey.pem");
}

opendir(DIR, "$newcerts/");
while(my $d = readdir(DIR)) {
    if($d =~ /^([A-Fa-f0-9]+\.pem)$/) { # untaint data
#    print STDERR "$1\n";
        unlink ("$newcerts/$1");
    }
}

open (TMPOUT, ">$dir"."/serial");
print TMPOUT "01\n";
close TMPOUT;
if ( -f "$dir"."/index.txt") {
    unlink("$dir"."/index.txt");
    open TMPOUT, ">$dir"."/index.txt";
    close TMPOUT;
}

#  we create the needed directories

if (! -d "$dir"."/CA") {
    mkdir ("$dir"."/CA",0777);
}
if (! -d "$dir"."/private") {
    mkdir ("$dir"."/private",0777);
}

# now we create the CA
create_selfsign_CA($cn, $passwd, $country, $state, $local, $org, $orgu, $email);
#print STDERR  "create_selfsign_CA($cn, $passwd, $country, $state, $local, $org, $orgu, $email)\n";

my $mode = 0600;
chmod($mode, "$dir/private/cakey.pem");
cp("$CA_collection/ownCA.pem", "$CA_collection/usedCA.pem");


# now we create the server certifikate
if ( ! -d "$newcerts") {
    mkdir ("$newcerts",0777);
}
if (! -d "$dir"."/crl") {
    mkdir ("$dir"."/crl",0777);
    # We need to just create it, because apache won't start, else
    open(OUT,">$crl_dir/crl.pem");
    close(OUT);
}
if (! -d "$dir"."/certs"){
    mkdir ("$dir"."/certs",0777);
}

if ( ! -f "$dir/index.txt" ) {
    open(FOO, ">$dir/index.txt");
    close(FOO);
}
if ( -f "$cert_dir"."/skey.pem") {
    unlink("$cert_dir"."/skey.pem");
}
if ( -f "$cert_dir"."/schoolserver_skey.pem") {
    unlink("$cert_dir"."/schoolserver_skey.pem");
}
if ( -f "$cert_dir"."/cert.pem") {
    unlink("$cert_dir"."/cert.pem");
}
if ( -f "$cert_dir"."/schoolserver_cert.pem") {
    unlink("$cert_dir"."/schoolserver_cert.pem");
}
if ( -f "$cert_dir"."/cert.der") {
    unlink("$cert_dir"."/cert.der");
}

cp ("$CA_collection/ownCA.pem", "$CA_collection/usedCA.pem");
create_sreq($fqhn, $passwd, $country, $state, $local, $org, $orgu, $email);
create_schoolserver_sreq($slss, $passwd, $country, $state, $local, $org, $orgu, $email);
#print STDERR  "create_sreq($fqhn, $passwd, $country, $state, $local, $org, $orgu, $email)\n";

sign_sreq("server_cert", $passwd);
sign_schoolserver_sreq("server_cert", $passwd);
#print STDERR  "sign_sreq(server_cert, $passwd)\n";
my $mode = 0640;
chmod($mode, "$cert_dir/skey.pem");
chown((getpwnam("root"))[2], (getgrnam("mail"))[2], "$cert_dir/skey.pem");

# --PEM to DER Format
change_cert_format("$CA_collection/usedCA.pem", "PEM", "$CA_derForm", "DER");
#print STDERR  "change_cert_format\n";
change_cert_format("$cert_dir"."/cert.pem", "PEM", "$cert_dir"."/cert.der", "DER");
change_cert_format("$cert_dir"."/schoolserver_cert.pem", "PEM", "$cert_dir"."/schoolserver_cert.der", "DER");
#print STDERR  "change_cert_format\n";

