#! /bin/bash
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: cyruspw.sh,v 1.1.1.1 2003/03/25 10:31:40 ray Exp $
#

PW1=""
PW2=""
IFS=""
while [ -z "$PW1" ]; do
    read -a PW1 -p "Enter new Cyrus Password: " -r -s
    echo
done
while [ -z "$PW2" ]; do
    read -a PW2 -p "Re-enter new Cyrus Password: " -r -s
    echo
done

if [ "$PW1" != "$PW2" ]; then
    echo "Sorry, passwords do not match."
    exit 1;
fi

export PW=$PW1
export PWCRYPT=`perl -e 'print crypt($ENV{PW}, pack("C2",(int(rand 26)+65),(int(rand 26)+65)));'`

if [ -z "$PWCRYPT" ]; then
    echo "Unable to get the crypt..."
    exit 1;
fi

echo "cyrus:$PWCRYPT" | chpasswd -e

SLAPDTMP="/etc/openldap/slapd.conf.$$"
SLAPDBAK="/etc/openldap/slapd.conf.bak"

cp --remove-destination /etc/openldap/slapd.conf $SLAPDBAK

cat /etc/openldap/slapd.conf |awk '
BEGIN      { OFS="        "; }
/^rootpw/  { printf "rootpw\t\t{crypt}%s\n", ENVIRON["PWCRYPT"]; next; }
           { print; next; };' > $SLAPDTMP

if [ ! -s $SLAPDTMP ]; then
    echo "Writing new slapd.conf failed"
    exit 1
fi

mv $SLAPDTMP /etc/openldap/slapd.conf

echo "Restarting LDAP Server"
rcldap stop
sleep 2
rcldap start
