#!/usr/bin/perl
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
# Purpose:   Sending command batch to imapserver
#
# $Id: imaptalk.pl,v 1.1.1.1 2003/03/25 10:31:40 ray Exp $
#
require 5.002;
use Socket;
use strict;
use FileHandle;
my ($remote,$port, $iaddr, $paddr, $proto, $line);

$remote  = shift || 'localhost';
$port    = shift || 'imap';

if ($port =~ /\D/) {
    $port = getservbyname($port, 'tcp');
}

die "No port" unless $port;

$iaddr  = inet_aton($remote) || die "no host: $remote";
$paddr   = sockaddr_in($port, $iaddr);
$proto   = getprotobyname('tcp');

socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || die "socket: $!";
connect(SOCK, $paddr)    || die "connect: $!";

readsock();

while( <STDIN> ) {
    chomp;
    command($_);
}

close(SOCK) || die "close: $!";
exit 0;

sub readsock {
    while( ($line = <SOCK>) != '\0' ) {
    	$line .= $line;
    }
    print "$line";
}

sub command {
    my $cmdline = shift;

    print "sending <$cmdline>\n";
    print SOCK "$cmdline\n";
    SOCK->flush();

    readsock();
}
