#! /usr/bin/perl -w
#
# Copyright (c) 2003 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: globalsupdate.pl,v 1.1 2003/05/06 11:37:52 varkoly Exp $
#

use strict;
use Config::IniFiles;

if( ! defined $ARGV[0] ) {
    print "missing infile\n";
    exit;
}

if( ! defined $ARGV[1] ) {
    print "missing outfile\n";
    exit;
}

my $cfhash = { 
    "GENERAL" => {
	"EnableFaxParamFrontend" => "true",
	"NewUserChangePassword"  => "false",
	"DisableDNSManagement"   => "false",
	"DisableDHCPManagement"  => "false",
	"DisableWebmailLink"     => "false",
	"DisableGroupwareLink"   => "false",
	"DisableGroupwareLogin"  => "false",
	"UserJpegPhotoMaxHeight" => "200",
	"UserJpegPhotoMaxWidth"  => "150",
	"MonitorServices"        => "ldap,cyrus,postfix,groupware,webmail,fetchd" },
    "SESSIOND" => {
	"SessiondHost" => "unix" },
    "SUAD" => {
	"SuadHost"      => "unix",
	"SuadPort"      => "44444",
	"SSL_key_file"  => "/etc/sessiond/certs/SuSEWebkey.pem",
	"SSL_cert_file" => "/etc/sessiond/certs/SuSEWebcert.pem",
	"SSL_ca_file"   => "/etc/sessiond/cacert.pem" },
    "FETCHD" => {
	"drop_undeliverable_mail" => "false" }
};


my $cfg = new Config::IniFiles(-file => "$ARGV[0]");

foreach my $section ( keys %$cfhash ) {
    if( ! $cfg->SectionExists($section) ) {
	print "adding section [$section]\n";
	$cfg->AddSection($section);
    }
    foreach my $parameter ( keys %{$cfhash->{$section}} ) {
	#print "\t$parameter = $cfhash->{$section}->{$parameter}\n";
	if( ! defined $cfg->setval($section, $parameter, $cfhash->{$section}->{$parameter}) ) {
	    print "adding new parameter $parameter\n";
	    $cfg->newval($section, $parameter, $cfhash->{$section}->{$parameter});
	}
    }
}

$cfg->WriteConfig("$ARGV[1]");
