#! /usr/bin/perl
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: ldifconv.pl,v 1.2 2003/05/06 11:36:55 varkoly Exp $
#

use strict;
use POSIX;
use Net::LDAP::LDIF;

if( ! defined $ARGV[0] ) {
    die "No input file given!\n";
}

if( ! defined $ARGV[1] ) {
    die "No output file given!\n";
}

my $ldifin = new Net::LDAP::LDIF("$ARGV[0]", "r");

my @oldentries = $ldifin->read();
my @newentries;
my $paddrhash;
my %prefhash;

$ldifin->done();

foreach my $e ( @oldentries ) {
    my $dn = $e->dn();

#    next if $dn =~ /uid=cyrus/;
#    next if $dn =~ /uid=mailadmin/;
#    next if ! ( ( $dn =~ /uid=/ ) ||
#		( $dn =~ /cn=/ ) ||
#		( $dn =~ /fn=/ ) );

    if(( $dn =~ /^uid=([^,]+),(dc|o|ou)=.*/ ) && 
	    ( $dn !~ /^uid=cyrus,(dc|o|ou)=/)){
	# replace Objectclasses
	my @oldoc = $e->get_value('objectclass');
	my @newoc = ();
	foreach my $oc ( @oldoc ) {
	    if(( $oc ne "account" ) && ( $oc ne "country")){
		push @newoc, $oc;
	    }
	}
	push @newoc, "SuSEcomFireConfig";
	$e->replace( 'objectClass' => \@newoc );
	# add Groupwarespecific Attributes
	$e->add( 'comfireAppointmentDays' => '5' );
	$e->add( 'comfireTaskDays' => '5' );
	$e->delete('shadowlastchange');
#	if( $e->exists("skyrixGreenConfig")){
#	    $e->delete("skyrixGreenConfig");
#	}
    }
    if( $dn =~ /^uid=cyrus,(dc|o|ou)=/ ){
	if( $e->exists("popAccount")){
	    $e->delete("popAccount");
	}
    }
    if( $dn =~ /^fn=(.*?),(dc|o|ou)=.*/ ) {
	if( $e->exists("mailDeliveryProgram")){
	    my @mdp = $e->get_value('mailDeliveryProgram');
	    $e->delete("mailDeliveryProgram");
	    foreach my $md ( @mdp ) {
		$md =~ s/\/usr\/cyrus\/bin\/deliver/\/usr\/lib\/cyrus\/bin\/deliver/;
		$e->add('mailDeliveryProgram' => "$md");
	    }
	}
	$e->delete('mail');
    }
    if( $dn =~ /^cn=freebusy,(dc|o|ou)=.*/ ){
	next;
    }
    push @newentries, $e;
}


my $ldifout = new Net::LDAP::LDIF("$ARGV[1]", "w");

$ldifout->write(@newentries);

$ldifout->done();

