#! /usr/bin/perl
#
# Copyright (c) 2001 SuSE GmbH Nuernberg, Germany.  All rights reserved.
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
#
# $Id: pwchange.pl,v 1.2 2003/05/06 11:36:55 varkoly Exp $
#

use strict;
use POSIX;
use Net::LDAP;
use Net::LDAP::Util qw( ldap_error_text);

my $base     = "dc=suse,dc=de";
my $rootdn   = "uid=cyrus,".$base;
my $rootpw   = "secret";
my $defpw    = "password";

my $ldap = Net::LDAP->new("localhost", version => 3);
die "unable to contact LDAP server" if ! defined $ldap;

my $mesg = $ldap->bind ( dn => "$rootdn",
			 password => "$rootpw" );
    
die "unable to bind LDAP server: ".ldap_error_text($mesg->code) if $mesg->code != 0;

$mesg = $ldap->search( base => $base,
		       scope => "one",
		       filter=> "(&(uid=*)(&(!(uid=cyrus))(!(uid=mailadmin))))",
		       attrs=> [ "userPassword" ] );
die "unable to search LDAP server: ".ldap_error_text($mesg->code) if $mesg->count <= 0;

foreach my $e ( $mesg->all_entries ) {
    $e->replace( userpassword => "{crypt}".
		 crypt($defpw, pack("C2",(int(rand 26)+65),(int(rand 26)+65)) ));
    $e->update($ldap);
}



