#! /bin/bash
#
# Copyright (c) 2002 SuSE Linux AG Nuernberg, Germany.  All rights reserved.
#
# $Id: smbactivate.sh,v 1.2 2003/05/06 11:36:55 varkoly Exp $
#

print_smb_conf_snippet()
{
    cat<<EOF
ldap server = localhost
ldap port = 389
ldap suffix = $BASEDN
ldap filter = (&(uid=%u)(objectclass=sambaAccount))
ldap admin dn = uid=cyrus,$BASEDN
ldap ssl = No
ldap del only sam attr = Yes
domain logons = yes
domain master = yes
logon home = \\\%L\%U
logon path = \\\%L\%U\profile
os level = 255
preferred master = yes
EOF
}

if [ ! -f /etc/sysconfig/samba ]; then
    echo "/etc/sysconfig/samba not found, please install the samba package first!"
    exit 1
fi

. /etc/sysconfig/samba

if [ -z "$SAMBA_SAM" -o "$SAMBA_SAM" != "ldap" ]; then
    echo "please set SAMBA_SAM=ldap in /etc/sysconfig/samba!"
    exit 1
fi

linkto /var/lib/samba/bin/smbd | grep ldap >/dev/null || {
    echo "running SuSEconfig -module samba..."
    SuSEconfig -module samba
}

BASEDN=$(awk 'BEGIN { IGNORECASE=1; } /^base/  { print $2; next; } { next; }' \
    < /etc/openldap/ldap.conf)

if [ -z "$BASEDN" ]; then
    echo "unable to get basedn from /etc/openldap/ldap.conf!"
    exit 1
fi

grep -E "^[[:space:]]*ldap.*" /etc/samba/smb.conf >/dev/null || {
    echo
    echo "Take care to have following options set in /etc/samba/smb.conf:"
    echo
    print_smb_conf_snippet
    exit 1
}

PASSWD=""
IFS=""
while [ -z "$PASSWD" ]; do
    read -a PASSWD -p "Enter Cyrus Password: " -r -s
    echo
done

RET=$(smbpasswd -w "$PASSWD")
echo $RET | grep "ERROR" >/dev/null && {
    echo $RET
    echo
    echo "unable to set passwd of rootdn!"
    echo
    echo "Take care to have following options set in /etc/samba/smb.conf:"
    echo
    print_smb_conf_snippet
    exit 1
}

cat<<EOF | /usr/bin/ldapadd -x -Duid=cyrus,$BASEDN -w "$PASSWD"
dn: uid=root,$BASEDN
uid: root
objectclass: account
EOF
if [ $? -gt 0 -a $? -ne 68 ]; then
    echo "Unable to add samba user root to the LDAP database."
    exit 1
fi

echo -en "$PASSWD\n$PASSWD\n" | /usr/bin/pdbedit -a -u root -b

insserv nmb
insserv smb
