#!/usr/bin/perl

use Config::IniFiles;

$lang = shift;
$lang = lc($lang);
$LANG = uc($lang);

$lmsg{DE}    = new Config::IniFiles( -file => "../openschool_de/de/srv/www/lib/imap_lang_DE.ini");
$lmsg{$lang} = new Config::IniFiles( -file => "$lang/srv/www/lib/imap_lang_$LANG.ini");

foreach my $section ($lmsg{DE}->Sections) {
   if(!$lmsg{$lang}->SectionExists($section)){
	$lmsg{$lang}->AddSection($section);
   }
   foreach my $param (sort $lmsg{DE}->Parameters($section)){
	print "$section, $param\n"; 
	$val_de   = $lmsg{DE}->val($section,$param);
	$val_lang = $lmsg{$lang}->val($section,$param);
	if(! defined $val_lang){
		$lmsg{$lang}->newval($section,$param,"DE=>$val_de");
	}
   }
}
$lmsg{$lang}->WriteConfig("$lang/srv/www/lib/imap_lang_$LANG.ini");

