#!/usr/bin/perl
use strict;
use File::stat;
my ($report) = @ARGV;
my $content = "";

system("cp /etc/openldap/slapd.conf /etc/openldap/slapd.conf.orig");
open(IN,"/etc/openldap/slapd.conf");
while(<IN>){
  $content .= $_;
}
close(IN);
$content =~ s/^access to attr=birthday
   by \* none/access to attr=birthday
   by self read break
   by * none/m;

if ( $content !~ /If needed only the creator may modify the created group/ ) {
   $content =~ s/# let Admins write below root/# If needed only the creator may modify the created group
access to filter="(&(objectClass=SuSESchoolGroup)(writerdn=*))"
  by dnattr=writerdn write
  by * read


# let Admins write below root/m;
}

# enhancing the self writable attributes
$content =~ s/comFireAppointmentDays$/comFireAppointmentDays,importSortInDirectory/;


open(OUT,">/etc/openldap/slapd.conf");
foreach (split /\n/,$content){
   print OUT $_."\n";
}
close(OUT);

# delete some not needed entries in crontab
open(IN,"/etc/crontab");
$content = '';
while(<IN>){
  $content .= $_;
}
close(IN);
$content =~ s/################################################################
# To get the suse "blacklists" make these line active
# Um die SuSE Blacklists regelmig zu holen aktivieren
# Sie diese Zeile:
################################################################
#0 2 \* \* 0      root    \/bin\/bash \/usr\/bin\/getlist-suse wait//m;

$content =~ s/################################################################
# Um das DynDNS-Skript von <kroe\@rs-schesslitz.de> zu benutzen
# editieren Sie die Datei \/root\/bin\/dyndns und Aktivieren Sie
# die nchste Zeile
################################################################
#0-59\/5 \* \* \* \* root    \/bin\/bash \/usr\/bin\/dyndns//m;

$content =~ s/\n\n\n\n\n\n/\n/m;

$content =~ s#/bin/bash /usr/sbin/uucico#/usr/sbin/uucico#;

open(OUT,">/etc/crontab");
foreach (split /\n/,$content){
   print OUT $_."\n";
}
close(OUT);

if (stat('/proc/net/route')) {
	my $route = `/sbin/route -n`;

	$route =~ /^(\d+.\d+).*eth0$/m;
	my $net = $1;
	$route =~ /^0\.0\.0\.0\s+(\d+.\d+)\.\d+\.\d+.*0\.0\.0\.0*/m;
	my $gw = $1;

	if($net ne $gw){
	    open(IN,"/etc/sysconfig/schoolserver");
	    my $content = '';
	    while(<IN>){
		if(/SCHOOL_ISGATE/){
		   $content .= "SCHOOL_ISGATE=\"yes\"\n";
		} else {
		   $content .= $_;
		}
	    }
	    close(IN);
	    open(OUT,">/etc/sysconfig/schoolserver");
	    print OUT $content;
	    close(OUT);
	}
}

# writing report
open(OUT,">>$report");
print OUT "modified /etc/crontab\n";
print OUT "modified /etc/openldap/slapd.conf\n";
print OUT "modified /etc/sysconfig/schoolserver\n";
close(OUT);
