#!/usr/bin/perl
use Config::IniFiles;

my ($report) = @ARGV;
my $DATE=`date +%Y-%m-%d.%H-%M`;

$LDAPBASE=`awk '/^[^#]/  { if (/base|BASE/) { print \$2 } }' /etc/openldap/ldap.conf`;
$LDAPHOST=`awk '/^[^#]/  { if (/host|HOST/) { print \$2 } }' /etc/openldap/ldap.conf`;
$SERVERNAME=`awk '/ServerName/ { print \$2 }' /etc/httpd/schoolserver_include.conf`;
$HOSTNAME=`cat /etc/HOSTNAME`;
$HOSTNAME=~/admin.(.*)/;
$DOMAIN=$1;
$PROXY=`host proxy`;
$PROXY=~ /(\d+)\.(\d+)\.(\d+)\.(\d+)/s;
$PROXY="$1.$2.$3.$4";


#Getting Basic-Settings
open(IN,"/var/SuSE/std.xml");
while(<IN>) {
	if (/<user_password>(.*)<\/user_password>/) {
		$ADMINPASSWD=$1;
	}
	if (/echo \'(.*)\' > \/root\/\.ssh\/authorized_keys/) {
		$KEYROOT=$1;
	}
	$STDXML .= $_;
}
close(IN);
if ($STDXML =~ /(<general>.*<\/general>)/s) {
	$GENERAL=$1;
}
# make it safe
chomp $LDAPBASE;
chomp $LDAPHOST;
chomp $SERVERNAME;
chomp $HOSTNAME;
chomp $DOMAIN;
chomp $GENERAL; 
chomp $ADMINPASSWD; 
chomp $KEYROOT;

#Let's work
#make some reperatures on sysconfig.schoolserver
system("sed 's/superschool.world/$DOMAIN/'   /etc/sysconfig/schoolserver    > /etc/sysconfig/schoolserver.1");
system("sed '/SCHOOL_PRINTSERVER_SEPARATE/d' /etc/sysconfig/schoolserver.1  > /etc/sysconfig/schoolserver");

#fill up the new xml-files
@files=('std.xml','std+win.xml','terminalserver.xml','thin_client.xml');
foreach $i (@files){
	system("cp /var/SuSE/$i /var/SuSE/$i.$DATE");
        if( -e "/var/SuSE/$i.rpmnew" ) { system("mv /var/SuSE/$i.rpmnew /var/SuSE/$i");}
	open(IN,"/var/SuSE/$i");
	my $x='';
	while(<IN>) {
		$x .= $_;
	}
	close(IN);
	$x =~ s/#LDAPBASE#/$LDAPBASE/g;
	$x =~ s/#LDAPSERVER#/$LDAPHOST/g;
	$x =~ s/#SCHOOLSERVERNAME#/$SERVERNAME/g;
	$x =~ s/#DOMAIN#/$DOMAIN/g;
	$x =~ s/<general>.*<\/general>/$GENERAL/s;
	$x =~ s/ADMINPASSWD/$ADMINPASSWD/g;
	$x =~ s/KEYROOT/$KEYROOT/g;
	open(OUT,">/var/SuSE/$i");
	print OUT $x;
	close(OUT);
}
 
# writing report
open(REPORT,">>$report");
print REPORT "created new xml files for autoinstallation\n";

#configure /etc/squid/squid.conf.in
if( -e '/etc/squid/squid.conf.in.rpmnew') {
   system("mv /etc/squid/squid.conf.in.rpmnew /etc/squid/squid.conf.in");
}
system("cp /etc/squid/squid.conf /etc/squid/squid.conf.orig");
open(IN,"/etc/squid/squid.conf.in");
my $x='';
while(<IN>) {
        $x .= $_;
}
close(IN);
$x =~ s/#PROXY#/$PROXY/g;
$x =~ s/#DOMAIN#/$DOMAIN/g;
$x =~ s/#LDAPBASE#/$LDAPBASE/g;
$x =~ s/#LDAPSERVER#/$LDAPHOST/g;
open(OUT,">/etc/squid/squid.conf");
print OUT $x;
close(OUT);

if( -e '/etc/squid/squidguard.conf.rpmnew') {
   system("cp /etc/squid/squidguard.conf  /etc/squid/squidguard.conf.orig");
   system("mv /etc/squid/squidguard.conf.rpmnew  /etc/squid/squidguard.conf");
}

#configure /srv/www/htdocs/proxy.pac.rpmnew
if( -e '/srv/www/htdocs/proxy.pac.rpmnew' ) {
   system("cp /srv/www/htdocs/proxy.pac /srv/www/htdocs/proxy.pac.orig");
   system("mv /srv/www/htdocs/proxy.pac.rpmnew /srv/www/htdocs/proxy.pac");
}
open(IN,"/srv/www/htdocs/proxy.pac");
my $x='';
while(<IN>) {
        $x .= $_;
}
close(IN);
$x =~ s/#DOMAIN#/$DOMAIN/g;
open(OUT,">/srv/www/htdocs/proxy.pac");
print OUT $x;
close(OUT);

print REPORT "setup new squid.conf, squidguard.conf & proxy.pac files\n";


#conbfigure smb.conf
my $netbios_name = '';
my $smbconf = new Config::IniFiles( -file => "/etc/samba/smb.conf" );
if(! defined $smbconf->val('global','hide dot files')){
    $smbconf->newval('global','hide dot files', 'yes');
}
if(! defined $smbconf->val('global','hide files')){
    $smbconf->newval('global','hide files','/.*/Desktop');
}
if(! $smbconf->SectionExists('classes')){
    $smbconf->AddSection('classes');
    $smbconf->newval('classes','browseable','yes'); 
    $smbconf->newval('classes','comment','Classes Folder For Teachers'); 
    $smbconf->newval('classes','path','/home/classes'); 
    $smbconf->newval('classes','valid users','@teachers'); 
}
$smbconf->setval('global','ldap filter','(&(uid=%u)(objectclass=sambaAccount)(!(disablelogin=yes))(|(!(gidnumber=103))(uid=%m)(uid=%m$)))');
$smbconf->setval('global','add user script','/usr/sbin/addsmbmachine2ldap %m');
$netbios_name = $smbconf->val('global','netbios name');
$smbconf->WriteConfig("/etc/samba/smb.conf");

@files=('administration.bat','teachers.bat','users.bat','workstations.bat');
foreach $i (@files){
        system("cp /var/lib/samba/netlogon/$i /var/lib/samba/netlogon/$i.$DATE");
	if(-e "/var/lib/samba/netlogon/$i.rpmnew") { 
	   system("mv /var/lib/samba/netlogon/$i.rpmnew /var/lib/samba/netlogon/$i");
	}
        open(IN,"/var/lib/samba/netlogon/$i");
        my $x='';
        while(<IN>) {
                $x .= $_;
        }
        close(IN);
        $x =~ s/#PDC-SERVER#/$netbios_name/g;
        open(OUT,">/var/lib/samba/netlogon/$i");
        print OUT $x;
        close(OUT);
}
# writing report
print REPORT "enhanced smb.conf\n";

# making nmbd always running 
system("insserv nmb");
print REPORT " making nmbd always running\n";

close(REPORT);
